/*
 =======================================================================================
  Name        : GIType.h 
 
  Author      : Mihaela Tancu
  Description : Define the GI_Type class  
 =======================================================================================
 */

#ifndef __GITYPE_H__
#define __GITYPE_H__

#include <afxtempl.h>
#include "GIItem.h"


class GI_Type 
{
// datas
public:
	char							m_szName[50];	//name of the type
	int								m_iSelected;	//number of selected objects for the type
	COLORREF						m_xTextColor;	//the text color of the type in list box
	CList<GI_Item *,GI_Item *>		m_oList;		//the list of objects associated with the type

public:
// methods
	GI_Type(char *szName, int _iSelected, COLORREF m_xTextColor); //contructor
    ~GI_Type();													  //destructor

    char* m_fn_p_oGetName(void)				{ return m_szName; }	//return the name of type
    int   m_fn_iGetSelected(void)			{ return m_iSelected; }	//return the number of objects selected for that type
	void  m_fn_iSetName(int _iSelected)     { m_iSelected=_iSelected; }	//set the number of selected objects
};

#endif // __GITYPE_H__