

#ifndef _FILE_H_
#define _FILE_H_

#include "util.h"

tdeStatus fn_eCreateDirectory( const char *_szDirectory );

// Copy a file or a directory (no '\' at end of directory name !)
// Source may contain wilcards. Dest must be a path to a directory !
// If source is a directory, the copy is recursive.
tdeStatus fn_eCopyFileOrDirectory( const char *_szSource, const char *_szDest );

// Copy some files to a directory. Function will also search for files in sub-dirs of source.
// Source may contain wilcards. Dest must be a path to a directory !
tdeStatus fn_eRecursiveFileCopy( const char *_szSource, const char *_szDest );


// Moves file(s) or a directory (no '\' at end of directory name !)
// Source may contain wilcards. Dest must be a path to a directory !
tdeStatus fn_eMoveFileOrDirectory( const char *_szSource, const char *_szDest );

// Deletes file(s) or directory (no '\' at end of directory name !)
// Source may contain wilcards.
// If source is a directory, the delete is recursive.
tdeStatus fn_eDeleteFileOrDirectory( const char *_szSource );


typedef struct tdstCopyFileContext_
{
	CString csMainDirectory;
	CString csBinDirectory;
	CString csLevelName;
} tdstCopyFileContext;

// Execute copy/move/deletes/rename commands in given array
// See file.cpp for exemples.
// stContext contains strings used when replacing %bin%, %level%....
tdeStatus fn_eTreatArrayOfFiles( char *_a_szFileCommands[], tdstCopyFileContext *_p_stContext );

// The arrays for fn_bTreatArrayOfFiles
extern char *g_a_szCommonFiles[];
extern char *g_a_szFilesAfterFirstPass[];
extern char *g_a_szFilesAfterSecondPass[];
extern char *g_a_szFixFilesAfterCRB[];
extern char *g_a_szDeleteFixFilesAfterCRB[];
extern char *g_a_szLevelFilesAfterCRB[];
extern char *g_a_szFilesBeforeBinarize[];
extern char *g_a_szDeleteFilesAfterBinarize[];


#endif