
#include "stdafx.h"
#include "GlobalData.h"
#include "/cpa/public/scr.h"

#define M_IsTitle         (_eAction==SCR_EA_Anl_BeginSection)
#define M_IsEnd           (_eAction==SCR_EA_Anl_EndSection)
#define M_IsBegSubSection (_eAction==SCR_EA_Anl_BeginSubSection)
#define M_IsEndSubSection (_eAction==SCR_EA_Anl_EndSubSection)
#define M_IsEntry         (_eAction==SCR_EA_Anl_Entry)
#define M_ActionIs(szActionAsked) (!strcmpi(_p_szName,szActionAsked))


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Callback function to analyse the section "LevelNames" in game.dsc
SCR_tde_Anl_ReturnValue fn_eScriptCallBackFirstLevel(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction)
{
	SCR_tde_Anl_ReturnValue eReturnValue = SCR_ERV_Anl_NormalReturn;
	
	_p_stFile=_p_stFile;
	
	if (M_IsTitle)
	{
		g_stTheGlobalData.a_csLevelNames.RemoveAll();
		g_stTheGlobalData.a_csLevelNames.SetSize( 0, 50 );
	}
	if (M_IsEntry)
	{
		if (M_ActionIs("LevelName"))
		{
			char *p_cDelimiter = strchr( _ap_szParams[0], '$' );
			if( p_cDelimiter ) *p_cDelimiter = 0;
			g_stTheGlobalData.a_csLevelNames.Add( _ap_szParams[0] );
		}
	}
	else if ( M_IsEnd )
	{
	}
	return(eReturnValue);
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Init acp modules for script parsing.

unsigned long g_SCR_a9MemTable[9] = {0,0,0,0,0,0,0,0,0};

void fn_vInitScr()
{
	Erm_M_InitErrMsg(Erm);
	Erm_M_InitErrMsg(Mmg);
	Mmg_fn_vFirstInitMmgModule(10);
	
	SCR_fn_v_RdL0_Init();
	g_SCR_a9MemTable[1] = 1000000;
	SCR_fn_v_Mem_InitWithMemLevel(g_SCR_a9MemTable);
	SCR_fn_v_RdL0_RegisterCallback( "FirstLevelDescription", fn_eScriptCallBackFirstLevel, SCR_CRC_c_RdL0_ForSection );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

void fn_vDesinitScr()
{
//	SCR_fn_v_RdL0_DeleteRegisterCallback( "FirstLevelDescription", SCR_CRC_c_RdL0_ForSection ,  );
	SCR_fn_v_RdL0_Close();
	Mmg_fn_vStopMmgModule();
	MMG_fn_vDesinitMemoryRasterDeclaration ();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Analyse game.dsc
BOOL fn_bReadGameDsc()
{
	char szText[1024];
	char szFileName[512];
	char szSectionName[512];

	// Compute long name of game.dsc
	sprintf( szFileName, "%s\\Gamedata\\Game.dsc", (const char *)g_stTheGlobalData.csMainDirectory );

	g_stTheGlobalData.a_cLevelsSelectedForBinarization.RemoveAll();
	g_stTheGlobalData.a_cBinarizedLevels.RemoveAll();

	// We need read acces on the file
	if( _access( szFileName, 04 ) == -1 )
	{
		sprintf( szText, "Can't read level list: '%s' is not accessible !\n(Does not exist or no read permission)", szFileName );
		AfxMessageBox( szText, MB_OK | MB_ICONSTOP );
		return FALSE;
	}

	// Analyse only the section describing the list of levels
	sprintf( szSectionName, "%s^FirstLevelDescription", szFileName );
	SCR_fnp_st_RdL0_AnalyseSection( szSectionName, SCR_CDF_uw_Anl_ForceAnalyse );
	SCR_fn_v_RdL0_DeleteOpenSection( szSectionName, SCR_CDR_c_RdL0_Match );

	int iSize = g_stTheGlobalData.a_csLevelNames.GetSize();
	g_stTheGlobalData.a_cLevelsSelectedForBinarization.SetSize( iSize );
	g_stTheGlobalData.a_cBinarizedLevels.SetSize( iSize );
	for( iSize--; iSize >= 0; iSize-- )
	{
		// clear the list of selected levels.
		g_stTheGlobalData.a_cLevelsSelectedForBinarization.SetAt( iSize, 0 );
		// clear the list of binarized levels.
		g_stTheGlobalData.a_cBinarizedLevels.SetAt( iSize, 0 );
	}


	// If no level found, print a warning.
	if( g_stTheGlobalData.a_csLevelNames.GetSize() == 0 )
	{
		sprintf( szText, "The list of level in '%s' is empty !", szFileName );
		AfxMessageBox( szText, MB_OK | MB_ICONEXCLAMATION );
		return FALSE;
	}

	return TRUE;
}
