/*=========================================================================
*
* ErrMlt.h	- error managment for the module : MLT
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef __ERRMlt_H__
#define __ERRMlt_H__

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 

//--- Export ---------------------------------------------------------

#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif

//----------------------------------------------------------------------

#ifndef __Erm_H__
#include "ERM.h"
#endif //__Erm_H__

#define __FATAL_ERR_Mlt__
#define __WARNING1_ERR_Mlt__
#define __WARNING2_ERR_Mlt__
#define __WARNING3_ERR_Mlt__
//----------
// Constant	 
//----------
// error of the Mlt Module
typedef enum e_uwMltErrNumber_{
	E_uwMltFatalErr,	
#ifdef __FATAL_ERR_Mlt__
//     -----------------
	E_uwMltFatalError1,	 
	E_uwMltFatalError2,	
	E_uwMltFatalError3,	
	E_uwMltFatalError4,	
#endif //__FATAL_ERR_Mlt__
	E_uwMltStartOfWarning,
#ifdef __WARNING1_ERR_Mlt__
//     -------------------
	E_uwMltWarning1Error1,	
	E_uwMltWarning1Error2,	
	E_uwMltWarning1Error3,
#endif //__WARNING1_ERR_Mlt__
#ifdef __WARNING2_ERR_Mlt__
//     -------------------
	E_uwMltWarning2Error1,	
	E_uwMltWarning2Error2,	
	E_uwMltWarning2Error3,	
	E_uwMltWarning2Error4,	
	E_uwMltWarning2Error5,
#endif //__WARNING2_ERR_Mlt__
#ifdef __WARNING3_ERR_Mlt__
//     -------------------
	E_uwMltWarning3Error1,	
	E_uwMltWarning3Error2,
#endif //__WARNING3_ERR_Mlt__
	E_uwMltErrNumber
} e_uwMltErrNumber;

//------------------
// Global Variables
//------------------
#undef __ERRMlt_EXTERN
#ifndef __DeclareGlobalVariableErrMlt_h__
#define __ERRMlt_EXTERN extern /*external declaration*/
#else //__DeclareGlobalVariableErrMlt_h__
#define __ERRMlt_EXTERN /*replace by nothing : we have to declare*/
#endif //__DeclareGlobalVariableErrMlt_h__

__ERRMlt_EXTERN CPA_EXPORT  unsigned char g_ucMltModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrMlt_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif //__DeclareGlobalVariableErrMlt_h__&& CPA_WANTS_IMPORT
;

#ifdef __ERROR_STRINGS__

__ERRMlt_EXTERN CPA_EXPORT  char * g_szMltModuleName /* Mandatory syntax 'g_sz'+[Abbreviation of ModuleName]+'ModuleName'*/
#if defined(__DeclareGlobalVariableErrMlt_h__) && !defined(CPA_WANTS_IMPORT)
= "Module Mlt"
#endif //__DeclareGlobalVariableErrMlt_h__ && CPA_WANTS_IMPORT
;

__ERRMlt_EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stMltTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrMlt_h__) && !defined(CPA_WANTS_IMPORT)
={ 
#ifdef __FATAL_ERR_Mlt__   
//	 -------------
	E_uwMltFatalError1, " text of the error # E_uwMltFatalError1 ",
	E_uwMltFatalError2, " text of the error # E_uwMltFatalError2",
	E_uwMltFatalError3, " text of the error # E_uwMltFatalError3",
	E_uwMltFatalError4, " text of the error # E_uwMltFatalError4",
#endif //__FATAL_ERR_Mlt__
#ifdef __WARNING1_ERR_Mlt__
//	 ----------------
	E_uwMltWarning1Error1, " text of the error # E_uwMltWarning1Error1 ",	
	E_uwMltWarning1Error2, " text of the error # E_uwMltWarning1Error2 ",
	E_uwMltWarning1Error3, " text of the error # E_uwMltWarning1Error3 ",
#endif //__WARNING1_ERR_Mlt__
#ifdef __WARNING2_ERR_Mlt__
//	 ----------------
	E_uwMltWarning2Error1, " text of the error # E_uwMltWarning2Error1 ",
	E_uwMltWarning2Error2, " text of the error # E_uwMltWarning2Error2 ",
	E_uwMltWarning2Error3, " text of the error # E_uwMltWarning2Error3 ",
	E_uwMltWarning2Error4, " text of the error # E_uwMltWarning2Error4 ",
	E_uwMltWarning2Error5, " text of the error # E_uwMltWarning2Error5 ",
#endif //__WARNING2_ERR_Mlt__
#ifdef __WARNING3_ERR_Mlt__
//	 ----------------
	E_uwMltWarning3Error1, " text of the error # E_uwMltWarning3Error1 ",
	E_uwMltWarning3Error2, " text of the error # E_uwMltWarning3Error2 ",
#endif //__WARNING3_ERR_Mlt__
	0xFFFF, "\0"//fin
};
#endif //__DeclareGlobalVariableErrMlt_h__ && CPA_WANTS_IMPORT
;

#endif //__ERROR_STRINGS__

#ifdef __cplusplus
};
#endif // __cplusplus 


#endif //__ERRMlt_H__
