/*=========================================================================
*
* ObjLoad.h	- Loading functions for OBJ file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef OBJLOAD_H
#define OBJLOAD_H



//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "typedef.h"

//--- Structures ---------------------------------------------------------

typedef struct MLT_tdstObjElement_
{
  long		lNumberInTable;
  xString	sSectionObj;
  xString	sSectionMod;
  xString	sTete;
  xString	sLetter;
  xString	sNeutral;
  long		lValue;
  double	a9_dCustomZoom[9];
  BOOL		bCustomZoom;
  // Object Table
  int		iType;				//type of the event
  xString	sObject;			//used for some events
  xString	sData;				//used for some events
  long		lSoundReference;	//used for SoundEvent
  long		lFirstCall;			//common for all events(Generic, Generate, Sound, Mechanic, Camera)
  long		lPeriod;			//common for all events(Generic, Generate, Sound, Mechanic, Camera)
  long		lPriority;			//common for all events(Generic, Generate, Sound, Mechanic, Camera)
  BOOL		bFlag;
} 
MLT_tdstObjElement;


//--- Functions ---------------------------------------------------------

// initialisation
extern void MLT_vInitOBJLoad	(void);
// library
extern void MLT_vLoadModuleLib	 (void);
extern void MLT_vDeleteModuleLib (void);
// loading callback
extern SCR_tde_Anl_ReturnValue MLT_xLoadObjHeader	(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue MLT_xLoadObj			(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);


#endif // OBJLOAD_H
