/*=========================================================================
*
* PhyLoad.h	- Saving functions for PHY file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef PHYSAVE_H
#define PHYSAVE_H


//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "objload.h"

//--- Functions ---------------------------------------------------------

// init
extern void MLT_vInitSaveTbl	(void);
// files
extern void MLT_vSaveTblFile	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void MLT_vSavePhyFile	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
// sections
extern void MLT_vSaveTbl		(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void MLT_vSavePhy		(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
// from OBJ
extern void MLT_vSaveTblFromObj	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void MLT_vSavePhyFromObj	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
// subsections
void MLT_vSaveA3dObj			(SCR_tdst_File_Description *p_stFile, MLT_tdstObjElement *p_stGeometric);
void MLT_vSaveSoundEvent		(SCR_tdst_File_Description *p_stFile, MLT_tdstObjElement *p_stGeometric);
void MLT_vSaveMechanicEvent		(SCR_tdst_File_Description *p_stFile, MLT_tdstObjElement *p_stGeometric);
void MLT_vSaveGenericEvent		(SCR_tdst_File_Description *p_stFile, MLT_tdstObjElement *p_stGeometric);
void MLT_vSaveGenerateEvent		(SCR_tdst_File_Description *p_stFile, MLT_tdstObjElement *p_stGeometric);
void MLT_vSaveCameraEvent		(SCR_tdst_File_Description *p_stFile, MLT_tdstObjElement *p_stGeometric);


#endif // PHYSAVE_H