/*=========================================================================
*
* PlgLoad.h	- Loading functions for Plg file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef _PLG_H_
#define _PLG_H_

//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "typedef.h"

//------------------------------------------------------------------------

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS


//--- Structures ---------------------------------------------------------

// PLG color
typedef struct MLT_tdstVColor_
{	
	float fR;
	float fG;
	float fB;
} 
MLT_tdstVColor;

// vertex color
typedef struct MLT_tdstVertexColor_
{
  xString			sName;
  long				xNbPoints;
  MLT_tdstVColor	*d_stListOfPoints;
} 
MLT_tdstVertexColor;



//--- Functions ---------------------------------------------------------

// load&save
extern void						MLT_vInitPLGLoad	 (void);
extern void						MLT_vSaveVertexColor (SCR_tdst_File_Description *p_stFile, MLT_tdstVertexColor *p_stVertexColor);
extern SCR_tde_Anl_ReturnValue	MLT_xLoadVertexColor (SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue	MLT_xLoadPLGCallback (SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
// library
extern void	MLT_vErasePLGLib		(void);
extern void	MLT_vLoadPLGFileInLib	(void);
extern void MLT_vSaveLibInPLGFile	(void);



#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus */
/********************************************************/
#endif // _WINDOWS

#endif // _PLG_H_ 
