/*=========================================================================
*
* Print.h	- Display functions 
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef PRINT_H
#define PRINT_H

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS


//--- Defines ---------------------------------------------------------

#define C_ComRes_cTitleLine		0  
#define C_ComRes_cNormalLine	1  
#define C_ComRes_cResultLine	2
#define C_ComRes_cWarningLine	3
#define C_ComRes_cErrorLine		4


//--- Globals ---------------------------------------------------------

// main options
extern BOOL g_bRaymanII;
extern BOOL g_bModifLst;
extern BOOL g_bEraseMdf;
// ignore options
extern BOOL g_bIgnoreZoo;
extern BOOL g_bIgnoreSct;
extern BOOL g_bIgnoreSpo;
extern BOOL g_bIgnoreGmt;
extern BOOL g_bIgnoreTex;
// conversion options
extern BOOL g_bCopyAnims;
extern BOOL g_bCopyTextures;
extern BOOL g_bGenerateRLI;
extern BOOL g_bUpdateGameDSC;
// erase options
extern BOOL g_bEraseDuplicated;
extern BOOL g_bEraseUnused;
// family options
extern BOOL g_bCommonFamily;
extern BOOL g_bSpecificFamily;
extern BOOL g_bAskFamily;
extern BOOL g_bApplyAll;
// bank option
extern BOOL g_bCreateBasicFamily;

// existence of files
extern BOOL g_bCreatedSpo;
extern BOOL g_bCreatedGmt;
extern BOOL g_bExistTex;
extern BOOL g_bExistSpo;
extern BOOL g_bExistMdf;
extern BOOL g_bExistMdt;
extern BOOL g_bExistSpoBank;

// multitextures
extern BOOL g_bBankConversion;
extern BOOL g_bClassConversion;
extern BOOL g_bLevelConversion;

// paths configurations
extern BOOL g_bStandardConfig;
extern char g_szAnims[255];
extern char g_szBanks[255];
extern char g_szClasses[255];
extern char g_szFamilies[255];
extern char g_szLevels[255];
extern char g_szTextures[255];

//--- Functions ---------------------------------------------------------

void fn_vAfxOutputStringRes (char* _szString, char _Line);
void fn_vAfxOutputStringCom (char* _szString, char _Line);

extern void MLT_vOutput( char cLineType, char *szFormat, ... );


#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS

#endif // PRINT_H
