/*=========================================================================
*
* Conventi.h	- String definitions
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef CONVENTION_H
#define CONVENTION_H



//--- General ---------------------------------------------------------

#define M_SetCurrentFileDouble		"SetCurrentFileDouble"
#define M_VersionNumber				"VersionNumber"

//--- Files ---------------------------------------------------------

#define M_FichierALW				".alw"
#define M_FichierLGT				".lgt"
#define M_FichierPLG				".plg"
#define M_FichierMOD				".mod"
#define M_FichierZOO				".zoo"

//--- Headers ---------------------------------------------------------

#define M_TBL_HEADER				"TBL_HEADER"
#define M_IPO_HEADER				"IPO_HEADER"
#define M_ZOO_HEADER				"ZOO_HEADER"
#define M_PHY_HEADER				"PHY_HEADER"
#define M_VSE_HEADER				"VSE_HEADER"
#define M_A3D_HEADER			    "A3dHEADER"



//--- Super-Objects ---------------------------------------------------------

// section name
#define M_SuperObject				"SuperObject"
// section entries
#define M_SPOActionTransparency		"Transparency"
#define M_SPOActionLinkedObject		"LinkedObject"
#define M_SPOActionGeometric		"Geometric"
#define M_SPOActionPutMatrix		"PutMatrix"
#define M_SPOActionAddChild			"AddChild"
#define M_SPOActionComment			"Comment"
#define M_SPOActionFlags			"Flags"

// modifications
#define M_Edit_ListModifSuperObject "Edit-ListModifSuperObject"

// parameters
#define M_Root						"Root"
#define M_SPO_Univers				"SPO_Univers"


//--- Matrix ---------------------------------------------------------

// section name
#define M_Matrix					"Matrix"
// section entries
#define M_MATActionTranslation		"MatrixTranslation"
#define M_MATActionRotation			"MatrixRotation"
#define M_MATActionScale			"MatrixScale"


//--- Characters ---------------------------------------------------------

// section name
#define M_InsertCharacter			"InsertCharacter"
#define M_InsertAlways				"InsertAlways"
// section entries
#define M_LVLActionCharacterFlags	"CharacterFlags"
#define M_LVLActionLinkCharacter	"LinkCharacter"
#define M_LVLActionInitialState		"InitialState"
#define M_LVLActionTransparency		"Transparency"
#define M_LVLActionTranslation		"MatrixTranslation"
#define M_LVLActionRotation			"MatrixRotation"
#define M_LVLActionScale			"MatrixScale"


//--- Sectors ---------------------------------------------------------

// section name
#define M_Sector					"Sector"

// env&surf subsection
#define M_ENVAndSRF					"ENVAndSRF"
// env&surf entries
#define M_SCTActionAddLstEnv		"AddLstEnvironment"
#define M_SCTActionAddLstSurface	"AddLstSurface"

// sector links subsection
#define M_SectorsLink				"SectorsLink"
// sector links entries
#define M_SCTActionVirtual			"Virtual"
#define M_SCTActionPriority			"Priority"
#define M_SCTActionCameraType		"CameraType"
#define M_SCTActionNewModelisation	"NewModelisation"
#define M_SCTActionAddLstSound		"AddLstSound"
#define M_SCTActionAddLstGraphic	"AddLstGraphic"
#define M_SCTActionAddLstActivity	"AddLstActivity"
#define M_SCTActionAddLstCollision	"AddLstCollision"
#define M_SCTActionAddLstSoundEvent "AddLstSoundEvent"

// static lights subsection
#define M_StaticLights				"StaticLights"
// static lights entries
#define M_SCTActionAddStaticLight	"AddLstStaticLights"

// border subsection
#define M_Border					"Border"
// border entries
#define M_SCTActionMinPointOfBorder	"MinPointOfBorder"
#define M_SCTActionMaxPointOfBorder	"MaxPointOfBorder"
#define M_SCTActionZmaxOfBorder		"ZmaxOfBorder"

// gothrough subsection
#define M_Gothrough					"Gothrough"
// gothrough entries
#define M_SCTActionGothrough		"GoThrough"

// parameters
#define M_Univers					"Univers"
#define M_NameGothrough				"Gothrough"


//--- Submaps ---------------------------------------------------------

// section name
#define M_CreateSubMaps				"CreateSubMaps"
// section entries
#define M_NumberOfSubMaps			"NumberOfSubMaps"
#define M_BeginSubMapSoundEvent		"BeginSubMapSoundEvent"

// parameters
#define M_SuperObjectRoot			"SuperObject:Root"
#define M_MatrixRoot				"Matrix:Root"
#define M_MatrixCenter				"*^Matrix:LevelCenter"


//--- Surfaces ---------------------------------------------------------

// section name
#define M_SurfaceDescription		"SurfaceDescription"
// section entries
#define M_SRFActionVisual			"SurfaceVisual"
#define M_SRFActionVisualMatrix		"SurfaceVisualMatrix"


//--- IPOs ---------------------------------------------------------

// section name
#define M_IpoMirror					"IPO_MIRROR"
#define M_Ipo						"IPO"
// section entries
#define M_IPOActionPO				"PO"
#define M_IPOActionRLI				"RLI"


//--- POs ---------------------------------------------------------

// section name
#define M_Phy						"PHY"
// section entries
#define M_PHYActionCS				"CS"
#define M_PHYActionVS				"VS"

// section names
#define M_CS						"CS"
#define M_VS						"VS"


//--- Zones ---------------------------------------------------------

// section name
#define M_AllCollideSets			"AllCollideSets"
// section entries
#define M_ZOOActionZDR				"ZDR"
#define M_ZOOActionZDM				"ZDM"
#define M_ZOOActionZDE				"ZDE"
#define M_ZOOActionZDD				"ZDD"

// parameter
#define M_Collide					"Collide"


//--- Visual Set ---------------------------------------------------------

// section name
#define M_LOD						"LOD"
// section entries
#define M_VSEActionLOD_Threshold	"LOD_Threshold"
#define M_VSEActionFichierMOD		"FichierMOD"
#define M_VSEActionFichierRLI		"FichierRLI"


//--- Geometric Objects ---------------------------------------------------------

// section name
#define M_Geometric					"Geometric"
// section entries
#define M_MODActionLookAt			"LookAt"
#define M_MODActionComment			"Comment"
#define M_MODActionAddEdge			"AddEdge"
#define M_MODActionAddVertex		"AddVertex"
#define M_MODActionAddElement		"AddElement"
#define M_MODActionGetElement		"GetElement"
#define M_MODActionGetVertices		"GetVertices"

// element sections
#define M_ElementFaceMapDescriptors "ElementFaceMapDescriptors"
#define M_ElementIndexedTriangles	"ElementIndexedTriangles"
#define M_ElementSprites			"ElementSprites"
#define M_ElementTMeshes			"ElementTMeshes"
#define M_ElementLines				"ElementLines"
#define M_ElementPoints				"ElementPoints"
#define M_ElementSpheres			"ElementSpheres"
#define M_ElementAlignedBoxes		"ElementAlignedBoxes"
#define M_ElementAltimap			"ElementAltimap"
#define M_ElementMegaFace			"ElementMegaFaces"
// triangles & facemap entries
#define M_MODActionMaterial			"Material"
#define M_MODActionPointedSector	"PointedSector"
#define M_MODActionAddFaceFMD		"AddFaceFMD"
#define M_MODActionTripledUV		"TripledUV"
#define M_MODActionAddFaceUV		"AddFaceUV"
#define M_MODActionGetFaces			"GetFaces"
#define M_MODActionAddFace			"AddFace"
#define M_MODActionGetUVs			"GetUVs"
#define M_MODActionAddUV			"AddUV"
// sprite entries
#define M_MODActionAddMaterial		"AddMaterial"
#define M_MODActionAddSprite		"AddSprite"
#define M_MODActionAddInfo			"AddInfo"
// meshes entries
#define M_MODActionAddPoint			"AddPoint"
#define M_MODActionFatness			"Fatness"
// lines entries
#define M_MODActionAddLine			"AddLine"
#define M_MODActionThickness		"Thickness"
// elements entries
#define M_MODActionAddCone			"AddCone"
#define M_MODActionAddSphere		"AddSphere"
#define M_MODActionAddAlignedBox	"AddAlignedBox"
// altimap entries
#define M_MODActionOrigin			"Origin"
#define M_MODActionSetVertex		"SetVertex"
#define M_MODActionSetSquare		"SetSquare"
#define M_MODActionSetTriangle		"SetTriangle"
#define M_MODActionSquarePattern	"SquarePattern"
// megaface entries
#define M_MODActionAddMegaFace		"AddMegaFace"

// element names
#define M_FaceMapDescriptors		"FaceMapDescriptors"
#define M_FaceMapDescriptor			"FaceMapDescriptor"
#define M_IndexedTriangles			"IndexedTriangles"
#define M_Sprites					"Sprites"
#define M_Sprite					"Sprite"
#define M_TMeshes					"TMeshes"
#define M_Lines						"Lines"
#define M_Cones						"Cones"
#define M_Points					"Points"
#define M_Spheres					"Spheres"
#define M_AlignedBoxes				"AlignedBoxes"
#define M_Altimap					"Altimap"
#define M_MegaFace					"MegaFaces"

// parameters
#define M_2DScaled					"2DScaled"
#define M_2DNonScaled				"2DNonScaled"


//--- PLG File ---------------------------------------------------------

// section name
#define M_VertexColor				"VertexColor"
// section entries
#define M_PLGActionAddVertexColor	"AddVertexColor"


//--- Game Materials ---------------------------------------------------------

// section name
#define M_GameMaterial				"GameMaterial"
// section entries
#define M_GMTActionCollideMat		"CollideMat"
#define M_GMTActionVisualMat		"VisualMat"
#define M_GMTActionSoundMat			"SoundType"


//--- Visual Materials ---------------------------------------------------------

// section name
#define M_Material					"Material"
// section entries
#define M_VMTActionType				"Type"
#define M_VMTActionScroll			"Scroll"
#define M_VMTActionBackface			"Backface"
#define M_VMTActionAddTexture		"AddTexture"
#define M_VMTActionAmbientColor		"AmbientColor"
#define M_VMTActionDiffuseColor		"DiffuseColor"
#define M_VMTActionSpecularColor	"SpecularColor"
// multitextures
#define M_VMTActionMultiTexture		"MultiTexture"
#define M_VMTActionUVComputing		"UVComputing"

//--- Textures ---------------------------------------------------------

// section name
#define M_Texture "Texture"
// section entries
#define M_TEXActionLoadTexture		"LoadTexture"
#define M_TEXActionTiling			"Tiling"
#define M_TEXActionMipMapping		"MipMapping"
#define M_TEXActionChromakey		"Chromakey"
#define M_TEXActionQuality			"Quality"
#define M_TEXActionPriority			"Priority"
// multitextures
#define M_TEXActionLinarMipMapping	"LinarMipMapping"
#define M_TEXActionCorrection		"PerspectiveCorrection"
#define M_TEXActionBlendToColor		"BlendToColor"
#define M_TEXActionBlendToAlpha		"BlendToAlpha"

//--- OBJ File ---------------------------------------------------------

// section names	
#define M_A3dObjectsTableELEMENT	"A3dObjectsTableELEMENT"
#define M_A3dObjectsTableGENERAL	"A3dObjectsTableGENERAL"
// section entries
#define M_OBJActionMaximumIndex		"MaximumIndex"
#define M_OBJActionSoundReference	"SoundReference"
#define M_OBJActionLipsSynchro		"LipsSynchro"
#define M_OBJActionCustomZoom		"CustomZoom"
#define M_OBJActionObjectType		"ObjectType"
#define M_OBJActionFirstCall		"FirstCall"
#define M_OBJActionPriority			"Priority"
#define M_OBJActionPeriod			"Period"
#define M_OBJActionStatus			"Status"
#define	M_OBJActionObject			"Object"
#define M_OBJActionBank				"Bank"
#define	M_OBJActionData				"Data"
// basic family
#define M_OBJActionActor			"Actor"
#define M_OBJActionCount			"Count"
#define M_OBJActionGridSettings		"GridSettings"
#define M_OBJActionOrientation		"Orientation"
#define M_OBJActionPivotOrientation	"PivotOrientation"
#define M_OBJActionPivotPosition	"PivotPosition"
#define M_OBJActionPosition			"Position"

// parameters
#define M_Object					"Object"
#define M_Fake						"Fake"


#define M_OBJActionFileType			"FileType"
#define M_OBJActionVersionNumber	"VersionNumber"

//--- CHL File ---------------------------------------------------------

// section names	
#define M_A3dChannelNames			"A3dChannelNames"
// section entries
#define M_CHLActionAddChannelName	"AddChannelName"


//--- A3D File ---------------------------------------------------------

// section names
#define M_A3dAnimationGENERAL		"A3dAnimationGENERAL"
#define M_A3dStringsTable			"A3dStringsTable"
#define M_A3dVertexesTable			"A3dVertexesTable"
#define M_A3dQuaternionsTable		"A3dQuaternionsTable"
#define M_A3dChannel				"Channel"
#define M_A3dFrame					"Frame"
// section entries
#define M_A3DActionActor			"Actor"
#define M_A3DActionNumberOfChannels	"NumberOfChannels"
#define M_A3DActionNumberOfFrames	"NumberOfFrames"
#define M_A3DActionCurrentFrame		"CurrentFrame"
#define M_A3DActionTransOffset		"AnimationTranslationOffset"
#define M_A3DActionRotationOffset	"AnimationRotationOffset"
#define M_A3DActionReferenceChannel	"AnimReferenceChannel"
#define M_A3DActionSpeed			"AnimationSpeed"
#define M_A3DActionNumberInTable	"NumberInTable"
#define M_A3DActionAdd				"Add"
#define M_A3DActionPosition			"Position"
#define M_A3DActionOrientation		"Orientation"
#define M_A3DActionScale			"Scale"


//--- Object Tables ---------------------------------------------------------

// section name
#define M_Tbl						"TBL"
#define M_Evt						"EVT"
// section entries
#define M_TBLActionMaximumIndex		"MaximumIndex"
#define M_TBLActionObjectType		"ObjectType"
#define M_TBLActionSoundEvent		"SoundEvent"
#define M_TBLActionCameraEvent		"CameraEvent"
#define M_TBLActionGenericEvent		"GenericEvent"
#define M_TBLActionGenerateEvent	"GenerateEvent"
#define M_TBLActionMechanicEvent	"MechanicEvent"
#define M_TBLActionPeriod			"Period"
#define M_TBLActionPriority			"Priority"
#define M_TBLActionFirstCall		"FirstCall"
#define M_TBLActionCustomZoom		"CustomZoom"
#define M_TBLActionLipsSynchro		"LipsSynchro"

// event names
#define M_3dObject					"3dObject"
#define M_SoundEvent				"SoundEvent"
#define M_CameraEvent				"CameraEvent"
#define M_GenericEvent				"GenericEvent"
#define M_GenerateEvent				"GenerateEvent"
#define M_MechanicEvent				"MechanicEvent"


//--- Lights ---------------------------------------------------------

// section name
#define M_Light						"Light"
// section entries
#define M_LGTActionSetState			"SetState"
#define M_LGTActionSetColor			"SetColor"
#define M_LGTActionSetMatrix		"SetMatrix"
#define M_LGTActionSetAlphas		"SetAlphas"
#define M_LGTActionSetNearFar		"SetNearFar"


//--- RLIs ---------------------------------------------------------

// section name
#define M_RLI						"RLI"
#define M_ISI						"ISI"
// section entries
#define M_RLIActionAddLOD			"AddLODRLI"
#define M_RLIActionAddVertexLOD		"AddVertexRLILOD"


//--- Prefixes ---------------------------------------------------------

// Borders
#define M_BoundingBox				"frtb"
// Frontiers
#define M_Frontier					"frt"
#define M_Fermeture					"frtc"
#define M_FronRever					"frtr"
#define M_NewFronRever				"frtf"
#define M_FermRever					"frtcr"
// Surfaces
#define M_Surface					"srf_"
// SuperObjects
#define M_SPO_						"SPO_"


//--- Specific ---------------------------------------------------------

#define M_NomAnim "nomdel'anim"






#endif // CONVENTION_H 