/*
 =======================================================================================
  Name        :error.h
 
  Author      :Vincent Lhullier             Date :27/04/97
 
  Description :error manager
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */
#ifndef __ERROR_H__
#define __ERROR_H__

/*
 =======================================================================================
	Enumeration of error type 
 =======================================================================================
 */

typedef enum Error_tdeValue_
{
	/* server */
	Error_eCantAccessServer,
	Error_eCantAccessTimeServer,

	/* error for local directory */
	Error_eCantCreateLocalPath,

	/* vss errors */	
	Error_eCantAccessExistantItem,
	Error_eFileAlreadyCheckOut,
	Error_eCantDeleteFile,
	Error_eSomeoneObtain,
	Error_eSomeoneUpdate,
	Error_eVssFileNotFound,
	Error_eAccessDenied,
	Error_eCantCreateVssProject,

	/* time error */
	Error_eVssFileNewer,
	Error_eVssSectionNewer,

	/* existence of file */
	Error_eLocalFileNotFound,
	Error_eSectionNotFound,

	/* validity of filename or section */
	Error_eInvalidFileName,
	Error_eInvalidSectionName,

	/* modification error */
	Error_eCantUpdateModification,
	Error_eVssSectionAlreadyCreated,
	Error_eVssParentSectionInexistent,


} Error_tdeValue;

/*
 =======================================================================================
	Functions 
 =======================================================================================
 */

/* Set functions */
void			Error_fn_vSet( Error_tdeValue _eError, char *_szErrorString = NULL );
void			Error_fn_vSetFmt( Error_tdeValue _eError, char *_szFormat, ... );

/* Get functions */
Error_tdeValue	Error_fn_eGet( void );
char			*Error_fn_p_szGetMessage( void );
char			*Error_fn_p_szGetSystemMessage( void );

/* display functions */
void			Error_fn_vDisplay( BOOL _bSystem = FALSE );

#endif //__ERROR_H__


