/*
 =======================================================================================
  Name        :MajData.h
 
  Author      :vincent lhullier             Date :21/07/97
 
  Description :header file to access function for updating data
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#ifndef __MAJDATA_H__
#define __MAJDATA_H__
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#include "SCR.h"
#include "ModifLst.h"
#include "IniData.h"
#include "Tree_Fct.h"
#include "Vss5_Fct.h"
#include "TimeFunc.h"
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*
 =======================================================================================
	Structures
 =======================================================================================
 */

/*
 * structure to store info about one file
 */
typedef struct tdstFileInfo_
{
	SCR_tdst_File_Open			*p_stFile;
	char						szFullName[MAX_PATH];
	SCR_tdst_Anl_SectionDes		*p_stSection;
	char						*p_cBuffer;
	long						lSize;
	COleDateTime				oTime;
	char						szLastUserName[ 20 ];
} tdstFileInfo;

/*
 =======================================================================================
	Globals
 =======================================================================================
 */

extern char				g_szVssFileName[ MAX_PATH ];
extern tdstFileInfo		g_stTarget;
extern tdstFileInfo		g_stSource;
extern char				g_cDeleteSectionModif;			
extern char				g_cAddModifiedFile;

/*
 =======================================================================================
	Functions
 =======================================================================================
 */

BOOL		fn_bSomeoneUpdate( BOOL bCreateFile, BOOL _bMessage );
BOOL		fn_bGetUpdateStatus( char *_p_szMsg = NULL);
BOOL		fn_bBeginUpdating( void );
BOOL		fn_bEndUpdating( void );

BOOL		fn_bDoModif( tdstModif *p_stModif );

BOOL		fn_bSomeoneObtain( BOOL _bMessage );
BOOL		fn_bGetObtainStatus( char *_p_szMsg = NULL );
BOOL		fn_bBeginObtaining( void );
BOOL		fn_bEndObtaining( void );

BOOL		fn_bObtainFile( char *szFileName, BOOL *_bObtain );
char		fn_cUpdateFile( char *_szLocalFileName );

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#endif /*__MAJDATA_H__*/
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/