/*
 =======================================================================================
  Name        :SaveMngr.h
 
  Author      :Vincent Lhullier             Date :11/07/97
 
  Description :manage save of data before modification
 	Create a copy of GameData tree with all file that would be modified. That will allow
	someone to recuperate previous version if save generate some problem in data.
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

#ifndef __SAVEMNGR_H__
#define __SAVEMNGR_H__


/*
 =======================================================================================
	Directory Functions
 =======================================================================================
 */

BOOL SAVE_fn_bDeleteTree( char *szDirName );

/*
 =======================================================================================
	Error functions 
 =======================================================================================
 */

void SAVE_fn_vErrorMessage( char *_szMessage );

/*
 =======================================================================================
	Version functions 
 =======================================================================================
 */

long SAVE_fn_lGetVersionNumberFromDirExt( char *_szSavedDirectoryName );
void SAVE_fn_vGetVersionDirName( long _lVersion, char *_szVersionDirName, BOOL _bOld );
BOOL SAVE_fn_bDeleteVersion( long _lVersion, BOOL _bOld );
long SAVE_fn_lGetUsedVersion( char *a_cVersion, BOOL _bOld );

/*
 =======================================================================================
	principal function 
 =======================================================================================
 */
BOOL SAVE_fn_bDeleteAllVersions( void );

#endif	/*__SAVEMNGR_H__*/
