/*
 =======================================================================================
  Name        :SaveMngr.h
 
  Author      :Vincent Lhullier             Date :11/07/97
 
  Description :manage save of data before modification
 	Create a copy of GameData tree with all file that would be modified. That will allow
	someone to recuperate previous version if save generate some problem in data.
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

#ifndef __SAVEMNGR_H__
#define __SAVEMNGR_H__


/*
 =======================================================================================
	Directory Functions
 =======================================================================================
 */

BOOL SAVE_fn_bDeleteTree( char *szDirName );
BOOL SAVE_fn_bCreateDirectory( char *szDirName );
BOOL SAVE_fn_bMoveDirectory( char *szSourceDir, char *szTargetDir );

/*
 =======================================================================================
	Error functions 
 =======================================================================================
 */

void SAVE_fn_vErrorMessage( char *_szMessage );

/*
 =======================================================================================
	Version functions 
 =======================================================================================
 */

long SAVE_fn_lGetVersionNumberFromDirExt( char *_szSavedDirectoryName );
void SAVE_fn_vGetVersionDirName( long _lVersion, char *_szVersionDirName );
BOOL SAVE_fn_bDeleteVersion( long _lVersion );
BOOL SAVE_fn_bRenameVersion( long _lOldVersion, long _lNewVersion );
long SAVE_fn_lGetUsedVersion( char *a_cVersion, SYSTEMTIME *a_stTime = NULL );
long SAVE_fn_lAnalyseCurrentUsedVersion( char *a_cVersion, SYSTEMTIME *a_stTime = NULL );




#endif	/*__SAVEMNGR_H__*/
