/* 
 MODULE : 	AI	(Artificial Intelligence Library)
 AUTHOR : 	Olivier Didelot
 FILE 	:	AI.h (Principal header file) 
*/
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_AI
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_AI
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef AI_H
#define AI_H
 
#include "AI/AI_Edit.h"
#include "AI/AI_pub.h"
 
#if defined(ACTIVE_AIDEBUG)
#ifndef U64
#include "AI/AIDebug/BreakPts.h" /*** DR ***/
#endif /*U64*/
#include "AI/AIDebug/Specif/AID_Trac.h"
#endif /* ACTIVE_AIDEBUG */
 
#endif /* AI_H */
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
