/*---------------------------------------------------------------------------*/
/* ReadFile.h : Manage the reading of script file.*/
/* auteur : Olivier Didelot.*/
/* date   : 29/08/1996*/
/* 18/2/97 modify Olivier Couvreur : C_...String for Editor*/
/*---------------------------------------------------------------------------*/
/* in order to compile AI in C++ and link with GAM in C*/
#if defined(__cplusplus)
extern "C"
{
#endif
 
#if !defined(__READRULE_H__)
#define __READRULE_H__
 
/*////////////////////*/
/* Global Variables //*/
/*////////////////////*/
#undef EXTERN
#undef extern
#if !defined(__DeclareGlobalVariableReadRule_h__)
#define EXTERN extern
#else
#define EXTERN
#endif /*__DeclareGlobalVariableReadRule_h__*/
 
#if defined(AI_USE_SCRIPT)
EXTERN SCR_tdst_Link_Table g_stMacroLinkTable;
EXTERN SCR_tdst_Link_Table g_stComportLinkTable;
EXTERN SCR_tdst_Link_Table g_stModelLinkTable;
EXTERN SCR_tdst_Link_Table g_stDsgVarLinkTable;
EXTERN SCR_tdst_Link_Table g_stDefinesLinkTable;
/*ANNECY CT 22/01/98*/
EXTERN SCR_tdst_Link_Table gs_stLightLinkTable;
/*ENDANNECY CT}*/
#endif /* AI_USE_SCRIPT */
 
void fn_vReadAIDefines(char *szDefineFilename);
 
#define M_DEFINE_NODE(a,b,c)
#include "DefNode.h"
#undef M_DEFINE_NODE
 
/*-------------------------------------------------------------------------------*/
/*                             Macros definition.*/
/*-------------------------------------------------------------------------------*/
#define M_IsScriptAIReference(szWord)   (!stricmp(szWord, C_ScriptAIReferenceString))
 
/* For the AIModel.*/
#define M_IsIntellAIModel(szWord)				(!stricmp(szWord, C_CreateIntellAIModel_String)) 
#define M_IsReflexAIModel(szWord)				(!stricmp(szWord, C_CreateReflexAIModel_String)) 
#define M_IsVariableDeclarationAIModel(szWord)  (!stricmp(szWord, C_CreateVariableDeclarationAIModel_String)) 
#define M_IsMacroAIModel(szWord)				(!stricmp(szWord, C_CreateMacroAIModel_String)) 
 
/* For .DEC (SAI + OTI)*/
#define M_IsTypeSaveVariable(szWord)  (!stricmp(szWord, C_TypeSaveVariables_String)) 
#define M_IsTypeInitVariable(szWord)  (!stricmp(szWord, C_TypeInitVariables_String)) 
 
/* For DEFINES.AI*/
#define M_IsConstantRef(szWord)  (!stricmp(szWord, C_ConstantRefString)) 
#define M_IsRealRef(szWord)		 (!stricmp(szWord, C_RealRefString)) 
 
 
/*-------------------------------------------------------------------------------*/
/*                            Functions definition.*/
/*-------------------------------------------------------------------------------*/
/* cf AI_proto.h*/
 
#endif /*__READRULE_H__*/
/* in order to compile AI in C++ and link with GAM in C*/
#if defined(__cplusplus)
}
#endif 
