/***********************************************************************************************/
/*  File Name   : WPEngDsp.h*/
/*  Goal        : Header file for displaying Waypoints in the 3D Engine*/
/*  Author      : Marc FASCIA*/
/*  Date        : 04/03/98*/
/***********************************************************************************************/
 
#if defined(__cplusplus)
extern "C"
{
#endif
 
#if !defined(__WP_ENGINE_DISPLAY__)
#define __WP_ENGINE_DISPLAY__
 
 
/*
------------------------------------------------------------------------------------------
INCLUDE FILES :
------------------------------------------------------------------------------------------
*/
 
#include "Acp_Base.h"
#include "MTH.h"
#include "POS.h"
#include "GLI.h"
#include "GLD.h"
#include "SPO.h"
 
/***********************************************************************************************/
/*  Name        : WP_SendWaypointsToViewport*/
/*  Description : Displays the Geo Objs for WP*/
/*  Author      : Marc FASCIA*/
/*  Date        : 04/03/98*/
/*  Optimized ? : No*/
/***********************************************************************************************/
void WP_SendWaypointsToViewport( GLD_tdstViewportAttributes * p_stViewport, unsigned long ulDrawMask );
 
 
/*--------------------------------------------------------------
  ---------------------- OLD VERSION ---------------------------
  --------------------------------------------------------------
 
#ifndef HieFriend
#define HieFriend
#endif
#include "SPO.h"
#include "SPO\HieSpObj.h"
 
#include "Acp_Base.h"
#include "MTH.h"
#include "POS.h"
#include "GLI.h"
#include "GLD.h"
 
#define _WP_D_WAYPOINT_FRIEND_
 
// *********************************************************************************************
//  Name        : WP_WPAttachInHierarchy
//  Description : Adds the WP SPO in the SPO hierarchy
// *********************************************************************************************
void WP_WPAttachInHierarchy( HIE_tdstSuperObject * p_stRootSPO );
 
// *********************************************************************************************
//  Name        : WP_WPIsolateFromHierarchy
//  Description : Removes the WP SPO in the SPO hierarchy
// *********************************************************************************************
void WP_WPIsolateFromHierarchy();
 
---------------------------------------------------------
------------- END OF OLD VERSION ------------------------
---------------------------------------------------------*/
 
#if defined(__cplusplus)
}
#endif
 
#endif /* __WP_ENGINE_DISPLAY__*/
 
