/*
------------------------------------------------------------------------------------------
HEADER FILE FOR :
 Prototype of waypoints, links and ways exported functions
------------------------------------------------------------------------------------------
File Name :
 WP_F_nc.h
------------------------------------------------------------------------------------------
Creation :
  * Date : 
   March 14,1997
  * Author : 
   Albert Pais
------------------------------------------------------------------------------------------
Contents :
  defines prototype and functions used for waypoints, links and
  ways
------------------------------------------------------------------------------------------
*/
 
/* in order to compile AI in C++ and link with GAM in C*/
#if defined(__cplusplus)
extern "C"
{
#endif
 
 
#if !defined(ONLY_TYPES)
/*
------------------------------------------------------------------------------------------
WAYPOINT FUNCTIONS DECLARATION:
------------------------------------------------------------------------------------------
*/
#ifdef _WP_D_DEFINE_WAYPOINTS_
 
#if !defined (__WP_WAYPOINTS_FUNCTIONS_PROTOS__)
#define __WP_WAYPOINTS_FUNCTIONS_PROTOS__
 
/****************************************/
#if !defined(CPA_EXPORT)
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/****************************************/
 
/* add reference and release */
CPA_EXPORT void WP_fnv_WayPoint_AddRef(WP_tdhWayPoint);
CPA_EXPORT void WP_fnv_WayPoint_Release(WP_tdhWayPoint);
 
/* retrieve radius : */
CPA_EXPORT MTH_tdxReal WP_fnx_WayPoint_GetRadius(WP_tdhWayPoint);
/* loading waypoints */
 
/* LOL*/
#if defined(AI_USE_SCRIPT)
CPA_EXPORT SCR_tde_Anl_ReturnValue WP_fne_WayPoint_ScriptCallBackLoad(SCR_tdst_File_Description *,char *,char **, SCR_tde_Anl_Action);
CPA_EXPORT SCR_tde_Anl_ReturnValue WP_fne_WayPoint_ScriptSubSectionCallBackLoad(SCR_tdst_File_Description *,char *,char **, SCR_tde_Anl_Action);
CPA_EXPORT SCR_tdst_Link_Value* WP_fnh_WayPoint_GetLoaded(char*);
#endif /* AI_USE_SCRIPT */
 
/* tools */
CPA_EXPORT void WP_fnv_WayPoint_ComputeLocation(WP_tdhWayPoint,MTH3D_tdstVector*);
 
/* LOL*/
#if defined(AI_USE_SCRIPT)
CPA_EXPORT void WP_fnv_WayPoint_InitLinkTable(void);
CPA_EXPORT void WP_fnv_WayPoint_CloseLinkTable(void);
 
CPA_EXPORT SCR_tdst_Link_Table* WP_fnp_WayPoint_GetLinkTable (void);
CPA_EXPORT WP_tdhWayPoint WP_fnh_WayPoint_GetHandleFromLinkTable(SCR_tdst_Link_Value*);
#endif /* AI_USE_SCRIPT */
 
#endif /*__WP_WAYPOINTS_FUNCTIONS_PROTOS__ */
 
#endif /* _WP_D_DEFINE_WAYPOINTS_ */
 
 
#endif /* !ONLY_TYPES */
 
/* in order to compile AI in C++ and link with GAM in C*/
#if defined(__cplusplus)
}
#endif
 
