/*
------------------------------------------------------------------------------------------
HEADER FILE FOR :
 Definitions of waypoints, link and ways handles.
------------------------------------------------------------------------------------------
File Name :
 WP_Handl.h
------------------------------------------------------------------------------------------
Creation :
  * Date : 
    March 15,1997
  * Author : 
    Albert Pais
------------------------------------------------------------------------------------------
Contents :
  Defines waypoints, links and ways handles
  Defines some macro-constants
------------------------------------------------------------------------------------------
*/
/*
Waypoint handle definition :
*/
 
/* in order to compile AI in C++ and link with GAM in C*/
#if defined(__cplusplus)
extern "C"
{
#endif
 
#if defined(_WP_D_DEFINE_WAYPOINTS_)
#if !defined(__WP_WAYPOINT_HANDLE_TYPES__)
#define __WP_WAYPOINT_HANDLE_TYPES__
 
/*ANNECY JMD {*/
typedef struct WP_tdstArc_* WP_tdHandleOfArc;
typedef struct WP_tdstListOfArc_ *WP_tdHandleOfListOfArc ;
typedef struct WP_tdstGraph_ *WP_tdHandleOfGraph;
typedef struct WP_tdstGraphNode_ *WP_tdhGraphNode ;
/*ENDANNECY JMD }*/
 
 
typedef struct WP_tdstWayPoint_* WP_tdhWayPoint;
#define WP_C_hWayPointInvalid ((WP_tdhWayPoint)0)
#define C_SectionWayPointDescription "WayPoint"
#define C_SubSectionIsolateWayPointDescription "Isolate"
#define C_SubSectionInWayWayPointDescription "InWay"
#define C_ScriptWayPointSuffixe "wp"
 
/*ANNECY Bart 19/01/98 {*/
#define C_SectionWPGraphDescription "WPGraph"
#define C_SectionWPSommetDescription "WPSommet"
/*ENDANNECY Bart }*/
 
 
 
#endif /* __WP_WAYPOINT_HANDLE_TYPES__ */
#endif /* _WP_D_DEFINE_WAYPOINTS_ */
 
/*
Link handle definition :
*/
 
#if defined(_WP_D_DEFINE_LINKS_)
 
#if !defined(__WP_LINK_HANDLE_TYPES__)
#define __WP_LINK_HANDLE_TYPES__
 
typedef struct WP_tdstLink_*     WP_tdhLink;
#define WP_C_hLinkInvalid     ((WP_tdhLink)0)
 
#endif /* __WP_LINK_HANDLE_TYPES__ */
#endif /* _WP_D_DEFINE_LINKS_ */
 
 
/* in order to compile AI in C++ and link with GAM in C*/
#if defined(__cplusplus)
}
#endif
