/*///////////////////////////////////////////////////////////*/
/*														   //*/
/*			Management of the Module : AI (Intelligence)   //*/
/*														   //*/
/*///////////////////////////////////////////////////////////*/
/*														   //*/
/* AIOption.h	: Generic compilation options for AI 	   //*/
/*														   //												   //*/
/*///////////////////////////////////////////////////////////*/
 
#if !defined(__AIOPTION_H__)
#define __AIOPTION_H__
 
/* important for external use of Ai files*/
#if defined(ACTIVE_EDITOR) 
	#if !defined(_AI_LIB_)
		#define _AI_LIB_
	#endif
#endif
 
/*
// debug infor for AI
#if defined(_AI_LIB_)
*/
	#if defined(ACTIVE_EDITOR) || ( defined(VISUAL) && defined(_DEBUG) ) 
		#if !defined(__DEBUG_AI__)
			#define __DEBUG_AI__ 
		#endif
	#else /* release without editor*/
		#if !defined(OPTIMIZED_COMMAND)
			#define OPTIMIZED_COMMAND
		#endif
	#endif
 
	/* ai debuger is active with editors*/
	#if defined (ACTIVE_EDITOR) && !defined(ACTIVE_AIDEBUG)
		#define ACTIVE_AIDEBUG   /*** DR ***/
	#endif
 
	/* IA debug errors and warnings*/
	#define __FATAL_ERR_AI__
	#define __WARNING_ERR_AI__
 
	/* script or binary options */
    #define AI_USE_SCRIPT
 
/* OPTIMIZATION FLAGS */
	/* to activate SwapParameters optimizations : it seems to work*/
	#define OPTIMIZE_SWAP_PARAMETER
 
	/* to activate Action table optimizations : not tested yet*/
	#define OPTIMIZE_ACTION_TABLE
 
	/* to activate Nb Nodes optimizations : don't use uwNbNode anymore : it seems to work too*/
	#if !defined(ACTIVE_EDITOR)
		#define OPTIMIZE_NB_NODES
	#endif
/*
#else
	#if !defined(OPTIMIZED_COMMAND)
		#define OPTIMIZED_COMMAND
	#endif
	#if !defined(__DEBUG_AI__)
		#define __DEBUG_AI__ 
	#endif
	#if !defined(AI_USE_SCRIPT)
		#define AI_USE_SCRIPT
	#endif	
#endif
*/
 
#endif /*__AIOPTION_H__*/
