/**************************************
 
	BreakPoints for AI Debugger
 
	header file
 
***************************************/
 
/* To avoid unnecessary includes :  */
#ifndef  __BREAKPOINTS_H
#define __BREAKPOINTS_H
 
 
/**************************************/
#if !defined(CPA_EXPORT)
  #if defined(CPA_WANTS_IMPORT)
    #define CPA_EXPORT __declspec(dllimport)
  #elif defined(CPA_WANTS_EXPORT)
    #define CPA_EXPORT __declspec(dllexport)
  #else
    #define CPA_EXPORT
  #endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/**************************************/
/*#undef extern*/
#define EXTERN_AID extern
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus *
 
 
/* For Global declaration in C files : */
#ifdef AID_GLOBALS
 #define __AID_EXTERN extern
#else /* !AID_GLOBALS */
 #define __AID_EXTERN
#endif /* !AID_GLOBALS */
 
/*
-----------------------------------------------------------------------------
INCLUDES FILES :
Include here any other header files of your module you need !
Ex : 
#include "toto.h"
Note : Do Not include header files from other Modules (do this in C files 
only)
-----------------------------------------------------------------------------
*/
 
 
#if defined(ACTIVE_AIDEBUG)
 
/*
-----------------------------------------------------------------------------
CONSTANT DECLARATION:
Ex :
#define AID_C_LMAX 100
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
TYPES DEFINITION : 
Declare here any type you need, and constant you need to do this :
Ex :    typedef struct AID_tdstToto_
{
 long aLMAX_lBuffer[AID_C_LMAX];
    ...
} AID_tdst_Toto ;
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
GLOBAL VARIABLE DECLARATION :
Ex : 
__AID_EXTERN <type> <variable name>
 #ifdef AID_GLOBALS
 = <initial values>
 #endif
 ;
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
PUBLIC FUNCTIONS DECLARATION:
Ex : 
extern CPA_EXPORT void AID_fn_vMyPublicFunction(void); 
Note : Public functions declaration must be done in PUBLIC HEADER files (.h)
in your Inc directory
-----------------------------------------------------------------------------
*/
 
	EXTERN_AID CPA_EXPORT struct tdstNodeInterpret_ * fn_pstSetValidBreakPoint( tdstNodeInterpret*, tdstScriptAI*, unsigned long );
 
/*
-----------------------------------------------------------------------------
PRIVATE FUNCTIONS DECLARATION: 
Ex : 
extern void AID_fn_vMyPrivateFunction(void); 
Note : Private functions MUST appear ONLY in PRIVATE HEADER files (.h) in 
your Src directory with source files (.c)
-----------------------------------------------------------------------------
*/
 
	ACP_tdxBool fn_bIsBreakableNode( tdstNodeInterpret* );
	tdstTreeInterpret * fn_pstFindTreeWithNode( tdstScriptAI*, unsigned long, tdstNodeInterpret* );
 
 
#endif /*ACTIVE_AIDEBUG*/
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __BREAKPOINTS_H  */
