/************************************************************************************************
* Name: DefFunc1.h                                                                              *
* Use : Macro Definition of functions for AI of Rayman II and Egypte                            *
* Author: Yann Le tensorer, Benoit Germain, Jacques Thenoz, Christophe Giraud                   *
*                                  (c) UBI Simulations Annecy                                   *
************************************************************************************************/
 
#include "FuncRay2.h"
 
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_VitesseHorizontaleDuPerso	,"ACT_VitesseHorizontaleDuPerso"			,"ACT_HorizontalPersoSpeed"    ,"Func_VitesseHorizontaleDuPerso"	,fn_p_stCode4VitesseHorizontaleDuPerso, USE_CONSTANT_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_VitesseVerticaleDuPerso		,"ACT_VitesseVerticaleDuPerso"				,"ACT_VerticalPersoSpeed"      ,"Func_VitesseVerticaleDuPerso"		,fn_p_stCode4VitesseHorizontaleDuPerso, USE_CONSTANT_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_GetPersoZoomFactor			,"ACT_DeformationPerso"						,"ACT_GetPersoZoomFactor"      ,"Func_GetPersoZoomFactor"		,fn_p_st3DFunc,USE_NO_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetPersoSighting			    ,"ACT_ViseePerso"							,"ACT_GetPersoSighting"        ,"Func_GetPersoSighting"		,fn_p_stGetPersoSighting, USE_NO_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetPersoHorizon				    ,"ACT_HorizonPerso"							,"ACT_GetPersoHorizon"         ,"Func_GetPersoHorizon"			,fn_p_st3DFunc, USE_NO_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetPersoBanking				    ,"ACT_AssiettePerso"						,"ACT_GetPersoBanking"         ,"Func_GetPersoBanking"			,fn_p_st3DFunc, USE_NO_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_LitPositionZDM		    		,"ZON_LitPositionZDM"						,"ZON_GetZDMPosition"			,"Func_LitPositionZDM"				,fn_p_stCode4LitPositionZDx,	USE_ZDM_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_LitPositionZDE			    	,"ZON_LitPositionZDE"						,"ZON_GetZDEPosition"			,"Func_LitPositionZDE"				,fn_p_stCode4LitPositionZDx,	USE_ZDE_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitPositionZDD				,"ZON_LitPositionZDD"						,"ZON_GetZDDPosition"			,"Func_LitPositionZDD"				,fn_p_stCode4LitPositionZDx,	USE_ZDD_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitCentreZDM				    ,"ZON_LitCentreZDM"							,"ZON_GetZDMCenter"				,"Func_LitCentreZDM"				,fn_p_stCode4LitCentreZDx,		USE_ZDM_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitCentreZDE				    ,"ZON_LitCentreZDE"							,"ZON_GetZDECenter"				,"Func_LitCentreZDE"				,fn_p_stCode4LitCentreZDx,		USE_ZDE_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_LitCentreZDD				    ,"ZON_LitCentreZDD"							,"ZON_GetZDDCenter"				,"Func_LitCentreZDD"				,fn_p_stCode4LitCentreZDx,		USE_ZDD_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitAxeZDM					,"ZON_LitAxeZDM"							,"ZON_GetZDMAxis"				,"Func_LitAxeZDM"					,fn_p_stCode4LitAxeZDx,			USE_ZDM_PERSO_PARAM		USE_BOOLEAN_PARAM,	USE_VECTOR_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitAxeZDE					,"ZON_LitAxeZDE"							,"ZON_GetZDEAxis"				,"Func_LitAxeZDE"					,fn_p_stCode4LitAxeZDx,			USE_ZDE_PERSO_PARAM		USE_BOOLEAN_PARAM,	USE_VECTOR_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitAxeZDD					,"ZON_LitAxeZDD"							,"ZON_GetZDDAxis"				,"Func_LitAxeZDD"					,fn_p_stCode4LitAxeZDx,			USE_ZDD_PERSO_PARAM		USE_BOOLEAN_PARAM,	USE_VECTOR_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_LitDimensionZDM				    ,"ZON_LitDimensionZDM"						,"ZON_GetZDMDimension"			,"Func_LitDimensionZDM"				,fn_p_stCode4LitDimensionZDx,	USE_ZDM_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitDimensionZDE				,"ZON_LitDimensionZDE"						,"ZON_GetZDEDimension"			,"Func_LitDimensionZDE"				,fn_p_stCode4LitDimensionZDx,	USE_ZDE_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_LitDimensionZDD				    ,"ZON_LitDimensionZDD"						,"ZON_GetZDDDimension"			,"Func_LitDimensionZDD"				,fn_p_stCode4LitDimensionZDx,	USE_ZDD_PERSO_PARAM,	USE_VECTOR_PARAM,	ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_VecteurPointAxe				,"VEC_VecteurPointAxe"						,"VEC_PointAxisVector"				,"Func_VecteurPointAxe"				,fn_p_stCode4VecteurPointAxe, USE_VECTOR_PARAM USE_VECTOR_PARAM USE_VECTOR_PARAM, USE_VECTOR_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_VecteurPointSegment				,"VEC_VecteurPointSegment"					,"VEC_PointSegmentVector"			,"Func_VecteurPointSegment"			,fn_p_stCode4VecteurPointAxe, USE_VECTOR_PARAM USE_VECTOR_PARAM USE_VECTOR_PARAM, USE_VECTOR_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_VectorContribution		    	,"VEC_ContributionVecteur"					,"VEC_VectorContribution"			,"Func_VectorContribution"			,fn_p_stVectorFunction, USE_VECTOR_PARAM USE_VECTOR_PARAM, USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/) /*this function is in Function.c*/
	M_DEFINE_FUNCTION(eFunc_VectorCombination			    ,"VEC_CombinaisonVecteur"					,"VEC_VectorCombination"			,"Func_VectorCombination"			,fn_p_stVectorFunction, USE_VECTOR_PARAM USE_REAL_PARAM USE_VECTOR_PARAM, USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/) /*this function is in Function.c*/
	M_DEFINE_FUNCTION(eFunc_TemporalVectorCombination		,"VEC_CombinaisonTemporelleVecteur"			,"VEC_TemporalVectorCombination"	,"Func_TemporalVectorCombination"	,fn_p_stVectorFunction, USE_VECTOR_PARAM USE_REAL_PARAM USE_VECTOR_PARAM, USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/) /*this function is in Function.c*/
	M_DEFINE_FUNCTION(eFunc_ScaledVector				    ,"VEC_MulVecteurScalaire"					,"VEC_ScaledVector"					,"Func_ScaledVector"				,fn_p_stVectorFunction, USE_VECTOR_PARAM USE_REAL_PARAM, USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/) /*this function is in Function.c*/
	M_DEFINE_FUNCTION(eFunc_GetVectorNorm				    ,"VEC_VecteurNorme"							,"VEC_GetVectorNorm"				,"Func_GetVectorNorm"				,fn_p_stVectorFunction,USE_VECTOR_PARAM,USE_REAL_PARAM, /**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_FUNCTION(eFunc_RotateVector					,"VEC_TourneVecteur"						,"VEC_RotateVector"					,"Func_RotateVector"				,fn_p_stVectorFunction,USE_VECTOR_PARAM USE_REAL_PARAM USE_VECTOR_PARAM,USE_VECTOR_PARAM ,NOT_ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_VectorAngle					    ,"VEC_VecteurAngle"							,"VEC_AngleVector"					,"Func_VecteurAngle"				,fn_p_stVectorAndAngle,USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM,USE_REAL_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_VectorCos					    ,"VEC_VecteurCos"							,"VEC_CosVector"					,"Func_VecteurCos"					,fn_p_stVectorAndAngle,USE_VECTOR_PARAM USE_VECTOR_PARAM,USE_REAL_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_FUNCTION(eFunc_VectorSin					,"VEC_VecteurSin"							,"VEC_SinVector"					,"Func_VecteurSin"					,fn_p_stVectorAndAngle,USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM,USE_REAL_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetNormalCollideVector  		,"COL_VecteurNormalCollision"				,"COL_GetNormalCollideVector"      ,"Func_GetNormalCollideVector"		,fn_p_stGetNormalCollideVector,USE_NO_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetNormalCollideVector2	    	,"COL_VecteurNormalCollision2"				,"COL_GetNormalCollideVector2"     ,"Func_GetNormalCollideVector2"		,fn_p_stGetNormalCollideVector,USE_CONSTANT_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetCollidePoint				    ,"COL_LitPointCollision"					,"COL_GetCollidePoint"             ,"Func_GetCollidePoint"				,fn_p_stGetCollidePoint,USE_NO_PARAM,USE_VECTOR_PARAM,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_GetCollidePoint2				,"COL_LitPointCollision2"					,"COL_GetCollidePoint2"            ,"Func_GetCollidePoint2"	    	    ,fn_p_stGetCollidePoint,USE_CONSTANT_PARAM,USE_VECTOR_PARAM,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_GetHandsCollidePoint	    	,"COL_LitPointCollisionMains"				,"COL_GetHandsCollidePoint"        ,"Func_GetHandsCollidePoint"		    ,fn_p_stGetCollidePoint,USE_NO_PARAM,USE_VECTOR_PARAM,ULTRA_ABLE)
	NU_M_DEFINE_FUNCTION(eFunc_GetCollideRate				,"COL_LitTauxDePenetrationCollision"		,"COL_GetCollideRate"              ,"eFunc_GetCollideRate"	    		,fn_p_stGetCollidePoint,USE_NO_PARAM,USE_REAL_PARAM,ULTRA_ABLE)
	NU_M_DEFINE_FUNCTION(eFunc_GetCollideRate2				,"COL_LitTauxDePenetrationCollision2"		,"COL_GetCollideRate2"             ,"Func_GetCollideRate2"	        	,fn_p_stGetCollidePoint,USE_CONSTANT_PARAM,USE_REAL_PARAM,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_GetCollideMaterialType          ,"COL_LitTypeMateriauCollision"		        ,"COL_GetCollideMaterialType"      ,"Func_GetCollideMaterialType"		,fn_p_stGetCollidePoint,USE_NO_PARAM,USE_MASK_PARAM,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_GetCollideMaterialType2         ,"COL_LitTypeMateriauCollision2"		    ,"COL_GetCollideMaterialType2"     ,"eFunc_GetCollideMaterialType2"	    ,fn_p_stGetCollidePoint,USE_CONSTANT_PARAM,USE_MASK_PARAM,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetCollisionPoint		    	,"COL_PointCollision"						,"COL_CollisionPoint"              ,"Func_CollisionPoint"				,fn_p_stGetCollision,USE_VECTOR_PARAM USE_VECTOR_PARAM C_LONG_PARAM,USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetCollisionVector			    ,"COL_NormaleCollision"						,"COL_CollisionNormalVector"       ,"Func_CollisionNormalVector"		,fn_p_stGetCollision,USE_VECTOR_PARAM USE_VECTOR_PARAM C_LONG_PARAM, USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetCollisionPerso			,"COL_PersoCollisionne"						,"COL_PersoCollisionne"            ,"Func_PersoCollisionne"			    ,fn_p_stGetCollision,USE_VECTOR_PARAM USE_VECTOR_PARAM C_LONG_PARAM, USE_PERSO_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetCollisionPointMaterial	    ,"COL_PointCollisionAvecMateriau"			,"COL_CollisionPointMaterial"      ,"Func_CollisionPointMaterial"		,fn_p_stGetCollisionWithCollideMaterial,USE_VECTOR_PARAM USE_VECTOR_PARAM C_LONG_PARAM USE_MASK_PARAM,USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	/* GMT functions */
	NU_M_DEFINE_FUNCTION(eFunc_GetLastTraversedMaterialType ,"COL_TypeDernierMateriauTraverse"			,"COL_GetLastTraversedMaterialType","Func_GetLastTraversedMaterialType" ,fn_p_stGameMaterialFunction  ,USE_NO_PARAM,USE_MASK_PARAM,/**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_FUNCTION(eFunc_GetLastTraversedMaterial	    ,"COL_DernierMateriauTraverse"				,"COL_GetLastTraversedMaterial"    ,"Func_GetLastTraversedMaterial"	    ,fn_p_stGameMaterialFunction  ,USE_NO_PARAM,USE_GMT_PARAM,/**/ ULTRA_ABLE /**/ )
    NU_M_DEFINE_FUNCTION(eFunc_GetCurrentCollidedGMT		,"LitGMTCourant"							,"COL_GetCurrentCollidedGMT"       ,"Func_GetCurrentCollidedGMT"		,fn_p_stGameMaterialFunction  ,USE_NO_PARAM,USE_GMT_PARAM,/**/ ULTRA_ABLE /**/ )
	/* collision communication management : NOT ULTRA, because only the executed actor can read his information */
	M_DEFINE_FUNCTION(eFunc_GetColliderType				    ,"COL_LitTypeDeCollisionneur"			    ,"COL_GetColliderType"             ,"Func_GetColliderType"				,fn_p_stCollideCommunicationFunc, USE_NO_PARAM, USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetColliderVector			    ,"COL_LitVecteurDeCollisionneur"			,"COL_GetColliderVector"           ,"Func_GetColliderVector"			,fn_p_stCollideCommunicationFunc, USE_CONSTANT_PARAM, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetColliderReal				    ,"COL_LitReelDeCollisionneur"				,"COL_GetColliderReal"             ,"Func_GetColliderReal"				,fn_p_stCollideCommunicationFunc, USE_CONSTANT_PARAM, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetLastCollisionActor		    ,"COL_LitDernierPersoCollisione"		    ,"COL_LitDernierPersoCollisione"   ,"Func_LitDernierPersoCollisione"	,fn_p_stGetLastCollisionActor,USE_PERSO_PARAM,USE_PERSO_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_ComputeRebondVector			    ,"COL_CalculVecteurRebond"				    ,"COL_CalculVecteurRebond"         ,"Func_CalculVecteurRebond"			,fn_p_stComputeRebondVector,USE_VECTOR_PARAM USE_VECTOR_PARAM USE_REAL_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
/* position management : ULTRA */
	M_DEFINE_FUNCTION(eFunc_GetModuleAbsolutePosition	    ,"MOD_PositionAbsolueModule"				,"MOD_GetModuleAbsolutePosition"   ,"Func_GetModuleAbsolutePosition"	,fn_p_st3DFunc,USE_MODULE_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetModuleRelativePosition	    ,"MOD_PositionRelativeModule"				,"MOD_GetModuleRelativePosition"   ,"Func_GetModuleRelativePosition"	,fn_p_st3DFunc,USE_MODULE_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_FUNCTION(eFunc_GetModuleZoomFactor		    ,"MOD_DeformationModule"					,"MOD_GetModuleZoomFactor"         ,"Func_GetModuleZoomFactor"			,fn_p_st3DFunc,USE_MODULE_PARAM,USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetModuleSighting			    ,"MOD_ViseeModule"							,"MOD_GetModuleSighting"           ,"Func_GetModuleSighting"			,fn_p_st3DFunc, USE_MODULE_PARAM USE_BOOLEAN_PARAM, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_CastIntegerToChannel		    ,"MOD_ConversionEnModule"					,"MOD_CastIntegerToChannel"        ,"Func_CastIntegerToChannel"			,fn_p_stMiscFunction,  USE_CONSTANT_PARAM, USE_MODULE_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
/* names and strings management */
	M_DEFINE_FUNCTION(eFunc_GetSlotDate				    ,"TEXT_LitDateDuSlot"						,"TEXT_GetSlotDate"                ,"Func_GetSlotDate"					,fn_p_stNamesFunc,USE_CONSTANT_PARAM,USE_STRING_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetSlotName					    ,"TEXT_LitNomDuSlot"						,"TEXT_GetSlotName"                ,"Func_GetSlotName"					,fn_p_stNamesFunc,USE_CONSTANT_PARAM,USE_STRING_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetSlotScore				    ,"TEXT_LitScoreDuSlot"						,"TEXT_GetSlotScore"               ,"Func_GetSlotScore"					,fn_p_stNamesFunc,USE_CONSTANT_PARAM,USE_STRING_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetStringCharAt				    ,"TEXT_LettreDuTexteALaPosition"			,"TEXT_GetStringCharAt"            ,"Func_GetStringCharAt"				,fn_p_stNamesFunc,USE_STRING_PARAM USE_CONSTANT_PARAM,USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_FUNCTION(eFunc_GetFormattedTextInfo			,"TEXT_LitInfoSurTexteFormate"				,"TEXT_GetFormattedTextInfo"       ,"Func_GetFormattedTextInfo"		    ,fn_p_stNamesFunc,USE_STRING_PARAM USE_REAL_PARAM USE_ADDR_ARRAY_PARAM USE_ADDR_ARRAY_PARAM USE_ADDR_ARRAY_PARAM USE_CONSTANT_PARAM,USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_FUNCTION(eFunc_GetInputEntryName			,"TEXT_LitNomDeLaTouche"					,"TEXT_GetInputEntryName"          ,"Func_GetInputEntryName"			,fn_p_stNamesFunc,USE_BUTTON_PARAM, USE_STRING_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetMechanicGravityFactor	    ,"MEC_LitGravite"							,"MEC_GetGravityFactor"            ,"Proc_GetMechanicGravityFactor"	    ,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicSlide			    ,"MEC_LitGlissement"						,"MEC_GetSlide"                    ,"Proc_GetMechanicSlide"			    ,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicRebound			,"MEC_LitRebond"							,"MEC_GetRebound"                  ,"Proc_GetMechanicRebound"			,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicSlopeLimit		,"MEC_LitLimitePente"						,"MEC_GetSlopeLimit"               ,"Proc_GetMechanicSlopeLimit"		,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicInertiaX			,"MEC_LitInertieX"							,"MEC_GetInertiaX"                 ,"Proc_GetMechanicInertiaX"			,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicInertiaY			,"MEC_LitInertieY"							,"MEC_GetInertiaY"                 ,"Proc_GetMechanicInertiaY"			,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicInertiaZ			,"MEC_LitInertieZ"							,"MEC_GetInertiaZ"                 ,"Proc_GetMechanicInertiaZ"			,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicTiltIntensity	    ,"MEC_LitIntensiteTilt"						,"MEC_GetTiltIntensity"            ,"Proc_GetMechanicTiltIntensity"	    ,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicTiltInertia		,"MEC_LitInertieTilt"						,"MEC_GetTiltInertia"              ,"Proc_GetMechanicTiltInertia"		,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicTiltOrigin		,"MEC_LitOrigineTilt"						,"MEC_GetTiltOrigin"               ,"Proc_GetMechanicTiltOrigin"		,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicMaxSpeed			,"MEC_LitVitesseMax"						,"MEC_GetMaxSpeed"                 ,"Proc_GetMechanicMaxSpeed"			,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_VECTOR_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicStreamPriority	,"MEC_LitPrioriteFlux"						,"MEC_GetStreamPriority"           ,"Proc_GetMechanicStreamPriority"	,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicStreamSpeed		,"MEC_LitVitesseFlux"						,"MEC_GetStreamSpeed"              ,"Proc_GetMechanicStreamSpeed"		,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_VECTOR_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetMechanicStreamFactor		,"MEC_LitFacteurDeFlux"						,"MEC_GetStreamFactor"             ,"Proc_GetMechanicStreamFactor"		,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
/* slide coef */
	NU_M_DEFINE_FUNCTION(eFunc_GetSlideFactorX				,"MEC_LitCoefDeGlisseX"						,"MEC_GetSlideFactorX"             ,"Proc_GetSlideFactorX"				,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetSlideFactorY				,"MEC_LitCoefDeGlisseY"						,"MEC_GetSlideFactorY"             ,"Proc_GetSlideFactorY"				,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetSlideFactorZ				,"MEC_LitCoefDeGlisseZ"						,"MEC_GetSlideFactorZ"             ,"Proc_GetSlideFactorZ"				,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_REAL_PARAM, ULTRA_ABLE )
    M_DEFINE_FUNCTION(eFunc_JumpImpulsion				    ,"MEC_ImpulsionSaut"						,"MEC_JumpImpulsion"               ,"Proc_JumpImpulsion"				,fn_p_ComputeJumpImpulsion, USE_VECTOR_PARAM USE_VECTOR_PARAM USE_REAL_PARAM, USE_VECTOR_PARAM, ULTRA_ABLE )
    /* anim speed */
	M_DEFINE_FUNCTION(eFunc_GetSpeedAnim				    ,"MEC_LitVitesseAnimation"					,"MEC_GetSpeedAnim"                ,"Proc_GetSpeedAnim"				    ,fn_p_GetMechanicParameter, USE_NO_PARAM, USE_VECTOR_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
 /* Hierarchy - Platform */
	M_DEFINE_FUNCTION(eFunc_HierGetFather				    ,"HIER_MonPere"								,"HIER_GetFather"                  ,"proc_HIERGetFather"				,fn_p_GetHierarchyLink, USE_NO_PARAM, USE_PERSO_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
 /* Zone Activation Privileged */
    NU_M_DEFINE_FUNCTION(eFunc_GetActivationZDD 			,"ZON_LitActivationZDD" 					,"ZON_GetZDDActivation"            ,"Func_LitActivationZDD"			    ,fn_p_GetPriviligedActivationZdx,	USE_ZDD_PERSO_PARAM, USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
    NU_M_DEFINE_FUNCTION(eFunc_GetActivationZDM	    		,"ZON_LitActivationZDM"	    				,"ZON_GetZDMActivation"            ,"Func_LitActivationZDM"			    ,fn_p_GetPriviligedActivationZdx,	USE_ZDM_PERSO_PARAM, USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
    NU_M_DEFINE_FUNCTION(eFunc_GetActivationZDE		    	,"ZON_LitActivationZDE"		    			,"ZON_GetZDEActivation"            ,"Func_LitActivationZDE"			    ,fn_p_GetPriviligedActivationZdx,	USE_ZDE_PERSO_PARAM, USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
    NU_M_DEFINE_FUNCTION(eFunc_GetActivationZDR			    ,"ZON_LitActivationZDR"			    		,"ZON_GetZDRActivation"            ,"Func_LitActivationZDR"			    ,fn_p_GetPriviligedActivationZdx,	USE_ZDR_PERSO_PARAM, USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
/* Computing collision frequency */
/* Computing Brain frequency */
/* Computing Light frequency */
    NU_M_DEFINE_FUNCTION(eFunc_GetCollisionFrequency		,"ACT_LitFrequenceCalculCollisions"         ,"ACT_GetCollComputationFrequency"     ,"Func_GetCollComputationFrequency"		,fn_p_GetComputationFrequency, USE_NO_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
    M_DEFINE_FUNCTION(eFunc_GetBrainFrequency			,"ACT_LitFrequenceCalculIA"					,"ACT_GetBrainComputationFrequency"    ,"Func_GetBrainComputationFrequency"		,fn_p_GetComputationFrequency, USE_NO_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
    NU_M_DEFINE_FUNCTION(eFunc_GetLightFrequency			,"ACT_LitFrequenceCalculLumieres"			,"ACT_GetLightComputationFrequency"    ,"Func_GetLightComputationFrequency"		,fn_p_GetComputationFrequency, USE_NO_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetBooleanInArray			    ,"ACT_LitBooleenDansTableau"		        ,"ACT_GetBooleanInArray"           ,"Func_GetBooleanInArray"	    	,fn_p_GetBooleanInArray		,USE_ADDR_ARRAY_PARAM USE_CONSTANT_PARAM, USE_BOOLEAN_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetNumberOfBooleanInArray       ,"ACT_LitNombreDeBooleensDansTableau"       ,"ACT_GetNumberOfBooleanInArray"   ,"Func_GetNumberOfBooleanInArray"    ,fn_p_GetBooleanInArray  ,USE_ADDR_ARRAY_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_GetButtonName				    ,"BUT_GetButtonName"        				,"BUT_GetButtonName"               ,"Func_GetButtonName"        		,fn_p_stGetButtonName		,USE_BUTTON_PARAM, USE_STRING_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
#if (!defined U64)
	NU_M_DEFINE_FUNCTION(eFunc_GetDriversAvailable			    ,"VID_GetDriversAvailable"		        	,"VID_GetDriversAvailable"         ,"Func_GetDriversAvailable"	        ,fn_p_stGetDriversAvailable	,USE_NO_PARAM, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
#else
	NU_M_DEFINE_FUNCTION(eFunc_GetDriversAvailable				,"VID_GetDriversAvailable"					,"VID_GetDriversAvailable"		   ,"Func_GetDriversAvailable"			,fn_p_stDummyFunction		,USE_NO_PARAM, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
#endif /* U64*/
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetCurrentLanguageId			,"TEXT_GetCurrentLanguageId"	            ,"TEXT_GetCurrentLanguageId"       ,"Func_GetCurrentLanguageId"	        ,fn_p_stGetCurrentLanguageId	,USE_NO_PARAM		,USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_GetNbLanguages					,"TEXT_GetNbLanguages"			            ,"TEXT_GetNbLanguages"             ,"Func_GetNbLanguages"			    ,fn_p_stGetNbLanguages			,USE_NO_PARAM		,USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_GetLanguageText					,"TEXT_GetLanguageText"			            ,"TEXT_GetLanguageText"            ,"Func_GetLanguageText"	            ,fn_p_stGetLanguageText			,USE_CONSTANT_PARAM	,USE_STRING_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_TextToInt						,"TEXT_TexteEnEntier"			            ,"TEXT_TextToInt"                  ,"Func_TextToInt"			        ,fn_p_stTextToInt					,USE_STRING_PARAM	,USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetMusicVolume					,"Option_GetVolumeMusical"		            ,"OPTION_GetMusicVolume"           ,"Func_GetMusicVolume"		        ,fn_p_stOptionRecupererFunc			,USE_NO_PARAM		,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetSfxVolume					,"Option_GetVolumeEffets"		            ,"OPTION_GetSfxVolume"             ,"Func_GetSfxVolume"	                ,fn_p_stOptionRecupererFunc			,USE_NO_PARAM		,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_SlotIsValid						,"Option_SlotIsValid"			            ,"OPTION_SlotIsValid"              ,"Func_SlotIsValid"			        ,fn_p_stOptionSlotIsValid			,USE_CONSTANT_PARAM		,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_NbAvailableResolution			,"VID_NbAvailableResolution"	            ,"VID_NbAvailableResolution"       ,"Func_NbAvailableResolution"        ,fn_p_stGetNbAvailableResolution	,USE_NO_PARAM		,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_CurrentResolution				,"VID_CurrentResolution"		            ,"VID_CurrentResolution"           ,"Func_CurrentResolution"	        ,fn_p_stGetCurrentResolution		,USE_NO_PARAM		,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetBrightness					,"VID_GetBrightness"			            ,"VID_GetBrightness"               ,"Func_GetBrightness"		        ,fn_p_stGetBrightness				,USE_NO_PARAM		,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_NameResolution					,"VID_NameResolution"			            ,"VID_NameResolution"              ,"Func_NameResolution"		        ,fn_p_stGetNameResolution			,USE_CONSTANT_PARAM	,USE_STRING_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetNbSlotsAvailable				,"OPTION_GetNbSlotsAvailable"			    ,"OPTION_GetNbSlotsAvailable"       ,"Func_GetNbSlotsAvailable"			,fn_p_stGetNbSlotsAvailable			,USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_FUNCTION(eFunc_GetTextureFiltering				,"VID_GetTextureFiltering"					,"VID_GetTextureFiltering"		    ,"Func_GetTextureFiltering"			,fn_p_stGetVideoOptions				,USE_NO_PARAM		,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_FUNCTION(eFunc_GetAntiAliasing					,"VID_GetAntiAliasing"						,"VID_GetAntiAliasing"			    ,"Func_GetAntiAliasing"				,fn_p_stGetVideoOptions				,USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_GetSaturationDistance			,"ACT_LitDistanceDeSaturation"			    ,"ACT_GetSaturationDistance"       ,"Func_GetSaturationDistance"		,fn_p_stGetMSSoundValues			,USE_NO_PARAM		,USE_CONSTANT_PARAM		,ULTRA_ABLE)
	NU_M_DEFINE_FUNCTION(eFunc_GetBackgroundDistance			,"ACT_LitDistanceDeBackground"			    ,"ACT_GetBackGroundDistance"       ,"Func_GetBackGroundDistance"		,fn_p_stGetMSSoundValues			,USE_NO_PARAM		,USE_CONSTANT_PARAM		,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetTooFarLimit					,"ACT_LitLimiteEloignement"					,"ACT_GetTooFarLimit"				,"Func_GetTooFarLimit"				,fn_p_stGetStdGameLimit				,USE_NO_PARAM		,USE_CONSTANT_PARAM		,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_GetTransparencyZoneMin			,"ACT_LitZoneMinTransparence"				,"ACT_GetTransparencyZoneMin"		,"Func_GetTransparencyZoneMin"		,fn_p_stGetStdGameLimit				,USE_NO_PARAM		,USE_CONSTANT_PARAM		,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_GetTransparencyZoneMax			,"ACT_LitZoneMaxTransparence"				,"ACT_GetTransparencyZoneMax"		,"Func_GetTransparencyZoneMax"		,fn_p_stGetStdGameLimit				,USE_NO_PARAM		,USE_CONSTANT_PARAM		,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
/* ANNECY MT - 30/03/99 { PC Protection Code */
#if (!defined U64)
	M_DEFINE_FUNCTION(eFunc_ExecuteVariable					,"PRO_ExecuteVariable"		                ,"PRO_ExecuteVariable"				,"Func_ExecuteVariable"				,fn_p_ExecuteVariable				,USE_ADDR_ARRAY_PARAM USE_ADDR_ARRAY_PARAM USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ComputeProtectKey				,"ACT_CalculeClefProtection"				,"ACT_ComputeProtectKey"			,"Func_ComputeProtectKey"			,fn_p_stComputeProtectKey			,USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_Xor								,"MATH_Xor"									,"MATH_Xor"							,"Func_Xor"							,fn_p_stComputeXor					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
/* ANNECY OA - 26/08/99 { */
	M_DEFINE_FUNCTION(eFunc_And								,"MATH_And"									,"MATH_And"							,"MATH_And"							,fn_p_stComputeXor					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_Or								,"MATH_Or"									,"MATH_Or"							,"Func_Or"							,fn_p_stComputeXor					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_Not								,"MATH_Not"									,"MATH_Not"							,"Func_Not"							,fn_p_stComputeNot					,USE_CONSTANT_PARAM						,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
/* END ANNECY OA } */
	M_DEFINE_FUNCTION(eFunc_DivUnsigned						,"MATH_DivU"								,"MATH_DivU"						,"Func_DivU"						,fn_p_stComputeXor					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_MulUnsigned						,"MATH_MulU"								,"MATH_MulU"						,"Func_MulU"						,fn_p_stComputeXor					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_AddUnsigned						,"MATH_AddU"								,"MATH_AddU"						,"Func_AddU"						,fn_p_stComputeXor					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_SubUnsigned						,"MATH_SubU"								,"MATH_SubU"						,"Func_SubU"						,fn_p_stComputeXor					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetMemoryValue					,"MATH_ValeurMemoire"						,"MATH_MemoryValue"					,"Func_MemoryValue"					,fn_p_stComputeXor					,USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
#else
    M_DEFINE_FUNCTION(eFunc_ExecuteVariable					,"PRO_ExecuteVariable"						,"PRO_ExecuteVariable"				,"Func_ExecuteVariable"				,fn_p_stDummyFunction				,USE_ADDR_ARRAY_PARAM USE_ADDR_ARRAY_PARAM USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ComputeProtectKey				,"ACT_CalculeClefProtection"				,"ACT_ComputeProtectKey"			,"Func_ComputeProtectKey"			,fn_p_stDummyFunction				,USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_Xor								,"MATH_Xor"									,"MATH_Xor"							,"Func_Xor"							,fn_p_stDummyFunction				,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
/* ANNECY OA - 26/08/99 { */
	M_DEFINE_FUNCTION(eFunc_And								,"MATH_And"									,"MATH_And"							,"MATH_And"							,fn_p_stDummyFunction					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_Or								,"MATH_Or"									,"MATH_Or"							,"Func_Or"							,fn_p_stDummyFunction					,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_Not								,"MATH_Not"									,"MATH_Not"							,"Func_Not"							,fn_p_stDummyFunction					,USE_CONSTANT_PARAM						,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
/* END ANNECY OA } */
	M_DEFINE_FUNCTION(eFunc_DivUnsigned						,"MATH_DivU"								,"MATH_DivU"						,"Func_DivU"						,fn_p_stDummyFunction				,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_MulUnsigned						,"MATH_MulU"								,"MATH_MulU"						,"Func_MulU"						,fn_p_stDummyFunction				,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_AddUnsigned						,"MATH_AddU"								,"MATH_AddU"						,"Func_AddU"						,fn_p_stDummyFunction				,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_SubUnsigned						,"MATH_SubU"								,"MATH_SubU"						,"Func_SubU"						,fn_p_stDummyFunction				,USE_CONSTANT_PARAM	USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetMemoryValue					,"MATH_ValeurMemoire"						,"MATH_MemoryValue"					,"Func_MemoryValue"					,fn_p_stDummyFunction				,USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
#endif /* U64 */
	M_DEFINE_FUNCTION(eFunc_GetCheats					,"FUNC_GetCheats"						,"FUNC_GetCheats"					,"Func_GetCheats"					,fn_GetCheatFlags				,USE_CONSTANT_PARAM	,USE_CONSTANT_PARAM		,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_FUNCTION(eFunc_GetBacklight,				"FUNC_GetBacklight",					"FUNC_GetBacklight",				"Func_GetBacklight",				fn_GetBacklight,				USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE)

	M_DEFINE_FUNCTION(eFunc_DoneAnalogCalibration,		"FUNC_DoneAnalogCalibration",				"FUNC_DoneAnalogCalibration",			"Func_DoneAnalogCalibration",			fn_DoneAnalogCalibration,			USE_NO_PARAM, USE_BOOLEAN_PARAM, NOT_ULTRA_ABLE)

/* END ANNECY MT } */
