/************************************************************************************************
* Name: DefProc1.h                                                                              *
* Use : Macro Definition of procedure for AI of Rayman II and Egypte                            *
* Author: Jacques Thnoz                                                                        *
*                                  (c) UBI Simulations Annecy                                   *
************************************************************************************************/
 
 
/**********************************************************************************************************************************************************************************************************************************************************/
/* Option procedures */
	NU_M_DEFINE_PROCEDURE(eProc_OptionChangeDetailsValue	    ,"Option_ChangeNiveauDeDetails"					,"OPTION_ChangeDetailsValue"                    ,"Proc_OptionChangeDetailsValue"        ,fn_p_stOptionChangerProc, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_OptionChangeMusicVolume		    ,"Option_ChangeVolumeMusical"					,"OPTION_ChangeMusicVolume"                     ,"Proc_OptionChangeMusicVolume"         ,fn_p_stOptionChangerProc, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_OptionChangeSfxVolume			    ,"Option_ChangeVolumeEffets"					,"OPTION_ChangeSfxVolume"                       ,"Proc_OptionChangeSfxVolume"           ,fn_p_stOptionChangerProc, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_OptionChangeVoiceVolume		    ,"Option_ChangeVolumeVoix"						,"OPTION_ChangeVoiceVolume"                     ,"Proc_OptionChangeVoiceVolume"         ,fn_p_stOptionChangerProc, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_OptionChangeActionKey			,"Option_ChangeConfigDeTouche"					,"OPTION_ChangeActionKey"                   ,"Proc_OptionChangeActionKey"		    ,fn_p_stOptionChangerProc, USE_BUTTON_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_OptionConfigureKey					,"Option_ConfigureTouche"					,"OPTION_ConfigureKey"								,"Proc_ConfigureKey"					,fn_p_stOptionChangerProc, USE_BUTTON_PARAM USE_BUTTON_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
/* 3D procedures */
	M_DEFINE_PROCEDURE(eProc_SetPersoAbsolutePosition	    	,"ACT_ChangePositionAbsoluePerso"				,"ACT_SetPersoAbsolutePosition"                 ,"Proc_SetPersoAbsolutePosition"        ,fn_p_st3DProc, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetPersoAtModulePosition		    ,"ACT_PlaceSurModuleDePerso"					,"ACT_SetPersoAtModulePosition"                 ,"Proc_SetPersoAtModulePosition"        ,fn_p_st3DProc, USE_PERSO_PARAM USE_MODULE_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ForcePersoAveragePosition		    ,"ACT_ForcePositionMoyennePerso"				,"ACT_ForcePersoAveragePosition"                ,"Proc_ForcePersoAveragePosition"       ,fn_p_stDynamProcedure, USE_NO_PARAM, /**/ ULTRA_ABLE /**/) /*dans procedur.c*/
	M_DEFINE_PROCEDURE(eProc_RelativeMovePerso				    ,"ACT_DeplacePerso"								,"ACT_RelativeMovePerso"                        ,"Proc_RelativeMovePerso"               ,fn_p_st3DProc, USE_VECTOR_PARAM USE_BOOLEAN_PARAM, /**/ ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_ChangePersoAnySighting			    ,"ACT_ChangeViseeQuelconquePerso"				,"ACT_SetPersoAnySighting"                      ,"Proc_ChangePersoAnySighting"          ,fn_p_st3DProc, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_ChangePersoSightingWithOffset	    ,"ACT_ChangeViseePersoAvecOffset"				,"ACT_SetPersoSightingWithOffset"               ,"Proc_ChangePersoSightingWithOffset"   ,fn_p_st3DProc, USE_VECTOR_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotatePersoAroundX				    ,"ACT_TournePersoAutourDeX"						,"ACT_RotatePersoAroundX"                       ,"Proc_RotatePersoAroundX"              ,fn_p_st3DProc, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotatePersoAroundY				    ,"ACT_TournePersoAutourDeY"						,"ACT_RotatePersoAroundY"                       ,"Proc_RotatePersoAroundY"              ,fn_p_st3DProc, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotatePersoAroundZ				    ,"ACT_TournePersoAutourDeZ"						,"ACT_RotatePersoAroundZ"                       ,"Proc_RotatePersoAroundZ"              ,fn_p_st3DProc, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotatePersoAroundVector		    ,"ACT_TournePersoAutourDeVecteur"				,"ACT_RotatePersoAroundVector"                  ,"Proc_RotatePersoAroundVector"         ,fn_p_st3DProc, USE_VECTOR_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_RotatePersoAroundVectorWithOffset  ,"ACT_TournePersoAutourDeVecteurAvecOffset"     ,"ACT_RotatePersoAroundVectorOffset"            ,"Proc_RotatePersoAroundVectorWithOffset"   ,fn_p_st3DProc, USE_VECTOR_PARAM USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_RotatePersoAroundXwithOffset	    ,"ACT_TournePersoAutourDeXavecOffset"			,"ACT_RotatePersoAroundXwithOffset"             ,"Proc_RotatePersoAroundXwithOffset"    ,fn_p_st3DProc, USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotatePersoAroundYwithOffset	,"ACT_TournePersoAutourDeYavecOffset"			,"ACT_RotatePersoAroundYwithOffset"             ,"Proc_RotatePersoAroundYwithOffset"    ,fn_p_st3DProc, USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotatePersoAroundZwithOffset	    ,"ACT_TournePersoAutourDeZavecOffset"			,"ACT_RotatePersoAroundZwithOffset"             ,"Proc_RotatePersoAroundZwithOffset"    ,fn_p_st3DProc, USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetFullPersoOrientation	        ,"ACT_ReorientePerso"			                ,"ACT_SetFullPersoOrientation"                  ,"Proc_SetFullPersoOrientation"         ,fn_p_st3DProc_ForReorientation, USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetFullPersoOrientationWithOffset	,"ACT_ReorientePersoAvecOffset"			        ,"ACT_SetFullPersoOrientWithOffset"             ,"Proc_SetFullPersoOrientationWithOffset"    ,fn_p_st3DProc_ForReorientation, USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	
	M_DEFINE_PROCEDURE(eProc_ZoomPerso					        ,"ACT_DeformePerso"								,"ACT_ZoomPerso"                                ,"Proc_ZoomPerso"                       ,fn_p_st3DProc, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ChangeOneCustomBit				    ,"ACT_ChangeCustomBit"							,"ACT_ChangeOneCustomBit"                       ,"Proc_ChangeOneCustomBit"              ,fn_p_stCustomBitsProc, USE_CONSTANT_PARAM USE_BOOLEAN_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ChangeManyCustomBits		    ,"ACT_ChangeCustomBits"							,"ACT_ChangeManyCustomBits"                     ,"Proc_ChangeManyCustomBits"            ,fn_p_stCustomBitsProc, USE_CONSTANT_PARAM USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
/* impose relative */
	M_DEFINE_PROCEDURE(eProc_ImposeSpeed					    ,"ACT_ImposeVecteurVitesse"						,"ACT_ImposeSpeed"                              ,"Proc_ImposeSpeed"                     ,fn_p_SetMechanicSpeedVector, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeSpeedX					    ,"ACT_ImposeVitesseX"							,"ACT_ImposeSpeedX"                             ,"Proc_ImposeSpeedX"                    ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeSpeedY					    ,"ACT_ImposeVitesseY"							,"ACT_ImposeSpeedY"                             ,"Proc_ImposeSpeedY"                    ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeSpeedZ					    ,"ACT_ImposeVitesseZ"							,"ACT_ImposeSpeedZ"                             ,"Proc_ImposeSpeedZ"                    ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeSpeedXY					    ,"ACT_ImposeVitesseXY"							,"ACT_ImposeSpeedXY"                            ,"Proc_ImposeSpeedXY"                   ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeSpeedXYZ					    ,"ACT_ImposeVitesseXYZ"							,"ACT_ImposeSpeedXYZ"                           ,"Proc_ImposeSpeedXYZ"                  ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
/* impose absolute */
	M_DEFINE_PROCEDURE(eProc_ImposeAbsoluteSpeed			    ,"ACT_ImposeVecteurVitesseAbsolu"				,"ACT_ImposeAbsoluteSpeed"                      ,"Proc_ImposeAbsoluteSpeed"             ,fn_p_SetMechanicSpeedVector, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ImposeAbsoluteSpeedX			    ,"ACT_ImposeVitesseAbsoluX"						,"ACT_ImposeAbsoluteSpeedX"                     ,"Proc_ImposeAbsoluteSpeedX"            ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ImposeAbsoluteSpeedY		    ,"ACT_ImposeVitesseAbsoluY"						,"ACT_ImposeAbsoluteSpeedY"                     ,"Proc_ImposeAbsoluteSpeedY"            ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeAbsoluteSpeedZ			    ,"ACT_ImposeVitesseAbsoluZ"						,"ACT_ImposeAbsoluteSpeedZ"                     ,"Proc_ImposeAbsoluteSpeedZ"            ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeAbsoluteSpeedXY			    ,"ACT_ImposeVitesseAbsoluXY"					,"ACT_ImposeAbsoluteSpeedXY"                    ,"Proc_ImposeAbsoluteSpeedXY"           ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ImposeAbsoluteSpeedXYZ			    ,"ACT_ImposeVitesseAbsoluXYZ"					,"ACT_ImposeAbsoluteSpeedXYZ"                   ,"Proc_ImposeAbsoluteSpeedXYZ"          ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
/* propose relative */
	M_DEFINE_PROCEDURE(eProc_ProposeSpeed					    ,"ACT_ProposeVecteurVitesse"					,"ACT_ProposeSpeed"                             ,"Proc_ProposeSpeed"                    ,fn_p_SetMechanicSpeedVector, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ProposeSpeedX				    ,"ACT_ProposeVitesseX"							,"ACT_ProposeSpeedX"                            ,"Proc_ProposeSpeedX"                   ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ProposeSpeedY					    ,"ACT_ProposeVitesseY"							,"ACT_ProposeSpeedY"                            ,"Proc_ProposeSpeedY"                   ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ProposeSpeedZ					    ,"ACT_ProposeVitesseZ"							,"ACT_ProposeSpeedZ"                            ,"Proc_ProposeSpeedZ"                   ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ProposeSpeedXY				    ,"ACT_ProposeVitesseXY"							,"ACT_ProposeSpeedXY"                           ,"Proc_ProposeSpeedXY"                  ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ProposeSpeedXYZ				    ,"ACT_ProposeVitesseXYZ"						,"ACT_ProposeSpeedXYZ"                          ,"Proc_ProposeSpeedXYZ"                 ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
/* propose absolute */
	M_DEFINE_PROCEDURE(eProc_ProposeAbsoluteSpeed			    ,"ACT_ProposeVecteurVitesseAbsolu"				,"ACT_ProposeAbsoluteSpeed"                     ,"Proc_ProposeAbsoluteSpeed"            ,fn_p_SetMechanicSpeedVector, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ProposeAbsoluteSpeedX			    ,"ACT_ProposeVitesseAbsoluX"					,"ACT_ProposeAbsoluteSpeedX"                    ,"Proc_ProposeAbsoluteSpeedX"           ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ProposeAbsoluteSpeedY		    ,"ACT_ProposeVitesseAbsoluY"					,"ACT_ProposeAbsoluteSpeedY"                    ,"Proc_ProposeAbsoluteSpeedY"           ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ProposeAbsoluteSpeedZ			    ,"ACT_ProposeVitesseAbsoluZ"					,"ACT_ProposeAbsoluteSpeedZ"                    ,"Proc_ProposeAbsoluteSpeedZ"           ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ProposeAbsoluteSpeedXY			    ,"ACT_ProposeVitesseAbsoluXY"					,"ACT_ProposeAbsoluteSpeedXY"                   ,"Proc_ProposeAbsoluteSpeedXY"          ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ProposeAbsoluteSpeedXYZ		    ,"ACT_ProposeVitesseAbsoluXYZ"					,"ACT_ProposeAbsoluteSpeedXYZ"                  ,"Proc_ProposeAbsoluteSpeedXYZ"         ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_FixePositionPerso				    ,"ACT_FixePositionPerso"						,"ACT_FixePositionPerso"                        ,"Proc_FixePositionPerso"               ,fn_p_stFixePositionPerso, USE_PERSO_PARAM USE_VECTOR_PARAM, NOT_ULTRA_ABLE )
/* add speed relative */
	NU_M_DEFINE_PROCEDURE(eProc_AddSpeed						    ,"ACT_AddVecteurVitesse"					    ,"ACT_AddSpeed"                                 ,"Proc_AddSpeed"                        ,fn_p_SetMechanicSpeedVector, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddSpeedX					    ,"ACT_AddVitesseX"							    ,"ACT_AddSpeedX"                                ,"Proc_AddSpeedX"                       ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddSpeedY					    ,"ACT_AddVitesseY"							    ,"ACT_AddSpeedY"                                ,"Proc_AddSpeedY"                       ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddSpeedZ					    ,"ACT_AddVitesseZ"							    ,"ACT_AddSpeedZ"                                ,"Proc_AddSpeedZ"                       ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddSpeedXY					    ,"ACT_AddVitesseXY"							    ,"ACT_AddSpeedXY"                               ,"Proc_AddSpeedXY"                      ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddSpeedXYZ					    ,"ACT_AddVitesseXYZ"						    ,"ACT_AddSpeedXYZ"                              ,"Proc_AddSpeedXYZ"                     ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
/* propose absolute */
	M_DEFINE_PROCEDURE(eProc_AddAbsoluteSpeed				    ,"ACT_AddVecteurVitesseAbsolu"				    ,"ACT_AddAbsoluteSpeed"                         ,"Proc_AddAbsoluteSpeed"                ,fn_p_SetMechanicSpeedVector, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddAbsoluteSpeedX			    ,"ACT_AddVitesseAbsoluX"					    ,"ACT_AddAbsoluteSpeedX"                        ,"Proc_AddAbsoluteSpeedX"               ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddAbsoluteSpeedY			    ,"ACT_AddVitesseAbsoluY"					    ,"ACT_AddAbsoluteSpeedY"                        ,"Proc_AddAbsoluteSpeedY"               ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddAbsoluteSpeedZ			    ,"ACT_AddVitesseAbsoluZ"					    ,"ACT_AddAbsoluteSpeedZ"                        ,"Proc_AddAbsoluteSpeedZ"               ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddAbsoluteSpeedXY			    ,"ACT_AddVitesseAbsoluXY"					    ,"ACT_AddAbsoluteSpeedXY"                       ,"Proc_AddAbsoluteSpeedXY"              ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddAbsoluteSpeedXYZ			    ,"ACT_AddVitesseAbsoluXYZ"					    ,"ACT_AddAbsoluteSpeedXYZ"                      ,"Proc_AddAbsoluteSpeedXYZ"             ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
/* Morphing management procedures */
	NU_M_DEFINE_PROCEDURE(eProc_PrepareMorph					    ,"MOD_PrepareMorph"								,"MOD_PrepareMorph"                         ,"Proc_PrepareMorph"					,fn_p_stPrepareMorph                , USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CHANNEL_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_StopMorph						    ,"MOD_StopMorph"								,"MOD_StopMorph"                            ,"Proc_StopMorph"						,fn_p_stStopMorph                   , USE_CHANNEL_PARAM,                                                                             /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_Morphing						    ,"MOD_Morphing"									,"MOD_Morphing"                             ,"Proc_Morphing"						,fn_p_stMorphing                    , USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CHANNEL_PARAM,                    /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ReleaseAllModulesControl		        ,"MOD_LibererTousLesModules"					,"MOD_ReleaseAllModulesControl"             ,"Proc_ReleaseAllModulesControl"		,fn_p_stModuleControlProcedure,USE_NO_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ChangeModuleSighting			        ,"MOD_ChangeViseeModule"						,"MOD_ChangeModuleSighting"                 ,"Proc_ChangeModuleSighting"			,fn_p_st3DProc, USE_VECTOR_PARAM USE_MODULE_PARAM USE_BOOLEAN_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetModuleAbsolutePosition		        ,"MOD_ChangePositionModule"						,"MOD_SetModuleAbsolutePosition"            ,"Proc_SetModuleAbsolutePosition"		,fn_p_st3DProc, USE_VECTOR_PARAM USE_MODULE_PARAM USE_BOOLEAN_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RelativeMoveModule				        ,"MOD_DeplaceModule"							,"MOD_RelativeMoveModule"                   ,"Proc_RelativeMoveModule"				,fn_p_st3DProc, USE_VECTOR_PARAM USE_MODULE_PARAM USE_BOOLEAN_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_ChangeModuleSightingWithOffset	    ,"MOD_ChangeViseeModuleAvecOffset"				,"MOD_ChangeModuleSightingWithOffset"       ,"Proc_ChangeModuleSightingWithOffset"  ,fn_p_st3DProc, USE_VECTOR_PARAM USE_MODULE_PARAM USE_BOOLEAN_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotateModuleAroundX			        ,"MOD_TourneModuleAutourDeX"					,"MOD_RotateModuleAroundX"                  ,"Proc_RotateModuleAroundX"				,fn_p_st3DProc, USE_MODULE_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotateModuleAroundY			        ,"MOD_TourneModuleAutourDeY"					,"MOD_RotateModuleAroundY"                  ,"Proc_RotateModuleAroundY"				,fn_p_st3DProc, USE_MODULE_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotateModuleAroundZ			        ,"MOD_TourneModuleAutourDeZ"					,"MOD_RotateModuleAroundZ"                  ,"Proc_RotateModuleAroundZ"				,fn_p_st3DProc, USE_MODULE_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_RotateModuleAroundVector		    ,"MOD_TourneModuleAutourDeVecteur"				,"MOD_RotateModuleAroundVector"             ,"Proc_RotateModuleAroundVector"		,fn_p_st3DProc, USE_MODULE_PARAM USE_VECTOR_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RotateModuleAroundVectorWithOffset  ,"MOD_TourneModuleAutourDeVecteurAvecOffset"    ,"MOD_RotateModuleAroundVectorOffset"       ,"Proc_RotateModuleAroundVectorOffset"  ,fn_p_st3DProc, USE_MODULE_PARAM USE_VECTOR_PARAM USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_RotateModuleAroundXwithOffset	    ,"MOD_TourneModuleAutourDeXavecOffset"			,"MOD_RotateModuleAroundXwithOffset"        ,"Proc_RotateModuleAroundXwithOffset"   ,fn_p_st3DProc, USE_MODULE_PARAM USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_RotateModuleAroundYwithOffset	    ,"MOD_TourneModuleAutourDeYavecOffset"			,"MOD_RotateModuleAroundYwithOffset"        ,"Proc_RotateModuleAroundYwithOffset"   ,fn_p_st3DProc, USE_MODULE_PARAM USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_RotateModuleAroundZwithOffset	    ,"MOD_TourneModuleAutourDeZavecOffset"			,"MOD_RotateModuleAroundZwithOffset"        ,"Proc_RotateModuleAroundZwithOffset"   ,fn_p_st3DProc, USE_MODULE_PARAM USE_REAL_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetFullModuleOrientation	        ,"MOD_ReorienteModule"	            	    	,"MOD_SetFullModuleOrientation"             ,"Proc_SetFullModuleOrientation"		,fn_p_st3DProc_ForReorientation, USE_MODULE_PARAM USE_BOOLEAN_PARAM USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_SetFullModuleOrientationWithOffset	,"MOD_ReorienteModuleAvecOffset"		    	,"MOD_SetFullModuleOrientationOffset"       ,"Proc_SetFullModuleOrientationOffset"  ,fn_p_st3DProc_ForReorientation, USE_MODULE_PARAM USE_BOOLEAN_PARAM USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ZoomModule						        ,"MOD_DeformeModule"							,"MOD_ZoomModule"                           ,"Proc_ZoomModule"						,fn_p_st3DProc, USE_MODULE_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
/* collision communication management : ULTRA */
	M_DEFINE_PROCEDURE(eProc_SetColliderType				        ,"COL_ChangeTypeDeCollisionneur"				,"COL_SetColliderType"                      ,"Proc_SetColliderType"                 ,fn_p_stCollideCommunicationProc, USE_CONSTANT_PARAM USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetColliderVector				        ,"COL_ChangeVecteurDeCollisionneur"				,"COL_SetColliderVector"                    ,"Proc_SetColliderVector"               ,fn_p_stCollideCommunicationProc, USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetColliderReal				        ,"COL_ChangeReelDeCollisionneur"				,"COL_SetColliderReal"                      ,"Proc_SetColliderReal"                 ,fn_p_stCollideCommunicationProc, USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ResetLastCollisionActor		        ,"COL_AnnuleDernierPersoCollisionne"			,"COL_ResetLastCollisionActor"              ,"Proc_ResetLastCollisionActor"         ,fn_p_stResetLastCollisionActor, USE_NO_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ClearCollisionReport					,"COL_VideRapportDeCollision"					,"COL_ClearCollisionReport"					,"Proc_ClearCollisionReport"			,fn_p_stResetLastCollisionActor, USE_NO_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_SetGoThroughMechanicsHandling	        ,"COL_TraiteCollisionTraversee"					,"COL_SetGoThroughMechanicsHandling"        ,"Proc_SetGoThroughMechanicsHandling"   ,fn_p_stMiscUltraProcedure, USE_BOOLEAN_PARAM, /**/ ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_EraseLastGoThroughMaterial	        ,"COL_EffaceDernierMateriauTraverse"			,"COL_EraseLastGoThroughMaterial"           ,"Proc_EraseLastGoThroughMaterial"      ,fn_p_stMiscUltraProcedure, USE_NO_PARAM, /**/ ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
/* String procedures */
	M_DEFINE_PROCEDURE(eProc_StringAddChar				        ,"TEXT_AjouteCaractere"							,"TEXT_AddChar"                             ,"Proc_StringAddChar"                   ,fn_p_stStringProc, USE_STRING_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_StringReplaceChar				        ,"TEXT_RemplaceCaractere"						,"TEXT_ReplaceChar"                         ,"Proc_StringReplaceChar"               ,fn_p_stStringProc, USE_STRING_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_PROCEDURE(eProc_StringRemoveChar			        ,"TEXT_RetireCaractere"							,"TEXT_RemoveChar"                          ,"Proc_StringRemoveChar"                ,fn_p_stStringProc, USE_STRING_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ChangeLanguage				        ,"TEXT_ChangeLangueCourante"					,"TEXT_ChangeLanguage"                      ,"Proc_ChangeLanguage"                  ,fn_p_stStringProc, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_IntToText						        ,"TEXT_EntierEnTexte"							,"TEXT_IntToText"                           ,"Proc_IntToText"			            ,fn_p_stIntToText, USE_STRING_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
 
	
/**********************************************************************************************************************************************************************************************************************************************************/
/* Meca */
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicAnimation			        ,"MEC_ActiveAnimation"							,"MEC_SetMechanicAnimation"                 ,"Proc_SetMechanicAnimation"            ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicCollide				        ,"MEC_ActiveCollision"							,"MEC_SetMechanicCollide"                   ,"Proc_SetMechanicCollide"              ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicGravity				        ,"MEC_ActiveGravite"							,"MEC_SetMechanicGravity"                   ,"Proc_SetMechanicGravity"              ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicTilt				        ,"MEC_ActiveTilt"								,"MEC_SetMechanicTilt"                      ,"Proc_SetMechanicTilt"                 ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicGi				        ,"MEC_ActiveGi"									,"MEC_SetMechanicGI"                        ,"Proc_SetMechanicGI"                   ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicClimb			        ,"MEC_ActiveVarappe"							,"MEC_SetMechanicClimb"                     ,"Proc_SetMechanicClimb"                ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicOnGround			        ,"MEC_ActivePlaqueAuSol"						,"MEC_SetMechanicOnGround"                  ,"Proc_SetMechanicOnGround"             ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicSpider			        ,"MEC_ActiveAraignee"							,"MEC_SetMechanicSpider"                    ,"Proc_SetMechanicSpider"               ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicShoot						,"MEC_ActiveShoot"								,"MEC_SetMechanicShoot"                     ,"Proc_SetMechanicShoot"                ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicSwim						,"MEC_ActiveNage"								,"MEC_SetMechanicSwim"						,"Proc_SetMechanicSwim"					,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicNeverFall					,"MEC_ActiveNeTombePas"							,"MEC_SetMechanicNeverFall"					,"Proc_SetMechanicNeverFall"			,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicNewMechanic					,"MEC_DesactiveNouvelleMecanique"				,"MEC_ResetMechanicNewMechanic"				,"Proc_ResetMechanicNewMechanic"		,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicCollisionControl	        ,"MEC_ControleCollision"						,"MEC_SetMechanicCollisionControl"          ,"Proc_SetMechanicCollisionControl"     ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicKeepSpeedZ		        ,"MEC_ConserveVitesseZ"							,"MEC_SetMechanicKeepSpeedZ"                ,"Proc_SetMechanicKeepSpeedZ"           ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicSpeedLimit			        ,"MEC_ActiveLimiteVitesse"						,"MEC_SetMechanicSpeedLimit"                ,"Proc_SetMechanicSpeedLimit"           ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicInertia				        ,"MEC_ActiveInertie"							,"MEC_SetMechanicInertia"                   ,"Proc_SetMechanicInertia"              ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicStream				        ,"MEC_ActiveFlux"								,"MEC_SetMechanicStream"                    ,"Proc_SetMechanicStream"               ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicStickOnPlatform		        ,"MEC_ActiveCollerAuxPlateformes"				,"MEC_SetMechanicStickOnPlatform"           ,"Proc_SetMechanicStickOnPlatform"      ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicScale				        ,"MEC_ActiveScale"								,"MEC_SetMechanicScale"                     ,"Proc_SetMechanicScale"                ,fn_p_SetMechanicOption, USE_BOOLEAN_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicGravityFactor		        ,"MEC_FixeGravite"								,"MEC_SetMechanicGravityFactor"             ,"Proc_SetMechanicGravityFactor"        ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicSlide				        ,"MEC_FixeGlissement"							,"MEC_SetMechanicSlide"                     ,"Proc_SetMechanicSlide"                ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicRebound				        ,"MEC_FixeRebond"								,"MEC_SetMechanicMaxRebound"                ,"Proc_SetMechanicMaxRebound"           ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicSlopeLimit			        ,"MEC_FixeLimitePente"							,"MEC_SetMechanicSlopeLimit"                ,"Proc_SetMechanicSlopeLimit"           ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicInertiaX			        ,"MEC_FixeInertieX"								,"MEC_SetMechanicInertiaX"                  ,"Proc_SetMechanicInertiaX"             ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicInertiaY			        ,"MEC_FixeInertieY"								,"MEC_SetMechanicInertiaY"                  ,"Proc_SetMechanicInertiaY"             ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicInertiaZ			        ,"MEC_FixeInertieZ"								,"MEC_SetMechanicInertiaZ"                  ,"Proc_SetMechanicInertiaZ"             ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicInertiaXYZ			        ,"MEC_FixeInertie"								,"MEC_SetMechanicInertiaXYZ"                ,"Proc_SetMechanicInertiaXYZ"           ,fn_p_SetMechanic3RealParameter, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicTiltIntensity	        ,"MEC_FixeIntensiteTilt"						,"MEC_SetMechanicTiltIntensity"             ,"Proc_SetMechanicTiltIntensity"        ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicTiltInertia		        ,"MEC_FixeInertieTilt"							,"MEC_SetMechanicTiltInertia"               ,"Proc_SetMechanicTiltInertia"          ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetMechanicTiltOrigin		        ,"MEC_FixeOrigineTilt"							,"MEC_SetMechanicTiltOrigin"                ,"Proc_SetMechanicTiltOrigin"           ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicSpeedMax			        ,"MEC_FixeVitesseMax"							,"MEC_SetMechanicSpeedMax"                  ,"Proc_SetMechanicSpeedMax"             ,fn_p_SetMechanicVectorParameter, USE_VECTOR_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicStreamPriority		        ,"MEC_FixePrioriteFlux"							,"MEC_SetMechanicStreamPriority"            ,"Proc_SetMechanicStreamPriority"       ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicStreamSpeed			        ,"MEC_FixeVitesseFlux"							,"MEC_SetMechanicStreamSpeed"               ,"Proc_SetMechanicStreamSpeed"          ,fn_p_SetMechanicVectorParameter, USE_VECTOR_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetMechanicStreamFactor		        ,"MEC_FixeFacteurDeFlux"						,"MEC_SetMechanicStreamFactor"              ,"Proc_SetMechanicStreamFactor"         ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_AddMechanicStreamSpeed		        ,"MEC_AjouteVitesseFlux"						,"MEC_AddMechanicStreamSpeed"               ,"Proc_AddMechanicStreamSpeed"          ,fn_p_SetMechanicVectorParameter, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_AddMechanicStreamSpeedList	        ,"MEC_AjouteVitesseFluxListe"					,"MEC_AddMechanicStreamSpeedList"           ,"Proc_AddMechanicStreamSpeedList"      ,fn_p_SetMechanicListParameter, USE_DSGVARIDLIST_PARAM USE_VECTOR_PARAM, /**/ NOT_ULTRA_ABLE /**/ )
/* limit */
	NU_M_DEFINE_PROCEDURE(eProc_MoveLimit						        ,"MEC_LimiteDeplacement"						,"MEC_MoveLimit"                            ,"Proc_MoveLimit"                       ,fn_p_SetMechanicSpeedVector, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_MoveLimitX					        ,"MEC_LimiteDeplacementX"						,"MEC_MoveLimitX"                           ,"Proc_MoveLimitX"                      ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_MoveLimitY					        ,"MEC_LimiteDeplacementY"						,"MEC_MoveLimitY"                           ,"Proc_MoveLimitY"                      ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_MoveLimitZ						        ,"MEC_LimiteDeplacementZ"						,"MEC_MoveLimitZ"                           ,"Proc_MoveLimitZ"                      ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_MoveLimitXYZ				        ,"MEC_LimiteDeplacementXYZ"						,"MEC_MoveLimitXYZ"                         ,"Proc_MoveLimitXYZ"                    ,fn_p_SetMechanicSpeedReal, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
/* stop limit */
	NU_M_DEFINE_PROCEDURE(eProc_StopMoveLimitX					        ,"MEC_StopLimiteDeplacementX"					,"MEC_StopMoveLimitX"                       ,"Proc_StopMoveLimitX"                  ,fn_p_SetMechanicSpeedReal, USE_NO_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_StopMoveLimitY				        ,"MEC_StopLimiteDeplacementY"					,"MEC_StopMoveLimitY"                       ,"Proc_StopMoveLimitY"                  ,fn_p_SetMechanicSpeedReal, USE_NO_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_StopMoveLimitZ				        ,"MEC_StopLimiteDeplacementZ"					,"MEC_StopMoveLimitZ"                       ,"Proc_StopMoveLimitZ"                  ,fn_p_SetMechanicSpeedReal, USE_NO_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_StopMoveLimitXYZ				        ,"MEC_StopLimiteDeplacementXYZ"					,"MEC_StopMoveLimitXYZ"                     ,"Proc_StopMoveLimitXYZ"                ,fn_p_SetMechanicSpeedReal, USE_NO_PARAM, /**/ ULTRA_ABLE /**/ )
/* platform */
	NU_M_DEFINE_PROCEDURE(eProc_SetPlatformLink				        ,"MEC_ForceLienPlateforme"						,"MEC_SetPlatformLink"                      ,"Proc_SetPlatformLink"                 ,fn_p_PlatformLink, USE_PERSO_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_FreePlatformLink			        ,"MEC_LibereLienPlateforme"						,"MEC_FreePlatformLink"                     ,"Proc_FreePlatformLink"                ,fn_p_PlatformLink, USE_NO_PARAM, /**/ ULTRA_ABLE /**/ )
/* Scale */
	M_DEFINE_PROCEDURE(eProc_MecSetScale					        ,"MEC_FixeScale"								,"MEC_SetScale"                             ,"Proc_SetScale"                        ,fn_p_SetMechanic3Real, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
/* Slide coeff */
	M_DEFINE_PROCEDURE(eProc_MecSetSlideFactorXYZ			        ,"MEC_FixeCoefDeGlisseXYZ"						,"MEC_SetSlideFactorXYZ"                    ,"Proc_SetSlideFactorXYZ"               ,fn_p_SetMechanic3Real, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_MecSetSlideFactorX				        ,"MEC_FixeCoefDeGlisseX"						,"MEC_SetSlideFactorX"                      ,"Proc_SetSlideFactorX"                 ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_MecSetSlideFactorY			        ,"MEC_FixeCoefDeGlisseY"						,"MEC_SetSlideFactorY"                      ,"Proc_SetSlideFactorY"                 ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_MecSetSlideFactorZ			        ,"MEC_FixeCoefDeGlisseZ"						,"MEC_SetSlideFactorZ"                      ,"Proc_SetSlideFactorZ"                 ,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_MecSetClimbSpeedLimit					,"MEC_FixeLimiteVitesseVarappe"					,"MEC_SetClimbSpeedLimit"                   ,"Proc_SetClimbSpeedLimit"               ,fn_p_SetMechanicClimbSpeedLimit, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )

	M_DEFINE_PROCEDURE(eProc_MecSetHangingLimit						,"MEC_ActiveMecaAccrochage"						,"MEC_SetHangingLimit"						,"Proc_SetHangingLimit"					,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_MecSetHangingOff						,"MEC_DesactiveMecaAccrochage"					,"MEC_SetHangingOff"						,"Proc_SetHangingOff"					,fn_p_SetMechanicSpeedReal, USE_NO_PARAM, /**/ ULTRA_ABLE /**/ )

	M_DEFINE_PROCEDURE(eProc_MecSetBaseCoeff						,"MEC_FixeCoeffSaut"							,"MEC_SetBaseCoeff"							,"Proc_SetBaseCoeff"					,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_MecSetWalkCoeff						,"MEC_FixeCoeffMarche"							,"MEC_SetWalkCoeff"							,"Proc_SetWalkCoeff"					,fn_p_SetMechanicRealParameter, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/ )
	
	
/**********************************************************************************************************************************************************************************************************************************************************/
/* Hierarchy - Platform */
	M_DEFINE_PROCEDURE(eProc_HierSetFather					        ,"HIER_ForcePere"								,"HIER_SetFather"                           ,"Proc_HierSetFather"                   ,fn_p_HierFatherLink,	USE_PERSO_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_HierFreeFather					        ,"HIER_LiberePere"								,"HIER_FreeFather"                          ,"Proc_HierFreeFather"                  ,fn_p_HierFatherLink,	USE_NO_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_HierListOfSon					        ,"HIER_MesFils"									,"HIER_ListOfSon"                           ,"Proc_HierListOfSon"                   ,fn_p_HierFatherLink,	USE_DSGVARIDLIST_PARAM, /**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_HierSetPlatformType			        ,"HIER_ForceTypePlateforme"						,"HIER_SetPlatformType"                     ,"Proc_HierSetPlatformType"             ,fn_p_stMiscProcedure,	USE_BOOLEAN_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_HierControlLink				        ,"HIER_ControlePlatforme"						,"HIER_LinkControl"                         ,"Proc_HierLinkControl"                 ,fn_p_LinkControl,		USE_BOOLEAN_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_HierFreezeEngine				        ,"HIER_GeleMoteur"								,"HIER_FreezeEngine"                        ,"Proc_HierFreezeEngine"                ,fn_p_stMiscProcedure,	USE_BOOLEAN_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_FixePositionZDM				        ,"ZON_FixePositionZDM"							,"ZON_SetPositionZDM"                       ,"Proc_FixePositionZDM"                 ,fn_p_stFixePositionZDx, USE_PERSO_PARAM USE_ZDM_PERSO_PARAM USE_VECTOR_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_FixePositionZDD				        ,"ZON_FixePositionZDD"							,"ZON_SetPositionZDD"                       ,"Proc_FixePositionZDD"                 ,fn_p_stFixePositionZDx, USE_PERSO_PARAM USE_ZDD_PERSO_PARAM USE_VECTOR_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_FixePositionZDE				        ,"ZON_FixePositionZDE"							,"ZON_SetPositionZDE"                       ,"Proc_FixePositionZDE"                 ,fn_p_stFixePositionZDx, USE_PERSO_PARAM USE_ZDE_PERSO_PARAM USE_VECTOR_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_PROCEDURE(eProc_ChangeLightIntensity		        ,"LUM_ChangerIntensiteLumineuse"				,"LIGHT_ChangeLightIntensity"               ,"Proc_ChangeLightIntensity"            ,fn_p_stChangeLigthIntensity		,USE_PERSO_PARAM USE_4_REALS_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SPO_ChangeFlag				        ,"SPO_ChangeFlag"								,"SPO_ChangeFlag"                           ,"Proc_SPO_ChangeFlag"                  ,fn_SPO_p_stChangeFlag, USE_SUPEROBJECT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ActChangeSpoFlag				        ,"ACT_ChangeSpoFlag"							,"ACT_ChangeSpoFlag"                        ,"ACT_ChangeSpoFlag"                    ,fn_p_stChangeActorSpoFlag, USE_CONSTANT_PARAM USE_CONSTANT_PARAM,/**/ ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_ChangeScreenSize				        ,"Ecran_ChangeTaille"							,"SCREEN_ChangeSize"                        ,"Proc_EcranChangeTaille"               ,fn_p_stChangeScreen, USE_CONSTANT_PARAM USE_2_CONSTANTS_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ChangeScreenClip				        ,"Ecran_ChangeClip"								,"SCREEN_ChangeClip"                        ,"Proc_EcranChangeClip"                 ,fn_p_stChangeScreen, USE_CONSTANT_PARAM USE_4_CONSTANTS_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_ChangeScreenPos				        ,"Ecran_ChangePos"								,"SCREEN_ChangePos"                         ,"Proc_EcranChangePos"                  ,fn_p_stChangeScreen, USE_CONSTANT_PARAM USE_2_CONSTANTS_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ChangeScreenPosPercent					,"Ecran_ChangePosPercent"						,"SCREEN_ChangePosPercent"                  ,"Proc_EcranChangePosPercent"           ,fn_p_stChangeScreen, USE_CONSTANT_PARAM USE_2_CONSTANTS_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
    NU_M_DEFINE_PROCEDURE(eProc_ChangeScreenRatio			            ,"Ecran_ChangeRatio"  						    ,"SCREEN_ChangeProportion"                  ,"Proc_EcranChangeRatio"                ,fn_p_stChangeScreen, USE_CONSTANT_PARAM USE_REAL_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_DisplayShadow					        ,"OMBRE_Affichage"								,"SHADOW_Display"                           ,"Proc_OMBREAffichage"                  ,fn_p_stShadow,	USE_CONSTANT_PARAM						,/**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ChangeShadowHeight			        ,"OMBRE_ChangeHauteur"							,"SHADOW_ChangeHeight"                      ,"Proc_OMBREChangeHauteur"              ,fn_p_stShadow,	USE_REAL_PARAM							,/**/ ULTRA_ABLE /**/ )
	NU_M_DEFINE_PROCEDURE(eProc_ChangeShadowVector			        ,"OMBRE_ChangeVecteurProjection"				,"SHADOW_ChangeVectorProjection"            ,"Proc_OMBREChangeVecteurProjection"    ,fn_p_stShadow,	USE_VECTOR_PARAM						,/**/ ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_PROCEDURE(eProc_ForceActivationZDD                  ,"ZON_ForceActivationZDD"                       ,"ZON_ForceActivationZDD"                   ,"Proc_ForceActivationZDD"              ,fn_p_stSetPrivilegeActivationZDx, USE_ZDD_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_ForceActivationZDM                  ,"ZON_ForceActivationZDM"                       ,"ZON_ForceActivationZDM"                   ,"Proc_ForceActivationZDM"              ,fn_p_stSetPrivilegeActivationZDx, USE_ZDM_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_ForceActivationZDE                     ,"ZON_ForceActivationZDE"                       ,"ZON_ForceActivationZDE"                   ,"Proc_ForceActivationZDE"              ,fn_p_stSetPrivilegeActivationZDx, USE_ZDE_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    NU_M_DEFINE_PROCEDURE(eProc_ForceActivationZDR                  ,"ZON_ForceActivationZDR"                       ,"ZON_ForceActivationZDR"                   ,"Proc_ForceActivationZDR"              ,fn_p_stSetPrivilegeActivationZDx, USE_ZDR_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_ForceDesactivationZDD               ,"ZON_ForceDesactivationZDD"                    ,"ZON_ForceDesactivationZDD"                ,"Proc_ForceDesactivationZDD"           ,fn_p_stSetPrivilegeActivationZDx, USE_ZDD_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_ForceDesactivationZDM               ,"ZON_ForceDesactivationZDM"                    ,"ZON_ForceDesactivationZDM"                ,"Proc_ForceDesactivationZDM"           ,fn_p_stSetPrivilegeActivationZDx, USE_ZDM_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_ForceDesactivationZDE                  ,"ZON_ForceDesactivationZDE"                    ,"ZON_ForceDesactivationZDE"                ,"Proc_ForceDesactivationZDE"           ,fn_p_stSetPrivilegeActivationZDx, USE_ZDE_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    NU_M_DEFINE_PROCEDURE(eProc_ForceDesactivationZDR               ,"ZON_ForceDesactivationZDR"                    ,"ZON_ForceDesactivationZDR"                ,"Proc_ForceDesactivationZDR"           ,fn_p_stSetPrivilegeActivationZDx, USE_ZDR_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    NU_M_DEFINE_PROCEDURE(eProc_LibereActivationZDD                 ,"ZON_LibereActivationZDD"                      ,"ZON_ReleaseActivationZDD"                 ,"Proc_LibereActivationZDD"             ,fn_p_stSetPrivilegeActivationZDx, USE_ZDD_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_LibereActivationZDM                 ,"ZON_LibereActivationZDM"                      ,"ZON_ReleaseActivationZDM"                 ,"Proc_LibereActivationZDM"             ,fn_p_stSetPrivilegeActivationZDx, USE_ZDM_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_LibereActivationZDE                 ,"ZON_LibereActivationZDE"                      ,"ZON_ReleaseActivationZDE"                 ,"Proc_LibereActivationZDE"             ,fn_p_stSetPrivilegeActivationZDx, USE_ZDE_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    NU_M_DEFINE_PROCEDURE(eProc_LibereActivationZDR                 ,"ZON_LibereActivationZDR"                      ,"ZON_ReleaseActivationZDR"                 ,"Proc_LibereActivationZDR"             ,fn_p_stSetPrivilegeActivationZDx, USE_ZDR_PERSO_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_ActiveZDR						        ,"ZON_ActiveZDR"						        ,"ZON_ActiveZDR"                            ,"Proc_ActiveZDR"                       ,fn_p_stActivationZDR,	USE_BOOLEAN_PARAM ,/**/ ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
/* Collision Flags and Computing collisions frequency */
    M_DEFINE_PROCEDURE(eProc_SetNoCollisionWithMap                  ,"ACT_FixePasDeCollisionAvecMap"                ,"ACT_SetNoColWithMap"                      ,"Proc_SetNoColWithMap"                 ,fn_p_stSetCollSetCollisionFlag, USE_BOOLEAN_PARAM ,/**/ ULTRA_ABLE /**/ )
    NU_M_DEFINE_PROCEDURE(eProc_SetNoCollisionWithProjectile        ,"ACT_FixePasDeCollisionAvecProjectiles"        ,"ACT_SetNoColWithProjectile"               ,"Proc_SetNoColWithProjectile"          ,fn_p_stSetCollSetCollisionFlag, USE_BOOLEAN_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetNoCollisionWithSecondCharact     ,"ACT_FixePasDeCollisionAvecActeursSecondaires" ,"ACT_SetNoColWithSeconfCharact"            ,"Proc_SetNoColWithSeconfCharact"       ,fn_p_stSetCollSetCollisionFlag, USE_BOOLEAN_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetNoCollisionWithMainCharact       ,"ACT_FixePasDeCollisionAvecActeurPrincipal"    ,"ACT_SetNoColWithMainCharact"              ,"Proc_SetNoColWithMainCharact"         ,fn_p_stSetCollSetCollisionFlag, USE_BOOLEAN_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetNoCollisionWithOtherSectors      ,"ACT_FixePasDeCollisionAvecAutresSecteurs"     ,"ACT_SetNoColWithOtherSectors"             ,"Proc_SetNoColWithOtherSectors"        ,fn_p_stSetCollSetCollisionFlag, USE_BOOLEAN_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetNoCollisionZdeWithProjectile        ,"ACT_FixePasDeCollisionZdeAvecProjectiles"     ,"ACT_SetNoColZdeWithProjectile"            ,"Proc_SetNoColZdeWithProjectile"       ,fn_p_stSetCollSetCollisionFlag, USE_BOOLEAN_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetCollComputeFrequency             ,"ACT_FixeFrequenceCalculCollisions"			,"ACT_SetCollComputeFreq"                   ,"Proc_SetCollComputeFreq"              ,fn_p_stSetComputationFrequency, USE_CONSTANT_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetBrainComputeFrequency               ,"ACT_FixeFrequenceCalculIA"					,"ACT_SetBrainComputeFreq"                  ,"Proc_SetBrainComputeFreq"             ,fn_p_stSetComputationFrequency, USE_CONSTANT_PARAM ,/**/ ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetLightComputeFrequency            ,"ACT_FixeFrequenceCalculLumieres"	    		,"ACT_SetLightComputeFreq"                  ,"Proc_SetLightComputeFreq"             ,fn_p_stSetComputationFrequency, USE_CONSTANT_PARAM ,/**/ ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
/* map exits management for world map update */
    M_DEFINE_PROCEDURE(eProc_SetUsedExitIdentifier                  ,"MAP_IndiqueLaSortieUtilisee"		            ,"MAP_SetUsedExitIdentifier"                ,"Proc_SetUsedExitIdentifier"           ,fn_p_stWorldMapProc, USE_CONSTANT_PARAM USE_CONSTANT_PARAM ,/**/ NOT_ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_GetUsedExitIdentifier                  ,"MAP_LitLaSortieUtilisee"			            ,"MAP_GetUsedExitIdentifier"                ,"Proc_GetUsedExitIdentifier"           ,fn_p_stWorldMapProc, USE_ADDR_LONG_PARAM USE_ADDR_LONG_PARAM ,/**/ NOT_ULTRA_ABLE /**/ )
    M_DEFINE_PROCEDURE(eProc_SetGlobalCounter                       ,"MAP_ChangeCompteurGlobal"			            ,"MAP_SetGlobalCounter"                     ,"eProc_SetGlobalCounter"               ,fn_p_stWorldMapProc, USE_CONSTANT_PARAM ,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_ReadAnalogJoystick                     ,"PAD_LitJoyAnalogiqueModeMario"			    ,"PAD_ReadAnalogJoystickMarioMode"          ,"PAD_ReadAnalogJoystickMarioMode"      ,fn_p_stReadAnalogJoystickMario, USE_4_REALS_PARAM USE_CONSTANT_PARAM USE_2_BOOLEANS_PARAM,/**/ ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_SetAnalogJoystickAxes                  ,"PAD_JoyAnalogiqueFixeAxes"			        ,"PAD_InitAnalogJoystickAxes"               ,"PAD_InitAnalogJoystickAxes"           ,fn_p_stSetAnalogJoystickAxes, USE_BUTTON_PARAM USE_BUTTON_PARAM ,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_SetPadReadingDsgvars                   ,"PAD_FixeVariablesDeLecture"			        ,"PAD_SetPadReadingDsgvars"                 ,"Proc_SetPadReadingDsgvars"            ,fn_p_stSetAnalogJoystickAxes, USE_ADDR_VECTOR_PARAM USE_ADDR_LONG_PARAM USE_ADDR_LONG_PARAM USE_ADDR_REAL_PARAM USE_ADDR_REAL_PARAM USE_ADDR_REAL_PARAM USE_ADDR_LONG_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
#if (!defined U64)
	NU_M_DEFINE_PROCEDURE(eProc_CancelKeyboardInertia			        ,"PAD_AnnuleInertieClavier"						,"PAD_CancelKeyboardInertia"                 ,"Proc_CancelKeyboardInertia"			,fn_p_stSetAnalogJoystickAxes, USE_NO_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
#else
	NU_M_DEFINE_PROCEDURE(eProc_CancelKeyboardInertia			        ,"PAD_AnnuleInertieClavier"						,"PAD_CancelKeyboardInertia"                 ,"Proc_CancelKeyboardInertia"			,fn_p_stDummy, USE_NO_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
#endif /* U64*/
	NU_M_DEFINE_PROCEDURE(eProc_GetPadCalibration						,"PAD_LitCalibration"							,"PAD_GetPadCalibration"					,"Proc_GetPadCalibration"				,fn_p_stSetAnalogJoystickAxes, USE_ADDR_LONG_PARAM USE_ADDR_LONG_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_SetPadCalibration						,"PAD_ChangeCalibration"						,"PAD_SetPadCalibration"					,"Proc_SetPadCalibration"				,fn_p_stSetAnalogJoystickAxes, USE_CONSTANT_PARAM USE_CONSTANT_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetBooleanInArray				        ,"ACT_FixeBooleenDansTableau"			        ,"ACT_SetBooleanInArray"                    ,"ACT_SetBooleanInArray"                ,fn_p_stSetBooleanInArray,	USE_ADDR_ARRAY_PARAM USE_CONSTANT_PARAM USE_BOOLEAN_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetDefaultFormatCharacter		        ,"TEXT_SetDefaultFormatCharacter"		        ,"TEXT_SetDefaultFormatCharacter"           ,"TEXT_SetDefaultFormatCharacter"       ,fn_p_stSetDefaultFormatCharacter,	USE_3_REALS_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
#if (!defined U64)
	NU_M_DEFINE_PROCEDURE(eProc_SelectDriver					        ,"VID_SelectDriver"						        ,"VID_SelectDriver"                         ,"VID_SelectDriver"						,fn_p_stSelectDriver,		USE_CONSTANT_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
#else
	NU_M_DEFINE_PROCEDURE(eProc_SelectDriver							,"VID_SelectDriver"								,"VID_SelectDriver"							,"VID_SelectDriver"						,fn_p_stDummy,				USE_CONSTANT_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
#endif /* U64*/


#ifdef U64
	M_DEFINE_PROCEDURE(eProc_SelectShapnessMax					    ,"VID_SelectShapnessMax"						 ,"VID_SelectShapnessMax"					,"Proc_SelectShapnessMax"				,Proc_SelectShapnessMax,	USE_BOOLEAN_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_CenterScreen					        ,"VID_CenterScreen"								 ,"VID_CenterScreen"						,"Proc_CenterScreen"					,fn_p_stCenterScreen,		USE_NO_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
#else
	M_DEFINE_PROCEDURE(eProc_SelectShapnessMax					    ,"VID_SelectShapnessMax"						 ,"VID_SelectShapnessMax"                   ,"Proc_SelectShapnessMax"				,fn_p_stDummy,				USE_BOOLEAN_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_CenterScreen					        ,"VID_CenterScreen"								 ,"VID_CenterScreen"						,"Proc_CenterScreen"					,fn_p_stDummy,				USE_NO_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
#endif /* U64 */	
	


	
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SelectResolution				        ,"VID_SelectResolution"					        ,"VID_SelectResolution"                     ,"VID_SelectResolution"					,fn_p_stSelectResolution,	USE_CONSTANT_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_ChangeBrightness				        ,"VID_ChangeBrightness"					        ,"VID_ChangeBrightness"                     ,"VID_ChangeBrightness"					,fn_p_stChangeBrightness,	USE_REAL_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_TexteEntier					        ,"TEXT_ParametreEntier"					        ,"TEXT_IntegerParameter"                    ,"TEXT_IntegerParameter"				,fn_p_stTextIntegerParameter,	USE_2_CONSTANTS_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_TexteReel						        ,"TEXT_ParametreReel"					        ,"TEXT_RealParameter"                       ,"TEXT_RealParameter"					,fn_p_stTextRealParameter,	USE_CONSTANT_PARAM	USE_REAL_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetTextureFiltering				    ,"VID_SetTextureFiltering"					    ,"VID_SetTextureFiltering"                  ,"VID_SetTextureFiltering"				,fn_p_stSetVideoOptions,	USE_CONSTANT_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_SetAntiAliasing				        ,"VID_SetAntiAliasing"					        ,"VID_SetAntiAliasing"                      ,"VID_SetAntiAliasing"					,fn_p_stSetVideoOptions,	USE_CONSTANT_PARAM	USE_REAL_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetInStereoMode					    ,"SOUND_SetInStereoMode"						,"SOUND_SetInStereoMode"			         ,"SOUND_SetInStereoMode"				,fn_p_stSetInStereoMode,	USE_BOOLEAN_PARAM	,/**/ NOT_ULTRA_ABLE /**/ )
 	M_DEFINE_PROCEDURE(eProc_SetSaturationBackGroundDistance		,"ACT_FixeDistanceSaturationBackGround"			,"ACT_SetSaturationBackGroundDistance"		 ,"Proc_SetSaturationBackGroundDistance",fn_p_stSetaturationAndBackgroundDistance,USE_CONSTANT_PARAM  USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/ )
 	M_DEFINE_PROCEDURE(eProc_SaveSoundEventInSlotMemory				,"SOUND_SauveRequeteCourante"					,"SOUND_SaveCurrentRequest"					 ,"Proc_SaveCurrentRequest"				,fn_p_stSaveCurrentSoundRequest,USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/ )
 	M_DEFINE_PROCEDURE(eProc_RestoreSoundEventInSlotMemory			,"SOUND_RestaureRequete"						,"SOUND_RestoreRequest"						 ,"Proc_RestoreRequest"					,fn_p_stSaveCurrentSoundRequest,USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/ )

#if defined(WIN32) && defined(_DEBUG)
 	M_DEFINE_PROCEDURE(eProc_DrawSegment							,"DEBUG_DessineSegment"							,"DEBUG_DrawSegment"						 ,"Proc_DrawSegment"					,fn_p_stDebugDrawSegment,USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/ )
#else 
	M_DEFINE_PROCEDURE(eProc_DrawSegment							,"DEBUG_DessineSegment"							,"DEBUG_DrawSegment"						 ,"Proc_DrawSegment"					,fn_p_stDummy,USE_VECTOR_PARAM USE_VECTOR_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/ )
#endif /* WIN32 && _DEBUG */	
/**********************************************************************************************************************************************************************************************************************************************************/
#if defined(WIN32)
	M_DEFINE_PROCEDURE(eProc_UpdateChecksum							,"ACT_MetAJourChecksum"							,"ACT_UpdateChecksum"						,"Proc_UpdateChecksum"					,fn_p_stMiscProtectProcedure,	USE_VECTOR_PARAM USE_CONSTANT_PARAM, ULTRA_ABLE)
#else
	M_DEFINE_PROCEDURE(eProc_UpdateChecksum							,"ACT_MetAJourChecksum"							,"ACT_UpdateChecksum"						,"Proc_UpdateChecksum"					,fn_p_stDummy,	USE_VECTOR_PARAM USE_CONSTANT_PARAM, ULTRA_ABLE)
#endif /* WIN32 */	
/**********************************************************************************************************************************************************************************************************************************************************/
#if defined(WIN32)
	M_DEFINE_PROCEDURE(eProc_ShellExecute							,"ShellExecute"									,"ShellExecute"								,"Proc_ShellExecute"					,fn_p_stShellExecuteProcedure,	USE_STRING_PARAM , NOT_ULTRA_ABLE)
#else
	M_DEFINE_PROCEDURE(eProc_ShellExecute							,"ShellExecute"									,"ShellExecute"								,"Proc_ShellExecute"					,fn_p_stDummy,	USE_STRING_PARAM , NOT_ULTRA_ABLE)
#endif /* WIN32 */	

	M_DEFINE_PROCEDURE(eProc_ForceVerticalUsingX				    ,"ACT_ForceVerticalUsingX"						,"ACT_ForceVerticalUsingX"                       ,"Proc_ForceVerticalUsingX"              ,fn_p_st3DProcVertical, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ForceVerticalUsingY				    ,"ACT_ForceVerticalUsingY"						,"ACT_ForceVerticalUsingY"                       ,"Proc_ForceVerticalUsingY"              ,fn_p_st3DProcVertical, USE_REAL_PARAM, /**/ ULTRA_ABLE /**/)

#include "ProcRay2.h"
