/************************************************************************************************
* Name: FuncRay2.h                                                                              *
* Use : Macro Definition of functions for AI of Rayman II                                       *
* Author: Christophe Giraud                                                                     *                                                                    
*                                  (c) UBI Simulations Annecy                                   *
************************************************************************************************/
 
/**********************************************************************************************************************************************************************************************************************************************************/
/* Management of magic points for Rayman */
	NU_M_DEFINE_FUNCTION(eFunc_LitPointsDeMagie			            ,"RAY_LitPointsDeMagie"                     ,"RAY_GetMagicPoints"					,"Func_LitPointsDeMagie"            ,fn_p_stCode4PointsDeMagie    , USE_NO_PARAM      , USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_LitPointsDeMagieMax			        ,"RAY_LitPointsDeMagieMax"                  ,"RAY_GetMagicPointsMax"				,"Func_LitPointsDeMagieMax"         ,fn_p_stCode4PointsDeMagie    , USE_NO_PARAM      , USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_AjouteEtLitPointsDeMagie	            ,"RAY_AjouteEtLitPointsDeMagie"             ,"RAY_AddAndGetMagicPoints"		    	,"Func_AjouteEtLitPointsDeMagie"    ,fn_p_stCode4PointsDeMagie    , USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_AjouteEtLitPointsDeMagieMax	        ,"RAY_AjouteEtLitPointsDeMagieMax"          ,"RAY_AddAndGetMagicPointsMax"	    	,"Func_AjouteEtLitPointsDeMagieMax" ,fn_p_stCode4PointsDeMagie    , USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_EnleveEtLitPointsDeMagie	            ,"RAY_EnleveEtLitPointsDeMagie"             ,"RAY_RemoveAndGetMagicPoints"			,"Func_EnleveEtLitPointsDeMagie"    ,fn_p_stCode4PointsDeMagie    , USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_EnleveEtLitPointsDeMagieMax	        ,"RAY_EnleveEtLitPointsDeMagieMax"          ,"RAY_RemoveAndGetMagicPointsMax"		,"Func_EnleveEtLitPointsDeMagieMax" ,fn_p_stCode4PointsDeMagie    , USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
/* Management of air points for Rayman */
	M_DEFINE_FUNCTION(eFunc_LitPointsDair				            ,"RAY_LitPointsDair"                        ,"RAY_GetAirPoints"		    			,"Func_LitPointsDair"               ,fn_p_stCode4PointsDair    , USE_NO_PARAM      , USE_REAL_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_LitPointsDairMax			            ,"RAY_LitPointsDairMax"                     ,"RAY_GetAirPointsMax"					,"Func_LitPointsDairMax"            ,fn_p_stCode4PointsDair    , USE_NO_PARAM      , USE_REAL_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_AjouteEtLitPointsDair	            ,"RAY_AjouteEtLitPointsDair"                ,"RAY_AddAndGetAirPoints"	    		,"Func_AjouteEtLitPointsDair"       ,fn_p_stCode4PointsDair    , USE_REAL_PARAM	, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_AjouteEtLitPointsDairMax	            ,"RAY_AjouteEtLitPointsDairMax"             ,"RAY_AddAndGetAirPointsMax"			,"Func_AjouteEtLitPointsDairMax"    ,fn_p_stCode4PointsDair    , USE_REAL_PARAM	, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_EnleveEtLitPointsDair		            ,"RAY_EnleveEtLitPointsDair"                ,"RAY_RemoveAndGetAirPoints"			,"Func_EnleveEtLitPointsDair"       ,fn_p_stCode4PointsDair    , USE_REAL_PARAM	, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_EnleveEtLitPointsDairMax	            ,"RAY_EnleveEtLitPointsDairMax"             ,"RAY_RemoveAndGetAirPointsMax" 		,"Func_EnleveEtLitPointsDairMax"    ,fn_p_stCode4PointsDair    , USE_REAL_PARAM	, USE_REAL_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_PersoLePlusProche			            ,"ACT_PersoLePlusProche"				    ,"ACT_NearestActor"                     ,"Func_PersoLePlusProche"           ,fn_p_stCode4PersoLePlusProche, USE_CONSTANT_PARAM      , USE_PERSO_PARAM   , ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_PersoLePlusProcheDansSecteurCourant	,"ACT_PersoLePlusProcheDansSecteurCourant"  ,"ACT_NearestActorInCurrentSector"      ,"Func_NearestActorInCurrentSector" ,fn_p_stGetNearestActorInCurrentSector, USE_CONSTANT_PARAM      , USE_PERSO_PARAM   , ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_NearerActorInFieldOfVision              ,"ACT_PersoLePlusProcheDansChampsDeVision"  ,"ACT_NearerActorInFieldOfVision"       ,"Func_NearerActorInFieldOfVision"  ,fn_p_stCode4PersoLePlusProche, USE_CONSTANT_PARAM      , USE_PERSO_PARAM   , ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_GetNbActivePerso			            ,"ACT_LitNbPersoActifs"                     ,"ACT_GetNbActivePerso"                 ,"Func_GetNbActivePerso"            ,fn_p_stGetNbActivePerso,USE_NO_PARAM,USE_CONSTANT_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_CibleLaPlusProche			            ,"ACT_CibleLaPlusProche"                    ,"ACT_CibleLaPlusProche"                ,"Func_CibleLaPlusProche"           ,fn_p_stCode4PersoLePlusProche, USE_4_CONSTANTS_PARAM USE_VECTOR_PARAM     , USE_PERSO_PARAM   , ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_CibleLaPlusProcheAvecAngles	            ,"ACT_CibleLaPlusProcheAvecAngles"           ,"ACT_CibleLaPlusProcheAvecAngles"       ,"Func_CibleLaPlusProcheavecAngles"  ,fn_p_stCode4PersoLePlusProche, USE_4_CONSTANTS_PARAM USE_VECTOR_PARAM USE_REAL_PARAM USE_REAL_PARAM, USE_PERSO_PARAM   , ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
/* Graph function management */
 
/* To reach a graph before building a way (or to travel on a graph without building a way) */
	M_DEFINE_FUNCTION(eFunc_ReseauWPLePlusProche                    ,"Reseau_WPLePlusProche",                   "NETWORK_CloserWPn"                     ,"Func_ReseauWPnLePlusProche"       ,fn_p_stCloserWPInGraph, USE_GRAPH_PARAM USE_CONSTANT_PARAM,                                                                       USE_WAYPOINT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_NetworkCloserWPOfType                ,"Reseau_WPDeTelTypeLePlusProche",          "NETWORK_CloserWPOfType"                ,"Func_NetworkCloserWPOfType"       ,fn_p_stCloserWPInGraph, USE_GRAPH_PARAM USE_CONSTANT_PARAM USE_CAPS_PARAM USE_WAYPOINT_PARAM USE_WAYPOINT_PARAM,                  USE_WAYPOINT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauWPLePlusDansLAxe                  ,"Reseau_WPLePlusDansLAxe",                 "NETWORK_CloserWPnInAxis"               ,"Func_ReseauWPnLePlusDansLAxe"     ,fn_p_stCloserWPInGraph, USE_GRAPH_PARAM USE_CONSTANT_PARAM USE_VECTOR_PARAM,                                                      USE_WAYPOINT_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_ReseauWPLePlusDansLAxe2              ,"Reseau_WPDeTelTypeLePlusDansLAxe",        "NETWORK_CloserWPnInAxis2"              ,"Func_ReseauWPnLePlusDansLAxe2"    ,fn_p_stCloserWPInGraph, USE_GRAPH_PARAM USE_CONSTANT_PARAM USE_CAPS_PARAM USE_WAYPOINT_PARAM USE_WAYPOINT_PARAM USE_VECTOR_PARAM, USE_WAYPOINT_PARAM, ULTRA_ABLE )
 
/* To travel on a graph without building a way */
	M_DEFINE_FUNCTION(eFunc_NetworkNextWPWithCapa,                      "Reseau_ProchainWPJoignableAvecCapacite",       "NETWORK_NextWPWithCapa",           "eFunc_NetworkNextWPWithCapa"         ,fn_p_stTravelOnAGraph, USE_GRAPH_PARAM USE_WAYPOINT_PARAM USE_CAPS_PARAM,                USE_WAYPOINT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_NetworkAffectTypeOfConnectedWP,          "Reseau_ChangeTypeDesWPJoignables",             "NETWORK_AffectTypeOfConnectedWP",  "Func_NetworkAffectTypeOfConnectedWP" ,fn_p_stTravelOnAGraph, USE_GRAPH_PARAM USE_CAPS_PARAM USE_WAYPOINT_PARAM USE_CONSTANT_PARAM,                USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_NetworkAffectTypeOfConnectedWPWithCapa,  "Reseau_ChangeTypeDesWPJoignablesAvecCapacite", "NETWORK_AffectTypeOfConnectedWP2", "Func_NetworkAffectTypeOfConnectedWP2",fn_p_stTravelOnAGraph, USE_GRAPH_PARAM USE_CAPS_PARAM USE_WAYPOINT_PARAM USE_CAPS_PARAM USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
 
/* To build a way from a graph */
	M_DEFINE_FUNCTION(eFunc_ReseauCheminLePlusCourt,                "Reseau_CheminLePlusCourt",                "NETWORK_ShorterWay",                   "Func_ReseauCheminLePlusCourt"             ,fn_p_stGraphToWayFunction, USE_GRAPH_PARAM USE_WAYPOINT_PARAM USE_WAYPOINT_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_NetworkBuildOrderedPath,                "Reseau_ConstruitCheminOrdonne",           "NETWORK_BuildOrderedPath",             "Func_NetworkBuildOrderedPath"             ,fn_p_stGraphToWayFunction, USE_GRAPH_PARAM USE_WAYPOINT_PARAM,                    USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_NetworkBuildOrderedPathCircular,        "Reseau_ConstruitCheminCirculaireOrdonne", "NETWORK_BuildOrderedPathCircular",     "Func_NetworkBuildOrderedPathCircular"     ,fn_p_stGraphToWayFunction, USE_GRAPH_PARAM USE_WAYPOINT_PARAM,                    USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_NetworkAllocateGraphToMSWay,            "Reseau_AffecteGraphAChemin",              "NETWORK_AllocateGraphToMSWay",         "Func_NetworkAllocateGraphToMSWay"         ,fn_p_stGraphToWayFunction, USE_GRAPH_PARAM,                                       USE_CONSTANT_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_NetworkAllocateGraphToMSWayCircular, "Reseau_AffecteGraphACheminCirculaire",    "NETWORK_AllocateGraphToMSWay",         "Func_NetworkAllocateGraphToMSWayCircular" ,fn_p_stGraphToWayFunction, USE_GRAPH_PARAM,                                       USE_CONSTANT_PARAM, ULTRA_ABLE )
 
/* To travel on the way built (no graph in parameter, bicose everything is tested with the MsWay) */
	M_DEFINE_FUNCTION(eFunc_ReseauLitIndexCourant,                  "Reseau_LitIndexCourant",                   "NETWORK_GetCurrentIndex",              "Func_ReseauLitIndexCourant"              ,fn_p_stWayFunction,      USE_NO_PARAM,       USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauForceIndexCourant,                "Reseau_ForceIndexCourant",                 "NETWORK_SetCurrentIndex",              "Func_ReseauForceIndexCourant"            ,fn_p_stWayFunction,      USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauLitPremierIndex,                  "Reseau_LitPremierIndex",                   "NETWORK_GetFirstIndex",                "Func_ReseauLitPremierIndex"              ,fn_p_stWayFunction,      USE_NO_PARAM,       USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauLitDernierIndex,                  "Reseau_LitDernierIndex",                   "NETWORK_GetLastIndex",                 "Func_ReseauLitDernierIndex"              ,fn_p_stWayFunction,      USE_NO_PARAM,       USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauIncrementIndex,                   "Reseau_IncrementIndex",                    "NETWORK_IncrementIndex",               "Func_ReseauIncrementIndex"               ,fn_p_stWayFunction,      USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauDecrementIndex,                   "Reseau_DecrementIndex",                    "NETWORK_DecrementIndex",               "Func_ReseauDecrementIndex"               ,fn_p_stWayFunction,      USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauLitWPAIndex,                      "Reseau_LitWPAIndex",                       "NETWORK_GetWPAIndex",                  "Func_ReseauLitWPAIndex"                  ,fn_p_stWayFunction,      USE_CONSTANT_PARAM, USE_WAYPOINT_PARAM, ULTRA_ABLE )
	
	M_DEFINE_FUNCTION(eFunc_ReseauLitCapaciteLiaisonAIndex,         "Reseau_LitCapaciteLiaisonAIndex",          "NETWORK_GetLinkCapacityToIndex",       "Func_ReseauLitCapaciteLiaisonAIndex"     ,fn_p_stWayFunction, USE_CONSTANT_PARAM,                                   USE_CAPS_PARAM,     ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_ReseauChangeCapaciteLiaisonAIndex,   "Reseau_ChangeCapaciteLiaisonAIndex",       "NETWORK_ChangeLinkCapacityToIndex",    "Func_ReseauChangeCapaciteLiaisonAIndex"  ,fn_p_stWayFunction, USE_CONSTANT_PARAM USE_CAPS_PARAM USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_ReseauLitPoidsLiaisonAIndex,         "Reseau_LitPoidsLiaisonAIndex",             "NETWORK_GetLinkWeightToIndex",         "Func_ReseauLitPoidsLiaisonAIndex"        ,fn_p_stWayFunction, USE_CONSTANT_PARAM,                                   USE_CONSTANT_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_ReseauChangePoidsLiaisonAIndex,      "Reseau_ChangePoidsLiaisonAIndex",          "NETWORK_ChangeLinkWeightToIndex",      "Func_ReseauChangePoidsLiaisonAIndex"     ,fn_p_stWayFunction, USE_CONSTANT_PARAM USE_CONSTANT_PARAM,                USE_CONSTANT_PARAM, ULTRA_ABLE )
	
	M_DEFINE_FUNCTION(eFunc_NetworkGetIndexOfWPInMSWay,             "Reseau_ChercheIndiceDuWP",                 "NETWORK_GetIndexOfWPInMSWay",          "Func_NetworkGetIndexOfWPInMSWay"         ,fn_p_stWayFunction,      USE_WAYPOINT_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_NetworkForceWPToCurrent,                "Reseau_ForceWPCourant",                    "NETWORK_ForceWPToCurrent",             "Func_NetworkForceWPToCurrent"            ,fn_p_stWayFunction,      USE_WAYPOINT_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
	
	NU_M_DEFINE_FUNCTION(eFunc_NetworkTestTheEnds,                  "Reseau_TestExtremities",                   "NETWORK_TestExtremite",                "Func_ReseauTestExtremite"                ,fn_p_stGetSituationOnRail, USE_REAL_PARAM,     USE_CONSTANT_PARAM, ULTRA_ABLE )
 
 
/* miscellaneous */
	M_DEFINE_FUNCTION(eFunc_ReseauLitCapaciteLiaisonDansGraph,   "Reseau_LitCapaciteLiaisonDansGraph",       "NETWORK_GetLinkCapInGraph",            "Func_ReseauLitCapaciteLiaisonDansGraph"    ,fn_p_stGraphFunction, USE_GRAPH_PARAM USE_WAYPOINT_PARAM USE_WAYPOINT_PARAM,                                   USE_CAPS_PARAM,     NOT_ULTRA_ABLE )
	M_DEFINE_FUNCTION(eFunc_ReseauChangeCapaciteLiaisonDansGraph,   "Reseau_ChangeCapaciteLiaisonDansGraph",    "NETWORK_SetLinkCapInGraph",            "Func_ReseauChangeCapaciteLiaisonDansGraph" ,fn_p_stGraphFunction, USE_GRAPH_PARAM USE_WAYPOINT_PARAM USE_WAYPOINT_PARAM USE_CAPS_PARAM USE_CONSTANT_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_ReseauLitPoidsLiaisonDansGraph,      "Reseau_LitPoidsLiaisonDansGraph",          "NETWORK_GetLinkWeightInGraph",         "Func_ReseauLitPoidsLiaisonDansGraph"       ,fn_p_stGraphFunction, USE_GRAPH_PARAM USE_WAYPOINT_PARAM USE_WAYPOINT_PARAM,                                   USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_ReseauChangePoidsLiaisonDansGraph,   "Reseau_ChangePoidsLiaisonDansGraph",       "NETWORK_SetLinkWeightInGraph",         "Func_ReseauChangePoidsLiaisonDansGraph"    ,fn_p_stGraphFunction, USE_GRAPH_PARAM USE_WAYPOINT_PARAM USE_WAYPOINT_PARAM USE_CONSTANT_PARAM,                USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	
	M_DEFINE_FUNCTION(eFunc_NetworkGetTypeOfWP,                  "Reseau_LitTypeDuWP",                       "NETWORK_GetTypeOfWP",                  "Func_NetworkGetTypeOfWP"                   ,fn_p_stMiscFuncOnTypeOfWP, USE_GRAPH_PARAM USE_WAYPOINT_PARAM, USE_CAPS_PARAM, NOT_ULTRA_ABLE )
/* Capability functions */
	NU_M_DEFINE_FUNCTION(eFunc_GetCapabilities,                     "Caps_LitCapacites",                        "CAPS_GetCapabilities",                 "Func_CapsGetCapabilities"                   ,fn_p_stPersoCapabilityFunction, USE_NO_PARAM, USE_CAPS_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_FUNCTION(eFunc_CapabilityAtBitNumber,                  "Caps_CapaciteAuBitNumero",                 "CAPS_CapabilityAtBitNumber",           "Func_CapabilityAtBitNumber"                ,fn_p_stCapabilityFunction, USE_CONSTANT_PARAM, USE_CAPS_PARAM, NOT_ULTRA_ABLE )
 
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetScrollSpeed				,           "MAT_VitesseTexture"                        ,"MAT_GetScrollSpeed",                  "Func_GetScrollSpeed"                       ,fn_p_stGetScrollSpeed,USE_CONSTANT_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetNbFrame					,           "ANI_LitNbFrame"						    ,"MAT_GetNbFrame",                      "Func_GetNbFrame"                           ,fn_p_stGetNbFrame,USE_NO_PARAM,USE_CONSTANT_PARAM,ULTRA_ABLE)
	//M_DEFINE_FUNCTION(eFunc_GetCurrentFrame					,        "ANI_LitFramecourante"						 ,"ANI_LitFramecourante",                 "Func_GetFramecourante"					,fn_p_stGetNbFrame,USE_NO_PARAM,USE_CONSTANT_PARAM,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_DotProduct					,           "VEC_ProduitScalaire"					    ,"VEC_DotProduct",                      "Func_DotProduct"                           ,fn_p_stDotProduct,USE_VECTOR_PARAM USE_VECTOR_PARAM,USE_REAL_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_CrossProduct				,           "VEC_ProduitVectoriel"					    ,"VEC_CrossProduct",                    "Func_CrossProduct"                         ,fn_p_stVectorOperations,USE_VECTOR_PARAM USE_VECTOR_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_FUNCTION(eFunc_Normalize					,           "VEC_Normer"							    ,"VEC_Normalize",                       "Func_Normalize"                            ,fn_p_stVectorOperations,USE_VECTOR_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_FUNCTION(eFunc_GetSPOCoordinates		,           "SPO_LitCoordonnees"					    ,"SPO_GetSPOCoordinates",               "Func_GetSPOCoordinates"                    ,fn_p_stGetSPOCoordinates,USE_SUPEROBJECT_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetTractionFactor			,           "ACT_LitFacteurDeTraction"				    ,"ACT_GetTractionFactor",               "Func_ACTGetTractionFactor"                 ,fn_p_stTractionFactorFunction, USE_NO_PARAM, USE_CONSTANT_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FUNCTION(eFunc_GetCenterZDEType			,           "ZON_LitCentreZDEType"					    ,"ZON_GetCenterZDEType",                "Func_GetCenterZDEType"                     ,fn_p_stGetZDxCenter,USE_PERSO_MASK_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_FUNCTION(eFunc_GetCenterZDMType			,           "ZON_LitCentreZDMType"					    ,"ZON_GetCenterZDMType",                "Func_GetCenterZDMType"                     ,fn_p_stGetZDxCenter,USE_PERSO_MASK_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_FUNCTION(eFunc_GetCenterZDRType			,           "ZON_LitCentreZDRType"					    ,"ZON_GetCenterZDRType",                "Func_GetCenterZDRType"                     ,fn_p_stGetZDxCenter,USE_PERSO_MASK_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_FUNCTION(eFunc_GetCenterZDDType			,           "ZON_LitCentreZDDType"					    ,"ZON_GetCenterZDDType",                "Func_GetCenterZDDType"                     ,fn_p_stGetZDxCenter,USE_PERSO_MASK_PARAM,USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_FUNCTION(eFunc_TextAffiche ,                           "TEXT_Affiche"                              ,"TEXT_DisplayText",                    "Func_TextAffiche"                          ,fn_p_stCode4TextAffiche, USE_ADDR_PERSO_PARAM USE_ALWAYS_PARAM USE_VECTOR_PARAM USE_STRING_PARAM USE_ADDR_LONG_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
    NU_M_DEFINE_FUNCTION(eFunc_GetCPUCounter ,                      "DEBUG_LitCompteurCPU"                      ,"DEBUG_GetCPUCounter",                 "Func_GetCPUCounter"                        ,fn_p_stGetCPUCounter, USE_NO_PARAM, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
