/************************************************************************************************
* Name: ProcRay2.h                                                                              *
* Use : Macro Definition of procedures for AI of Rayman II                                      *
* Author: Christophe Giraud                                                                     *                                                                    
*                                  (c) UBI Simulations Annecy                                   *
************************************************************************************************/
 
/**********************************************************************************************************************************************************************************************************************************************************/
    /* Magic points management */
	NU_M_DEFINE_PROCEDURE(eProc_FixePointsDeMagie		    ,"RAY_FixePointsDeMagie"			,"RAY_SetMagicPoints"               ,"Proc_FixePointsDeMagie"           ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_FixePointsDeMagieMax	    ,"RAY_FixePointsDeMagieMax"			,"RAY_SetMagicPointsMax"            ,"Proc_FixePointsDeMagieMax"        ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_InitPointsDeMagie		,"RAY_InitPointsDeMagie"			,"RAY_InitMagicPoints"              ,"Proc_InitPointsDeMagie"           ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_InitPointsDeMagieMax	,"RAY_InitPointsDeMagieMax"			,"RAY_InitMagicPointsMax"           ,"Proc_InitPointsDeMagieMax"        ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_AjoutePointsDeMagie	    ,"RAY_AjoutePointsDeMagie"			,"RAY_AddMagicPoints"               ,"Proc_AddMagicPoints"              ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_AjoutePointsDeMagieMax	    ,"RAY_AjoutePointsDeMagieMax"		,"RAY_AddMagicPointsMax"            ,"Proc_AddMagicPointsMax"           ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_EnlevePointsDeMagie	    ,"RAY_EnlevePointsDeMagie"			,"RAY_SubMagicPoints"               ,"Proc_SubMagicPoints"              ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_EnlevePointsDeMagieMax	,"RAY_EnlevePointsDeMagieMax"		,"RAY_SubMagicPointsMax"            ,"Proc_SubMagicPointsMax"           ,fn_p_stCode4MagicPointsProcedures, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
   /* Air points management */
	M_DEFINE_PROCEDURE(eProc_FixePointsDair			    ,"RAY_FixePointsDair"				,"RAY_SetAirPoints"                 ,"Proc_FixePointsDair"              ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_FixePointsDairMax		    ,"RAY_FixePointsDairMax"			,"RAY_SetAirPointsMax"              ,"Proc_FixePointsDairMax"           ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_InitPointsDair			,"RAY_InitPointsDair"				,"RAY_InitAirPoints"                ,"Proc_InitPointsDair"              ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_InitPointsDairMax		,"RAY_InitPointsDairMax"			,"RAY_InitAirPointsMax"             ,"Proc_InitPointsDairMax"           ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_AjoutePointsDair		    ,"RAY_AjoutePointsDair"				,"RAY_AddAirPoints"                 ,"Proc_AddAirPoints"                ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_AjoutePointsDairMax	    ,"RAY_AjoutePointsDairMax"			,"RAY_AddAirPointsMax"              ,"Proc_AddAirPointsMax"             ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_EnlevePointsDair		,"RAY_EnlevePointsDair"				,"RAY_SubAirPoints"                 ,"Proc_SubAirPoints"                ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_EnlevePointsDairMax	    ,"RAY_EnlevePointsDairMax"			,"RAY_SubAirPointsMax"              ,"Proc_SubAirPointsMax"             ,fn_p_stCode4AirPointsProcedures, USE_REAL_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
    NU_M_DEFINE_PROCEDURE(eProc_FixePositionFade		,"FAD_FixePositionFade"				,"FAD_FixePositionFade"                                    ,"Proc_FixePositionFade"            ,fn_p_stFixePositionFade, USE_SUPEROBJECT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
   	M_DEFINE_PROCEDURE(eProc_FixeLumierePersoLocal	,"LUM_FixeLumierePersoLocal"        ,"LIGHT_SetLocalPersoLight"		    ,"Proc_SetLocalPersoLight"		,fn_p_stSetLocalLight,USE_PERSO_PARAM USE_BOOLEAN_PARAM USE_BOOLEAN_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_FixeLumiereStaticOnOff	,"LUM_FixeLumiereStaticOnOff"       ,"LIGHT_SetStaticLightOnOff"		,"Proc_SetStaticLightOnOff"		,fn_p_stSetLight,USE_LIGHT_PARAM USE_BOOLEAN_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_FixeLumiereStaticNearFar,"LUM_FixeLumiereStaticNearFar"     ,"LIGHT_SetStaticLightNearFar"		,"Proc_SetStaticLightNearFar"	,fn_p_stSetLight,USE_LIGHT_PARAM USE_2_REALS_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_FixeLumiereStaticColor	,"LUM_FixeLumiereStaticCouleur"     ,"LIGHT_SetStaticLightColor"		,"Proc_SetStaticLightColor"		,fn_p_stSetLight,USE_LIGHT_PARAM USE_4_REALS_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_CalculeLumiereEffet		,"LUM_CalculeLumiereEffet"          ,"LIGHT_ComputeLightEffect"			,"Proc_ComputeLightEffect"		,fn_p_stSetLight,USE_NO_PARAM,NOT_ULTRA_ABLE)
/* Blend RLI */
	M_DEFINE_PROCEDURE(eProc_NoRLI					,"LUM_RLIDesactive"					,"LIGHT_RLIPasDeRLI"                ,"Proc_RLIPasDeRLI"                 ,fn_p_stRLIProcedure, USE_NO_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_FixeRLI					,"LUM_RLIFixe"						,"LIGHT_RLIFixe"                    ,"Proc_RLIFixe"                     ,fn_p_stRLIProcedure, USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_BlendRLI				,"LUM_RLIBlend"						,"LIGHT_RLIBlend"                   ,"Proc_RLIBlend"                    ,fn_p_stRLIProcedure, USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
/* Type Of WP */
	M_DEFINE_PROCEDURE(eProc_ChangeTypeOfWP		        ,"Reseau_ChangeTypeDuWP"			,"NETWORK_ChangeWPType"             ,"Proc_ChangeTypeOfWP"              ,fn_p_stMiscProcOnTypeOfWP, USE_GRAPH_PARAM USE_WAYPOINT_PARAM USE_CAPS_PARAM USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
/* Capability procedures */
	M_DEFINE_PROCEDURE(eProc_SetCapabilities            ,"Caps_FixeCapacites"               ,"CAPS_SetCapabilities"             ,"Proc_CAPSSetCapabilities"         ,fn_p_stCapabilityProcedure, USE_CAPS_PARAM,                    ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_AddCapabilities         ,"Caps_AjouteCapacites"             ,"CAPS_AddCapabilities"             ,"Proc_CAPSAddCapabilities"         ,fn_p_stCapabilityProcedure, USE_CAPS_PARAM,                    ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SubCapabilities         ,"Caps_EnleveCapacites"             ,"CAPS_SubCapabilities"             ,"Proc_CAPSSubCapabilities"         ,fn_p_stCapabilityProcedure, USE_CAPS_PARAM,                    ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_ChangeCapabilities      ,"Caps_ChangeCapacites"             ,"CAPS_ChangeCapabilities"          ,"Proc_CAPSChangeCapabilities"      ,fn_p_stCapabilityProcedure, USE_CAPS_PARAM USE_CONSTANT_PARAM, ULTRA_ABLE )
/* Reinit Graph */
	M_DEFINE_PROCEDURE(eProc_ReinitGraph             ,"Reseau_ReinitGraph"               ,"NETWORK_ReinitGraph"              ,"Proc_ReinitGraph"                 ,fn_p_stReinitGraphProcedure, USE_GRAPH_PARAM, NOT_ULTRA_ABLE )
 
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_PROCEDURE(eProc_FixeVitesseTexture         ,"MAT_FixeVitesseTexture"           ,"MAT_SetScrollSpeed"               ,"Proc_SetScrollSpeed"              ,fn_p_stSetScrollSpeed, USE_GMT_PARAM USE_2_REALS_PARAM, NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_ScrollingOnOff             ,"MAT_ScrollingOnOff"               ,"MAT_SetScrollOnOff"               ,"Proc_SetScrollOnOff"              ,fn_p_stSetScrollSpeed, USE_GMT_PARAM USE_BOOLEAN_PARAM, NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_FixeDecalageTexture        ,"MAT_FixeDecalageTexture"          ,"MAT_SetTextureOffset"             ,"Proc_SetTextureOffset"            ,fn_p_stSetScrollSpeed, USE_GMT_PARAM USE_2_REALS_PARAM, NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_ScrollingPause             ,"MAT_ScrollingPause"               ,"MAT_SetScrollPause"               ,"Proc_SetScrollPause"              ,fn_p_stSetScrollSpeed, USE_GMT_PARAM USE_BOOLEAN_PARAM, NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_ChangeCurrFrame		    ,"ANI_ChangeFrameCourante"		    ,"ANI_ChangeCurrFrame"              ,"Proc_ChangeCurrFrame"             ,fn_p_stManageFrame,USE_CONSTANT_PARAM,ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_ChangeRandomFrame		    ,"ANI_ChangeFrameAleatoire"			,"ANI_ChangeRandomFrame"            ,"Proc_ChangeRandomFrame"           ,fn_p_stManageFrame,USE_NO_PARAM,ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_FreezeAnim				    ,"ANI_GelerPerso"					,"ANI_FreezeAnim"                   ,"Proc_FreezeAnim"                  ,fn_p_stFreezeAnim,USE_NO_PARAM,ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_UnFreezeAnim			    ,"ANI_DegelerPerso"					,"ANI_UnFreezeAnim"                 ,"Proc_UnFreezeAnim"                ,fn_p_stFreezeAnim,USE_NO_PARAM,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetSuperimposed		    ,"SPO_SetSuperimposed"				,"SPO_SetSuperimposed"              ,"Proc_SetSuperimposed"		        ,fn_p_stSPOSuperimpoed, USE_CONSTANT_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM , ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_SetSuperimposed2		    ,"SPO_SetSuperimposed2"  			,"SPO_SetSuperimposed2"             ,"Proc_SetSuperimposed2"	        ,fn_p_stSPOSuperimpoed, USE_REAL_PARAM USE_REAL_PARAM USE_REAL_PARAM , ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_ReleaseSuperimposed	    ,"SPO_ReleaseSuperimposed"		    ,"SPO_ReleaseSuperimposed"          ,"Proc_ReleaseSuperimposed"	        ,fn_p_stSPOSuperimpoed, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_PROCEDURE(eProc_SetSPOCoordinates	    ,"SPO_FixeCoordonnees"			    ,"SPO_SetCoordinates"               ,"Proc_SetCoordinates"	            ,fn_p_stSetSPOCoordinates,USE_SUPEROBJECT_PARAM USE_VECTOR_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_SwitchSuperimposedTab		,"SPO_SwitchSuperimposedTab"        ,"SPO_SwitchSuperimposedTab"        ,"Proc_SwitchSuperimposedTab"		,fn_p_stSPOSuperimpoed, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetTractionFactor	    ,"ACT_FixeFacteurDeTraction"		,"ACT_SetTractionFactor"            ,"Proc_ACTsetTractionFactor"         ,fn_p_stTractionFactorProcedure, USE_CONSTANT_PARAM, ULTRA_ABLE )
	M_DEFINE_PROCEDURE(eProc_TurnToPositionAngle	    ,"ACT_OrienteVersPositionAngle"     ,"ACT_TurnToPositionAngle"          ,"Proc_TurnToPositionAngle"         ,fn_p_stTurnToPosition,USE_VECTOR_PARAM USE_REAL_PARAM,ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_TurnToPositionSpeed	    ,"ACT_OrienteVersPositionVitesse"	,"ACT_TurnToPositionSpeed"          ,"Proc_TurnToPositionSpeed"         ,fn_p_stTurnToPosition,USE_VECTOR_PARAM USE_REAL_PARAM,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_PROCEDURE(eProc_SortArray	 		    ,"TAB_Trie"							,"ARRAY_Sort"                       ,"Proc_TABSortArray"                ,fn_p_stSortArray,USE_ADDR_ARRAY_PARAM USE_2_CONSTANTS_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_ActiveJoystickAnal		    ,"Option_ActiveJoystickAnalogique"	,"OPTION_ActiveJoystickAnal"        ,"Proc_ActiveJoystickAnal"          ,fn_p_stActiveJoystickAnal,USE_NO_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_UnActiveJoystickAnal    ,"Option_DesactiveJoystickAnalogique","OPTION_UnActiveJoystickAnal"     ,"Proc_UnActiveJoystickAnal"        ,fn_p_stActiveJoystickAnal,USE_NO_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetZDMSizeSphere		    ,"ZON_FixeTailleZDMSphere"			,"ZON_SetZDMSizeSphere"             ,"Proc_SetZDMSizeSphere"            ,fn_p_stSetZDxSize,USE_ZDM_PERSO_PARAM USE_REAL_PARAM,ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_SetZDDSizeCone		    ,"ZON_FixeTailleZDDCone"			,"ZON_SetZDDSizeCone"               ,"Proc_SetZDDSizeCone"              ,fn_p_stSetZDxSize,USE_ZDD_PERSO_PARAM USE_2_REALS_PARAM,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_PROCEDURE(eProc_SetSoundVolumeAnim	    ,"SON_FixeAnimVolume"				,"SOUND_SetVolumeAnim"              ,"Proc_SetVolumeAnim"               ,fn_p_stSetSoundVolume,USE_CONSTANT_PARAM,ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_SetSoundVolumeMusic	    ,"SON_FixeMusicVolume"				,"SOUND_SetVolumeMusic"             ,"Proc_SetVolumeMusic"              ,fn_p_stSetSoundVolume,USE_CONSTANT_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_SetSoundVolumeAmbiance	    ,"SON_FixeAmbianceVolume"			,"SOUND_SetVolumeAmbiance"          ,"Proc_SetVolumeAmbiance"           ,fn_p_stSetSoundVolume,USE_CONSTANT_PARAM,NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_SetDopplerEffect		    ,"SON_ChangeEffetDoppler"			,"SOUND_SetDopplerEffect"           ,"Proc_SetDopplerEffect"            ,fn_p_stSetDopplerEffect,USE_REAL_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_PauseSound				    ,"SON_Pause"						,"SOUND_PauseSound"                 ,"Proc_PauseSound"                  ,fn_p_stPauseSound,USE_NO_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_ResumeSound			    ,"SON_Reprendre"					,"SOUND_ResumeSound"                ,"Proc_ResumeSound"                 ,fn_p_stPauseSound,USE_NO_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_StopMenuSound			    ,"SON_ArretSonMenu"					,"SOUND_StopMenuSound"              ,"Proc_StopMenuSound"               ,fn_p_stPauseSound,USE_NO_PARAM,NOT_ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_PROCEDURE(eProc_ChangeCaractere		    ,"TEXT_ChangeCaractere"				,"TEXT_ChangeCharactere"            ,"Proc_ChangeCaractere"             ,fn_p_stCode4ChangeCaractere, USE_ALWAYS_PARAM USE_STRING_PARAM USE_CONSTANT_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_FormateTexte  		        ,"TEXT_FormateTexte"				,"TEXT_FormatText"                  ,"Proc_FormateTexte"                ,fn_p_stCode4FormateTexte   , USE_STRING_PARAM USE_STRING_PARAM USE_STRING_PARAM, /**/ NOT_ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_ValideNomDuSlot  		    ,"MNU_ValideNomDuSlot"				,"MNU_ValidateSlotName"             ,"Proc_ValideNomDuSlot"             ,fn_p_stCode4ValideNomDuSlot, USE_CONSTANT_PARAM USE_STRING_PARAM USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_RestoreNomDuSlot  		    ,"MNU_RestoreNomDuSlot"				,"MNU_RestoreSlotName"             ,"Proc_RestoreNomDuSlot"             ,fn_p_stCode4RestoreNomDuSlot, USE_CONSTANT_PARAM, /**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_ChangePersoSighting	    ,"ACT_ChangeViseePerso"				,"ACT_ChangeActorSighting"          ,"Proc_ChangePersoSighting"         ,fn_p_stChangePersoHorizSighting, USE_VECTOR_PARAM, /**/ ULTRA_ABLE /**/)
	M_DEFINE_PROCEDURE(eProc_PlayDemo                   ,"DEM_JoueDemo"                     ,"DEM_PlayDemo"                     ,"Proc_PlayDemo"                    ,fn_p_stPlayDemo            , USE_STRING_PARAM USE_STRING_PARAM USE_BOOLEAN_PARAM USE_STRING_PARAM,     /**/ NOT_ULTRA_ABLE /**/)
/* Specific PC IA procs*/
#ifndef U64

	M_DEFINE_PROCEDURE(eProc_InitKeyBoardDirections     ,"PAD_InitKeyBoardDirections"		,"PAD_InitKeyBoardDirections"       ,"PAD_InitKeyBoardDirections"       ,fn_p_stInitKeyBoardDirections, USE_BUTTON_PARAM USE_BUTTON_PARAM USE_BUTTON_PARAM USE_BUTTON_PARAM USE_BUTTON_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_PadSetCenterposition	    ,"PAD_SetCenterPosition"			,"PAD_SetCenterPosition"            ,"PAD_SetCenterPosition"            ,fn_p_stSetCenterPosition,	USE_NO_PARAM,  NOT_ULTRA_ABLE)
	M_DEFINE_PROCEDURE(eProc_PadSetMaximalValues	    ,"PAD_SetMaximalValues"				,"PAD_SetMaximalValues"             ,"PAD_SetMaximalValues"             ,fn_p_stSetMaximalValues,	USE_NO_PARAM,  NOT_ULTRA_ABLE)
#else
	/*XB Groumpf !!!!!*/
	/*Add dummy entries because of CFast IA functions'call is index based !!!!*/

	M_DEFINE_PROCEDURE(eProc_InitKeyBoardDirections     ,"PAD_InitKeyBoardDirections"		,"PAD_InitKeyBoardDirections"       ,"PAD_InitKeyBoardDirections"       ,fn_p_stDummy, USE_BUTTON_PARAM USE_BUTTON_PARAM USE_BUTTON_PARAM USE_BUTTON_PARAM USE_BUTTON_PARAM,/**/ NOT_ULTRA_ABLE /**/ )
	M_DEFINE_PROCEDURE(eProc_PadSetCenterposition	    ,"PAD_SetCenterPosition"			,"PAD_SetCenterPosition"            ,"PAD_SetCenterPosition"            ,fn_p_stDummy,	USE_NO_PARAM,  NOT_ULTRA_ABLE)
	NU_M_DEFINE_PROCEDURE(eProc_PadSetMaximalValues	    ,"PAD_SetMaximalValues"				,"PAD_SetMaximalValues"             ,"PAD_SetMaximalValues"             ,fn_p_stDummy,	USE_NO_PARAM,  NOT_ULTRA_ABLE)
	/*End XB*/
#endif
/* End Specific PC IA procs*/
 
/* ANNECY MT - 22/10/98 {*/
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_PROCEDURE(eProc_ChangeTooFarLimit		    ,"ACT_FixeLimiteEloignement"		,"ACT_ChangeTooFarLimit"            ,"Proc_ChangeTooFarLimit"		    ,fn_p_stSetTooFarLimit,			USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_ChangeTransparencyZone     ,"ACT_FixeZoneTransparence"			,"ACT_ChangeTransparencyZone"       ,"Proc_ChangeTransparencyZone"      ,fn_p_stSetTransparencyZone,	USE_CONSTANT_PARAM	USE_CONSTANT_PARAM, /**/ ULTRA_ABLE /**/)
/* END ANNECY MT }*/
 
    NU_M_DEFINE_PROCEDURE(eProc_SetBaseFrequenceForMenu ,"Effect_SetBaseFrequenceForMenu"  ,"Effect_SetBaseFrequenceForMenu" ,"Proc_SetBaseFrequenceForMenu" ,fn_p_stBaseFrequenceForMenu,			USE_REAL_PARAM, /**/ NOT_ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_SaveSinusContext		     ,"Effect_SaveSinusContext"         ,"Effect_SaveSinusContext"        ,"Proc_SaveSinusContext"        ,fn_p_stSaveSinusEffectContext,		USE_NO_PARAM, /**/ NOT_ULTRA_ABLE /**/)
    M_DEFINE_PROCEDURE(eProc_RestoreSinusContext     ,"Effect_RestoreSinusContext"      ,"Effect_RestoreSinusContext"     ,"Proc_RestoreSinusContext"		  ,fn_p_stSaveSinusEffectContext,		USE_NO_PARAM, /**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_PROCEDURE(eProc_TextSuperImposed,                       "TEXT_SuperImposed"                         ,"TEXT_SuperImposed",                   "Func_TextSuperImposed"                     ,fn_p_stTextSuperImposed, USE_CONSTANT_PARAM, NOT_ULTRA_ABLE )
