/*
  MODULE : COL (Intersection & Collision Library)
  AUTHOR : Frederic PHILIPPE
           UBI R&D
  FILE : COL.h (Principal header file)
*/
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_COL
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_COL
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef COL_H
#define COL_H
 
struct GLI_tdstDataOfElement_;
#include "COL/Futil.h"
 
#include "COL/Box.h"
#include "COL/Inters.h"
#include "COL/IntersGO.h"
#include "COL/OctreeGO.h"
 
#include "COL/CollGOUt.h"
#include "COL/CollGOCo.h"
 
#include "COL/CsEltPts.h"
#include "COL/CsEltEdg.h"
#include "COL/CsSphElt.h"
 
#include "COL/CollGO.h"
 
#endif /* COL_H */
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
