/* Header for the definition of a boolean characteristic */
/*/////////////////////////////////////////////////////////*/
#ifndef _CTL_DECIMAL_DATA_
#define _CTL_DECIMAL_DATA_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
#include "CTL_Dat.hpp"
 
class CPA_EXPORT CTL_Editor_DecimalData : public CTL_Editor_Data
{
/*Constructor / Destructor*/
public:
	CTL_Editor_DecimalData(	char cDataSize, 
													CString,
													CTL_Editor_DataList *_pclParentList,
													CTL_Editor_Data *pclCurrentBaseData = NULL);
 
	~CTL_Editor_DecimalData();
 
/*Attributes*/
public:
	long double m_ldCurrentValue;
	long double m_ldOldValue;
	
	long double m_ldKeepedValueForUndo;
 
	char m_cDataSize;
 
protected:
 
private:
	
/*Member functions*/
public:
	/*Function called to get a string representing the value of the data*/
	CStringList *m_fn_pcslFormatDataValueString();
  /*Function called to set the value of the data acoording to a string representing it*/
	void m_fn_vSetValueWithString(CStringList *);
 
	/*Function called to Init the data*/
	void m_fn_vInitData();
 
	/*Function called to read associated motor's data*/
	void m_fn_vGetMotorData();
	
	/*Function called to update associated motor's data*/
	void m_fn_vUpdateMotorData(CTL_tdeUpdateReason eReason = CTL_UPDATE_REASON__NO_REASON_GIVEN,
														 long _lUserDefinedReason = 0);
 
	/*Function called to update data with another one*/
	void m_fn_vUpdateData(CTL_Editor_Data *pclSourceData,
												CTL_tdeUpdateReason eReason = CTL_UPDATE_REASON__NO_REASON_GIVEN,
												long _lUserDefinedReason = 0);
 
	/*Function called to look if data has been modified (by motor for example)*/
	void m_fn_vLookIfDataHasBeenModified();
 
	/*Undo*/
	/*Function called to save the current Value (for Undo)*/
	void m_fn_vKeepCurrentValue();
 
	/*Function called to validate Undo for the current change*/
	void m_fn_vRegisterUndoAction();
 
	/*CPA2 Stegaru Cristian 98/06/24*/
	virtual BOOL mfn_bEqualsModifiedDataOldValue (CTL_Editor_Data *pModifiedData);
	long double mfn_ldSetCurrentValue (long double ldValue)
	{
		if (m_ldCurrentValue != ldValue)
		{
			m_ldOldValue = m_ldCurrentValue;
			m_ldCurrentValue = ldValue;
		}
		return m_ldOldValue;
	}
	long double mfn_ldGetCurrentValue () { return m_ldCurrentValue;}
	/*End CPA2 Stegaru Cristian 98/06/24*/
 
protected:
 
private:
 
};
 
#endif /*_CTL_DECIMAL_DATA_*/
