/* Header for the definition of a Masked Data characteristic */
/*/////////////////////////////////////////////////////////*/
#ifndef _CTL_MASKED_DATA_
#define _CTL_MASKED_DATA_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
/*#include <afxtempl.h>*/
 
#include "CTL_Dat.hpp"
 
class CTL_Editor_MaskDescriptor;
 
class CPA_EXPORT CTL_Editor_MaskedData : public CTL_Editor_Data
{
public:
	/*Constructors*/
	/*for a Boolean coded on (at least) a char*/
	CTL_Editor_MaskedData(CTL_Editor_MaskDescriptor *_pclMaskdescriptor,
												CString,
												CTL_Editor_DataList *_pclParentList,
												CTL_Editor_Data *pclCurrentBaseData = NULL);
 
	/* Destructor*/
	~CTL_Editor_MaskedData();
 
/*Attributes*/
public:
 	unsigned long m_ulCurrentValue;
	unsigned long m_ulOldValue;
 
 	unsigned long m_ulKeepedValueForUndo;
 
protected:
 
private:
	CTL_Editor_MaskDescriptor *m_pri_pclMaskdescriptor;
 
/*Member functions*/
public:
	/*Function called to get a string representing the value of the data*/
	CStringList *m_fn_pcslFormatDataValueString();
 	/*Function called to set the value of the data acoording to a string representing it*/
	void m_fn_vSetValueWithString(CStringList *);
 
	/*Function called to Init the data*/
	void m_fn_vInitData();
 
	/*Function called to read associated motor's data*/
	void m_fn_vGetMotorData();
	
	/*Function called to update associated motor's data*/
	void m_fn_vUpdateMotorData(CTL_tdeUpdateReason eReason = CTL_UPDATE_REASON__NO_REASON_GIVEN,
														 long _lUserDefinedReason = 0);
 
	/*Function called to update data with another one*/
	void m_fn_vUpdateData(CTL_Editor_Data *pclSourceData,
												CTL_tdeUpdateReason eReason = CTL_UPDATE_REASON__NO_REASON_GIVEN,
												long _lUserDefinedReason = 0);
 
	/*Function called to look if data has been modified (by motor for example)*/
	void m_fn_vLookIfDataHasBeenModified();
 
	/*Undo*/
	/*Function called to save the current Value (for Undo)*/
	void m_fn_vKeepCurrentValue();
 
	/*Function called to validate Undo for the current change*/
	void m_fn_vRegisterUndoAction();
	/*CPA2 Stegaru Cristian 98/06/24*/
	virtual BOOL mfn_bEqualsModifiedDataOldValue (CTL_Editor_Data *pModifiedData);
	unsigned long mfn_ulSetCurrentValue (unsigned long ulValue)
	{
		if (m_ulCurrentValue != ulValue)
		{
			m_ulOldValue = m_ulCurrentValue;
			m_ulCurrentValue = ulValue;
		}
		return m_ulOldValue;
	}
	unsigned long mfn_ulGetCurrentValue () { return m_ulCurrentValue;}
	/*End CPA2 Stegaru Cristian 98/06/24*/
 
	/**/
	CTL_Editor_MaskDescriptor *m_pub_fn_pclGetMaskdescriptor();
 
protected:
 
private:
 
};											   
 
#endif /*_CTL_MASKED_DATA_*/
