/* Header for the definition of a text characteristic */
/*/////////////////////////////////////////////////////////*/
#ifndef _CTL_TEXT_DATA_
#define _CTL_TEXT_DATA_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
#include "CTL_Dat.hpp"
 
class CPA_EXPORT CTL_Editor_TextData : public CTL_Editor_Data
{
/*Constructor / Destructor*/
public:
	CTL_Editor_TextData(CString,
											CTL_Editor_DataList *_pclParentList,
											CTL_Editor_Data *pclCurrentBaseData = NULL);
 
	~CTL_Editor_TextData();
 
/*Attributes*/
public:
	CString m_csCurrentString;
	CString m_csOldString;
 
protected:
 
private:
	
/*Member functions*/
public:
	/*Function called to get a string representing the value of the data*/
	CStringList *m_fn_pcslFormatDataValueString();
  /*Function called to set the value of the data acoording to a string representing it*/
	void m_fn_vSetValueWithString(CStringList *);
 
	/*Function called to Init the data*/
	void m_fn_vInitData();
 
	/*Function called to read associated motor's data*/
	void m_fn_vGetMotorData();
	
	/*Function called to update associated motor's data*/
	void m_fn_vUpdateMotorData(CTL_tdeUpdateReason eReason = CTL_UPDATE_REASON__NO_REASON_GIVEN,
														 long _lUserDefinedReason = 0);
 
	/*Function called to update data with another one*/
	void m_fn_vUpdateData(CTL_Editor_Data *pclSourceData,
												CTL_tdeUpdateReason eReason = CTL_UPDATE_REASON__NO_REASON_GIVEN,
												long _lUserDefinedReason = 0);
 
	/*Function called to look if data has been modified (by motor for example)*/
	void m_fn_vLookIfDataHasBeenModified();
 
	/*CPA2 Stegaru Cristian 98/06/24*/
	virtual BOOL mfn_bEqualsModifiedDataOldValue (CTL_Editor_Data *pModifiedData);
	CString mfn_csSetCurrentString (CString csText)
	{
		if (m_csCurrentString != csText)
		{
			m_csOldString = m_csCurrentString;
			m_csCurrentString = csText;
		}
		return m_csOldString;
	}
	CString mfn_csGetCurrentString () { return m_csCurrentString;}
 
	/*End CPA2 Stegaru Cristian 98/06/24*/
protected:
 
private:
 
};
 
#endif /*_CTL_TEXT_DATA_*/
