/* CTL_Editor_Edit windows*/
/**/
/* YB*/
/*///////////////////////////////////////////////////////////////////////////*/
#ifndef _CPACSPED_HPP_
#define _CPACSPED_HPP_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
#include "ACP_Base.h"
#include "CTL\WControls\CTL_BWC.hpp"
 
class CTL_Editor_IntegerControl;
class CTL_Editor_DecimalControl;
class CTL_Editor_VectorControl;
 
/*############################################################################*/
typedef enum CTL_eEditType
{
	CTL_EDIT_TYPE__INTEGER = 0,
	CTL_EDIT_TYPE__DECIMAL,
	CTL_EDIT_TYPE__VECTOR,
																			 
} CTL_tdeEditType;
 
/*############################################################################*/
 
class CPA_EXPORT CTL_Editor_Edit :	public CEdit,
																		public CTL_BaseWindowsControl
{
/* Construction*/
public:
	CTL_Editor_Edit(long _lMin, 
									long _lMax,
									long _lAdditionnalStyles,
									CTL_Editor_IntegerControl *_pclControl,
									CWnd *_pclParentWnd,
								  long _lUserDefinedType = 0,
								  long _lUserDefinedCode = 0);
 
	CTL_Editor_Edit(long double _ldMin, 
									long double _ldMax,
									long _lAdditionnalStyles,
									CTL_Editor_DecimalControl *_pclControl,
									CWnd *_pclParentWnd,
								  long _lUserDefinedType = 0,
								  long _lUserDefinedCode = 0);
 
	CTL_Editor_Edit(long double _ldMin, 
									long double _ldMax,
									long _lAdditionnalStyles,
									CTL_Editor_VectorControl *_pclControl,
									CWnd *_pclParentWnd,
									long _lUserDefinedType = 0,
									long _lUserDefinedCode = 0);
 
/* Attributes*/
public:
 
private:
	CTL_tdeEditType m_pri_tdeType;
 
	/*For integers*/
	CTL_Editor_IntegerControl *m_pri_pclIntegerControl;
	long m_pri_lMin, m_pri_lMax, m_pri_lCurrent;
 
	/*For decimals*/
	CTL_Editor_DecimalControl *m_pri_pclDecimalControl;
	long double m_pri_ldMin, m_pri_ldMax, m_pri_ldCurrent;
	
	/*For vectirs*/
	CTL_Editor_VectorControl *m_pri_pclVectorControl;
 
/* Operations*/
public:
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CTL_Editor_Edit)*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
public:
	virtual ~CTL_Editor_Edit();
 
	void m_fn_vSetCurrentValue(long lNewValue);
	void m_fn_vSetCurrentValue(long double ldNewValue);
 
	/*For TUT registration*/
	virtual void m_pub_fn_vRegisterWindowsControl(CString _csAdditionnalInfo);
 
	/* Generated message map functions*/
protected:
/*ROMTEAM Selection (Cristian Stegaru 24/03/98)*/
	void mfn_vRefreshMotorData ();
/*ENDROMTEAM Selection (Cristian Stegaru)*/
	/*{{AFX_MSG(CTL_Editor_Edit)*/
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKillFocus( CWnd* pNewWnd );
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	/*}}AFX_MSG*/
 
	DECLARE_MESSAGE_MAP()
};
 
/*///////////////////////////////////////////////////////////////////////////*/
#endif /*_CPACSPED_HPP_*/
 
