/*=========================================================================
* 3DOSLib.h :  This file contain included all files of 3DOS project.
*
* Version              1.0
* Creation date        16/12/96
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1996
*=======================================================================*/
 
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions :
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_GAM
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_GAM
/* End Of Top File Dependancies checking instructions.
   ###############################################################################################
*/
 
 
 
#if !defined(__3DOSLIB_H__)
#define __3DOSLIB_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
 
 
/**** Include Handles, Options and Macros headers ****/
#include "GAM/Options/Options.h"
#include "GAM/Macros.h"
 
/**** Include all 3DOS mini-structures headers ****/
#include "GAM/GAMHandl.h"
#include "GAM/Structur/StdObjSt.h"
 
#include "GAM/Actions/AllActs.h"
 
/**** Include all 3DOS structures headers ****/
#include "GAM\Structur/3DOSLkTb.h"
#include "GAM\Structur/MemGame.h"
#include "GAM\Structur/ErrGame.h"
#include "GAM\Structur/GameScpt.h"
#include "GAM\Structur/EngMode.h"
#include "GAM\Structur/Objects.h"
#include "GAM\Structur/State.h"
#include "GAM\Structur/Anim_s.h"
#include "GAM\Structur/objstbls.h"
 
/**** Include all 3DOS animation headers ****/
#include "GAM/PlayAnim/PlayAnim.h"
#include "GAM/PlayAnim/PlayEvts.h"
#include "GAM/PlayAnim/Anim.h"
 
 
 
 
/**** Include all 3DOS headers ****/
#include "GAM/GameEng.h"
#include "GAM/Basic.h"
#include "GAM/chanlist.h"
#include "GAM/ObjInit.h"
#include "GAM/ObjType.h"
#include "GAM/ZdxStuff.h"
#include "GAM/Zemem.h"
#include "GAM/Family.h"
#include "GAM/TBLLoad.h"
 
#include "GAM/Always.h"
#include "GAM/Caps.h"
#include "GAM/Clock.h"
#include "GAM/ColMotor.h"
#include "GAM/Engine.h"
#include "GAM/GamSave.h"
#include "GAM/HitPts.h"
#include "GAM/InitEng.h"
#include "GAM/LoadAni.h"
#include "GAM/LoadGame.h"
#include "GAM/LoadFml.h"
#include "GAM/LoadLvl.h"
#include "GAM/MainChar.h"
#include "GAM/ia_dnm.h"
#include "GAM/typecam.h"
#include "GAM/CHLLoad.h"
#include "GAM/toolmatr.h"
#include "GAM/toolcam.h"
/*#include "GAM/servctrl.h"*/
#include "GAM/physicol.h"
#include "GAM/Effect.h"
#include "GAM\LipsSync.h"
#include "GAM\Micros.h"
#include "GAM\collisio.h"
#include "GAM\AlwAct.h"
#include "GAM\GamOpt.h"
#include "GAM\TextFrmt.h"
 
#include "GAM\Locale\fonpub.h"
#include "GAM\Locale\fontext.h"
#include "GAM\Locale\fonload.h"
 
#endif /* !__3DOSLIB_H__*/
 
/* ##############################################################################################
 This must be at the End of this file.
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions.
   ##############################################################################################
*/
