#ifndef __LOADLSYN_H__
#define __LOADLSYN_H__
 
#ifdef D_USE_LIPSYNC
#ifdef  __cplusplus
extern "C" {
#endif
 
#define C_SectionA3dLSGeneral		"A3dLSGeneral"
#define C_EntryNumberOfFrames		"TotalFrameNumber"
#define C_EntryLSSpeed				"NbFramesPerSecond"
#define C_EntryLSSound				"LoadSoundEvent"
#define C_EntryLSStopSound			"LoadStopSoundEvent"	/* MR0808*/
#define C_EntryLSChannelNumber		"SelectedChannel"
#define C_EntryNumberOfTexts		"TextNumber"			/* MR1908*/
#define C_EntryNumberOfActings		"ActingNumber"
 
#define C_SectionA3dLSData			"A3dLSData"
#define C_EntryLSMouth				"LSMouth"
#define C_EntryLSIntensity			"LSIntensity"
#define C_EntryLSExpression			"LSExpression"
 
/* MR1908*/
#define C_SectionTextDial			"Text"
#define C_EntryDisplayText			"DisplayText"
 
/* MR2108*/
#define C_SectionLSActing			"Acting"
#define C_EntryActingFlag			"ActingFlag"
 
#define C_SectionDialogue			"TextDial"
#define C_EntryText					"Text"
#define C_EntryFont					"Font"
#define C_EntryPosition				"Pos"
 
#define C_SectionActing				"ActingDescription"
#define C_EntryNewState				"NewState"
 
extern CPA_EXPORT void fn_vLipsSynchroLoadInit();
 
#if !defined(U64)
extern CPA_EXPORT SCR_tdst_Link_Table *fn_p_stGetLipsSynchroLinkTable();
#endif /* U64 */
 
/* For BIN*/
/*----------------------------------------------------------------------------
//  Description : GAM_fn_ulWriteLipsSynchroBinaryBloc
//  Write a binary bloc for a lip synchro structure
------------------------------------------------------------------------------
//  Input :		_ulStructAddress : Address of the element indexed triangle
//				_p_cDestBuffer : Pointer to the buffer
//  Output :	length of the data written
----------------------------------------------------------------------------*/
extern CPA_EXPORT unsigned long GAM_fn_ulWriteLipsSynchroBinaryBloc(unsigned long _ulStructAddress, 
																	char* _p_cDestBuffer);
 
/*-----------------------------------------------------------------------------
 *  Description : Read binary function for Lips synchro table
 *-----------------------------------------------------------------------------
 *  Input :		_ulLST : Address of the lips synchro table
 *  Output :	
 *---------------------------------------------------------------------------*/
extern CPA_EXPORT void GAM_fn_vResolveLSTBinaryBloc(unsigned long _ulLST);
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /*  D_USE_LIPSYNC*/
 
#endif /* __LOADLSYN_H__ */
