/*=========================================================================
* ToolsCPA.h : CPA tools include
*
*
* Version              1.0
* Creation date        10/01/97
*	Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1997
*=======================================================================*/
 
#if !defined(__CPATOOLS_H__)
#define __CPATOOLS_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
/****************************************
 * Here is the list of disabled WARNING *
 ****************************************/
#if defined(VISUAL)
#pragma warning(disable:4010) /** single-line comment contains line-continuation character **/
#pragma warning(disable:4032) /** formal parameter 1 has different type when promoted **/
#pragma warning(disable:4100) /** unreferenced formal parameter **/
#pragma warning(disable:4115) /** named type definition in parentheses **/
#pragma warning(disable:4127) /** conditional expression is constant **/
#pragma warning(disable:4201) /** nonstandard extension used : nameless struct/union **/
#pragma warning(disable:4213) /** nonstandard extension used : cast on l-value **/
#pragma warning(disable:4214) /** nonstandard extension used : bit field types other than int **/
#pragma warning(disable:4310) /** cast truncates constant value **/
#pragma warning(disable:4514) /** unreferenced inline function has been removed **/
#pragma warning(disable:4702) /** unreachable code **/
#pragma warning(disable:4711) /** selected for automatic inline expansion **/
#endif /* VISUAL */
 
#if defined(WIN32)&&defined(__cplusplus)
#include "stdafx.h"
#endif /* WIN32&&__cplusplus */
 
#define HieFriend
#include "ACP_Base.h"
#include "CPA_Expt.h"
#include "CPA_Std.h"
 
#include "Options\Options.h"
 
#include "SAI.h"
#include "MTH.h"
#include "POS.h"
#include "GEO.h"
#include "GLD.h"
#if (!defined(U64))
#include "TEX.h"
#endif /* !defined(U64) */
#include "GLI.h"
#include "COL.h"
#include "MEC.h"
/* Shaitan Clean Env {*/
/*#include "ENV.h"*/
/* End Shaitan Clean Env }*/
#include "SND.h"
/* Shaitan Clean Env {*/
/*#include "SRF.h"*/
/* End Shaitan Clean Env }*/
#include "SCT.h"
#include "SPO.h"
#include "LST.h"
/*#include "FON.h"*/
#include "ERM.h"
#include "GMT.h"
#ifdef USE_IPT_DX5
#include "IPT_DX5.h" /* InPuT (absolutely before GAM.h)*/
#else /* USE_IPT_WIN */
#include "IPT.h" /* InPuT (absolutely before GAM.h)*/
#endif /* USE_IPT_WIN */
#include "MMG.h"
#include "SCR.h"
#include "TMR.h"
#include "RND.h"
#include "PCS.h"
#include "PO.h"
/*XB980821*/
#ifndef D_THROW_IPO
#include "IPO.h"
#endif /* D_THROW_IPO */
/*End XB*/
/* Oliv' - Portage v15*/
#ifndef U64
#include "DPT.h"
#endif
/* EndOfOliv'*/
/* FBF {*/
/*#include "MNU.h"*/
/* FBF }*/
#ifdef GAM_VIGNETTE
#include "VIG.h"
#endif /* GAM_VIGNETTE */
#include "SHW.h"
#include "SIF.h"
/*XB980821*/
#ifndef D_THROW_IPO
#include "ISI.h"
#endif /* D_THROW_IPO */
/*End XB*/
#ifndef D_THROW_PRT
#include "PRT.h"
#endif /* D_THROW_PRT */
/*#include "CMP.h"*/
/*XB980821*/
#ifndef D_THROW_IPO
#include "ISI.h"
#endif /* D_THROW_IPO */
/*End XB*/
#include "FIL.h"
#ifdef GAM_VIDEO
#include "VDO.h"
#endif /* GAM_VIDEO */
#include "TMP.h"
#include "AI.h"
 
#include "GAMVers.h"
#include "GAMLst.h"
 
#include "Macros.h"
 
#endif /* __CPATOOLS_H__ */
