/*****************************************
//										//
//		Management of the Module : GEO	//
//										//
// File Name		: ErrGEO.h			//
// Date		: 03/02/97					//
// Author		: Philippe Vimont		//
//										//
*****************************************/
 
#ifndef __GEO_ERRGEO_H__
#define __GEO_ERRGEO_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#define C_szGEOVersion "GEO V0.5.1" /* The format is GEO Va.b.c with GEO is the Tag of the module */
#define C_szGEOFullName  "Geometry Common"/* the complete and clear name of the module */
#define C_szGEODate __DATE__ /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
#include "ERM.h"
 
#define __FATAL_ERR_GEO__
#define __WARNING1_ERR_GEO__
 
/*----------*/
/* Constant	 */
/*----------*/
/* error of the GEO Module*/
 
typedef enum e_uwGEOErrNumber_{
	E_uwGEOFatalErr,
#ifdef __FATAL_ERR_GEO__
/*     -----------------*/
	E_uwGEONotEnoughtMemory,	 
	E_uwGEOUnAvailableChannel,
	E_uwGEOIncreaseNumberOfSource,
#endif /*__FATAL_ERR_GEO__*/
	E_uwGEOStartOfWarning,/* important constant, it allows to recognize if an error is fatal or not.*/
#ifdef __WARNING1_ERR_GEO__
/*     -------------------*/
    E_uwGEOCanNotFree,
	E_uwGEOCanNotloadBitmap,
	E_uwGEOTryToKillDynamicChannel,
 E_uwGEODebugDynamicAllocation,
#endif /*__WARNING1_ERR_GEO__*/
#ifdef __WARNING2_ERR_GEO__
/*     -------------------*/
#endif /*__WARNING2_ERR_GEO__*/
#ifdef __WARNING3_ERR_GEO__
/*     -------------------*/
#endif /*__WARNING3_ERR_GEO__*/
	E_uwGEOErrNumber
} e_uwGEOErrNumber;
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef __ERRGEO_EXTERN
#ifndef __DeclareGlobalVariableErrGEO_h__
#define __ERRGEO_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableErrGEO_h__*/
#define __ERRGEO_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableErrGEO_h__*/
 
__ERRGEO_EXTERN CPA_EXPORT  unsigned char g_ucGEOModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrGEO_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif /*__DeclareGlobalVariableErrGEO_h__&& CPA_WANTS_IMPORT*/
;
 
#ifdef __ERROR_STRINGS__
 
__ERRGEO_EXTERN CPA_EXPORT  char * g_a_szGEOInformationModule []
#if defined(__DeclareGlobalVariableErrGEO_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szGEOVersion, C_szGEOFullName, C_szGEODate}
#endif /*__DeclareGlobalVariableErrGEO_h__ &&  CPA_WANTS_IMPORT*/
;
 
__ERRGEO_EXTERN CPA_EXPORT char * g_szGEOModuleName /* Mandatory syntax 'g_sz'+[Abbreviation of ModuleName]+'ModuleName'*/
#if defined(__DeclareGlobalVariableErrGEO_h__) && !defined(CPA_WANTS_IMPORT)
= "Module GEO"
#endif /*__DeclareGlobalVariableErrGEO_h__ && CPA_WANTS_IMPORT*/
;
 
__ERRGEO_EXTERN CPA_EXPORT struct tdstErrorMsg_ g_a_stGEOTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrGEO_h__) && !defined(CPA_WANTS_IMPORT)
={ 
#ifdef __FATAL_ERR_GEO__   
/*	 -------------*/
	E_uwGEONotEnoughtMemory, " Not Enought Memory...",
	E_uwGEOUnAvailableChannel, " Unexistant channel ",
	E_uwGEOIncreaseNumberOfSource,"GEO_fn_vMemoryLogFile : Increase max number of sources",
#endif /*__FATAL_ERR_GEO__*/
#ifdef __WARNING1_ERR_GEO__
	E_uwGEOCanNotFree , "Can not free! ",
 E_uwGEOCanNotloadBitmap , " Could Not DownLoad textures 8 or 16 bits in file : " ,
	E_uwGEOTryToKillDynamicChannel  , "Try to Kill dynamic channel! ",
 E_uwGEODebugDynamicAllocation,"Debug verion : dynamic allocation in bloc GEO (don't forget to increase the bloc)",
/*	 ----------------*/
#endif /*__WARNING1_ERR_GEO__*/
#ifdef __WARNING2_ERR_GEO__
/*	 ----------------*/
#endif /*__WARNING2_ERR_GEO__*/
#ifdef __WARNING3_ERR_GEO__
/*	 ----------------*/
#endif /*__WARNING3_ERR_GEO__*/
	0xFFFF, "\0"/*fin*/
};
#endif /*__DeclareGlobalVariableErrGEO_h__ && CPA_WANTS_IMPORT*/
;
 
#endif /*__ERROR_STRINGS__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__ERRGEO_H__*/
