/*///////////////////////////////////////////////////////////*/
/*															//*/
/*			Management of the Module : GLD					//*/
/*															//			   */
/* File Name	: ErrGLD.h									//*/
/* Date			: 29/07/97									//*/
/* Author		: Christophe Martinaud						//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
/*															//*/
/* abbreviation of the module-name. Used in macro is 'GLD'	//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
/* Last modification :  Variable g_szGLDModuleName has been */
/*                      suppressed...*/
/*///////////////////////////////////////////////////////////*/
#ifndef __ERRGLD_H__
#define __ERRGLD_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#define C_szGLDVersion  "GLD V5.8.7" /* The format is Tmr Va.b.c with Tmr is the Tag of the module */
#define C_szGLDFullName "Graphic Library for Display"/* the complete and clear name of the module */
#define C_szGLDDate     "July 29 1997" /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
#ifndef __Erm_H__
#include "ERM.h"
#endif
 
#define __FATAL_ERR_GLD__
#define __WARNING1_ERR_GLD__
 
/*----------*/
/* Constant	 */
/*----------*/
/* error of the GLD Module*/
typedef enum e_uwGLDErrNumber_{
	E_uwGLDFatalErr,	
#ifdef __FATAL_ERR_GLD__
/*     -----------------*/
/* Devices Errors*/
/* CreateDevice*/
    E_uwGLD_CD_DDCreateFailed,
    E_uwGLD_CD_DDQueryInterfaceFailed,
    E_uwGLD_CD_DDSetCoopLevelFailed,
    E_uwGLD_CD_DDSetDisplayModeFailed,
    E_uwGLD_CD_DDCreatePrimSurfFailed,
    E_uwGLD_CD_DDCreateClipperFailed,
    E_uwGLD_CD_DDSetClipperWndFailed,
    E_uwGLD_CD_DDSetClipperSurfFailed,
    E_uwGLD_CD_MaxNumberReached,
    E_uwGLD_CD_NotEnoughMemForDev,
    E_uwGLD_CD_DDGetBackBufferFailed,
    E_uwGLD_CD_DDGetSurfDescFailed,
    E_uwGLD_CD_DDCreateOffBufFailed,
    E_uwGLD_CD_NotEnoughMemForZBuf,
 
/* AdjustDeviceToWindow*/
    E_uwGLD_ADTW_DeviceInFullScrMode,
    E_uwGLD_ADTW_DDReleaseBufFailed,
    E_uwGLD_ADTW_DDCreateOffBufFailed,
    E_uwGLD_ADTW_NotEnoughMemForZBuf,
 
/* FlipDevice*/
    E_uwGLD_FD_DDRestoreSurfFailed,
    E_uwGLD_FD_DDFlipFailed,
    E_uwGLD_FD_DDBlitFailed,
 
/* DeleteDevice*/
    E_uwGLD_DD_DestroyDDObjFailed,
 
/* SwapDeviceMode*/
    E_uwGLD_SDM_AnotherDevInFScrMode,
    E_uwGLD_SDM_NotEnoughMemForSwap,
    E_uwGLD_SDM_DeleteDeviceFailed,
    E_uwGLD_SDM_CreateDeviceFailed,
 
/* Viewports Errors*/
/* ClearViewport*/
    E_uwGLD_CV_DDRestoreSurfFailed,
    E_uwGLD_CV_DDBltFailed,
 
/* RequestWriteToViewport*/
    E_uwGLD_RWTV_DDRestoreSurfFailed,
    E_uwGLD_RWTV_DDLockFailed,
 
/* WriteToViewportFinished*/
    E_uwGLD_WTVF_DDUnlockFailed,
 
/* CreateViewport*/
    E_uwGLD_CRV_MaxNumberReached,
    E_uwGLD_CRV_NotEnoughMemForVpt,
 
/* Rasters Errors*/
/* SetMonitorFrequency*/
    E_uwGLD_SMF_BadMonitorFrequency,
    
/* Creation of timer*/
	E_uwGLD_RCFR_CreateTimerFailed,
 
/* InitMainRasterObject    */
    E_uwGLD_IMRO_NotEnoughMemoryForMRO,
 
/* CreateRasterForDevice*/
    E_uwGLD_CRFD_MaxNumberOfRastersReached,
    E_uwGLD_CRFD_NotEnoughMemForRaster,
 
/* Display rasters for device*/
    E_uwGLD_DRFD_DDRestoreSurfFailed,
    E_uwGLD_DRFD_DDLockFailed,
    E_uwGLD_DRFD_DDUnlockSurfFailed,
 
/* Pictures Errors*/
/* LoadPictures*/
    E_uwGLD_LP_DDCreateFailed,
    E_uwGLD_LP_DDQueryInterfaceFailed,
    E_uwGLD_LP_DDSetCoopLevelFailed,
    E_uwGLD_LP_MaxNumberOfPicReached,
    E_uwGLD_LP_NotEnoughMemForPic,
    E_uwGLD_LP_LoadBitmapFailed,
 
/* ReadFromPictureFinished*/
    E_uwGLD_RFPF_DDUnlockSurfFailed,  
 
/* RequestReadFromPicture*/
    E_uwGLD_RRFP_ReloadBitmapFailed,
    E_uwGLD_RRFP_DDLockFailed,
    E_uwGLD_RRFP_DDRestoreSurfFailed,
#endif /*__FATAL_ERR_GLD__*/
	E_uwGLDStartOfWarning,/* important constant, it allows to recognize if an error is fatal or not.*/
#ifdef __WARNING1_ERR_GLD__
/*     -------------------*/
/* ClearDevice*/
    E_uwGLD_CLD_EraseSurfaceFailed, 
/* Create Device*/
    E_uwGLD_CD_InitTimerLibFailed,
/* Memory free*/
    E_uwGLDWarningCanNotFree,
#endif /*__WARNING1_ERR_GLD__*/
#ifdef __WARNING2_ERR_GLD__
/*     -------------------*/
#endif /*__WARNING2_ERR_GLD__*/
#ifdef __WARNING3_ERR_GLD__
/*     -------------------*/
#endif /*__WARNING3_ERR_GLD__*/
	E_uwGLDErrNumber
} e_uwGLDErrNumber;
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef __ERRGLD_EXTERN
#ifndef __DeclareGlobalVariableErrGLD_h__
#define __ERRGLD_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableErrGLD_h__*/
#define __ERRGLD_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableErrGLD_h__*/
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
__ERRGLD_EXTERN CPA_EXPORT  unsigned char g_ucGLDModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrGLD_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif /*__DeclareGlobalVariableErrGLD_h__&& CPA_WANTS_IMPORT*/
;
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
#ifdef __ERROR_STRINGS__
 
__ERRGLD_EXTERN CPA_EXPORT  char * g_a_szGLDInformationModule []
#if defined(__DeclareGlobalVariableErrGLD_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szGLDVersion, C_szGLDFullName, C_szGLDDate}
#endif /*__DeclareGlobalVariableErrGLD_h__ &&  CPA_WANTS_IMPORT*/
;
 
__ERRGLD_EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stGLDTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrGLD_h__) && !defined(CPA_WANTS_IMPORT)
={ 
#ifdef __FATAL_ERR_GLD__   
/*	 -------------*/
/* Devices Errors*/
/* CreateDevice*/
    E_uwGLD_CD_DDCreateFailed, "CreateDevice : Can't create DirectDraw object",
    E_uwGLD_CD_DDQueryInterfaceFailed, "CreateDevice : Can't get DirectDraw2 Interface",
    E_uwGLD_CD_DDSetCoopLevelFailed, "CreateDevice : Can't set cooperative level",
    E_uwGLD_CD_DDSetDisplayModeFailed, "CreateDevice : Can't set display mode",
    E_uwGLD_CD_DDCreatePrimSurfFailed, "CreateDevice : Can't create Primary surface",
    E_uwGLD_CD_DDCreateClipperFailed, "CreateDevice : Can't create Clipper",
    E_uwGLD_CD_DDSetClipperWndFailed, "CreateDevice : Can't associate Clipper with window",
    E_uwGLD_CD_DDSetClipperSurfFailed, "CreateDevice : Can't associate Clipper with surface",
    E_uwGLD_CD_MaxNumberReached, "CreateDevice : Maximal number of devices has been reached",
    E_uwGLD_CD_NotEnoughMemForDev, "CreateDevice : Not enough memory to create device structure",
    E_uwGLD_CD_DDGetBackBufferFailed, "CreateDevice : Can't get back buffer",
    E_uwGLD_CD_DDGetSurfDescFailed, "CreateDevice : Can't get surface description",
    E_uwGLD_CD_DDCreateOffBufFailed, "CreateDevice : Can't create offscreen buffer",
    E_uwGLD_CD_NotEnoughMemForZBuf, "CreateDevice : Not enough memory to create Z Buffer",
 
/* AdjustDeviceToWindow*/
    E_uwGLD_ADTW_DeviceInFullScrMode, "AdjustDevice : Can't adjust a device in full screen mode",
    E_uwGLD_ADTW_DDReleaseBufFailed, "AdjustDevice : Can't release offscreen buffer",
    E_uwGLD_ADTW_DDCreateOffBufFailed, "AdjustDevice : Can't create new offscreen buffer",
    E_uwGLD_ADTW_NotEnoughMemForZBuf, "AdjustDevice : Not enough memory to adjust Z Buffer",
 
/* FlipDevice*/
    E_uwGLD_FD_DDRestoreSurfFailed, "FlipDevice : Can't restore surface",
    E_uwGLD_FD_DDFlipFailed, "FlipDevice : Can't flip",
    E_uwGLD_FD_DDBlitFailed, "FlipDevice : Can't blit",
 
/* DeleteDevice*/
    E_uwGLD_DD_DestroyDDObjFailed, "DeleteDevice : Can't destroy DirectDraw objects",
 
/* SwapDeviceMode*/
    E_uwGLD_SDM_AnotherDevInFScrMode, "SwapDeviceMode : Another device is already in fullscreen mode",
    E_uwGLD_SDM_NotEnoughMemForSwap, "SwapDeviceMode : Not enough memory to achieve operation",
    E_uwGLD_SDM_DeleteDeviceFailed, "SwapDeviceMode : Can't delete the old device",
    E_uwGLD_SDM_CreateDeviceFailed, "SwapDeviceMode : Can't create the new device",
 
/* Viewports Errors*/
/* ClearViewport*/
    E_uwGLD_CV_DDRestoreSurfFailed, "ClearViewport : Can't restore surface",
    E_uwGLD_CV_DDBltFailed, "ClearViewport : Can't blit",
 
/* RequestWriteToViewport*/
    E_uwGLD_RWTV_DDRestoreSurfFailed, "RequestWriteToVpt : Can't restore surface",
    E_uwGLD_RWTV_DDLockFailed, "RequestWriteToVpt : Can't lock the back buffer",
 
/* WriteToViewportFinished*/
    E_uwGLD_WTVF_DDUnlockFailed, "WriteToVptFinished : Can't unlock the back buffer",
 
/* CreateViewport*/
    E_uwGLD_CRV_MaxNumberReached, "CreateViewport : The maximal number of viewports has been reached",
    E_uwGLD_CRV_NotEnoughMemForVpt, "CreateViewport : Not enough memory to create the viewport structure",
 
/* Rasters Errors*/
/* SetMonitorFrequency*/
    E_uwGLD_SMF_BadMonitorFrequency, "SetMonitorFrequency : Invalid frequency for monitor",
	
/* Creation of raster*/
	E_uwGLD_RCFR_CreateTimerFailed, "Timer couldn't be created",
    
/* InitMainRasterObject    */
    E_uwGLD_IMRO_NotEnoughMemoryForMRO, "Not enough memory to create a new set of rasters",
 
/* CreateRasterForDevice*/
    E_uwGLD_CRFD_MaxNumberOfRastersReached, "CreateRasterForDev : The maximal number of rasters has been reached for this set",
    E_uwGLD_CRFD_NotEnoughMemForRaster, "CreateRasterForDev : Not enough memory to create a new raster",
 
/* Display rasters for device*/
    E_uwGLD_DRFD_DDRestoreSurfFailed, "DisplayRasters : Can't restore back buffer",
    E_uwGLD_DRFD_DDLockFailed, "DisplayRasters : Can't lock back buffer",
    E_uwGLD_DRFD_DDUnlockSurfFailed, "DisplayRasters : Can't unlock back buffer",
 
/* Pictures Errors*/
/* LoadPictures*/
    E_uwGLD_LP_DDCreateFailed, "LoadPictures : Can't create DirectDraw object for pictures",
    E_uwGLD_LP_DDQueryInterfaceFailed, "LoadPictures : Can't get DirectDraw2 interface for pictures",
    E_uwGLD_LP_DDSetCoopLevelFailed, "LoadPictures : Can't set cooperative level for pictures",
    E_uwGLD_LP_MaxNumberOfPicReached, "LoadPictures : The maximal number of pictures has been reached",
    E_uwGLD_LP_NotEnoughMemForPic, "LoadPictures : Not enough memory for picture structure",
    E_uwGLD_LP_LoadBitmapFailed, "LoadPictures : Can't load bitmap in surface",
 
/* ReadFromPictureFinished*/
    E_uwGLD_RFPF_DDUnlockSurfFailed, "RequestReadFP : Can't unlock surface associated with picture",
 
/* RequestReadFromPicture*/
    E_uwGLD_RRFP_ReloadBitmapFailed, "RequestReadFP : Can't reload bitmap in surface",
    E_uwGLD_RRFP_DDLockFailed, "RequestReadFP : Can't lock surface associated with picture",
    E_uwGLD_RRFP_DDRestoreSurfFailed, "RequestReadFP : Can't restore surface",
#endif /*__FATAL_ERR_GLD__*/
#ifdef __WARNING1_ERR_GLD__
/*	 ----------------*/
/* ClearDevice*/
    E_uwGLD_CLD_EraseSurfaceFailed, "ClearDevice : Device surface couldn't be erased",
/* CreateDevice*/
    E_uwGLD_CD_InitTimerLibFailed, "CreateDevice : The timer library couldn't be initialized",
/* Memory free*/
    E_uwGLDWarningCanNotFree, "A block of memory couldn't be freed !!!",
#endif /*__WARNING1_ERR_GLD__*/
#ifdef __WARNING2_ERR_GLD__
/*	 ----------------*/
#endif /*__WARNING2_ERR_GLD__*/
#ifdef __WARNING3_ERR_GLD__
/*	 ----------------*/
#endif /*__WARNING3_ERR_GLD__*/
	0xFFFF, "\0"/*fin*/
};
#endif /*__DeclareGlobalVariableErrGLD_h__ && CPA_WANTS_IMPORT*/
;
 
#endif /*__ERROR_STRINGS__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /*__ERRGLD_H__*/
