/*///////////////////////////////////////////////////////////*/
/*															//*/
/*		Memory Management of the Module : GLD				//*/
/*															//			   */
/* File Name	: MmgGLD.h									//*/
/* Date			: 29/01/97									//*/
/* Author		: Christophe Martinaud						//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
#ifndef __MemGLD_H__
#define __MemGLD_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
#ifndef __Mmg_H__
#include "MMG.h"
#endif
 
typedef enum e_ucGLDStaticBlocks_{
	E_ucGLDBlock1, 
	E_ucGLDBlock2,
	E_ucGLDBlock3,	   
	E_ucGLDBlock4,	   
	E_ucGLDMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucGLDStaticBlocks;
 
#undef __MMG_GLD_EXTERN
#ifdef __DeclareGlobalVariableMmgGLD_h__
#define __MMG_GLD_EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgGLD_h__*/
#define __MMG_GLD_EXTERN extern
#endif /*__DeclareGlobalVariableMmgGLD_h__*/
 
#ifndef _FIRE_DEADCODE_U64_
__MMG_GLD_EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stGLDBlocksInfo[E_ucGLDMaxBlocksNb];
#endif /* _FIRE_DEADCODE_U64_ */
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
__MMG_GLD_EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stGLDDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MemGLD_H__*/
