/*///////////////////////////////////////////////////////////*/
/*															//*/
/*			Management of the Module : Gli					//*/
/*															//			   */
/* File Name	: ErrGli.h									//*/
/* Date			: 29/01/97									//*/
/* Author		: Christophe Martinaud						//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
/*															//*/
/* abbreviation of the module-name. Used in macro is 'Gli'	//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
 
#ifndef __ERRGli_H__
#define __ERRGli_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#define C_szGliVersion  "Gli V5.8.6" /* The format is Tmr Va.b.c with Tmr is the Tag of the module */
#define C_szGliFullName "Graphic Library for Display"/* the complete and clear name of the module */
#define C_szGliDate     "May 12 1997" /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/
 
#include "CPA_Expt.h"
 
#ifndef __Erm_H__
#include "ERM.h"
#endif
 
#define __FATAL_ERR_Gli__
#define __WARNING1_ERR_Gli__
 
/*----------*/
/* Constant	 */
/*----------*/
/* error of the Gli Module*/
typedef enum e_uwGliErrNumber_{
	E_uwGliFatalErr,	
#ifdef __FATAL_ERR_Gli__
/*     -----------------*/
/* Devices Errors*/
/* CreateDevice*/
    E_uwGli_CD_DDCreateFailed,
    E_uwGli_CD_DDQueryInterfaceFailed,
    E_uwGli_CD_DDSetCoopLevelFailed,
    E_uwGli_CD_DDSetDisplayModeFailed,
    E_uwGli_CD_DDCreatePrimSurfFailed,
    E_uwGli_CD_DDCreateClipperFailed,
    E_uwGli_CD_DDSetClipperWndFailed,
    E_uwGli_CD_DDSetClipperSurfFailed,
    E_uwGli_CD_MaxNumberReached,
    E_uwGli_CD_NotEnoughMemForDev,
    E_uwGli_CD_DDGetBackBufferFailed,
    E_uwGli_CD_DDGetSurfDescFailed,
    E_uwGli_CD_DDCreateOffBufFailed,
    E_uwGli_CD_NotEnoughMemForZBuf,
 
/* AdjustDeviceToWindow*/
    E_uwGli_ADTW_DeviceInFullScrMode,
    E_uwGli_ADTW_DDReleaseBufFailed,
    E_uwGli_ADTW_DDCreateOffBufFailed,
    E_uwGli_ADTW_NotEnoughMemForZBuf,
 
/* FlipDevice*/
    E_uwGli_FD_DDRestoreSurfFailed,
    E_uwGli_FD_DDFlipFailed,
    E_uwGli_FD_DDBlitFailed,
 
/* DeleteDevice*/
    E_uwGli_DD_DestroyDDObjFailed,
 
/* SwapDeviceMode*/
    E_uwGli_SDM_AnotherDevInFScrMode,
    E_uwGli_SDM_NotEnoughMemForSwap,
    E_uwGli_SDM_DeleteDeviceFailed,
    E_uwGli_SDM_CreateDeviceFailed,
 
/* Viewports Errors*/
/* ClearViewport*/
    E_uwGli_CV_DDRestoreSurfFailed,
    E_uwGli_CV_DDBltFailed,
 
/* RequestWriteToViewport*/
    E_uwGli_RWTV_DDRestoreSurfFailed,
    E_uwGli_RWTV_DDLockFailed,
 
/* WriteToViewportFinished*/
    E_uwGli_WTVF_DDUnlockFailed,
 
/* CreateViewport*/
    E_uwGli_CRV_MaxNumberReached,
    E_uwGli_CRV_NotEnoughMemForVpt,
 
/* Rasters Errors*/
/* SetMonitorFrequency*/
    E_uwGli_SMF_BadMonitorFrequency,
    
/* Creation of timer*/
	E_uwGli_RCFR_CreateTimerFailed,
 
/* InitMainRasterObject    */
    E_uwGli_IMRO_NotEnoughMemoryForMRO,
 
/* CreateRasterForDevice*/
    E_uwGli_CRFD_MaxNumberOfRastersReached,
    E_uwGli_CRFD_NotEnoughMemForRaster,
 
/* Display rasters for device*/
    E_uwGli_DRFD_DDRestoreSurfFailed,
    E_uwGli_DRFD_DDLockFailed,
    E_uwGli_DRFD_DDUnlockSurfFailed,
 
/* Pictures Errors*/
/* LoadPictures*/
    E_uwGli_LP_DDCreateFailed,
    E_uwGli_LP_DDQueryInterfaceFailed,
    E_uwGli_LP_DDSetCoopLevelFailed,
    E_uwGli_LP_MaxNumberOfPicReached,
    E_uwGli_LP_NotEnoughMemForPic,
    E_uwGli_LP_LoadBitmapFailed,
 
/* ReadFromPictureFinished*/
    E_uwGli_RFPF_DDUnlockSurfFailed,  
 
/* RequestReadFromPicture*/
    E_uwGli_RRFP_ReloadBitmapFailed,
    E_uwGli_RRFP_DDLockFailed,
    E_uwGli_RRFP_DDRestoreSurfFailed,
#endif /*__FATAL_ERR_Gli__*/
	E_uwGliStartOfWarning,/* important constant, it allows to recognize if an error is fatal or not.*/
#ifdef __WARNING1_ERR_Gli__
/*     -------------------*/
/* ClearDevice*/
    E_uwGli_CLD_EraseSurfaceFailed, 
/* Create Device*/
    E_uwGli_CD_InitTimerLibFailed,
/* Memory free*/
    E_uwGliWarningCanNotFree,
#endif /*__WARNING1_ERR_Gli__*/
#ifdef __WARNING2_ERR_Gli__
/*     -------------------*/
#endif /*__WARNING2_ERR_Gli__*/
#ifdef __WARNING3_ERR_Gli__
/*     -------------------*/
#endif /*__WARNING3_ERR_Gli__*/
	E_uwGliErrNumber
} e_uwGliErrNumber;
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef __ERRGli_EXTERN
#ifndef __DeclareGlobalVariableErrGli_h__
#define __ERRGli_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableErrGli_h__*/
#define __ERRGli_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableErrGli_h__*/
 
__ERRGli_EXTERN CPA_EXPORT  unsigned char g_ucGliModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrGli_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif /*__DeclareGlobalVariableErrGli_h__&& CPA_WANTS_IMPORT*/
;
 
#ifdef __ERROR_STRINGS__
 
__ERRGli_EXTERN CPA_EXPORT  char * g_a_szGliInformationModule []
#if defined(__DeclareGlobalVariableErrGli_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szGliVersion, C_szGliFullName, C_szGliDate}
#endif /*__DeclareGlobalVariableErrGli_h__ &&  CPA_WANTS_IMPORT*/
;
 
__ERRGli_EXTERN CPA_EXPORT  char * g_szGliModuleName /* Mandatory syntax 'g_sz'+[Abbreviation of ModuleName]+'ModuleName'*/
#if defined(__DeclareGlobalVariableErrGli_h__) && !defined(CPA_WANTS_IMPORT)
= "Module Gli"
#endif /*__DeclareGlobalVariableErrGli_h__ && CPA_WANTS_IMPORT*/
;
 
__ERRGli_EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stGliTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrGli_h__) && !defined(CPA_WANTS_IMPORT)
={ 
#ifdef __FATAL_ERR_Gli__   
/*	 -------------*/
/* Devices Errors*/
/* CreateDevice*/
    E_uwGli_CD_DDCreateFailed, "CreateDevice : Can't create DirectDraw object",
    E_uwGli_CD_DDQueryInterfaceFailed, "CreateDevice : Can't get DirectDraw2 Interface",
    E_uwGli_CD_DDSetCoopLevelFailed, "CreateDevice : Can't set cooperative level",
    E_uwGli_CD_DDSetDisplayModeFailed, "CreateDevice : Can't set display mode",
    E_uwGli_CD_DDCreatePrimSurfFailed, "CreateDevice : Can't create Primary surface",
    E_uwGli_CD_DDCreateClipperFailed, "CreateDevice : Can't create Clipper",
    E_uwGli_CD_DDSetClipperWndFailed, "CreateDevice : Can't associate Clipper with window",
    E_uwGli_CD_DDSetClipperSurfFailed, "CreateDevice : Can't associate Clipper with surface",
    E_uwGli_CD_MaxNumberReached, "CreateDevice : Maximal number of devices has been reached",
    E_uwGli_CD_NotEnoughMemForDev, "CreateDevice : Not enough memory to create device structure",
    E_uwGli_CD_DDGetBackBufferFailed, "CreateDevice : Can't get back buffer",
    E_uwGli_CD_DDGetSurfDescFailed, "CreateDevice : Can't get surface description",
    E_uwGli_CD_DDCreateOffBufFailed, "CreateDevice : Can't create offscreen buffer",
    E_uwGli_CD_NotEnoughMemForZBuf, "CreateDevice : Not enough memory to create Z Buffer",
 
/* AdjustDeviceToWindow*/
    E_uwGli_ADTW_DeviceInFullScrMode, "AdjustDevice : Can't adjust a device in full screen mode",
    E_uwGli_ADTW_DDReleaseBufFailed, "AdjustDevice : Can't release offscreen buffer",
    E_uwGli_ADTW_DDCreateOffBufFailed, "AdjustDevice : Can't create new offscreen buffer",
    E_uwGli_ADTW_NotEnoughMemForZBuf, "AdjustDevice : Not enough memory to adjust Z Buffer",
 
/* FlipDevice*/
    E_uwGli_FD_DDRestoreSurfFailed, "FlipDevice : Can't restore surface",
    E_uwGli_FD_DDFlipFailed, "FlipDevice : Can't flip",
    E_uwGli_FD_DDBlitFailed, "FlipDevice : Can't blit",
 
/* DeleteDevice*/
    E_uwGli_DD_DestroyDDObjFailed, "DeleteDevice : Can't destroy DirectDraw objects",
 
/* SwapDeviceMode*/
    E_uwGli_SDM_AnotherDevInFScrMode, "SwapDeviceMode : Another device is already in fullscreen mode",
    E_uwGli_SDM_NotEnoughMemForSwap, "SwapDeviceMode : Not enough memory to achieve operation",
    E_uwGli_SDM_DeleteDeviceFailed, "SwapDeviceMode : Can't delete the old device",
    E_uwGli_SDM_CreateDeviceFailed, "SwapDeviceMode : Can't create the new device",
 
/* Viewports Errors*/
/* ClearViewport*/
    E_uwGli_CV_DDRestoreSurfFailed, "ClearViewport : Can't restore surface",
    E_uwGli_CV_DDBltFailed, "ClearViewport : Can't blit",
 
/* RequestWriteToViewport*/
    E_uwGli_RWTV_DDRestoreSurfFailed, "RequestWriteToVpt : Can't restore surface",
    E_uwGli_RWTV_DDLockFailed, "RequestWriteToVpt : Can't lock the back buffer",
 
/* WriteToViewportFinished*/
    E_uwGli_WTVF_DDUnlockFailed, "WriteToVptFinished : Can't unlock the back buffer",
 
/* CreateViewport*/
    E_uwGli_CRV_MaxNumberReached, "CreateViewport : The maximal number of viewports has been reached",
    E_uwGli_CRV_NotEnoughMemForVpt, "CreateViewport : Not enough memory to create the viewport structure",
 
/* Rasters Errors*/
/* SetMonitorFrequency*/
    E_uwGli_SMF_BadMonitorFrequency, "SetMonitorFrequency : Invalid frequency for monitor",
	
/* Creation of raster*/
	E_uwGli_RCFR_CreateTimerFailed, "Timer couldn't be created",
    
/* InitMainRasterObject    */
    E_uwGli_IMRO_NotEnoughMemoryForMRO, "Not enough memory to create a new set of rasters",
 
/* CreateRasterForDevice*/
    E_uwGli_CRFD_MaxNumberOfRastersReached, "CreateRasterForDev : The maximal number of rasters has been reached for this set",
    E_uwGli_CRFD_NotEnoughMemForRaster, "CreateRasterForDev : Not enough memory to create a new raster",
 
/* Display rasters for device*/
    E_uwGli_DRFD_DDRestoreSurfFailed, "DisplayRasters : Can't restore back buffer",
    E_uwGli_DRFD_DDLockFailed, "DisplayRasters : Can't lock back buffer",
    E_uwGli_DRFD_DDUnlockSurfFailed, "DisplayRasters : Can't unlock back buffer",
 
/* Pictures Errors*/
/* LoadPictures*/
    E_uwGli_LP_DDCreateFailed, "LoadPictures : Can't create DirectDraw object for pictures",
    E_uwGli_LP_DDQueryInterfaceFailed, "LoadPictures : Can't get DirectDraw2 interface for pictures",
    E_uwGli_LP_DDSetCoopLevelFailed, "LoadPictures : Can't set cooperative level for pictures",
    E_uwGli_LP_MaxNumberOfPicReached, "LoadPictures : The maximal number of pictures has been reached",
    E_uwGli_LP_NotEnoughMemForPic, "LoadPictures : Not enough memory for picture structure",
    E_uwGli_LP_LoadBitmapFailed, "LoadPictures : Can't load bitmap in surface",
 
/* ReadFromPictureFinished*/
    E_uwGli_RFPF_DDUnlockSurfFailed, "RequestReadFP : Can't unlock surface associated with picture",
 
/* RequestReadFromPicture*/
    E_uwGli_RRFP_ReloadBitmapFailed, "RequestReadFP : Can't reload bitmap in surface",
    E_uwGli_RRFP_DDLockFailed, "RequestReadFP : Can't lock surface associated with picture",
    E_uwGli_RRFP_DDRestoreSurfFailed, "RequestReadFP : Can't restore surface",
#endif /*__FATAL_ERR_Gli__*/
#ifdef __WARNING1_ERR_Gli__
/*	 ----------------*/
/* ClearDevice*/
    E_uwGli_CLD_EraseSurfaceFailed, "ClearDevice : Device surface couldn't be erased",
/* CreateDevice*/
    E_uwGli_CD_InitTimerLibFailed, "CreateDevice : The timer library couldn't be initialized",
/* Memory free*/
    E_uwGliWarningCanNotFree, "A block of memory couldn't be freed !!!",
#endif /*__WARNING1_ERR_Gli__*/
#ifdef __WARNING2_ERR_Gli__
/*	 ----------------*/
#endif /*__WARNING2_ERR_Gli__*/
#ifdef __WARNING3_ERR_Gli__
/*	 ----------------*/
#endif /*__WARNING3_ERR_Gli__*/
	0xFFFF, "\0"/*fin*/
};
#endif /*__DeclareGlobalVariableErrGli_h__ && CPA_WANTS_IMPORT*/
;
 
#endif /*__ERROR_STRINGS__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /*__ERRGli_H__*/
