 
 
/* (c) Ubi Studios 1997 */
/* See Vincent Greco for any comment or question */
 
/* To avoid unnecessary includes :  */
#ifndef  __LGTLOAD_H__
#define __LGTLOAD_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#if !defined(U64)
extern CPA_EXPORT SCR_tdst_Link_Table * LGT_fn_p_stGetLightLinkTable();
#endif /* U64 */
 
extern CPA_EXPORT BOOL LGT_fn_bInitLGTLoading();
 
extern CPA_EXPORT BOOL LGT_fn_bStopLGTLoading();
 
 
/********************************************************************
NAME : LGT_fn_xLoadLight
AIM  : Load a Light (with scripts)
*********************************************************************/
 
#if !defined(U64)
extern CPA_EXPORT SCR_tde_Anl_ReturnValue LGT_fn_xLoadLight(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
#endif /* U64 */
 
/*----------------------------------------------------------------------------
//  Description : GLI_fn_vPrepareSaveLightBinaryBloc
//----------------------------------------------------------------------------
//  Input :             
//  Output : 
----------------------------------------------------------------------------*/
extern CPA_EXPORT void GLI_fn_vPrepareSaveLightBinaryBloc();
 
/*----------------------------------------------------------------------------
//  Description : GLI_fn_ulWriteLightBinaryBloc
//----------------------------------------------------------------------------
//  Input :  _ulStructAdress : Address of the structure to be written
//			 _p_cDestBuffer : Output buffer           
//  Output : The length of the data written
----------------------------------------------------------------------------*/
extern CPA_EXPORT unsigned long GLI_fn_ulWriteLightBinaryBloc(unsigned long _ulStructAdress,
										  char* _p_cDestBuffer);
 
/*----------------------------------------------------------------------------
//  Description : GLI_fn_vWriteAllLightBinaryBlocs
//----------------------------------------------------------------------------
//  Input :  _szBinaryFileName           
//  Output : 
----------------------------------------------------------------------------*/
extern CPA_EXPORT void GLI_fn_vWriteAllLightBinaryBlocs(char* _szBinaryFileName);
 
/*----------------------------------------------------------------------------
//  Description : GLI_fn_ulReadLightBinaryBloc
//----------------------------------------------------------------------------
//  Input :		_p_cLoadedBuffer : Input buffer
//				_ulLoadedBufferSize : Size of the loaded buffer           
//  Output : The address of the allocated bloc
----------------------------------------------------------------------------*/
extern CPA_EXPORT unsigned long GLI_fn_ulReadLightBinaryBloc(char* _p_cLoadedBuffer,unsigned long _ulLoadedBufferSize);
 
/*----------------------------------------------------------------------------
//  Description : GLI_fn_vReadAllLightBinaryBlocs
//----------------------------------------------------------------------------
//  Input :		_szBinaryFileName : The binary file name           
//  Output : 
----------------------------------------------------------------------------*/
extern CPA_EXPORT void GLI_fn_vReadAllLightsBinaryBlocs(char* _szBinaryFileName);
 
/*----------------------------------------------------------------------------
//  Description : GLI_fn_vReadAllLightBinaryBlocs2
//----------------------------------------------------------------------------
//  Input :		_szBinaryFileName : The binary file name           
//  Output : 
----------------------------------------------------------------------------*/
extern CPA_EXPORT void GLI_fn_vReadAllLightsBinaryBlocs2(char* _szBinaryFileName);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_hLoadGameMaterial
//  Load a game material from the scripts or from the binary bloc
//----------------------------------------------------------------------------
//  Input : _szSectionName : Name of the section to load            
//  Output : A handle to the loaded game material
----------------------------------------------------------------------------*/
extern CPA_EXPORT struct GLI_tdstLight_* GMT_fn_hLoadLight(char* _szSectionName);
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __LGTLOAD_H__  */
 
 
