#ifndef GLI_TEXTURE_H
#define GLI_TEXTURE_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLL using these function :*/
#include "cpa_expt.h"
 
 
#define GLI_C_lTiledTexture             0x00000001
#define GLI_C_lNZTexture                0x00000002
#define GLI_C_lMipMapTexture            0x00000004
#define GLI_C_lAlphaTexture             0x00000008
#define GLI_C_lNZFilteredTexture        0x00000010
#define GLI_C_lAddTransparencyTexture   0x00000020
#define GLI_C_lNoZBufferWriteTexture    0x00000040
#define GLI_C_lPaletteTexture           0x00000080
#define GLI_C_lAlphaTest                0x00000100
#define GLI_C_lAAATexture				0x00000200
#define GLI_C_lMAATexture               0x00000400
 
/*
 * To Indicate that's a PROCEDURAL_TEXTURE
 */
#define GLI_C_lProceduralTexture        0x00000800
 
#define GLI_C_lTGATexture               0x80000000
#define GLI_C_lBMPTexture               0x40000000
 
/*
 * Procedural_texture type
 */
#define TEXPRO_C_lWater                 0
#define TEXPRO_C_lFire                  1
 
 
 
#define GLI_C_lNBMaxOfTextures 1024
 
extern CPA_EXPORT void GLI_xLoadTexture (struct GLI_tdstTexture_ **h_stTexture, struct GLD_tdstDeviceAttributes_ *p_stDev, char *d_ucFileName, long lTextureCaps, long lTextureQuality);
 
extern CPA_EXPORT void GLI_fn_vOpenBigFileTextures(char *p_szFileName);
extern CPA_EXPORT void GLI_fn_vCloseBigFileTextures(void);
 
extern CPA_EXPORT void GLI_vRefreshAllCyclingTextures( float fCoefOfMultiplicatoin);
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* GLI_TEXTURE_H*/
