/* (c) Ubi R&D 1996*/
/* See Alain Robin for any comment or question*/
 
#ifndef __GMTZNLOD_H__
#define __GMTZNLOD_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
/****************************************************************************/
/* CONSTANTS																*/
/****************************************************************************/
#define C_EntryCollideMaterial "Collision"
#define C_SectionCollideMaterial "CollideMaterial"
 
#define GMT_C_szZDM "Zdm"
#define GMT_C_szZDR "Zdr"
#define GMT_C_szZDE "Zde"
#define GMT_C_szZDD "Zdd"
 
/*
 * Types of ZDM
 * When adding a type, remember to modify GMT_fn_p_szZdmMaskToName()
 */ 
#define GMT_C_uwPieds      1
#define GMT_C_uwCorps      2
#define GMT_C_uwTete       4
#define GMT_C_uwMains      8
#define GMT_C_uwFigee      16
#define GMT_C_uwDos        32
 
#define GMT_C_szPieds      "ZdmPieds"
#define GMT_C_szCorps      "ZdmCorps"
#define GMT_C_szTete       "ZdmTete"
#define GMT_C_szMains      "ZdmMains"
#define GMT_C_szFigee      "ZdmFigee"
#define GMT_C_szDos        "ZdmDos"
/*
 * Types of ZDM: the end
 */
 
/*ROMTEAM WorldEditor (Cristi Petrescu 11/12/97)*/
 /*
 * Zone types
 * Tells what zones are used by a specific material
 * Use them as bit flags
 */
#define GMT_C_uwZDM				1
#define GMT_C_uwZDR				2
#define GMT_C_uwZDE				4
#define	GMT_C_uwZDD				8  /* this might be unnecessary*/
#define GMT_C_uwBoundingVolume	16 /* this might be unnecessary*/
#define GMT_C_uwTestPoint		32 /* this might be unnecessary*/
/*
 * Zone types: the end
 */
/*ENDROMTEAM WorldEditor (Cristi Petrescu)*/
 
/*////////////////////////////////////////////////////////////////////////////
//  Description : GMT_fn_vInitLoadGameMaterial
//  Loading process initialization 
//////////////////////////////////////////////////////////////////////////////
//  Input :             
//  Output :  
*****************************************************************************/
extern CPA_EXPORT void  GMT_fn_vInitLoadCollideMaterial();
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_hLoadCollideMaterial
//  Load a collide material from the scripts or from the binary bloc
//----------------------------------------------------------------------------
//  Input : _szSectionName : Name of the section to load            
//  Output : A handle to the loaded collide material
----------------------------------------------------------------------------*/
extern CPA_EXPORT GMT_tdxHandleToCollideMaterial GMT_fn_hLoadCollideMaterial(char* _szSectionName);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vPrepareSaveBinaryBloc
//----------------------------------------------------------------------------
//  Input :             
//  Output : 
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void GMT_fn_vPrepareSaveCollideBinaryBloc();*/
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_ulWriteCMTBinaryBloc
//----------------------------------------------------------------------------
//  Input :  _ulStructAdress : Address of the structure to be written
//			 _p_cDestBuffer : Output buffer           
//  Output : The length of the data written
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT unsigned long GMT_fn_ulWriteCMTBinaryBloc(unsigned long _ulStructAdress,
										  char* _p_cDestBuffer);
*/
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vWriteAllCMTBinaryBlocs
//----------------------------------------------------------------------------
//  Input :  _szBinaryFileName           
//  Output : 
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void GMT_fn_vWriteAllCMTBinaryBlocs(char* _szBinaryFileName);*/
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_ulReadBinaryBloc
//----------------------------------------------------------------------------
//  Input :		_p_cLoadedBuffer : Input buffer
//				_ulLoadedBufferSize : Size of the loaded buffer           
//  Output : The address of the allocated bloc
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT unsigned long GMT_fn_ulReadCMTBinaryBloc(char* _p_cLoadedBuffer,unsigned long _ulLoadedBufferSize);*/
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vReadAllCMTBinaryBlocs
//----------------------------------------------------------------------------
//  Input :		_szBinaryFileName : The binary file name           
//  Output : 
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void GMT_fn_vReadAllCMTBinaryBlocs(char* _szBinaryFileName);*/
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vReadAllCMTBinaryBlocs
//----------------------------------------------------------------------------
//  Input :		_szBinaryFileName : The binary file name           
//  Output : 
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void GMT_fn_vReadAllCMTBinaryBlocs2(char* _szBinaryFileName);*/
 
/*---------------------------------------------------------------------------/
//  Description : GMT_fn_vDeleteCMTEntryWithPriority
------------------------------------------------------------------------------
//  Input :             
//  Output : 
----------------------------------------------------------------------------*/
extern CPA_EXPORT void GMT_fn_vDeleteCMTEntryWithPriority(unsigned char ucPrioMin, unsigned char ucPrioMax);
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif
