/*///////////////////////////////////////////////////////////*/
/*															//*/
/*		Memory Management of the Module : Gmt				//*/
/*															//			   */
/* File Name	: MmgGmt.h									//*/
/* Date			: Mar 97									//*/
/* Author		: Alain Robin								//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
#ifndef __MemGmt_H__
#define __MemGmt_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
#include "MMG.h"
 
typedef enum e_ucGmtStaticBlocks_{
	E_ucGmtBlock1,    
	E_ucGmtMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucGmtStaticBlocks;
 
#undef __MEMGMT_EXTERN
#ifdef __DeclareGlobalVariableMmgGmt_h__
#define __MEMGMT_EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgGmt_h__*/
#define __MEMGMT_EXTERN extern
#endif /*__DeclareGlobalVariableMmgGmt_h__*/
 
__MEMGMT_EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stGmtBlocksInfo[E_ucGmtMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
__MEMGMT_EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stGmtDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MemGmt_H__*/
