 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_HDL
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_HDL
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
 
#ifndef _HDL_H_
#define _HDL_H_
 
/* Includes for the HDL files themselves */
#include "HDL/HDLProto.h"
 
/* Includes of the handles definition files or handle definitions */
 
/* Handle for GEO/GLI */
typedef struct GEO_tdstGeometricObject_		*ACP_tdxHandleOfObject;
typedef struct GEO_tdstFaceMapDescriptor_	*ACP_tdxHandleOfFMD;
typedef struct GLI_tdstMaterial_			*ACP_tdxHandleOfMaterial;
typedef ACP_tdxIndex						ACP_tdxHandleOfElement;
typedef struct GEO_tdstSprite_				*ACP_tdxHandleOfSprite;
typedef void 								*ACP_tdxHandleToRadiosity;
typedef struct VET_tdstVisualEnvironment_	*ACP_tdxHandleToVisualEnvironment;
typedef struct GLI_tdstTexture_				*ACP_tdxHandleOfTexture;
 
/* Handles for MEC */
#include "MEC/hMecMatC.h"
 
/* Handles for GMT */
#include "HDL/GmtHandl.h"
 
/* Handles for GLD */
typedef struct GLD_tdstViewportAttributes_* GLD_tdxHandleToViewportAttributes;
 
/* Handles for SPO */
typedef void * HIE_tdxHandleToVoid;
#define GEO_tdxHandleToMatrix POS_tdxHandleToPosition /* For transformation GLI->POS*/
#include "SPO/HieHand.h"
 
/* FBF */
typedef struct GLI_tdstLight_                           *GLI_tdxHandleToLight;
typedef struct GLI_tdstCamera_                          *GLI_tdxHandleToCamera;
/* fin FBF */
 
typedef  void* DNM_tdxHandleToMecIdentityCard;
 
/* Handles for GAM */
#include "GAM/GAMHandl.h"
 
/* Handles for AI */
#include "AI/AIBASE/AI_Handl.h"
 
/* Handles for BIN */
#if !defined(U64)
/*#include "BIN/BINHandl.h"*/
#endif /* U64 */
 
/* Handles for SND */
#include "SND/SNDHandl.h"
 
/* Handles for BIN */
typedef struct BIN_stReducedLinkTable* BIN_tdxHandleToReducedLinkTable;
 
#endif /*_HDL_H_*/
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
 
