/*///////////////////////////////////////////////////////////*/
/*															//*/
/*		Memory Management of the Module : INO				//*/
/*															//			   */
/* File Name	: MmgINO.h									//*/
/* Date			: 29/03/97									//*/
/* Author		: Francis Jentey    						//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
#ifndef __MemINO_H__
#define __MemINO_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
#ifndef __Mmg_H__
#include "MMG.h"
#endif
 
typedef enum e_ucINOStaticBlocks_{
	E_ucINOBlock1, 
	E_ucINOBlock2,
	E_ucINOBlock3,	   
	E_ucINOBlock4,	   
	E_ucINOMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucINOStaticBlocks;
 
#undef __MMG_INO_EXTERN
#ifdef __DeclareGlobalVariableMmgINO_h__
#define __MMG_INO_EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgINO_h__*/
#define __MMG_INO_EXTERN extern
#endif /*__DeclareGlobalVariableMmgINO_h__*/
 
__MMG_INO_EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stINOBlocksInfo[E_ucINOMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
__MMG_INO_EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stINODynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MemINO_H__*/
