/*=========================================================================
* IPT_KDef.h : xchange structure for script
*
* Version              1.0
* Creation date        02/04/97
*	Revision date
*
* (c) Ubi Studios 1997
*=======================================================================*/
 
#if !defined(__IPT_KDef_H__)
#define __IPT_KDef_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
/****************************************/
#if !defined(CPA_EXPORT)
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif /* CPA_WANTS_IMPORT || CPA_WANTS_EXPORT */
#endif /* CPA_EXPORT */
/****************************************/
 
/***** Structures definitions *** */
 
typedef struct IPT_tdstScriptValue_ * IPT_tdxHandleToScriptValue;
 
#if defined(D_IPT_Input_StructureDefine)
struct IPT_tdstScriptValue_
{
 char *zsKeyName;
 signed short swKeyValue;
};
 
struct IPT_tdstConvertValue_ 
{
 signed short swAZERTYKeyValue;
 signed short swQWERTYKeyValue;
};
 
#endif /* D_IPT_Input_StructureDefine */
 
/***** Enums declarations *** */
enum IPT_E_KeyWord_
{
 IPT_E_KeyWord_And = ((signed short)0xf001),
 IPT_E_KeyWord_Or,
 IPT_E_KeyWord_Not,
 IPT_E_KeyWord_KeyJustPressed,
 IPT_E_KeyWord_KeyJustReleased,
 IPT_E_KeyWord_KeyPressed,
 IPT_E_KeyWord_KeyReleased,
 IPT_E_KeyWord_ActionJustValidated,
 IPT_E_KeyWord_ActionJustInvalidated,
 IPT_E_KeyWord_ActionValidated,
 IPT_E_KeyWord_ActionInvalidated,
 IPT_E_KeyWord_PadJustPressed,
 IPT_E_KeyWord_PadJustReleased,
 IPT_E_KeyWord_PadPressed,
 IPT_E_KeyWord_PadReleased,
 IPT_E_KeyWord_JoystickAxeValue,
 IPT_E_KeyWord_JoystickJustPressed,
 IPT_E_KeyWord_JoystickJustReleased,
 IPT_E_KeyWord_JoystickPressed,
 IPT_E_KeyWord_JoystickReleased,
 IPT_E_KeyWord_JoystickOrPadJustPressed,
 IPT_E_KeyWord_JoystickOrPadJustReleased,
 IPT_E_KeyWord_JoystickOrPadPressed,
 IPT_E_KeyWord_JoystickOrPadReleased,
 IPT_E_KeyWord_Sequence,
 IPT_E_KeyWord_SequenceKey,
 IPT_E_KeyWord_SequenceKeyEnd,
 IPT_E_KeyWord_SequencePad,
 IPT_E_KeyWord_SequencePadEnd,
 IPT_E_NumberOfKeyWord
};
 
enum IPT_E_DeviceEvent_
{
 IPT_E_FirstDeviceEvent    = (0x01),
 IPT_E_KeyboardDeviceEvent = IPT_E_FirstDeviceEvent,
 IPT_E_Pad00DeviceEvent,
 IPT_E_Pad01DeviceEvent,
 IPT_E_Pad02DeviceEvent,
 IPT_E_Pad03DeviceEvent,
 IPT_E_Pad04DeviceEvent,
 IPT_E_Pad05DeviceEvent,
 IPT_E_Pad06DeviceEvent,
 IPT_E_Pad07DeviceEvent,
 IPT_E_Pad08DeviceEvent,
 IPT_E_Pad09DeviceEvent,
 IPT_E_Pad10DeviceEvent,
 IPT_E_Pad11DeviceEvent,
 IPT_E_Pad12DeviceEvent,
 IPT_E_Pad13DeviceEvent,
 IPT_E_Pad14DeviceEvent,
 IPT_E_Pad15DeviceEvent,
 IPT_E_NumberOfDeviceEvent
};
 
enum IPT_E_PadEvent_
{
 IPT_E_FirstPadAction = 0x00,
 IPT_E_PadUp          = IPT_E_FirstPadAction,
 IPT_E_PadDown,
 IPT_E_PadLeft,
 IPT_E_PadRight,
 IPT_E_JoyXValue,
 IPT_E_JoyYValue,
 IPT_E_JoyZValue,
 IPT_E_JoyRValue,
 IPT_E_JoyUValue,
 IPT_E_JoyVValue,
 IPT_E_PadFirstButton,
 IPT_E_PadButton0     = IPT_E_PadFirstButton,
 IPT_E_PadButton1,
 IPT_E_PadButton2,
 IPT_E_PadButton3,
 IPT_E_PadButton4,
 IPT_E_PadButton5,
/* ANNECY AV {*/
/*
 IPT_E_PadButton6,
 IPT_E_PadButton7,
 IPT_E_PadButton8,
 IPT_E_PadButton9,
 IPT_E_PadButton10,
 IPT_E_PadButton11,
 IPT_E_PadButton12,
 IPT_E_PadButton13,
 IPT_E_PadButton14,
 IPT_E_PadButton15,
 IPT_E_PadButton16,
 IPT_E_PadButton17,
 IPT_E_PadButton18,
 IPT_E_PadButton19,
 IPT_E_PadButton20,
 IPT_E_PadButton21,
 IPT_E_PadButton22,
 IPT_E_PadButton23,
 IPT_E_PadButton24,
 IPT_E_PadButton25,
 IPT_E_PadButton26,
 IPT_E_PadButton27,
 IPT_E_PadButton28,
 IPT_E_PadButton29,
 IPT_E_PadButton30,
 IPT_E_PadButton31,
 IPT_E_PadLastButton    = IPT_E_PadButton31,
*/
 IPT_E_PadLastButton = IPT_E_PadButton5,
/* END ANNECY AV }*/
 IPT_E_JoyFirstButton,
 IPT_E_JoyButton0     = IPT_E_JoyFirstButton,
 IPT_E_JoyButton1,
 IPT_E_JoyButton2,
 IPT_E_JoyButton3,
 IPT_E_JoyButton4,
 IPT_E_JoyButton5,
/* ANNECY AV {*/
#ifdef U64
 IPT_E_JoyButton6,
 IPT_E_JoyButton7,
 IPT_E_JoyButton8,
 IPT_E_JoyButton9,
 IPT_E_JoyButton10,
 IPT_E_JoyButton11,
 IPT_E_JoyButton12,
 IPT_E_JoyButton13,
 IPT_E_JoyButton14,
 IPT_E_JoyButton15,
#endif
#ifdef DREAM
 IPT_E_JoyButton6,
 IPT_E_JoyButton7,
 IPT_E_JoyButton8,
 IPT_E_JoyButton9,
 IPT_E_JoyButton10,
 IPT_E_JoyButton11,
 IPT_E_JoyButton12,
 IPT_E_JoyButton13,
 IPT_E_JoyButton14,
 IPT_E_JoyButton15,
 IPT_E_JoyButton16,
 IPT_E_JoyButton17,
#endif /* DREAM */
/* ANNECY AV {*/
/*
 IPT_E_JoyButton16,
 IPT_E_JoyButton17,
 IPT_E_JoyButton18,
 IPT_E_JoyButton19,
 IPT_E_JoyButton20,
 IPT_E_JoyButton21,
 IPT_E_JoyButton22,
 IPT_E_JoyButton23,
 IPT_E_JoyButton24,
 IPT_E_JoyButton25,
 IPT_E_JoyButton26,
 IPT_E_JoyButton27,
 IPT_E_JoyButton28,
 IPT_E_JoyButton29,
 IPT_E_JoyButton30,
 IPT_E_JoyButton31,
 IPT_E_JoyLastButton    = IPT_E_JoyButton31,
*/
#ifdef U64
 IPT_E_JoyLastButton    = IPT_E_JoyButton15 ,
#else
#ifdef DREAM
 IPT_E_JoyLastButton    = IPT_E_JoyButton17,
#else
 IPT_E_JoyLastButton    = IPT_E_JoyButton5 ,
#endif /* DREAMCAST */
#endif
/* END ANNECY AV }*/
 IPT_E_NumberOfPadAndJoyAction,
};
 
enum IPT_E_HistoricSate_
{
 IPT_E_Stopped = 0x00,
 IPT_E_Stopping,
 IPT_E_InProgress,
};
 
#undef EXTERN
#undef extern
#if !defined(D_IPT_Input_VariableDefine)
#define EXTERN extern
#else
#define EXTERN
#endif /* D_IPT_Input_VariableDefine */
 
#if (!defined(U64))
 
EXTERN struct IPT_tdstConvertValue_ IPT_g_ConvertAZERTYtoQWERTY[]
#if defined(D_IPT_Input_VariableDefine)
=
{
 C_ucKey_A,C_ucKey_Q,
 C_ucKey_Z,C_ucKey_W,
 C_ucKey_Q,C_ucKey_A,
 C_ucKey_M,C_ucKey_PVIRG,
 C_ucKey_W,C_ucKey_Z,
 C_ucKey_VIRG,C_ucKey_M,
 C_ucKey_PVIRG,C_ucKey_VIRG,
 -1,-1
}
#endif /* D_IPT_Input_VariableDefine */
;
 
EXTERN struct IPT_tdstScriptValue_ IPT_g_hScriptKeyValue[]
#if defined(D_IPT_Input_VariableDefine)
=
{
 "",C_ucKey_SQUARE,
 "1",C_ucKey_1,
 "2",C_ucKey_2,
 "3",C_ucKey_3,
 "4",C_ucKey_4,
 "5",C_ucKey_5,
 "6",C_ucKey_6,
 "7",C_ucKey_7,
 "8",C_ucKey_8,
 "9",C_ucKey_9,
 "0",C_ucKey_0,
 ")",C_ucKey_END_BRACET,
 "=",C_ucKey_EQUAL,
 "A",C_ucKey_A,
 "Z",C_ucKey_Z,
 "E",C_ucKey_E,
 "R",C_ucKey_R,
 "T",C_ucKey_T,
 "Y",C_ucKey_Y,
 "U",C_ucKey_U,
 "I",C_ucKey_I,
 "O",C_ucKey_O,
 "P",C_ucKey_P,
 "^",C_ucKey_EXP,
 "$",C_ucKey_DOLLAR,
 "Q",C_ucKey_Q,
 "S",C_ucKey_S,
 "D",C_ucKey_D,
 "F",C_ucKey_F,
 "G",C_ucKey_G,
 "H",C_ucKey_H,
 "J",C_ucKey_J,
 "K",C_ucKey_K,
 "L",C_ucKey_L,
 "M",C_ucKey_M,
 "%",C_ucKey_PERCENT,
 "*",C_ucKey_MUL,
 "<",C_ucKey_INF,
 "W",C_ucKey_W,
 "X",C_ucKey_X,
 "C",C_ucKey_C,
 "V",C_ucKey_V,
 "B",C_ucKey_B,
 "N",C_ucKey_N,
 ",",C_ucKey_VIRG,
 ";",C_ucKey_PVIRG,
 ":",C_ucKey_PP,
 "!",C_ucKey_NOT,
 "F1",C_ucKey_F1,
 "F2",C_ucKey_F2,
 "F3",C_ucKey_F3,
 "F4",C_ucKey_F4,
 "F5",C_ucKey_F5,
 "F6",C_ucKey_F6,
 "F7",C_ucKey_F7,
 "F8",C_ucKey_F8,
 "F9",C_ucKey_F9,
 "F10",C_ucKey_F10,
 "F11",C_ucKey_F11,
 "F12",C_ucKey_F12,
 "PrintScreen",C_ucKey_SYSTEM,
 "Scroll",C_ucKey_SCROLL,
 "Pause",C_ucKey_PAUSE,
 
 " ",C_ucKey_SPACE,
 "Esc",C_ucKey_ESC,
 "Tab",C_ucKey_TAB,
 "Caps",C_ucKey_CAPSLOCK,
 "LeftShift",C_ucKey_LSHIFT,
 "RightShift",C_ucKey_RSHIFT,
 "LeftCtrl",C_ucKey_LCTRL,
 "RightCtrl",C_ucKey_RCTRL,
 "LeftAlt",C_ucKey_LALT,
 "RightAlt",C_ucKey_RALT,
 "Enter",C_ucKey_ENTER,
 "Back",C_ucKey_BACK,
 
 "Ins",C_ucKey_INS,
 "Del",C_ucKey_DEL,
 "Home",C_ucKey_HOME,
 "End",C_ucKey_END,
 "Prior",C_ucKey_PRIOR,
 "Next",C_ucKey_NEXT,
 
 "Up",C_ucKey_UP,
 "Down",C_ucKey_DOWN,
 "Left",C_ucKey_LEFT,
 "Right",C_ucKey_RIGHT,
 
 "VerrNum",C_ucKey_NUMLOCK,
 "Pad/",C_ucKey_PAD_DIV,
 "Pad*",C_ucKey_PAD_MUL,
 "Pad-",C_ucKey_PAD_SUB,
 "Pad+",C_ucKey_PAD_ADD,
 "Pad.",C_ucKey_PAD_POINT,
 "Pad0",C_ucKey_PAD_0,
 "Pad1",C_ucKey_PAD_1,
 "Pad2",C_ucKey_PAD_2,
 "Pad3",C_ucKey_PAD_3,
 "Pad4",C_ucKey_PAD_4,
 "Pad5",C_ucKey_PAD_5,
 "Pad6",C_ucKey_PAD_6,
 "Pad7",C_ucKey_PAD_7,
 "Pad8",C_ucKey_PAD_8,
 "Pad9",C_ucKey_PAD_9,
 "PadEnter",C_ucKey_PAD_ENTER,
 "--Last--",-1
}
#endif /* D_IPT_Input_VariableDefine */
;
#endif /* !U64 */
 
EXTERN struct IPT_tdstScriptValue_ IPT_g_hScriptPadValue[]
#if defined(D_IPT_Input_VariableDefine)
=
{
#ifdef DREAM
 "PadUp"      ,IPT_E_PadUp,
 "PadDown"    ,IPT_E_PadDown,
 "PadLeft"    ,IPT_E_PadLeft,
 "PadRight"   ,IPT_E_PadRight,
 "PadXValue"  ,IPT_E_JoyXValue,
 "PadYValue"  ,IPT_E_JoyYValue,
 "PadZValue"  ,IPT_E_JoyZValue,
 "PadRValue"  ,IPT_E_JoyRValue,
 "PadUValue"  ,IPT_E_JoyUValue,
 "PadVValue"  ,IPT_E_JoyVValue,
 "A_Button"	  ,IPT_E_JoyButton2,
 "B_Button"	  ,IPT_E_JoyButton1,
 "C_Button"	  ,IPT_E_JoyButton0,
 "X_Button"	  ,IPT_E_JoyButton10,
 "Y_Button"	  ,IPT_E_JoyButton9,
 "Z_Button"	  ,IPT_E_JoyButton8,
 "L_Button"	  ,IPT_E_JoyButton17,
 "R_Button"	  ,IPT_E_JoyButton16,
 "Start_Button",IPT_E_JoyButton3,
 "Cross_Up"	  ,IPT_E_JoyButton4,
 "Cross_Down" ,IPT_E_JoyButton5,
 "Cross_Left" ,IPT_E_JoyButton6,
 "Cross_Right",IPT_E_JoyButton7,
#else
 "PadUp"      ,IPT_E_PadUp,
 "PadDown"    ,IPT_E_PadDown,
 "PadLeft"    ,IPT_E_PadLeft,
 "PadRight"   ,IPT_E_PadRight,
 "PadXValue"  ,IPT_E_JoyXValue,
 "PadYValue"  ,IPT_E_JoyYValue,
 "PadZValue"  ,IPT_E_JoyZValue,
 "PadRValue"  ,IPT_E_JoyRValue,
 "PadUValue"  ,IPT_E_JoyUValue,
 "PadVValue"  ,IPT_E_JoyVValue,
 "PadButton0" ,IPT_E_PadButton0,
 "PadButton1" ,IPT_E_PadButton1,
 "PadButton2" ,IPT_E_PadButton2,
 "PadButton3" ,IPT_E_PadButton3,
 "PadButton4" ,IPT_E_PadButton4,
 "PadButton5" ,IPT_E_PadButton5,
/* ANNECY AV {*/
/*
 "PadButton6" ,IPT_E_PadButton6,
 "PadButton7" ,IPT_E_PadButton7,
 "PadButton8" ,IPT_E_PadButton8,
 "PadButton9" ,IPT_E_PadButton9,
 "PadButton10",IPT_E_PadButton10,
 "PadButton11",IPT_E_PadButton11,
 "PadButton12",IPT_E_PadButton12,
 "PadButton13",IPT_E_PadButton13,
 "PadButton14",IPT_E_PadButton14,
 "PadButton15",IPT_E_PadButton15,
 "PadButton16",IPT_E_PadButton16,
 "PadButton17",IPT_E_PadButton17,
 "PadButton18",IPT_E_PadButton18,
 "PadButton19",IPT_E_PadButton19,
 "PadButton20",IPT_E_PadButton20,
 "PadButton21",IPT_E_PadButton21,
 "PadButton22",IPT_E_PadButton22,
 "PadButton23",IPT_E_PadButton23,
 "PadButton24",IPT_E_PadButton24,
 "PadButton25",IPT_E_PadButton25,
 "PadButton26",IPT_E_PadButton26,
 "PadButton27",IPT_E_PadButton27,
 "PadButton28",IPT_E_PadButton28,
 "PadButton29",IPT_E_PadButton29,
 "PadButton30",IPT_E_PadButton30,
 "PadButton31",IPT_E_PadButton31,
*/
/* END ANNECY AV }*/
 "JoyButton0" ,IPT_E_JoyButton0,
 "JoyButton1" ,IPT_E_JoyButton1,
 "JoyButton2" ,IPT_E_JoyButton2,
 "JoyButton3" ,IPT_E_JoyButton3,
 "JoyButton4" ,IPT_E_JoyButton4,
 "JoyButton5" ,IPT_E_JoyButton5,
/* ANNECY AV {*/
#ifdef U64
 "JoyButton6" ,IPT_E_JoyButton6,
 "JoyButton7" ,IPT_E_JoyButton7,
 "JoyButton8" ,IPT_E_JoyButton8,
 "JoyButton9" ,IPT_E_JoyButton9,
 "JoyButton10",IPT_E_JoyButton10,
 "JoyButton11",IPT_E_JoyButton11,
 "JoyButton12",IPT_E_JoyButton12,
 "JoyButton13",IPT_E_JoyButton13,
 "JoyButton14",IPT_E_JoyButton14,
 "JoyButton15",IPT_E_JoyButton15,
#endif
/* ANNECY AV {*/
/*
 "JoyButton16",IPT_E_JoyButton16,
 "JoyButton17",IPT_E_JoyButton17,
 "JoyButton18",IPT_E_JoyButton18,
 "JoyButton19",IPT_E_JoyButton19,
 "JoyButton20",IPT_E_JoyButton20,
 "JoyButton21",IPT_E_JoyButton21,
 "JoyButton22",IPT_E_JoyButton22,
 "JoyButton23",IPT_E_JoyButton23,
 "JoyButton24",IPT_E_JoyButton24,
 "JoyButton25",IPT_E_JoyButton25,
 "JoyButton26",IPT_E_JoyButton26,
 "JoyButton27",IPT_E_JoyButton27,
 "JoyButton28",IPT_E_JoyButton28,
 "JoyButton29",IPT_E_JoyButton29,
 "JoyButton30",IPT_E_JoyButton30,
 "JoyButton31",IPT_E_JoyButton31,
*/
#endif /* DREAM */
/* END ANNECY AV }*/
 "--Last--",-1
}
#endif /* D_IPT_Input_VariableDefine */
;
 
EXTERN unsigned long IPT_g_ulPadAndJoyButtonFlag[]
#if defined(D_IPT_Input_VariableDefine)
=
{
 C_ulButtonFlag1,
 C_ulButtonFlag2,
 C_ulButtonFlag3,
 C_ulButtonFlag4,
 C_ulButtonFlag5,
 C_ulButtonFlag6,
 C_ulButtonFlag7,
 C_ulButtonFlag8,
 C_ulButtonFlag9,
 C_ulButtonFlag10,
 C_ulButtonFlag11,
 C_ulButtonFlag12,
 C_ulButtonFlag13,
 C_ulButtonFlag14,
 C_ulButtonFlag15,
 C_ulButtonFlag16,
 C_ulButtonFlag17,
 C_ulButtonFlag18,
 C_ulButtonFlag19,
 C_ulButtonFlag20,
 C_ulButtonFlag21,
 C_ulButtonFlag22,
 C_ulButtonFlag23,
 C_ulButtonFlag24,
 C_ulButtonFlag25,
 C_ulButtonFlag26,
 C_ulButtonFlag27,
 C_ulButtonFlag28,
 C_ulButtonFlag29,
 C_ulButtonFlag30,
 C_ulButtonFlag31,
 C_ulButtonFlag32
}
#endif /* D_IPT_Input_VariableDefine */
;
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
EXTERN struct IPT_tdstScriptValue_ IPT_g_hScriptKeyWordValue[]
#if defined(D_IPT_Input_VariableDefine)
=
{
 /* Logical operators */
 "And"                      ,IPT_E_KeyWord_And,
 "Or"                       ,IPT_E_KeyWord_Or,
 "Not"                      ,IPT_E_KeyWord_Not,
 /* Keyboard operators */
 "KeyJustPressed"           ,IPT_E_KeyWord_KeyJustPressed,
 "KeyJustReleased"          ,IPT_E_KeyWord_KeyJustReleased,
 "KeyPressed"               ,IPT_E_KeyWord_KeyPressed,
 "KeyReleased"              ,IPT_E_KeyWord_KeyReleased,
 /* Action operators */
 "ActionJustValidated"      ,IPT_E_KeyWord_ActionJustValidated,
 "ActionJustInvalidated"    ,IPT_E_KeyWord_ActionJustInvalidated,
 "ActionValidated"          ,IPT_E_KeyWord_ActionValidated,
 "ActionInvalidated"        ,IPT_E_KeyWord_ActionInvalidated,
 /* Pad operators */
 "PadJustPressed"           ,IPT_E_KeyWord_PadJustPressed,
 "PadJustReleased"          ,IPT_E_KeyWord_PadJustReleased,
 "PadPressed"               ,IPT_E_KeyWord_PadPressed,
 "PadReleased"              ,IPT_E_KeyWord_PadReleased,
 /* Joystick operators */
 "JoyAxeValue"              ,IPT_E_KeyWord_JoystickAxeValue,
 "JoyJustPressed"           ,IPT_E_KeyWord_JoystickJustPressed,
 "JoyJustReleased"          ,IPT_E_KeyWord_JoystickJustReleased,
 "JoyPressed"               ,IPT_E_KeyWord_JoystickPressed,
 "JoyReleased"              ,IPT_E_KeyWord_JoystickReleased,
 /* joystick and pad operators */
 "JoyOrPadJustPressed"      ,IPT_E_KeyWord_JoystickOrPadJustPressed,
 "JoyOrPadJustReleased"     ,IPT_E_KeyWord_JoystickOrPadJustReleased,
 "JoyOrPadPressed"          ,IPT_E_KeyWord_JoystickOrPadPressed,
 "JoyOrPadReleased"         ,IPT_E_KeyWord_JoystickOrPadReleased,
 /* Sequence operators */
 "Sequence"                 ,IPT_E_KeyWord_Sequence,
 "Key"                      ,IPT_E_KeyWord_SequenceKey,
 "Pad"                      ,IPT_E_KeyWord_SequencePad,
 "--Last--",-1
}
#endif /* D_IPT_Input_VariableDefine */
;
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
typedef unsigned char (IPT_tdfn_bIsKeyWordValid)(IPT_tdxHandleToKeyWordElement);
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
EXTERN IPT_tdfn_bIsKeyWordValid *IPT_p_fn_bIsKeyWordValid[IPT_E_NumberOfKeyWord&0x00ff]
#if defined(D_IPT_Input_VariableDefine)
=
{
 /* Be carefull about the order of the functions pointers */
 NULL,
 /* Logical operators */
 IPT_fn_bIsKeyWordValid_And,
 IPT_fn_bIsKeyWordValid_Or,
 IPT_fn_bIsKeyWordValid_Not,
 /* Keyboard operators */
 IPT_fn_bIsKeyWordValid_KeyJustPressed,
 IPT_fn_bIsKeyWordValid_KeyJustReleased,
 IPT_fn_bIsKeyWordValid_KeyPressed,
 IPT_fn_bIsKeyWordValid_KeyReleased,
 /* actions operators */
 IPT_fn_bIsKeyWordValid_ActionJustValidated,
 IPT_fn_bIsKeyWordValid_ActionJustInvalidated,
 IPT_fn_bIsKeyWordValid_ActionValidated,
 IPT_fn_bIsKeyWordValid_ActionInvalidated,
 /* pad operators */
 IPT_fn_bIsKeyWordValid_PadJustPressed,
 IPT_fn_bIsKeyWordValid_PadJustReleased,
 IPT_fn_bIsKeyWordValid_PadPressed,
 IPT_fn_bIsKeyWordValid_PadReleased,
 /* joystick operators */
 IPT_fn_bIsKeyWordValid_JoystickAxeValue,
 IPT_fn_bIsKeyWordValid_JoystickJustPressed,
 IPT_fn_bIsKeyWordValid_JoystickJustReleased,
 IPT_fn_bIsKeyWordValid_JoystickPressed,
 IPT_fn_bIsKeyWordValid_JoystickReleased,
 /* joystick and pad operators */
 IPT_fn_bIsKeyWordValid_JoystickOrPadJustPressed,
 IPT_fn_bIsKeyWordValid_JoystickOrPadJustReleased,
 IPT_fn_bIsKeyWordValid_JoystickOrPadPressed,
 IPT_fn_bIsKeyWordValid_JoystickOrPadReleased,
 /* sequences operators */
 IPT_fn_bIsKeyWordValid_Sequence,
 IPT_fn_bIsKeyWordValid_SequenceKey,
 IPT_fn_bIsKeyWordValid_SequenceKeyEnd,
 IPT_fn_bIsKeyWordValid_SequencePad,
 IPT_fn_bIsKeyWordValid_SequencePadEnd,
}
#endif /* D_IPT_Input_VariableDefine */
;
 
#undef EXTERN
#undef extern
 
#endif /* __IPT_KDef_H__ */
