/* ISI_Func.h*/
/* PC Version*/
 
#ifndef _ISI_FUNC_H_
#define _ISI_FUNC_H_
 
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLL using these function :*/
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "GLI\GLI_Defn.h"/*pour ISI_tdstColor*/
#include "IPO\IPOHandl.h"/*pour IPO_tdxHandleToInstanciatedPhysicalObject*/
 
/*Prototypes*/
 
/* ##-########################### 
   ## Saving / Loading
   ############################## */
 
/* ##F===================================================================================
NAME :          ISI_fn_pGetLinkTable
DESCRIPTION :   Function to get the link table.
OUTPUT : Link table.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
extern CPA_EXPORT SCR_tdst_Link_Table *ISI_fn_pGetLinkTable(void);
 
/* ##F===================================================================================
NAME :          ISI_fn_vDisinitLinkTable
DESCRIPTION :   Function to disinit the link table.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
extern CPA_EXPORT void ISI_fn_vDisinitLinkTable(void);
 
/* ##F===================================================================================
NAME :          ISI_fn_xLoadISI
DESCRIPTION :   Load the ISI of an IPO. (Script callback)
INPUT : p_fFile       = script file description.
        szAction      = action name.
        szParams      = table of param.
        cType         = type of action.
OUTPUT : script error code.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
extern CPA_EXPORT SCR_tde_Anl_ReturnValue ISI_fn_xLoadISI(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
 
/*ANNECY JMD 17/02/98{*/
/* ##F===================================================================================
NAME :          ISI_fn_xLoadISI2
DESCRIPTION :   Load the ISI of an PO. (Script callback)
INPUT : p_fFile       = script file description.
        szAction      = action name.
        szParams      = table of param.
        cType         = type of action.
OUTPUT : script error code.
=========================================================================================
LAST MODIFICATIONS : 17/02/98 Jean-Marc Drouaud
=======================================================================================*/
 
extern CPA_EXPORT SCR_tde_Anl_ReturnValue ISI_fn_xLoadISI2(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
/*END ANNECY JMD }*/
 
/* ##F===================================================================================
NAME :          ISI_vSaveVertexISI
DESCRIPTION :   Save an ISI of an IPO. (Script callback)
INPUT : _p_stFile     = script file description.
        _sFileName    = file name.
        _p_vPtr       = struct adress.
        _xAction      = type of action
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
extern CPA_EXPORT void ISI_vSaveVertexISI(SCR_tdst_File_Description *_p_stFile, char *_sFileName, void *_p_vPtr, SCR_tde_Ntfy_Action _xAction);
 
/* ##F===================================================================================
NAME :          ISI_vSaveISIFromIPO
DESCRIPTION :   Save all ISI for one IPO.
INPUT : _hIPO   = IPO handle to save.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
extern CPA_EXPORT void ISI_vSaveISIFromIPO(IPO_tdxHandleToInstanciatedPhysicalObject _hIPO);
 
/* ##F===================================================================================
NAME :          ISI_fn_vSaveISIFromIPOFromHierarchie
DESCRIPTION :   Save all ISI for all IPO which are child of a super object,
                or which is the super object.
INPUT : _hSuperObject   = super object handle to save.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
extern CPA_EXPORT void ISI_fn_vSaveISIFromIPOFromHierarchie(HIE_tdxHandleToSuperObject _hSuperObject);
 
/* ##F===================================================================================
NAME :          ISI_fn_vPrepareSaveBinaryBloc
DESCRIPTION :   function to prepare the binary save process.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
/*extern CPA_EXPORT void ISI_fn_vPrepareSaveBinaryBloc(void);*/
 
/* ##F===================================================================================
NAME :          ISI_fn_ulWriteBinaryBloc
DESCRIPTION :   Write a binary bloc for a ISI
INPUT : _ulStructAddress = Address of the element.
        _p_cDestBuffer   = Pointer to the buffer.
OUTPUT : length of the data written.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
/*extern CPA_EXPORT unsigned long ISI_fn_ulWriteBinaryBloc(unsigned long _ulStructAddress, char* _p_cDestBuffer);*/
 
/* ##F===================================================================================
NAME :          ISI_fn_vWriteAllISIBinaryBlocs
DESCRIPTION :   Write all the binary blocs for the ISI
INPUT : _szBinaryFileName = Name of the binary file.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
/*extern CPA_EXPORT void ISI_fn_vWriteAllISIBinaryBlocs(char* _szBinaryFileName);*/
 
/* ##F===================================================================================
NAME :          ISI_fn_ulReadISIBinaryBloc
DESCRIPTION :   Read the binary bloc for ISI.
INPUT : _p_cLoadedBuffer    = pointer to the loaded buffer.
        _ulLoadedBufferSize = Size of the loaded buffer.
OUTPUT : The pointer to the allocated element.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
/*extern CPA_EXPORT void ISI_fn_ulReadISIBinaryBloc(unsigned long _ulLoadedBuffer);*/
 
/* ##F===================================================================================
NAME :          ISI_fn_vReadAllISIBinaryBlocs
DESCRIPTION :   Read all the binary blocs for the ISI.
INPUT : _szBinaryFile = Name of the binary file.
=========================================================================================
LAST MODIFICATIONS : 20/11/97 David Fournier : New commentary form.
=======================================================================================*/
/*extern CPA_EXPORT void ISI_fn_vReadAllISIBinaryBlocs(char* _szBinaryFile);*/
 
 
/*End Proto*/
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* _ISI_FUNC_H_ */
