/*=========================================================================*/
/* CPAFrame.hpp : main header file for the CPA_MainFrame class*/
/* This is a part of the CPA project.*/
/**/
/* Version			1.0*/
/* Creation date	06/06/96*/
/* Revision date*/
/**/
/* (c) Ubi Studio 1996*/
/**/
/* DO NOT MODIFY THAT FILE. IF SOMETHING NEEDS TO BE CHANGE, PLEASE CONTACT */
/* VINCENT GRECO OR CHRISTOPHE BEAUDET.*/
/*=========================================================================*/
 
#ifndef __CPAFRAME_HPP__
#define __CPAFRAME_HPP__
#include "FRMBsMn.hpp"
class CPA_DLLBase;
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#ifdef TEST_CPA_VERSION_3D
extern  void CPA_EXPORT     fn_vInitCompleteWorld3D(LPCTSTR);
extern  void CPA_EXPORT     fn_vCloseCompleteWorld3D();
#endif /* TEST_CPA_VERSION_3D*/
 
/*##########*/
/* MainFrame*/
/*##########*/
 
#define C_ucMaxFrameName	100		/* Max name of mainframe*/
 
#ifdef ACTIVE_EDITOR
class CPA_EXPORT CPA_MainFrame : public FRMBaseMenu
#else
class CPA_EXPORT CPA_MainFrame : public CFrameWnd
#endif /* ACTIVE_EDITOR*/
{
public: 
	CPA_MainFrame();
	~CPA_MainFrame();
	DECLARE_DYNCREATE(CPA_MainFrame)
 
public:
	char		m_szProjectName[C_ucMaxFrameName];		/* Name of project*/
 
/* Operations*/
public:
	void OnUpdateFrameTitle(BOOL);
	void OnClose(void);
 
#ifdef ACTIVE_EDITOR
	virtual void fn_vInitGeneralDialogBarWithContext(void);
	virtual BOOL PreCreateWindow( CREATESTRUCT& cs );
	void DisactivateEditors(void);
	void ActivateEditors(void);
 
 
#endif /* ACTIVE_EDITOR*/
 
/* Generated message map functions*/
protected:
	/*{{AFX_MSG(CPA_MainFrame)*/
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSysCommand(UINT, LPARAM);
	afx_msg LRESULT OnDisplayChange(UINT wParam, LONG lParam);
	afx_msg LRESULT m_lOnPowerManagement(UINT wParam, LONG lParam);
    afx_msg void OnSize(UINT, int, int);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR *);
#ifdef ACTIVE_EDITOR
    afx_msg void OnNcLButtonDown(UINT, CPoint);
	afx_msg void OnSwapToEditors(void);
	afx_msg void OnFullScreen(void);
    afx_msg void OnAppExit(void);
    afx_msg void OnWindowPosChanged(WINDOWPOS *);
	afx_msg UINT OnNcHitTest(CPoint);
	afx_msg int OnMouseActivate( CWnd* pDesktopWnd, UINT nHitTest, UINT message );
#endif /* ACTIVE_EDITOR*/
public:
	afx_msg void OnActivateApp(BOOL, DWORD);
	afx_msg void OnActivate( UINT nState, CWnd* pWndOther, BOOL bMinimized );
 
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
 
/*///////////////////////////////////////////////////////////////////////////*/
 
#endif /* __CPAFRAME_HPP__*/
