/*=========================================================================*/
/* CPAWndButo.hpp :	Window Button used by PopUpToolBar.*/
/* This is a part of the PCA project.*/
/**/
/* Version			1.0*/
/* Creation date	26/06/96*/
/* Revision date*/
/**/
/* (c) Ubi Studios 1996*/
/**/
/* DO NOT MODIFY THAT FILE. IF SOMETHING NEEDS TO BE CHANGE, PLEASE CONTACT*/
/* OLIVIER DIDELOT OR MARC VILLEMAIN.*/
/*=========================================================================*/
/* CPA_WndButton window*/
 
#ifndef __CPAWBUTO_HPP__
#define __CPAWBUTO_HPP__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#ifdef ACTIVE_EDITOR
 
#include "CPAMCapt.hpp"
 
class CPA_PopUpToolBar;
 
/*#########################################################################*/
class CPA_EXPORT CPA_WndButton : public CWnd, public CPA_MouseCapturer
{
public:
	CPA_WndButton();
 
private:
	CToolBarCtrl		m_oToolBarCtrl;
	CPA_PopUpToolBar	*m_p_oPopUpTBParent;
	long				m_lFamily;
	tdstButton			m_a_stButtons[C_MAX_BUTTON_PER_FAMILY];
	long				m_lNbButtons;
	long				m_lNbButtonsTotal;
	long				m_lIdResource;
	long				m_lIdChosenButton;
/* Operations*/
public:
	void CreateWndButton(CPA_PopUpToolBar	*p_oPopUpTB,
						 long               lWndPosX,
						 long               lWndPosY,
						 tdstButton         a_stButtons[],
						 long               lNbButtons,
						 long               lFamily,
						 long				lNbButtonsTotal,
						 long				lIdResource);
 
	long GetChosenButtonId() { return m_lIdChosenButton; };
 
 /*any class deriving from CPA_MouseCapturer one must declare this method as is*/
 CWnd *m_p_oGrabCapture() { return m_p_oGrabCaptureFor(this); }
 
private:
	int CreateToolBarCtrl();
	int CreateToolBar();
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CPA_WndButton)*/
	protected:
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
public:
	virtual ~CPA_WndButton();
 
	/* Generated message map functions*/
protected:
	/*{{AFX_MSG(CPA_WndButton)*/
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonUp( UINT, CPoint );
	afx_msg void OnMouseMove( UINT, CPoint );
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
#endif /* ACTIVE_EDITOR*/
#endif /* __PCAWBUTO_HPP__*/
/*///////////////////////////////////////////////////////////////////////////*/
