/*=========================================================================*/
/* DEVMul2D.hpp :	MultiDevice 3D which manage the Device 2D.*/
/* This is a part of the PCA project.*/
/**/
/* Version			1.0*/
/* Creation date	22/07/96*/
/* Revision date*/
/**/
/* (c) Ubi Studios 1996*/
/**/
/* DO NOT MODIFY THAT FILE. IF SOMETHING NEEDS TO BE CHANGE, PLEASE CONTACT */
/* OLIVIER DIDELOT.*/
/*=========================================================================*/
 
#ifndef __DEVMUL2D_HPP__
#define __DEVMUL2D_HPP__
#include "DEVMulti.hpp"
class CPA_ProjectDoc;
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
/*-------------------------------------------------------------------------*/
class CPA_EXPORT DEV_MultiDevice2D : public DEV_MultiDevice
{
protected: 
	DEV_MultiDevice2D();
	DECLARE_DYNCREATE(DEV_MultiDevice2D)
 
public:
	DEV_MultiDevice2D(int);
	virtual ~DEV_MultiDevice2D();
    void                Init(void);
	CPA_ProjectDoc      *GetDocument();
 
/* Engine*/
/*----------------------------------------------------------------------------------------------------------------------*/
 
/* Editor*/
/*----------------------------------------------------------------------------------------------------------------------*/
#ifdef ACTIVE_EDITOR
public:
	void    ViewportTips(LPTOOLTIPTEXT p_ToolTipText, UINT Id);
    void    CreateViewportToolBar(void);
    void    DrawObject(void);       
    void    DrawObjectExcept0(void);
#endif /* ACTIVE_EDITOR*/
 
protected:
	/*{{AFX_MSG(DEV_MultiDevice)*/
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
 
/*--------------------------------------------------------------------*/
inline CPA_ProjectDoc* DEV_MultiDevice2D::GetDocument()
{ 
    return (CPA_ProjectDoc*) m_pDocument; 
}
 
#endif /* __DEVMUL2D_HPP__*/
