/*=========================================================================*/
/* ToolDLLb.hpp :       base of Tools DLL*/
/* This is a part of the CPA project.*/
/**/
/* Version                      1.0*/
/* Creation date        10/06/96*/
/* Revision date*/
/**/
/* (c) Ubi Studio 1996*/
/**/
/* DO NOT MODIFY THAT FILE. IF SOMETHING NEEDS TO BE CHANGE, PLEASE CONTACT*/
/* VINCENT GRECO OR CHRISTOPHE BEAUDET.*/
/*=========================================================================*/
 
#ifndef __TOOLDLLB_HPP__
#define __TOOLDLLB_HPP__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
 
#ifdef ACTIVE_EDITOR
 
#include "CPADLLb.hpp"
 
class CPA_MainWorld;
 
/*##########################################################################*/
/* Definition of a Tool DLL*/
typedef struct tdstToolDLLDef_
{
} tdstToolDLLDef;
 
 
/*##########################################################################*/
/* Tool DLL Base Class*/
class CPA_EXPORT CPA_ToolDLLBase : public CPA_DLLBase
{
protected:
    tdstToolDLLDef m_stToolDLLDefinition;
 
public:
    CPA_ToolDLLBase() {};
    ~CPA_ToolDLLBase() {};
 
    tdstToolDLLDef *GetDefinition(void)	{ return &m_stToolDLLDefinition; }
 
public:
 
    /* To want/won't to receive Window Messages*/
    void fn_vSetReceivingWindowMessages(BOOL _bWantToReceive = TRUE);
    /* TO Want/won't to receive Evt Editor Messages*/
    void fn_vSetReceivingEvtEditorMessages(BOOL _bWantToReceive = TRUE);
 
	virtual void fn_vOnChangeCurrentEditor (CPA_EditorBase *pCurrentEditor, CPA_EditorBase *pNewEditor) { }
};
 
#endif /* ACTIVE_EDITOR*/
#endif /* __OBJDLLB_HPP__*/
