/*=========================================================================
* MWIC.h : MecCamIdCard's functions
*
* Version              1.0
* Creation date        03/01/97
* Revision date
*
* (c) Ubi Studios 1997
*=======================================================================*/
 
#if !defined(__MecCamIdCard_TYPES__)
#define __MecCamIdCard_TYPES__
 
#include "DNMMecId.h"
#include "acp_base.h"
#include "hidcard.h"
 
#if !defined(ONLY_TYPES)
#define ONLY_TYPES
#define _MecCamIdCard_UNDEF
#endif /* ONLY_TYPES */
 
#if defined(_MecCamIdCard_UNDEF)
#undef _MecCamIdCard_UNDEF
#undef ONLY_TYPES
#endif /* MecCamIdCard_UNDEF */
 
#ifdef __cplusplus
extern "C" {
#endif
 
 
typedef struct DNM_stMecCameraIdCard
{
    /* Identity */
    DNM_tdeMechanicsID m_eIdentity; /* = DNM_eCamera */
 
   /* linear speed  m/s*/
	MTH_tdxReal m_xLinearSpeed;
	/* angular speed  degree/s*/
	MTH_tdxReal m_xAngularSpeed;
 
 
   /*  Speeding Up  m/s*/
	MTH_tdxReal m_xSpeedingUp;
 
} DNM_tdstMecCameraIdCard;
 
 
/* Put here all macro-accessors */
#define DNM_M_eCameraIdCardGetIdentity(_p_stCameraIdCard) ((_p_stCameraIdCard)->m_eIdentity)
 
#define DNM_M_xCameraIdCardGetAngularSpeed(_p_stCameraIdCard) ((_p_stCameraIdCard)->m_xAngularSpeed)
#define DNM_M_xCameraIdCardGetLinearSpeed(_p_stCameraIdCard) ((_p_stCameraIdCard)->m_xLinearSpeed)
 
#define DNM_M_xCameraIdCardSetAngularSpeed(_p_stCameraIdCard,xValue) ((_p_stCameraIdCard)->m_xAngularSpeed=xValue)
#define DNM_M_xCameraIdCardSetLinearSpeed(_p_stCameraIdCard,xValue) ((_p_stCameraIdCard)->m_xLinearSpeed=xValue)
 
#define DNM_M_xCameraIdCardGetSpeedingUp(_p_stCameraIdCard) ((_p_stCameraIdCard)->m_xSpeedingUp)
#define DNM_M_xCameraIdCardSetSpeedingUp(_p_stCameraIdCard,xValue) ((_p_stCameraIdCard)->m_xSpeedingUp = xValue)
 
/* Private */
#define DNM_M_eCameraIdCardSetIdentity(_p_stCameraIdCard,_eValue) (DNM_M_eCameraIdCardGetIdentity(_p_stCameraIdCard) = _eValue)
 
/* temporary */
#define DNM_M_xCameraIdCardGetInstructionSpeed(_p_stCameraIdCard) DNM_M_Float2Real(5.)
 
/* Give handle a semantic */
struct DNM_stMecCameraIdCard *DNM_fn_p_stMecCameraIdCardGiveBackSemantic(DNM_tdxHandleToMecIdentityCard _hCameraIdCard);
 
#ifdef __cplusplus
}
#endif
 
#endif /* !__MecCamIdCard_TYPES__ */
 
