/*
 *=======================================================================================
 * Name        : MecPfm.c
 * Author      : J Thnoz               Date : 01/05/98
 * Description : Mechanic platform functions
 *=======================================================================================
 */
 
 
#ifndef _MECPFM_H_
#define _MECPFM_H_
 
#ifdef __cplusplus
extern "C" {
#endif
 
 
void MEC_fn_vUpdatePlatform (DNM_tdstDynamics *p_stDynamic, HIE_tdxHandleToSuperObject hSupObj, POS_tdxHandleToPosition hPreviousReferenceMatrix, POS_tdxHandleToPosition hInvPreviousReferenceMatrix );
 
ACP_tdxBool MEC_fn_vBasePlatformManagement ( struct DNM_stDynamics *p_stDynamic, HIE_tdxHandleToSuperObject hSupObj );
 
void MEC_fn_vSetPlatformLink (struct DNM_stDynamics *p_stDynamic, HIE_tdxHandleToSuperObject hSupObj, HIE_tdxHandleToSuperObject hFatherSupObj);
 
void MEC_fn_vCutPlatformLink (struct DNM_stDynamics *p_stDynamic, HIE_tdxHandleToSuperObject hSupObj);
 
void MEC_fn_vForcePlatformLink (struct DNM_stDynamics *p_stDynamic, HIE_tdxHandleToSuperObject hSupObj, HIE_tdxHandleToSuperObject hFatherSupObj);
 
void MEC_fn_vFreePlatformLink (struct DNM_stDynamics *p_stDynamic, HIE_tdxHandleToSuperObject hSupObj );
 
void MEC_fn_vDynamicComputeAbsoluteMatrix
( 
	struct DNM_stDynamics *p_stDynamic,
	HIE_tdxHandleToSuperObject hSupObj,
	POS_tdxHandleToPosition hPreviousMatrix,
	POS_tdxHandleToPosition hInvPreviousMatrix,
	POS_tdxHandleToPosition hCurrentMatrix		
);
 
 
#ifdef __cplusplus
}
#endif
 
 
#endif /*_MECPFM_H_*/
