/*=========================================================================
* MecMatCa.h : MecMatCharacteristics's functions
*
* Version              1.0
* Creation date        07/01/97
* Revision date
*
* (c) Ubi Studios 1997
*=======================================================================*/
 
#if !defined(__MecMatCharacteristics_TYPES__)
#define __MecMatCharacteristics_TYPES__
 
#include "acp_base.h"
#include "hMecMatC.h"
 
#if !defined(ONLY_TYPES)
#define ONLY_TYPES
#define _MecMatCharacteristics_UNDEF
#endif /* ONLY_TYPES */
 
#if defined(_MecMatCharacteristics_UNDEF)
#undef _MecMatCharacteristics_UNDEF
#undef ONLY_TYPES
#endif /* MecMatCharacteristics_UNDEF */
 
#ifdef __cplusplus
extern "C" {
#endif
 
/***************************************/
#if !defined(CPA_EXPORT)
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif /* CPA_WANTS_IMPORT || CPA_WANTS_EXPORT */
#endif /* CPA_EXPORT */
/***************************************/
 
typedef struct DNM_stMecMatCharacteristics
{
	MTH_tdxReal m_xSlide;
	MTH_tdxReal m_xRebound;
} DNM_tdstMecMatCharacteristics;
 
 
/* Put here all macro-accessors */
#define DNM_M_xMatCharacteristicsGetSlide(_p_stMatCharacteristics) ((_p_stMatCharacteristics)->m_xSlide)
#define DNM_M_xMatCharacteristicsGetRebound(_p_stMatCharacteristics) ((_p_stMatCharacteristics)->m_xRebound)
 
#define DNM_M_xMatCharacteristicsSetSlide(_p_stMatCharacteristics,_xValue) (DNM_M_xMatCharacteristicsGetSlide(_p_stMatCharacteristics) = _xValue)
#define DNM_M_xMatCharacteristicsSetRebound(_p_stMatCharacteristics,_xValue) (DNM_M_xMatCharacteristicsGetRebound(_p_stMatCharacteristics) = _xValue)
 
/* Clone */
#define DNM_M_MatCharacteristicsCopyClone(_p_stDst,_p_stSrc) (\
    DNM_M_xMatCharacteristicsSetSlide(_p_stDst,DNM_M_xMatCharacteristicsGetSlide(_p_stSrc)), \
    DNM_M_xMatCharacteristicsSetRebound(_p_stDst,DNM_M_xMatCharacteristicsGetRebound(_p_stSrc)))
 
/* Give handle a semantic */
struct DNM_stMecMatCharacteristics *DNM_fn_p_stMecMatCharacteristicsGiveBackSemantic(DNM_tdxHandleToMecMatCharacteristics _hMatCharacteristics);
 
/* Default initialisation (Recommended !!!) */
void DNM_fn_vMecMatCharacteristicsInitDefault(DNM_tdstMecMatCharacteristics *_p_stMecMatCharacteristics);
 
/*** MecMatCharacteristics scripts ***/
#define C_SectionMecMatCharacteristicsDescription "MecMatCharacteristics"
#define C_EntryMecMatCharacteristicsChamp         "Champ"
 
#ifdef __cplusplus
}
#endif
 
#endif /* !__MecMatCharacteristics_TYPES__ */
 
