/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          MTH.h
MODULE :        MTH     (Common Mathematic Library)
 
DESCRIPTION : Principal header file for module MTH
 
VERSION :       MTH V5.0.13 / Alexandre LANGER [ALX] Ubi R&D / Add Comments
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
 
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions :
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_MTH
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_MTH
/* End Of Top File Dependancies checking instructions.
   ###############################################################################################
*/
 
 
 
 
 
#ifndef MTH_H
#define MTH_H
 
/* ##INCLUDE#
-----------------------------------------------------------------------------------------
                Includes Files
-----------------------------------------------------------------------------------------
*/
 
#include <stdio.h>
#include <memory.h>
 
#ifdef U64
 #include <gu.h>
#endif  /* U64 */
 
#ifndef PSX
 #include <math.h>
#endif /* not PSX */
 
/*------------------------------*/
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/*------------------------------*/
 
	/*
#ifdef PSX
 #define MTH_Break __I_break(1024)
 #include "GTE\gte_mac.h"
#else
 #include "MTH/MTH_Real.h"
 #include "MTH/MTH2D.h"
 #include "MTH/MTH3D.h"
#endif // PSX 
 */
	
#ifdef PSX
 #define MTH_Break __I_break(1024)
 #include "GTE\gte_mac.h"
#else
#ifndef CODEWARRIOR
#define MTH_INLINE static __inline
#else
#define MTH_INLINE __inline
#endif
 #include "MTH/MTH_Real.h"
 #include "MTH/MTH2D.h"
 #include "MTH/MTH3D.h"
#endif /* PSX */
/*------------------------------*/
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
/*------------------------------*/
 
#endif /* MTH_H */
 
 
 
 
 
/* ##############################################################################################
 This must be at the End of this file.
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions.
   ##############################################################################################
*/
 
 
 
 
 
 
