/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          MTH_fnop.h
MODULE :        MTH     (Common Mathematic Library) 
 
DESCRIPTION : Non Optimization for PC and float
 
VERSION :       MTH V5.0.13 / Alexandre LANGER [ALX] Ubi R&D / Add Comments
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
 
#ifndef MTH_FNOP_H
#define MTH_FNOP_H
 
#include "acp_base.h"
 
#define MTH_CALL
 
/* ****************** */
/* *** MTH_M_xSqrt ** */
/* ****************** */
#define MTH_M_xSqrtLow          MTH_M_xSqrt
#define MTH_M_xSqrtMedium       MTH_M_xSqrt
#define MTH_M_xSqrtHigh         MTH_M_xSqrt
 
/* ********************* */
/* *** MTH_M_xInvSqrt ** */
/* ********************* */
#define MTH_M_xInvSqrtLow       MTH_M_xInvSqrt
#define MTH_M_xInvSqrtMedium    MTH_M_xInvSqrt
#define MTH_M_xInvSqrtHigh      MTH_M_xInvSqrt
 
/* ***************** */
/* *** MTH_M_xInv ** */
/* ***************** */
#define MTH_M_xInvLow           MTH_M_xInv
#define MTH_M_xInvMedium        MTH_M_xInv
#define MTH_M_xInvHigh          MTH_M_xInv
 
/* ***************** */
/* *** MTH_M_xDiv ** */
/* ***************** */
#define MTH_M_xDivLow           MTH_M_xDiv
#define MTH_M_xDivMedium        MTH_M_xDiv
#define MTH_M_xDivHigh          MTH_M_xDiv
 
/* ***************************** */
/* *** MTH_M_xRealToLongRound ** */
/* ***************************** */
#define MTH_M_xRealToLongRoundLow       MTH_M_xRealToLongRound
#define MTH_M_xRealToLongRoundMedium    MTH_M_xRealToLongRound
#define MTH_M_xRealToLongRoundHigh      MTH_M_xRealToLongRound
 
/* ************************ */
/* *** MTH_M_xRealToLong ** */
/* ************************ */
#define MTH_M_xRealToLongLow            MTH_M_xRealToLong
#define MTH_M_xRealToLongMedium         MTH_M_xRealToLong
#define MTH_M_xRealToLongHigh           MTH_M_xRealToLong
 
 
/* ##MACRO#----------------------------------------------------------------------------
                          MACRO definition
---------------------------------------------------------------------------------------*/
 
/* ##M==================================================================================
NAME :          MTH_M_vInit
DESCRIPTION :   Initialization
INPUT :         void
OUTPUT :        void
=======================================================================================*/
#define MTH_M_vInit()                   \
{}
 
/* ##F===================================================================================
NAME :          MTH_fn_vSet24bitFPU
DESCRIPTION :   Set Pentium FPU internal precision to 24bit
INPUT :         void
OUTPUT :        void
=======================================================================================*/
INLINE void MTH_CALL  MTH_fn_vSet24bitFPU(void)
{
}
 
/* ##F===================================================================================
NAME :          MTH_fn_vSet53bitFPU
DESCRIPTION :   Set Pentium FPU internal precision to 53bit
INPUT :         void
OUTPUT :        void
=======================================================================================*/
INLINE void MTH_CALL MTH_fn_vSet53bitFPU(void)
{
}
 
/* ##F===================================================================================
NAME :          MTH_fn_vSet64bitFPU
DESCRIPTION :   Set Pentium FPU internal precision to 64bit
INPUT :         void
OUTPUT :        void
=======================================================================================*/
INLINE void MTH_CALL MTH_fn_vSet64bitFPU(void)
{
}
 
#endif /* MTH_FNOP_H */
