/*--------------------------------*/
/* Conversion of numericals types */
/*--------------------------------*/
/* Version 1.0                    */
/* Author : S Leroy               */
/* Date : 4/03/98                 */
/* Modification : 4/03/98         */
/*--------------------------------*/
/* PC Version by M Trabucato      */
/*--------------------------------*/
/* Conversion : OK (avec version 27.04.98 12:03 (11041))    */
/*--------------------------------*/
 
#ifndef _CONVERSE_H_
#define _CONVERSE_H_
 
/*----------------------------------------------------------------------------------*/
 
#include "MTH\Specif\SCA\SCA_sl12.h"
#include "MTH\Specif\SCA\SCA_sl.h"
#include "MTH\Specif\SCA\SCA_sw12.h"
#include "MTH\Specif\SCA\SCA_sw.h"
 
/*----------------------------------------------------------------------------------*/
 
#define SCA_M_sw12_Div_SwBySw(a,b)      MTH_M_xDiv(a,b)
#define SCA_M_sw_Div_SwBySl12(a,b)      MTH_M_xDiv(a,b)
#define SCA_M_sl12_Div_SlBySl(a,b)      MTH_M_xDiv(a,b)
#define SCA_M_sl12_Div_SwBySw(a,b)      MTH_M_xDiv(a,b)
 
 
/* sl <- sl12 * sl */
#define SCA_M_sl_Mul_Sl12BySl(a,b)      MTH_M_xMul(a,b)
#define SCA_M_sl_Mul_Sw12BySw(a,b)      MTH_M_xMul(a,b)
#define SCA_M_sl_Mul_Sl12BySl(a,b)      MTH_M_xMul(a,b)
#define SCA_M_sl_Mul_Sl12BySw(a,b)      MTH_M_xMul(a,b)
#define SCA_M_sw_Mul_Sw12BySw(a,b)      MTH_M_xMul(a,b)
 
/*------------*/
/* sl <- sw^2 */
/*------------*/
#define SCA_M_sl_Sqr_sw(_xOp)           MTH_M_xSqr(_xOp)
 
 
/* Macro definitions */
#define SCA_M_converse_scTosl12(_sc)   (_sc)
 
#define SCA_M_converse_swTosl(_sl12Value)     (_sl12Value)
#define SCA_M_converse_swTosw12(_sl12Value)   (_sl12Value)
#define SCA_M_converse_swTosl12(_sl12Value)   (_sl12Value)
#define SCA_M_converse_slTosw(_sl12Value)     (_sl12Value)
#define SCA_M_converse_slTosw12(_sl12Value)   (_sl12Value)
#define SCA_M_converse_slTosl12(_sl12Value)   (_sl12Value)
#define SCA_M_converse_sl12Tosl(_sl12Value)   (_sl12Value)
#define SCA_M_converse_sl12Tosw(_sl12Value)   (_sl12Value)
#define SCA_M_converse_sl12Tosw12(_sl12Value) (_sl12Value)
#define SCA_M_converse_sw12Tosl12(_sl12Value) (_sl12Value)
#define SCA_M_converse_sw12Tosw(_sl12Value)   (_sl12Value)
#define SCA_M_converse_sw12Tosl(_sl12Value)   (_sl12Value)
 
/* ShortCuts */
#define scTosl12(_sc)          SCA_M_converse_scTosl12(_sc)
#define swTosl(_sl12Value)     SCA_M_converse_swTosl(_sl12Value)
#define swTosw12(_sl12Value)   SCA_M_converse_swTosw12(_sl12Value)
#define swTosl12(_sl12Value)   SCA_M_converse_swTosl12(_sl12Value)
#define slTosw(_sl12Value)     SCA_M_converse_slTosw(_sl12Value)
#define slTosw12(_sl12Value)   SCA_M_converse_slTosw12(_sl12Value)
#define slTosl12(_sl12Value)   SCA_M_converse_slTosl12(_sl12Value)
#define sl12Tosl(_sl12Value)   SCA_M_converse_sl12Tosl(_sl12Value)
#define sl12Tosw(_sl12Value)   SCA_M_converse_sl12Tosw(_sl12Value)
#define sl12Tosw12(_sl12Value) SCA_M_converse_sl12Tosw12(_sl12Value)
#define sw12Tosl12(_sl12Value) SCA_M_converse_sw12Tosl12(_sl12Value)
#define sw12Tosw(_sl12Value)   SCA_M_converse_sw12Tosw(_sl12Value)
#define sw12Tosl(_sl12Value)   SCA_M_converse_sw12Tosl(_sl12Value)
#define EntDecTosl12(_xEnt,_xDec)   (MTH_M_xAdd(_xEnt,(MTH_M_xDiv(_Dec,MTH_M_xLongtoReal(10000)))))
 
 
#endif /* _CONVERSE_H_ */
