/*----------------------------------------------------------------------------------*/
/* Filename :   sl12.h                                                              */
/* Author   :   Frederic Philippe                                                   */
/*          :   Marc Trabucato                                                      */
/* Target   :   PC                                                                  */
/*----------------------------------------------------------------------------------*/
 
/* -----------------15/04/98 15:58----------------------------
 * Conversion : useless (avec version 23.04.98 19:58 (2667))
 * -----------------------------------------------------------*/
 
#ifndef _SL12_H_
#define _SL12_H_
 
/*----------------------------------------------------------------------------------*/
 
#include "MTH\Specif\SCA\SCA_sl12.h"
 
/*----------------------------------------------------------------------------------*/
 
/* Define the type DNM_tdxReal */
#define td_sl12       SCA_td_sl12
 
/* Constants */
#define sl12_ZERO     SCA_sl12_C_ZERO
#define sl12_ONE      SCA_sl12_C_ONE
 
/* Conversions : Macros definitions           */
#define DoubleTosl12(_dfValue) SCA_sl12_M_sl12DoubleToReal(_dfValue)
#define FloatTosl12(_fValue)   SCA_sl12_M_sl12FloatToReal(_fValue)
#define IntTosl12(_iValue)     SCA_sl12_M_sl12IntToReal(_iValue)
 
#define sl12ToDouble(_sl12Value) SCA_sl12_M_RealToDouble(_sl12Value)
#define sl12ToFloat(_sl12Value)  SCA_sl12_M_RealToFloat(_sl12Value)
#define sl12ToInt(_sl12Value)    SCA_sl12_M_RealToInt(_sl12Value)
 
/* Comparisons */
#define sl12_bGreater(_sl12Op1,_sl12Op2)       SCA_sl12_M_bGreater(_sl12Op1,_sl12Op2)
#define sl12_bGreaterEqual(_sl12Op1,_sl12Op2)  SCA_sl12_M_bGreaterEqual(_sl12Op1,_sl12Op2)
#define sl12_bLess(_sl12Op1,_sl12Op2)          SCA_sl12_M_bLess(_sl12Op1,_sl12Op2)
#define sl12_bLessEqual(_sl12Op1,_sl12Op2)     SCA_sl12_M_bLessEqual(_sl12Op1,_sl12Op2)
#define sl12_bEqual(_sl12Op1,_sl12Op2)         SCA_sl12_M_bEqual(_sl12Op1,_sl12Op2)
#define sl12_bDiferent(_sl12Op1,_sl12Op2)      SCA_sl12_M_bDifferent(_sl12Op1,_sl12Op2)
#define sl12_bEqualZero(_sl12Op1)              SCA_sl12_M_bIsNull(_sl12Op1)
#define sl12_bIsNull(_sl12Op1)                 SCA_sl12_M_bIsNull(_sl12Op1)
#define sl12_bInUnitEqual( x )                 MTH_M_bInUnitEqual(x)
 
/* Operations */
#define sl12_Add(_sl12Op1,_sl12Op2) SCA_sl12_M_sl12Add(_sl12Op1,_sl12Op2)
#define sl12_Sub(_sl12Op1,_sl12Op2) SCA_sl12_M_sl12Sub(_sl12Op1,_sl12Op2)
#define sl12_Mul(_sl12Op1,_sl12Op2) SCA_sl12_M_sl12Mul(_sl12Op1,_sl12Op2)
#define sl12_Div(_sl12Op1,_sl12Op2) SCA_sl12_M_sl12Div(_sl12Op1,_sl12Op2)
 
#define sl12_Inv(_sl12Op) SCA_sl12_M_sl12Inv(_sl12Op)
#define sl12_Neg(_sl12Op) SCA_sl12_M_sl12Neg(_sl12Op)
#define sl12_Sqr(_sl12Op) SCA_sl12_M_sl12Sqr(_sl12Op)
#define sl12_Cub(_sl12Op) sl12_Mul(_sl12Op,sl12_Sqr(_sl12Op))
#define sl12_Sqrt(_sl12Op) SCA_sl12_M_sl12Sqrt(_sl12Op)
#define sl12_Abs(_sl12Op) SCA_sl12_M_sl12Abs(_sl12Op)
 
#define sl12_Sin(_sl12Op) SCA_sl12_M_sl12Sin(_sl12Op)
#define sl12_Cos(_sl12Op) SCA_sl12_M_sl12Cos(_sl12Op)
#define sl12_Tan(_sl12Op) SCA_sl12_M_sl12Tan(_sl12Op)
 
#define sl12_ASin(_sl12Op) SCA_sl12_M_sl12ASin(_sl12Op)
#define sl12_ACos(_sl12Op) SCA_sl12_M_sl12ACos(_sl12Op)
 
/*----------------------------------------------------------------------------------*/
 
#endif /* _SL12_H_ */
