/*
 
NetDebug.h : trace facilities
 
*/
 
#if !defined( __DEBUG )
#define __DEBUG
 
#include "NET\NetDef.h"
 
#define NET_USE_DEBUG
/*#define NET_MEMORY_DEBUG*/
 
#define Net_C_Debug_GSUbi		0
#define Net_C_Debug_Ten			1
#define Net_C_Debug_IPX			2
#define Net_C_Debug_TCP			3
#define Net_C_Debug_UDP			4
#define Net_C_Debug_NetSer		5
#define Net_C_Debug_NetL1		6
#define Net_C_Debug_Serial		7
#define Net_C_Debug_Modem		8
#define Net_C_Debug_SLinks		9
#define Net_C_Debug_SBlocks		10
#define Net_C_Debug_SThread		11
#define Net_C_Debug_SBuffin		12
#define Net_C_Debug_SBuffout	13
#define Net_C_Debug_Memory		14
#define Net_C_Debug_DPlay		15
#define Net_C_Debug_User_1		16
#define Net_C_Debug_User_2		17
#define Net_C_Debug_User_3		18
 
 
  /* Open a trace file. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugOpen(unsigned short uwNumFile);
 
  /* Active a trace file. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugActiv(unsigned short uwNumFile);
 
  /* Close a trace file. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugClose(unsigned short uwNumFile);
 
  /* Ouput a format string in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugFormat(unsigned short uwNumFile,const char *pFormat,...);
 
  /* Ouput a string in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugS(unsigned short uwNumFile,const char *s);
 
  /* Ouput a string with a long in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSI(unsigned short uwNumFile,const char *s,long l);
 
  /* Ouput two string with a long in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSISI(unsigned short uwNumFile,const char *s1,long l1,const char *s2,long l2);
 
  /* Ouput three string with a long in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSISISI(unsigned short uwNumFile,const char *s1,long l1,const char *s2,long l2,const char *s3,long l3);
 
  /* Ouput four string with a long in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSISISISI(unsigned short uwNumFile,const char *s1,long l1,const char *s2,long l2,const char *s3,long l3,const char *s4,long l4);
 
  /* Ouput two string in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSS(unsigned short uwNumFile,const char *s1,const char *s2);
 
  /* Ouput three string in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSSS(unsigned short uwNumFile,const char *s1,const char *s2,const char *s3);
 
  /* Ouput a string with a long and a other string in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSIS(unsigned short uwNumFile,const char *s1,long l1,const char *s2);
 
  /* Ouput two string with a long in the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSSI(unsigned short uwNumFile,const char *s1,const char *s2,long l1);
 
  /* OutPut a string whith dump memory ... */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugSDump(unsigned short uwNumFile,const char *s,void *pAddr, unsigned long ulSize);
 
  /* Clear the select file debug. */
_NET_EXPORT_ void _NET_CALLING_CONV_ vDebugClear(unsigned short uwNumFile);
 
#endif
