/*
 
RASLaunch.h : internet modem connection facilities
 
*/
 
#include <windows.h>
 
#ifdef __cplusplus
extern "C" {
#endif
 
/* initialisation state */
 
enum { RASInitialized = 1, IPInitialized = 1<<2 };
 
/* various error codes */
 
enum {
	myRAS_NotInitialized = 1, 
	myRAS_Busy, 
	myRAS_IPUnavailable, 
	myRAS_InvalidAddress, 
	myRAS_InternalError };
 
/* connection state */
 
enum { myRAS_ERROR = -1, myRAS_UNKNOWN, myRAS_CONNECTED, myRAS_DISCONNECTED, myRAS_IDLE };
 
/* connectivity testing */
 
enum { myRAS_Testing = 1, myRAS_Connectable, myRAS_NotConnectable, myRAS_Canceled };
 
int RAS_Init(void);
int RAS_Exit(void);
 
int RASScanEntries(char, char *, int);
int RASScanConnections(char, char *, int, int *);
int RASGetConnectionAccount(const char *pcEntryName, char *pcAccountName, char *pcPassword);
int RASStartConnection(const char *, const char*, const char*);
int RASGetConnectionState(void);
int RASCloseConnection(void);
 
 
int RASTouchTarget(const char *);
int RASGetConnectivity();
int RASCancelTouch();
 
#ifdef __cplusplus
}
#endif
 
