/*ROMTEAM WorldEditor*/
/*//////////////////////////////////////////////////////////////////////////////////////*/
/* File        : Arrow3D.hpp: interface for the Arrow3D  class.*/
/* Author      : Ionut Grozea*/
/* Date        : 97.11*/
/* Description :*/
/*//////////////////////////////////////////////////////////////////////////////////////*/
#ifndef __ARROWS3D_HPP__
#define __ARROWS3D_HPP__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
/****************************************/
/* classes*/
/****************************************/
 
class CPA_EXPORT Arrow3D : public Shape3D  
{
/* data*/
private:
	ACP_tdxHandleOfElement m_hElement;
/* functions*/
private:
	void CommonArrow3D();
 
public:
	Arrow3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, const CString _csName = "", tdeSaveStatus _eStatus = E_ss_NoSave);
	Arrow3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, CPA_BaseObject *_p_oOwnerFile, const CString _csName = "", char *_p_cRefPath = NULL, tdeSaveStatus _eStatus = E_ss_Responsible);
	Arrow3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, CPA_BaseObject *_p_oOwnerFile, ACP_tdxHandleOfObject _hObject, const CString _csName = "", char *_p_cRefPath = NULL, tdeSaveStatus _eStatus = E_ss_Modify);
	~Arrow3D();
	ACP_tdxHandleOfElement GetHElement(){return m_hElement;}
};
 
 
 
/*//////////////////////////////////////////////////////////////////////////////////////*/
/* Name:       : DoubleArrow3D:*/
/* Author      : Ionut Grozea*/
/* Date        : 01.05.1998*/
/* Description : DoubleArrow3D object.*/
/*//////////////////////////////////////////////////////////////////////////////////////*/
class CPA_EXPORT DoubleArrow3D : public Shape3D  
{
/* data*/
private:
	ACP_tdxHandleOfElement m_hElement;
/* functions*/
private:
	void CommonDoubleArrow3D();
 
public:
	DoubleArrow3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, const CString _csName = "", tdeSaveStatus _eStatus = E_ss_NoSave);
	DoubleArrow3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, CPA_BaseObject *_p_oOwnerFile, const CString _csName = "", char *_p_cRefPath = NULL, tdeSaveStatus _eStatus = E_ss_Responsible);
	DoubleArrow3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, CPA_BaseObject *_p_oOwnerFile, ACP_tdxHandleOfObject _hObject, const CString _csName = "", char *_p_cRefPath = NULL, tdeSaveStatus _eStatus = E_ss_Modify);
	~DoubleArrow3D();
	ACP_tdxHandleOfElement GetHElement(){return m_hElement;}
};
#endif /**/
