/*ROMTEAM WorldEditor*/
/*//////////////////////////////////////////////////////////////////////////////////////*/
/* File        : Line3D.hpp: interface for the Line3D, Arc3D and Bezier3D classes.*/
/* Author      : Viorel Preoteasa*/
/* Date        : 97.11*/
/* Description :*/
/*//////////////////////////////////////////////////////////////////////////////////////*/
#ifndef __LINE3D_HPP__
#define __LINE3D_HPP__
 
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
/*jawka*/
/*#include "..\\Ai\\AiBase\\Mth_CiAr.h"*/
/*#include "..\\Ai\\AiBase\\Way_Dyna.h"*/
#include "mth.h"
#include "acp_base.h"
#include "gld.h"
 
/*#include "..\\Ai\\AiBase\\Mth_Bez.h"*/
 
 
/* no geometric object created : */ 
#define EDWAY_C_ucModeNoObject 0
/* a geometric object is created */
#define EDWAY_C_ucModeRealObject 1
 
 
class CPA_EXPORT Line3D
{
/* data*/
protected:
	ACP_tdxHandleOfObject m_hGeometricObject;
	ACP_tdxHandleOfElement m_hLineElement;
	long m_lColor;
	GLD_tdstViewportAttributes	*m_pstViewPortAttributes;
	MTH3D_tdstVector **m_dstListOfPoints;
	ACP_tdstDynaParam *m_pstDynaParams;
	unsigned char m_ucObjectMode;
/* functions*/
protected:
	MTH3D_tdstVector *GetListOfPoints();
 
public:
	Line3D ();
	~Line3D();
 
	void SetColor(long lColor){m_lColor = lColor;}
	void SetViewPortAttributes(GLD_tdstViewportAttributes *pstViewPortAttributes){m_pstViewPortAttributes = pstViewPortAttributes;}
	void Draw();
	virtual unsigned char GetSamplingRate() = 0;
	void GetPoint(unsigned char _ucSamplingNumber, MTH3D_tdstVector*_pstSampledPoint);
	long GetColor(){return m_lColor;}
/*	GLD_tdstViewportAttributes *GetViewPortAttributes(){return m_pstViewPortAttributes;}*/
};
 
#endif /**/
