/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          PCS.h
 
DESCRIPTION :   Physical collide set module
 
VERSION :       1.00/Olivier Jourdan/Creation
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
/* (c) Ubi R&D 1997*/
/* See Olivier JOURDAN for any comment or question*/
 
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_PCS
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_PCS
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef __PCS_H__
#define __PCS_H__
 
 
 
#ifdef  __cplusplus
extern "C" {
#endif
 
  /* ##INCLUDE#----------------------------------------------------------------------------
                          Includes Files
---------------------------------------------------------------------------------------*/
 
/*////////////////////////////////*/
#ifdef PSX
/*////////////////////////////////*/
	
	#include "PCS/PSX/PCS_Cnst.h"
	#include "PCS/PSX/PCS_Stru.h"
	#include "PCS/PSX/PCS_Hndl.h"
	#include "PCS/PSX/PCS_Accs.h"
	#include "PCS/PSX/PCS_Glob.h"
	#include "PCS/PSX/PCS_Load.h"
 
/*////////////////////////////////*/
#else /* PSX */
/*////////////////////////////////*/
 
	/* For DLL using these function :*/
	#include "cpa_expt.h" 
	/* Constants */
	#include "PCS\PCS_Cst.h"
	#ifdef PCS_FRIEND
	  #include "PCS\PCS_Str.h"
	  #include "PCS\PCS_Hdl.h"
	  #include "PCS\PCS_Mcr.h"
	#else
	  #include "PCS\PCS_Hdl.h"
	  #include "PCS\PCS_Fct.h"
	  #include "PCS\PCS_Mcr.h"
	#endif /* PCS_FRIEND*/
 
	#include "PCS\PCS_Prt.h"
 
/*////////////////////////////////*/
#endif /* PSX */
/*////////////////////////////////*/
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
/*#define extern Do_not_use_extern_in_c_files*/
 
#endif /* __PCS_H__*/
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
