/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          PCS_fct.h
 
DESCRIPTION :   Complex function of Physical collide set module
 
VERSION :       1.00/Olivier Jourdan/Creation
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef __PCS_FUNCT_H__
#define __PCS_FUNCT_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#include "cpa_expt.h"
 
/* ##F===================================================================================
NAME :          PCS_fn_hGetGeoObjOfPhysicalCollSet
DESCRIPTION :   Get the Zdx of type in Physical Collide Set
INPUT :         ucZoneType  [type of zone]
                hPhyCollSet [handle to physical collide set]
OUTPUT :        handle of object zdx
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern CPA_EXPORT ACP_tdxHandleOfObject PCS_fn_hGetGeoObjOfPhysicalCollSet(
                                          unsigned char                   ucZoneType,
                                          PCS_tdxHandleToPhysicalCollSet  hPhyCollSet);
 
 
/* ##F===================================================================================
NAME :          PCS_fn_vSetGeoObjOfPhysicalCollSet
DESCRIPTION :   Set the Zdx of type in Physical Collide Set
INPUT :         ucZoneType  [type of zone]
                hPhyCollSet [handle to physical collide set]
                hGeoObj     [handle of object zdx]
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern CPA_EXPORT void PCS_fn_vSetGeoObjOfPhysicalCollSet(
                                          unsigned char                   ucZoneType,
                                          PCS_tdxHandleToPhysicalCollSet  hPhyCollSet,
                                          ACP_tdxHandleOfObject           hGeoObj);
 
 
/* ##F===================================================================================
NAME :          PCS_fn_vAddPhysicalCollSetToBoundingVolume
DESCRIPTION :   Compute the bouding volume of the physical collide set
INPUT :         _hBoundingVolume  [handle to bounding volume]
                _hPhyCollSet      [handle to physical collide set]
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern CPA_EXPORT void PCS_fn_vAddPhysicalCollSetToBoundingVolume(
                                          ACP_tdxHandleOfObject           _hBoundingVolume,
                                          PCS_tdxHandleToPhysicalCollSet  _hPhyCollSet);
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __PCS_FUNCT_H__ */
