/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          PCS_Mcr.h
 
DESCRIPTION :   Macro function of Physical collide set module
 
VERSION :       1.00/Olivier Jourdan/Creation
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _PCS_MACRO_H__
#define _PCS_MACRO_H__
 
/* ##-########################### */
/* ##SECTION   Get ZDX            */
/* ############################## */
 
/* ##M===================================================================================
NAME :          PCS_M_hGetZddGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zdd [zone de detection (detection zone)]
=======================================================================================*/
#define PCS_M_hGetZddGeoObjOfPhysicalCollSet(_hPhyCollSet) ((_hPhyCollSet)->hZdd)
 
/* ##M===================================================================================
NAME :          PCS_M_hGetZdeGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zde [zone d evenement (event zone)]
=======================================================================================*/
#define PCS_M_hGetZdeGeoObjOfPhysicalCollSet(_hPhyCollSet) ((_hPhyCollSet)->hZde)
 
/* ##M===================================================================================
NAME :          PCS_M_hGetZdmGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zdm [zone de mouvement (movment zone)]
=======================================================================================*/
#define PCS_M_hGetZdmGeoObjOfPhysicalCollSet(_hPhyCollSet) ((_hPhyCollSet)->hZdm)
 
/* ##M===================================================================================
NAME :          PCS_M_hGetZdrGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zdr [zone de recalage ]
=======================================================================================*/
#define PCS_M_hGetZdrGeoObjOfPhysicalCollSet(_hPhyCollSet) ((_hPhyCollSet)->hZdr)
 
/* ##-########################### */
/* ##SECTION   Set ZDX            */
/* ############################## */
 
/* ##M===================================================================================
NAME :          PCS_M_vSetZddGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zdd [zone de detection (detection zone)]
=======================================================================================*/
#define PCS_M_vSetZddGeoObjOfPhysicalCollSet(_hPhyCollSet,_hGeoObj) ((_hPhyCollSet)->hZdd = (_hGeoObj) )
 
 
/* ##M===================================================================================
NAME :          PCS_M_vSetZdeGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zde [zone d evenement (event zone)]
=======================================================================================*/
#define PCS_M_vSetZdeGeoObjOfPhysicalCollSet(_hPhyCollSet,_hGeoObj) ((_hPhyCollSet)->hZde = (_hGeoObj) )
 
/* ##M===================================================================================
NAME :          PCS_M_vSetZdmGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zdm [zone de mouvement (movment zone)]
=======================================================================================*/
#define PCS_M_vSetZdmGeoObjOfPhysicalCollSet(_hPhyCollSet,_hGeoObj) ((_hPhyCollSet)->hZdm = (_hGeoObj) )
 
/* ##M===================================================================================
NAME :          PCS_M_vSetZdrGeoObjOfPhysicalCollSet
DESCRIPTION :   Get Zdr [zone de recalage]
=======================================================================================*/
#define PCS_M_vSetZdrGeoObjOfPhysicalCollSet(_hPhyCollSet,_hGeoObj) ((_hPhyCollSet)->hZdr = (_hGeoObj) )
 
#endif /* _PCS_MACRO_H__ */
