/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          PCS_Prt.h
 
DESCRIPTION :   Proto of Physical collide set module
 
VERSION :       1.00/Olivier Jourdan/Creation
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef __PCS_PROTO_H__
#define __PCS_PROTO_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
#include "cpa_expt.h"
 
/* ##F===================================================================================
NAME :          PCS_fn_hCreatePhysicalCollideSet
DESCRIPTION :   Creates the structure and returns an handle on it
OUTPUT :        handle to physical collide set
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern CPA_EXPORT PCS_tdxHandleToPhysicalCollSet PCS_fn_hCreatePhysicalCollideSet();
 
 
/* ##F===================================================================================
NAME :          PCS_fn_hGetZddGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zdd (zone de detection)
INPUT :         handle to physical collide set
OUTPUT :        handle of object zdd
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern ACP_tdxHandleOfObject PCS_fn_hGetZddGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet);
 
/* ##F===================================================================================
NAME :          PCS_fn_hGetZdeGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zde (zone d evenement)
INPUT :         handle to physical collide set
OUTPUT :        handle of object zde
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern ACP_tdxHandleOfObject PCS_fn_hGetZdeGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet);
 
/* ##F===================================================================================
NAME :          PCS_fn_hGetZdrGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zdr (zone de recalage)
INPUT :         handle to physical collide set
OUTPUT :        handle of object zdr
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern ACP_tdxHandleOfObject PCS_fn_hGetZdrGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet);
 
/* ##F===================================================================================
NAME :          PCS_fn_hGetZdmGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zdm (zone de mouvement)
INPUT :         handle to physical collide set
OUTPUT :        handle of object zdm
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern ACP_tdxHandleOfObject PCS_fn_hGetZdmGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet);
 
/* ##F===================================================================================
NAME :          PCS_fn_vSetZddGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zdd (zone de detection)
INPUT :         handle to physical collide set
                handle of object zdd
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern void PCS_fn_vSetZddGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet,ACP_tdxHandleOfObject _hGeoObj);
 
 
/* ##F===================================================================================
NAME :          PCS_fn_vSetZdeGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zde (zone d evenement
INPUT :         handle to physical collide set
                handle of object zde
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern void PCS_fn_vSetZdeGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet,ACP_tdxHandleOfObject _hGeoObj);
 
/* ##F===================================================================================
NAME :          PCS_fn_vSetZdmGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zdm (zone de mouvement)
INPUT :         handle to physical collide set
                handle of object zdm
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern void PCS_fn_vSetZdmGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet,ACP_tdxHandleOfObject _hGeoObj);
 
 
/* ##F===================================================================================
NAME :          PCS_fn_vSetZdrGeoObjOfPhysicalCollSet
DESCRIPTION :   get Zdr (zone de recalage)
INPUT :         handle to physical collide set
                handle of object zdr
=========================================================================================
CREATION :      Olivier Jourdan
=======================================================================================*/
extern void PCS_fn_vSetZdrGeoObjOfPhysicalCollSet(PCS_tdxHandleToPhysicalCollSet _hPhyCollSet,ACP_tdxHandleOfObject _hGeoObj);
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __PCS_PROTO_H__ */
