#ifndef D_THROW_VISUAL_SET
 
/*=========================================================================
* VSLoad.h :       Header file for loading VS
*
* Version                      1.0
* Creation date								 05/05/97
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1997
*=======================================================================*/
#if !defined(__VSLOAD_H__)
#define __VSLOAD_H__
 
/* For DLL using these function :*/
#include "cpa_expt.h" 
 
 
/*****************************************************************************************/
/**** Below : macros used to read script.                                             ****/
/*****************************************************************************************/
#define C_GrandChildSection    ( 2)
#define C_ChildSection         ( 1)
#define C_ThisSection          ( 0)
#define C_ParentSection        (-1)
#define C_GrandParentSection   (-2)
 
#define C_GrandChildContext    ( 2)
#define C_ChildContext         ( 1)
#define C_ThisContext          ( 0)
#define C_ParentContext        (-1)
#define C_GrandParentContext   (-2)
 
#define M_IsTitle         (_eAction==SCR_EA_Anl_BeginSection)
#define M_IsEnd           (_eAction==SCR_EA_Anl_EndSection)
#define M_IsBegSubSection (_eAction==SCR_EA_Anl_BeginSubSection)
#define M_IsEndSubSection (_eAction==SCR_EA_Anl_EndSubSection)
#define M_IsEntry         (_eAction==SCR_EA_Anl_Entry)
 
#define M_ActionIs(szActionAsked) (!strcmpi(_p_szName,szActionAsked))
 
 
 
/**** VS scripts ****/
#define C_Section_VSHeader									"VSE_HEADER"
#define C_Entry_FileVersion									"VersionNumber"
#define C_Section_VSGeneral									"VS"
#define C_SubSection_LOD										"LOD"
 
#define C_Entry_LOD_Threshold								"LOD_Threshold"			
#define C_Entry_FichierMOD									"FichierMOD"
 
/*ANNECY JMD 17/02/98 {*/
#define C_Entry_FichierRLI									"FichierRLI"
#define C_Section_VSRLI											"RLI"
/*END ANNECY JMD }*/
 
/*
 * Animations files script call-backs
 */
#if !defined(U64)
extern CPA_EXPORT SCR_tde_Anl_ReturnValue VS_fn_eScriptCallBackHeader(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
extern CPA_EXPORT SCR_tde_Anl_ReturnValue VS_fn_eScriptCallBackGeneral(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
extern CPA_EXPORT SCR_tde_Anl_ReturnValue VS_fn_eScriptCallBackLOD(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
/*extern CPA_EXPORT SCR_tde_Anl_ReturnValue VS_fn_eScriptCallBackBinHeader(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);*/
/*extern CPA_EXPORT SCR_tde_Anl_ReturnValue VS_fn_eScriptCallBackBinGeneral(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);*/
/*extern CPA_EXPORT SCR_tde_Anl_ReturnValue VS_fn_eScriptCallBackBinLOD(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);*/
#endif /* U64 */
 
/*************************************************/
/********* global for VS Link Table *************/
/*************************************************/
#if !defined(U64)
extern CPA_EXPORT SCR_tdst_Link_Table VS_g_stLinkTable;
#endif /* U64 */
/*************************************************/
 
/*
 * Initialisation and access to link table for VS name storage
 */
#if !defined(U64)
extern CPA_EXPORT SCR_tdst_Link_Table *VS_fn_p_stGetLinkTable(void);
#endif /* U64 */
extern CPA_EXPORT void VS_fn_vInitLinkTable(void);
extern CPA_EXPORT void VS_fn_vCloseLinkTable(void);
extern CPA_EXPORT void VS_fn_vRegisterAllScriptSections(void);
 
/*
 * For the binarisation
 */
 
extern CPA_EXPORT GEO_tdxHandleToVisualSet VS_fn_xLoadVisualSet(char* _szSectionName);
/*
extern CPA_EXPORT void VS_fn_vPrepareSaveBinaryBloc();
extern CPA_EXPORT unsigned long VS_fn_ulWriteBinaryBloc(unsigned long _ulStructAddress, char* _p_cDestBuffer);
extern CPA_EXPORT void VS_fn_vWriteAllVSBinaryBlocs(char* _szBinaryFileName);
extern CPA_EXPORT unsigned long VS_fn_ulReadBinaryBloc(char* _p_cLoadedBuffer,unsigned long _ulLoadedBufferSize);
extern CPA_EXPORT void VS_fn_vReadAllVSBinaryBlocs(char* _szBinaryFileName);
extern CPA_EXPORT void VS_fn_vReadAllVSBinaryBlocs2(char* _szBinaryFileName);
extern CPA_EXPORT void VS_fn_vResolveBinaryBloc(unsigned long _ulAddress);
*/
/* !__VSLOAD_H__ */
#endif 
 
#endif /* D_THROW_VISUAL_SET */
