/*///////////////////////////////////////////////////////////*/
/*															//*/
/*			Management of the Module : Pos					//*/
/*															//			   */
/* File Name	: ErrPos.h									//*/
/* Date			: 03/10/96									//*/
/* Author		: First_Name Last_Name						//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
/*															//*/
/* abbreviation of the module-name. Used in macro is 'Pos'	//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
 
#ifndef __ERRPOS_H__
#define __ERRPOS_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#define C_szPosVersion "POS V5.0.2" /* The format is XXX Va.b.c with Xxx is the Tag of the module */
#define C_szPosFullName  "Position module"/* the complete and clear name of the module */
#define C_szPosDate "24 Apr 1997" /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/
 
/* For DLLs who are using this module : */ 
#include "CPA_expt.h"
 
#include "ERM.h"
 
#define __FATAL_ERR_POS__
#define __WARNING1_ERR_POS__
#define __WARNING2_ERR_POS__
#define __WARNING3_ERR_POS__
/*----------*/
/* Constant	 */
/*----------*/
/* error of the Pos Module*/
typedef enum e_uwPosErrNumber_{
	E_uwPosFatalErr,	
#ifdef __FATAL_ERR_POS__
/*     -----------------*/
	E_uwPosFatalError1,	 
	E_uwPosFatalError2,	
	E_uwPosFatalError3,	
	E_uwPosFatalError4,	
#endif /*__FATAL_ERR_POS__*/
	E_uwPosStartOfWarning,/* important constant, it allows to recognize if an error is fatal or not.*/
#ifdef __WARNING1_ERR_POS__
/*     -------------------*/
	E_uwPosWarning1Error1,	
	E_uwPosWarning1Error2,	
	E_uwPosWarning1Error3,
#endif /*__WARNING1_ERR_POS__*/
#ifdef __WARNING2_ERR_POS__
/*     -------------------*/
	E_uwPosWarning2Error1,	
	E_uwPosWarning2Error2,	
	E_uwPosWarning2Error3,	
	E_uwPosWarning2Error4,	
	E_uwPosWarning2Error5,
#endif /*__WARNING2_ERR_POS__*/
#ifdef __WARNING3_ERR_POS__
/*     -------------------*/
	E_uwPosWarning3Error1,	
	E_uwPosWarning3Error2,
#endif /*__WARNING3_ERR_POS__*/
	E_uwPosErrNumber
} e_uwPosErrNumber;
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef __ERRPOS_EXTERN
#ifndef __DeclareGlobalVariableErmPos_h__
#define __ERRPOS_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableErmPos_h__*/
#define __ERRPOS_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableErmPos_h__*/
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
__ERRPOS_EXTERN CPA_EXPORT  unsigned char g_ucPosModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErmPos_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif /*__DeclareGlobalVariableErrPos_h__&& CPA_WANTS_IMPORT*/
;
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
#ifdef __ERROR_STRINGS__
 
__ERRPOS_EXTERN CPA_EXPORT  char * g_a_szPosInformationModule []
#if defined(__DeclareGlobalVariableErmPos_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szPosVersion, C_szPosFullName, C_szPosDate}
#endif /*__DeclareGlobalVariableErrPos_h__ &&  CPA_WANTS_IMPORT*/
;
 
__ERRPOS_EXTERN CPA_EXPORT  char * g_szPosModuleName /* Mandatory syntax 'g_sz'+[Abbreviation of ModuleName]+'ModuleName'*/
#if defined(__DeclareGlobalVariableErmPos_h__) && !defined(CPA_WANTS_IMPORT)
= "Module Pos"
#endif /*__DeclareGlobalVariableErrPos_h__ && CPA_WANTS_IMPORT*/
;
 
__ERRPOS_EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stPosTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErmPos_h__) && !defined(CPA_WANTS_IMPORT)
={ 
#ifdef __FATAL_ERR_POS__   
/*	 -------------*/
	E_uwPosFatalError1, " Invalid handle ",
	E_uwPosFatalError2, " Wrong format. Perhaps your position isn't initialized ? ",
	E_uwPosFatalError3, " Use of an uninitialized position",
	E_uwPosFatalError4, " ",
#endif /*__FATAL_ERR_POS__*/
#ifdef __WARNING1_ERR_POS__
/*	 ----------------*/
	E_uwPosWarning1Error1, " ",	
	E_uwPosWarning1Error2, " ",
	E_uwPosWarning1Error3, " ",
#endif /*__WARNING1_ERR_POS__*/
#ifdef __WARNING2_ERR_POS__
/*	 ----------------*/
	E_uwPosWarning2Error1, " ",
	E_uwPosWarning2Error2, " ",
	E_uwPosWarning2Error3, " ",
	E_uwPosWarning2Error4, " ",
	E_uwPosWarning2Error5, " ",
#endif /*__WARNING2_ERR_POS__*/
#ifdef __WARNING3_ERR_POS__
/*	 ----------------*/
	E_uwPosWarning3Error1, " ",
	E_uwPosWarning3Error2, " ",
#endif /*__WARNING3_ERR_POS__*/
	0xFFFF, "\0"/*fin*/
};
#endif /*__DeclareGlobalVariableErmPos_h__ && CPA_WANTS_IMPORT*/
;
 
#endif /*__ERROR_STRINGS__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /*__ERRPOS_H__*/
