/*
  MODULE : PRT (Particle system Library)
  AUTHOR : Frederic PHILIPPE
           UBI R&D
  FILE : PRT.h (Principal header file)
*/
 
#ifndef D_THROW_PRT
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_PRT
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_PRT
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef PRT_H
#define PRT_H
 
#include "PRT/PrtSyst.h"
#include "PRT/PrtSrc.h"
#include "PRT/PrtEnv.h"
#include "PRT/PrtMeca.h"
#include "PRT/PointPrt.h"
#include "PRT/SegmtPrt.h"
#include "PRT/SprtPrt.h"
 
#endif /* PRT_H */
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
 
#endif /* D_THROW_PRT */
 
