/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *  SCR.h
 *  Main include file for script parser.
 *
 *  In SCR_Cfg.h, you can retreive the current script version with the two defines :
 *  #define SCR_C_sz_Cfg_ScriptVersion  "Version.Revision.Patch"
 *  #define SCR_C_ui_Cfg_ScriptVersion  VersionRevisionRelease (200 to 999).
 *
 *  (c) Ubi Simulations 1997, Beaudet Christophe
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *
 */
 
#if !defined(__SCR_h__)
#define __SCR_h__
 
/*===============================================================================================*/
 
#include "cpa_std.h"
 
#ifdef __cplusplus
extern "C" {
#endif /* __cpluscplus */
 
/*===============================================================================================*/
 
/* For Level 4 */
#if defined(VISUAL)
#pragma warning(disable:4010)
#pragma warning(disable:4032)
#pragma warning(disable:4100)
#pragma warning(disable:4115)
#pragma warning(disable:4127)
#pragma warning(disable:4201)
#pragma warning(disable:4214) 
#pragma warning(disable:4310)
#pragma warning(disable:4514)
#pragma warning(disable:4702)
#pragma warning(disable:4711)
#endif /* VISUAL */
 
#if !defined(U64)
#include "SCR/SCR_Anl.h"
#include "SCR/SCR_Bin.h"
#include "SCR/SCR_Cfg.h"
#include "SCR/SCR_CFil.h"
#include "SCR/SCR_Cxt.h"
#include "SCR/SCR_Dbg.h"
#include "SCR/SCR_DyAr.h"
#include "SCR/SCR_Err.h"
#include "SCR/SCR_File.h"
#include "SCR/SCR_Hash.h"
#include "SCR/SCR_Link.h"
#include "SCR/SCR_Mem.h"
#include "SCR/SCR_Ntfy.h"
#include "SCR/SCR_Page.h"
#include "SCR/SCR_Pars.h"
#include "SCR/SCR_Sect.h"
#include "SCR/SCR_RdL0.h"
#include "SCR/SCR_SvL0.h"
#include "SCR/SCR_SvL1.h"
#include "SCR/SCR_Vars.h"
#include "SCR/SCR_XXXX.h"
#endif
 
/*===============================================================================================*/
 
#ifdef __cplusplus
}
#endif /* __cplusplus */
 
/*===============================================================================================*/
 
#endif /* !__SCR_h__ */
