/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *  SCR_Vars.h
 *  Scripts, Beaudet Christophe
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *
 */
 
#ifndef __SCR_Vars_h__Types
#define __SCR_Vars_h__Types
 
#ifndef __Only_Types__
#define __SCR_Vars_h__Undef
#define __Only_Types__
#endif /* !__Only_Types__ */
 
/*
 *=================================================================================================
 *  Includes.
 *=================================================================================================
 */
 
#include "SCR_Cfg.h"
 
#ifdef __SCR_Vars_h__Undef
#undef __Only_Types__
#undef __SCR_Vars_h__Undef
#endif /* __SCR_Vars_h__Undef */
 
/*
 *=================================================================================================
 *  Constants.
 *=================================================================================================
 */
 
/*
 *  To export code.
 */
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else /* CPA_WANTS_IMPORT */
#define CPA_EXPORT
#endif /* CPA_WANTS_IMPORT */
 
/*
 *=================================================================================================
 *  Types.
 *=================================================================================================
 */
 
/*
 *  To describe a global variable.
 */
typedef struct SCR_tdst_Vars_Description_
{
	SCR_tdst_DyAr_Header	stHeader;									/* Header of element */
    char					a_szVarName[SCR_CV_ui_Cfg_MaxLenVarName];	/* Name of variable */
    char					a_szVarValue[SCR_CV_ui_Cfg_MaxLenVarVal];	/* Value of variable */
} SCR_tdst_Vars_Description;
 
#endif /* !__SCR_Vars_h__Types */
 
/*
 *=================================================================================================
 *  Global variables.
 *=================================================================================================
 */
 
#if !defined(__SCR_Vars_h__Globals) && !defined(__Only_Types__)
#define __SCR_Vars_h__Globals
 
CPA_EXPORT extern SCR_tdst_DyAr_Description     SCR_g_st_Vars_Array;
 
#endif /* !__SCR_Vars_h__Globals && !__Only_Types__ */
 
/*
 *=================================================================================================
 *  Protos.
 *=================================================================================================
 */
 
#if !defined(__SCR_Vars_h__Protos) && !defined(__Only_Types__)
#define __SCR_Vars_h__Protos
 
extern void                         fn_v_Vars_InitModule(void);
extern void                         fn_v_Vars_CloseModule(void);
 
extern SCR_tdst_Vars_Description    *fnp_st_Vars_Add(char *, char *);
extern void                         fn_v_Vars_Delete(SCR_tdst_Vars_Description *);
extern SCR_tdst_Vars_Description    *fnp_st_Vars_Search(char *);
 
extern void							fn_v_Vars_ReduceMemory(void);
extern void							fn_v_Vars_DeleteWithMemLevel(unsigned char, unsigned char);
 
#endif /* !__SCR_Vars_h__Protos && !__Only_Types__ */
 
