/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          SHWCpa.H
 
DESCRIPTION :   Complex functions of SHW Module
 
VERSION :       1.00 / Philippe Thibaut / Creation
 
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef __SHW_FUNCT_H__
#define __SHW_FUNCT_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#include "cpa_expt.h"
 
 
/* ##F===================================================================================
NAME :          SHW_fn_vDrawShadow
DESCRIPTION :   Draw a Fake Shadow for a Character
=========================================================================================
CREATION : Philippe Thibaut
=======================================================================================*/
extern CPA_EXPORT void SHW_fn_vDrawShadow( struct GLD_tdstViewportAttributes_ *p_stVpt,
            HIE_tdxHandleToSuperObject hHandleOfCharacter,
            HIE_tdxHandleToSuperObject _hSprObjSector,
            long SectorDrawmask
            );
 
/* ##F===================================================================================
NAME :          SHW_fn_vInitShadow
DESCRIPTION :   Init of the Array of Geometric Objects for the Characters' shadows
=========================================================================================
CREATION : Philippe Thibaut
=======================================================================================*/
extern CPA_EXPORT void SHW_fn_vInitShadow(GLD_tdhDevice _hGLDDevice);
 
 
/* ##F===================================================================================
NAME :          SHW_fn_vInitShadowCounter
DESCRIPTION :   Initialization of the Counter for the Characters' shadows. 
                MUST BE RUN AT EACH FRAME
=========================================================================================
CREATION : Philippe Thibaut
=======================================================================================*/
extern CPA_EXPORT void SHW_fn_vInitShadowCounter(void);
 
 
/* ##F===================================================================================
NAME :          SHW_fn_vSetLevelOfQualityOfShadows
DESCRIPTION :   Initialization of the quality of the Shadows
                Now it is  0 ( No Shadow) 1 ( Low Quality)  or 2 (High Quality)
=========================================================================================
CREATION : Philippe Thibaut
=======================================================================================*/
extern CPA_EXPORT void SHW_fn_vSetLevelOfQualityOfShadows(short xQualityOfShadow);
 
/*ANNECY VL 01/12/97{*/
/* ##F===================================================================================
NAME :          SHW_fn_bIntersectShadowSuperObjectLevel1
DESCRIPTION :   Find the face upon which  the shadow is projected (For quality level 1 )
				this function is also used by gam project to compute foot print location
=========================================================================================
CREATION : Philippe Thibaut
=======================================================================================*/
extern CPA_EXPORT ACP_tdxBool SHW_fn_bIntersectShadowSuperObjectLevel1(
                  MTH3D_tdstVector           *p_stVertexA,
                  MTH3D_tdstVector           *p_stVertexB,
                  MTH3D_tdstVector           *p_ststVectAB,
                  HIE_tdxHandleToSuperObject _hSprObj,
                  MTH3D_tdstVector           *p_stPickedPoint,
                  HIE_tdxHandleToSuperObject *p_hPickedSprObj,
                  ACP_tdxHandleOfObject      *p_hPickedObject,
                  ACP_tdxIndex               *p_xPickedElement,
                  ACP_tdxIndex               *p_xPickedFace,
                  MTH3D_tdstVector           *pstGlobalNormalOfPickedFace,
                  HIE_tdxHandleToSuperObject hHandleOfCharacter);
/*ENDANNECY VL }*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __SHW_FUNCT_H__ */
