/*=============================================================================
 *
 *  Filename:           _ACTypes.hpp
 *  Version:            2.0 (VSS5)
 *  Date:				30/12/96
 *  Author:             Marc Trabucato
 *
 *  Description:		description of TAction_Interface class, which is the
 *						base class of action DLL (inherit CPA_ToolDLLBase
 *
 *===========================================================================*/
 
#ifndef __ACTYPES_HPP__
#define __ACTYPES_HPP__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/
 
/*----------------------------------------------------------*/
/* TYPES & ENUMS*/
/*----------------------------------------------------------*/
 
/* type of State modification*/
typedef enum
{
    C_iAnim,
    C_iSpeed,
    C_iSpeedW,
    C_iReplay,
    C_iReplayW,
    C_iNextState,
    C_iInterruptState,
    C_iMeca,
    C_iTPList,
    C_iDefaultStatus,
	C_iCustomBits
} tdeChangingState;
 
/* type of zone*/
typedef enum
{
    C_eZDd,
    C_eZDe,
    C_eZDm,
    C_eZDr,
    C_eError
} tde_ZoneType;
 
/* zone modification (OnQuery)*/
class CPA_tdoNameList;
typedef struct tdstModifZone_
{
    CPA_tdoNameList *p_oNameList;
    short            wIndex;
} tdstModifZone;
 
/*----------------------------------------------------------*/
/* CONSTANTS*/
/*----------------------------------------------------------*/
#define C_szActionTypeName      "Action"
#define C_szStateTypeName       "State"
#define C_szZATypeName          "ZA"
#define C_szZAListTypeName      "ZAList"
 
#define C_uiLoadAllActions      1
#define C_uiSaveAction          2
#define C_uiSaveStates          3
#define C_uiRemoveZone          4
#define C_uiLoadZA				5
#define C_uiLoadZAList			6
#define C_uiInsertZone          7
#define C_uiOpenWithNone        10
#define C_uiOpenWithFamily      11
#define C_uiOpenWithAction      12
#define C_uiOpenWithState       13
#define C_szTACModuleNameErO	"TAC Module"
 
#endif  /*__ACTYPES_HPP__*/
