/****************************************************************************
 
         TDE.H : Prototypes of sprite-drawing functions and procedures       
         Last update : 25 july 96
 
*****************************************************************************/
 
/*
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
You must do : 
#define TDE_GLOBALS 
in one (and only one) .c file of your Module.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
 
/* To avoid unnecessary includes :  */
 
 
#ifndef  __TDE_TDE_H
#define __TDE_TDE_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* F1 Engine Team, 25.03.1997, using 'small' TDE*/
/*#define TDE_LIGHT*/
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
/* For Global declaration in C files : */
#ifndef TDE_GLOBALS
 #define __TDE_EXTERN extern
#else /* !TDE_GLOBALS */
 #define __TDE_EXTERN
#endif /* !TDE_GLOBALS */
 
/*
-----------------------------------------------------------------------------
INCLUDES FILES :
Include here any other header files of your module you need !
Ex : 
#include "toto.h"
Note : Do Not include header files from other Modules (do this in C files 
only)*/
#ifdef WATCOM
#pragma warning 389 9
#endif /* WATCOM*/
 
#include "CPA_STD.H"
 
#include <windows.h>
#include <windowsx.h>
 
/* comme un porc */
#include "ddraw.h"
 
#include "acp_base.h"
#include "GLD.h"
 
#include "TMR.h"
 
#include "TDE/errtde.h"
#include "TDE/mmgtde.h"
#include "TDE/macrotde.h"
#include "TDE/tde_def.h"
#include "TDE/tde_values.h"
#include "TDE/tde_struct.h"
#include "TDE/tde_matrix.h"
#include "TDE/tde_rect.h"
#include "TDE/tde_draw.h"
#include "TDE/tde_dtext.h"
#include "TDE/tde_init.h"
#include "TDE/tde_Hierarchy.h"
#include "TDE/tde_Var.h"
#include "TDE/tde_lines.h"
#ifdef WATCOM
#include "TDE/tde_wop1616.h"
#else  /* WATCOM*/
#include "TDE/tde_vop1616.h"
#endif /* WATCOM*/
#include "TDE/tde_pick.h"
#include "TDE/tde_files.h"
 
/*
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
CONSTANT DECLARATION:
Ex :
#define TDE_C_LMAX 100
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
TYPES DEFINITION : 
Declare here any type you need, and constant you need to do this :
Ex :              typedef struct TDE_tdstToto_
{
        long aLMAX_lBuffer[TDE_C_LMAX];
    ...
} TDE_tdst_Toto ;
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
GLOBAL VARIABLE DECLARATION :
Ex : 
__TDE_EXTERN <type> <variable name>
 #ifdef TDE_GLOBALS
 = <initial values>
 #endif
 ;
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
PUBLIC FUNCTIONS DECLARATION:
Ex : 
extern CPA_EXPORT void TDE_fn_vMyPublicFunction(void); 
Note : Public functions declaration must be done in PUBLIC HEADER files (.h)
in your Inc directory
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
PRIVATE FUNCTIONS DECLARATION: 
Ex : 
extern void TDE_fn_vMyPrivateFunction(void); 
Note : Private functions MUST appear ONLY in PRIVATE HEADER files (.h) in 
your Src directory with source files (.c)
-----------------------------------------------------------------------------
*/
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __TDE_TDE_H  */
 
 
 
 
 
 
 
 
 
 
 
 
