/****************************************************************************
 
         TDE_DEF.H : Macro definitions for quantities
         Yan Marchal, 97/03/14
 
*****************************************************************************/
 
/*
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
You must do : 
#define TDE_GLOBALS 
in one (and only one) .c file of your Module.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
 
/* To avoid unnecessary includes :  */
#ifndef  __TDE_DEF_H
#define __TDE_DEF_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
/*
-----------------------------------------------------------------------------
CONSTANTS DECLARATION :
-----------------------------------------------------------------------------
*/
 
#define C_TDEDEC            1
 
#define TDE_M_PI            ( 3.1415927 )
#define TDE_M_2PI           ( 6.2831854 )
#define TDE_M_PIO2          ( 1.5707963 )
#define TDE_M_PIO4          ( 0.7853982 )
 
/* The depth of the matrix stack, which also is the maximal number of*/
/* levels in the hierarchy :*/
#define TDE_kSTACKDEPTH     10
/* Maximal priority (depth of the Z-list)*/
#define TDE_kMAXPRIORITY    50
/* Maximal number of intersecting super-objects (used for picking)*/
#define TDE_kMAXPICK        20
/* Number of letters in a bitmap font*/
#define TDE_kNBLETTERS      224
/* Index of the letter used for insert cursor (add 32 to get the ASCII index)*/
#define TDE_kINSERTCURSOR   96
 
/*
-----------------------------------------------------------------------------
*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __TDE_VAR_H  */
 
 
 
 
