/**************************************************************************************
 
                File            : TDE_DRAWTEXT.H
                Text drawing routines
 
***************************************************************************************/
 
/*
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
You must do : 
#define TDE_GLOBALS 
in one (and only one) .c file of your Module.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
 
/* To avoid unnecessary includes :  */
#ifndef  __TDE_DRAWTEXT_H
#define __TDE_DRAWTEXT_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
/* For Global declaration in C files : */
#ifndef TDE_GLOBALS
 #define __TDE_EXTERN extern
#else /* !TDE_GLOBALS */
 #define __TDE_EXTERN
#endif /* !TDE_GLOBALS */
 
/*
-----------------------------------------------------------------------------
FUNCTIONS DECLARATION:
-----------------------------------------------------------------------------
*/
 
extern BOOL         TDE_bIsBreakChar            (char c);
extern TDE_tdxValue TDE_xGetVerticalOffset      (TDE_tdsTextBox *pTextBox, long *p_lNbLines);
extern TDE_tdxValue TDE_xGetHorizontalOffset    (TDE_tdsTextBox *pTextBox, long lStartIndex, long *p_lEndIndex);
extern void         TDE_vDrawBitmapText         (GLD_tdpstViewportAttributes   p_stViewAttrib,
                                                 TDE_tdsTextBox                *pTextBox);
extern void         TDE_vTDE_vAdjustTextBoxFormatRect( TDE_tdsTextBox *pTextBox);                                                 
extern void         TDE_vDrawTrueTypeText       (GLD_tdpstViewportAttributes   p_stViewAttrib,
                                                 TDE_tdsTextBox                *pTextBox);
extern void         TDE_vDrawTextInABox         (GLD_tdpstViewportAttributes   p_stViewAttrib,
                                                 TDE_tdsSuperObject            *p_stSuperObject,
                                                 BOOL                          bViewPortLocked);
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __TDE_DRAWTEXT_H  */
 
