/*///////////////////////////////////////////////////////////*/
/**/
/*			Management of the Module : Tmr*/
/**/
/* File Name	: ErrTmr.h*/
/* Date			: 07/03/97*/
/* Author		: Francis Jentey*/
/**/
/*///////////////////////////////////////////////////////////*/
/**/
/* abbreviation of the module-name. Used in macro is 'Tmr'*/
/**/
/*///////////////////////////////////////////////////////////*/
 
#ifndef __ERRTmr_H__
#define __ERRTmr_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#define C_szTmrVersion "Tmr V5.0.2" /* The format is Tmr Va.b.c with Tmr is the Tag of the module */
#define C_szTmrFullName  "Module Timer"/* the complete and clear name of the module */
#define C_szTmrDate "Apr 22 1997" /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "ERM.h"
 
#define __FATAL_ERR_Tmr__
#define __WARNING1_ERR_Tmr__
#define __WARNING2_ERR_Tmr__
#define __WARNING3_ERR_Tmr__
/*----------*/
/* Constant	 */
/*----------*/
/* error of the Tmr Module*/
typedef enum e_uwTmrErrNumber_{
	E_uwTmrFatalErr,	
#ifdef __FATAL_ERR_Tmr__
/*     -----------------*/
#endif /*__FATAL_ERR_Tmr__*/
	E_uwTmrStartOfWarning,/* important constant, it allows to recognize if an error is fatal or not.*/
#ifdef __WARNING1_ERR_Tmr__
/*     -------------------*/
    E_uwTmrLibraryNotInitialized,
    E_uwTmrInvalidType,
    E_uwTmrTypeNotAvailable,
    E_uwTmrInvalidHandle,
    E_uwTmrInvalidForEventTimer,
    E_uwTmrMaxTimerCountReached,
    E_uwTmrTimerNotReady,
  /*E_uwTmrStartTimerFirst,*/
    E_uwTmrCreateEventFailed,
 
#endif /*__WARNING1_ERR_Tmr__*/
#ifdef __WARNING2_ERR_Tmr__
/*     -------------------*/
 
#endif /*__WARNING2_ERR_Tmr__*/
#ifdef __WARNING3_ERR_Tmr__
/*     -------------------*/
 
#endif /*__WARNING3_ERR_Tmr__*/
	E_uwTmrErrNumber
} e_uwTmrErrNumber;
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef __ERRTmr_EXTERN
#ifndef __DeclareGlobalVariableErrTmr_h__
#define __ERRTmr_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableErrTmr_h__*/
#define __ERRTmr_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableErrTmr_h__*/
 
__ERRTmr_EXTERN CPA_EXPORT  unsigned char g_ucTmrModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrTmr_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif /*__DeclareGlobalVariableErrTmr_h__&& CPA_WANTS_IMPORT*/
;
 
#ifdef __ERROR_STRINGS__
 
__ERRTmr_EXTERN CPA_EXPORT  char * g_a_szTmrInformationModule []
#if defined(__DeclareGlobalVariableErrTmr_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szTmrVersion, C_szTmrFullName, C_szTmrDate}
#endif /*__DeclareGlobalVariableErrTmr_h__ &&  CPA_WANTS_IMPORT*/
;
 
__ERRTmr_EXTERN CPA_EXPORT  char * g_szTmrModuleName /* Mandatory syntax 'g_sz'+[Abbreviation of ModuleName]+'ModuleName'*/
#if defined(__DeclareGlobalVariableErrTmr_h__) && !defined(CPA_WANTS_IMPORT)
= "Module Tmr"
#endif /*__DeclareGlobalVariableErrTmr_h__ && CPA_WANTS_IMPORT*/
;
 
__ERRTmr_EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stTmrTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrTmr_h__) && !defined(CPA_WANTS_IMPORT)
={ 
#ifdef __FATAL_ERR_Tmr__   
/*	 -------------*/
#endif /*__FATAL_ERR_Tmr__*/
#ifdef __WARNING1_ERR_Tmr__
/*	 ----------------*/
    E_uwTmrLibraryNotInitialized , "The Timer.lib isn't initialize. See fn_wTimerInitLibrary.",
    E_uwTmrInvalidType , "You specified an unknow timer type.",
    E_uwTmrTypeNotAvailable , "This timer type isn't supported. Try a lower precision.",
    E_uwTmrInvalidHandle , "Unknow timer handle.",
    E_uwTmrInvalidForEventTimer , "Event timer can't be start, stop or reset.",
    E_uwTmrMaxTimerCountReached , "Too many timer. The library support a fix count of timer.",
    E_uwTmrTimerNotReady , "The timer isn't ready. Try to the fn_wTimerResetTimer before.",
  /*E_uwTmrStartTimerFirst , "The timer must be started before.",*/
    E_uwTmrCreateEventFailed , "The system is unable to create an event!",
 
#endif /*__WARNING1_ERR_Tmr__*/
#ifdef __WARNING2_ERR_Tmr__
/*	 ----------------*/
#endif /*__WARNING2_ERR_Tmr__*/
#ifdef __WARNING3_ERR_Tmr__
/*	 ----------------*/
#endif /*__WARNING3_ERR_Tmr__*/
	0xFFFF, "\0"/*fin*/
}
#endif /*__DeclareGlobalVariableErrTmr_h__ && CPA_WANTS_IMPORT*/
;
 
#endif /*__ERROR_STRINGS__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__ERRTmr_H__*/
