/*/////////////////////////////////////////////////////////////////////////////*/
/**/
/* Public header file List of Data used by WAW*/
/**/
/*/////////////////////////////////////////////////////////////////////////////*/
 
/* To avoid unnecessary includes :  */
#ifndef __WAW_LIST_HPP
#define __WAW_LIST_HPP
 
#include <afxtempl.h>
 
/**************************************/
#if !defined(CPA_EXPORT)
  #if defined(CPA_WANTS_IMPORT)
    #define CPA_EXPORT __declspec(dllimport)
  #elif defined(CPA_WANTS_EXPORT)
    #define CPA_EXPORT __declspec(dllexport)
  #else
    #define CPA_EXPORT
  #endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/**************************************/
 
/*#ifdef __cplusplus*/
/*extern "C" {*/
/*#endif /* __cplusplus **/
 
 
/* For Global declaration in C files : */
#ifdef WAW_GLOBALS
 #define __WAW_EXTERN extern
#else /* !WAW_GLOBALS */
 #define __WAW_EXTERN
#endif /* !AID_GLOBALS */
 
/*
-----------------------------------------------------------------------------
INCLUDES FILES :
Include here any other header files of your module you need !
Ex : 
#include "toto.h"
Note : Do Not include header files from other Modules (do this in C files 
only)
-----------------------------------------------------------------------------
*/
 
#include "WAW_Data.hpp"
 
/*
-----------------------------------------------------------------------------
CONSTANT DECLARATION:
Ex :
#define WAW_C_LMAX 100
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
TYPES DEFINITION : 
Declare here any type you need, and constant you need to do this :
Ex :    typedef struct WAW_tdstToto_
{
 long aLMAX_lBuffer[WAW_C_LMAX];
    ...
} WAW_tdst_Toto ;
-----------------------------------------------------------------------------
*/
 
	class CPA_EXPORT WAW_DataList : public CList<WAW_Data*,WAW_Data*>
		{
		public :
			WAW_DataList( CString );
			WAW_DataList( WAW_hUserInfo );
 
		/* members :*/
		public:
		protected:
		private:
			WAW_hUserInfo m_pri_hUserInfo;
 
		/* functions :*/
		public:
			void m_pub_fn_vGetAll();
 
			void m_pub_fn_vGetData();
			void m_pub_fn_vGetNode();
			void m_pub_fn_vGetWithName( CString );
			void m_pub_fn_vGetChildren( CString );
			void m_pub_fn_vGetVisible();
 
			void m_pub_fn_vSelectData();
			void m_pub_fn_vSelectNode();
			void m_pub_fn_vSelectWithName( CString );
			void m_pub_fn_vSelectChildren( CString );
			void m_pub_fn_vSelectVisible();
 
		protected:
		private:
			void m_pri_fn_vFillList( CTreeCtrl*, HTREEITEM );
			void m_pri_fn_vUpdateVisible();
		};
	
 
/*
-----------------------------------------------------------------------------
GLOBAL VARIABLE DECLARATION :
Ex : 
__AID_EXTERN <type> <variable name>
 #ifdef AID_GLOBALS
 = <initial values>
 #endif
 ;
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
PUBLIC FUNCTIONS DECLARATION:
Ex : 
extern CPA_EXPORT void WAW_fn_vMyPublicFunction(void); 
Note : Public functions declaration must be done in PUBLIC HEADER files (.h)
in your Inc directory
-----------------------------------------------------------------------------
*/
	
/*
-----------------------------------------------------------------------------
PRIVATE FUNCTIONS DECLARATION: 
Ex : 
extern void WAW_fn_vMyPrivateFunction(void); 
Note : Private functions MUST appear ONLY in PRIVATE HEADER files (.h) in 
your Src directory with source files (.c)
-----------------------------------------------------------------------------
*/
 
 
/*#ifdef __cplusplus*/
/*};*/
/*#endif /* __cplusplus   */
 
 
#endif /* __WAW_LIST_HPP  */
