/*/////////////////////////////////////////////////////////////////////////////*/
/**/
/* Public header file to use WAW*/
/**/
/*/////////////////////////////////////////////////////////////////////////////*/
 
/* To avoid unnecessary includes :  */
#ifndef __WAW_USER_HPP
#define __WAW_USER_HPP
 
 
/**************************************/
#if !defined(CPA_EXPORT)
  #if defined(CPA_WANTS_IMPORT)
    #define CPA_EXPORT __declspec(dllimport)
  #elif defined(CPA_WANTS_EXPORT)
    #define CPA_EXPORT __declspec(dllexport)
  #else
    #define CPA_EXPORT
  #endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/**************************************/
 
/*
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus *
*/
 
/* For Global declaration in C files : */
#ifdef WAW_GLOBALS
 #define __WAW_EXTERN extern
#else /* !WAW_GLOBALS */
 #define __WAW_EXTERN
#endif /* !AID_GLOBALS */
 
/*
-----------------------------------------------------------------------------
INCLUDES FILES :
Include here any other header files of your module you need !
Ex : 
#include "toto.h"
Note : Do Not include header files from other Modules (do this in C files 
only)
-----------------------------------------------------------------------------
*/
 
#include "WAW_Data.hpp"
 
/*
-----------------------------------------------------------------------------
CONSTANT DECLARATION:
Ex :
#define WAW_C_LMAX 100
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
TYPES DEFINITION : 
Declare here any type you need, and constant you need to do this :
Ex :    typedef struct WAW_tdstToto_
{
 long aLMAX_lBuffer[WAW_C_LMAX];
    ...
} WAW_tdst_Toto ;
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
GLOBAL VARIABLE DECLARATION :
Ex : 
__AID_EXTERN <type> <variable name>
 #ifdef AID_GLOBALS
 = <initial values>
 #endif
 ;
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
PUBLIC FUNCTIONS DECLARATION:
Ex : 
extern CPA_EXPORT void WAW_fn_vMyPublicFunction(void); 
Note : Public functions declaration must be done in PUBLIC HEADER files (.h)
in your Inc directory
-----------------------------------------------------------------------------
*/
	
	extern CPA_EXPORT void  WAW_fn_vInitWatchWindow();
	extern CPA_EXPORT void  WAW_fn_vRefreshWatchWindow();
	
	extern CPA_EXPORT CWnd* WAW_fn_pclGetWatchWindowDialog();
	extern CPA_EXPORT CWnd* WAW_fn_pclGetWatchWindowTree();
 
	extern CPA_EXPORT void WAW_fn_vDisplayWatchWindow();
	extern CPA_EXPORT void WAW_fn_vHideWatchWindow();
	extern CPA_EXPORT void WAW_fn_vSetWatchWindowTopMost( BOOL );
 
	extern CPA_EXPORT WAW_hUserInfo WAW_fn_hUserRegister( CString, WAW_CallBack );
 
	extern CPA_EXPORT WAW_Data * WAW_fn_pclAddData( WAW_hUserInfo, WAW_Data*, CString, CString, void * _pvUserData = NULL );
	extern CPA_EXPORT WAW_Data * WAW_fn_pclAddData( CString, WAW_Data*, CString, CString, void * _pvUserData = NULL );
	extern CPA_EXPORT WAW_Data * WAW_fn_pclAddNode( WAW_hUserInfo, WAW_Data*, CString, void * _pvUserData = NULL );
	extern CPA_EXPORT WAW_Data * WAW_fn_pclAddNode( CString, WAW_Data*, CString, void * _pvUserData = NULL );
 
	extern CPA_EXPORT BOOL WAW_fn_bUpdateData( WAW_Data*, CString /*data value*/ );
 
	extern CPA_EXPORT BOOL WAW_fn_bDeleteData( WAW_Data* );
 
	extern CPA_EXPORT BOOL WAW_fn_bSetDataIcon( WAW_Data*, HICON, HICON _hSeclectIcon = NULL );
 
/*
-----------------------------------------------------------------------------
PRIVATE FUNCTIONS DECLARATION: 
Ex : 
extern void WAW_fn_vMyPrivateFunction(void); 
Note : Private functions MUST appear ONLY in PRIVATE HEADER files (.h) in 
your Src directory with source files (.c)
-----------------------------------------------------------------------------
*/
	WAW_hUserInfo WAW_fn_hFindInfo( CString );
	void WAW_fn_vSendMessage( WAW_tdeMessage, void* );
 
	BOOL WAW_fn_bCheckForEmptyNode( HTREEITEM );
 
	/*
#ifdef __cplusplus
};
#endif // __cplusplus
*/
 
#endif /* __WAW_USER_HPP  */
