/*---------------------------------------------------------------------------*/
/* AIUseCPA.h : CPA include for AI.*/
/* auteur : Olivier Didelot.*/
/* date   : 28/01/1997*/
/*---------------------------------------------------------------------------*/
#ifndef __AIUSECPA_H__
#define __AIUSECPA_H__
 
/****************************************
 * Here is the list of disabled WARNING *
 ****************************************/
#if defined(VISUAL)
/*#pragma warning(disable:4010)   // single-line comment contains line-continuation character **/
/*#pragma warning(disable:4702)   // unreachable code */
#pragma warning(disable:4244) /* conversion from 'type1' to 'type2', possible loss of data **/
#pragma warning(disable:4514)   /* unreferenced inline function has been removed*/
#pragma warning(disable:4201)   /* nonstandard extension used : nameless struct/union*/
#pragma warning(disable:4127)   /* conditional expression is constant*/
#pragma warning(disable:4214)   /* nonstandard extension used : bit field types other than int*/
#pragma warning(disable:4115)   /* named type definition in parentheses*/
#if !defined(__cplusplus)
#pragma warning(disable:4032)   /* formal parameter 1 has different type when promoted*/
#endif
#pragma warning(disable:4206)   /* nonstandard extension used : translation unit is empty*/
#endif /*VISUAL*/
 
#include "ACP_Base.h"
#include "GMT.h"
#include "MMG.h" /* MemoryManaGer*/
#include "ERM.h" /* ErrorManager*/
#include "SCR.h" /* SCRipt*/
#include "GEO.h"
#include "GLI.h" 
#include "COL.h" 
#include "SPO.h" /*"Hie.h"*/
#include "MEC.h" /* Mechanic*/
#include "LST.h" /* LiST*/
#ifdef USE_IPT_DX5
#include "IPT_DX5.h" /* InPuT (absolutely before GAM.h)*/
#else /* USE_IPT_WIN */
#include "IPT.h" /* InPuT (absolutely before GAM.h)*/
#endif /* USE_IPT_WIN */
#include "PCS.h" /* Physical Collide Set */
 
#include "RND.h" /* RaNDom*/
/*XB980428*/
/*#include "VIG.h" // Vignette*/
/*End XB*/
/* Shaitan Clean Env {*/
/*#include "SRF.h" // Surface*/
/* End Shaitan Clan Env }*/
 
/*#include "FON.h" // Font*/
#include "SND.h" /* SND*/
#define ENV_FRIEND
/* Shaitan Clean Env {*/
/*#include "ENV.h" // ENV*/
/* End Shaitan Clan Env }*/
#include "SCT.h" /* SeCTor*/
#include "FIL.h" /* SeCTor*/
 
/* in order to compile AI in C++ and link with GAM in C*/
#if defined(__cplusplus)
extern "C"
{
#endif
#ifndef D_THROW_PRT
#include "PRT.h"
#endif /* D_THROW_PRT */
#include "GAM.h" /* GAMe*/
#ifndef U64
#include "DPT.h" /* DataPaTh*/
#endif
#if defined(__cplusplus)
}
#endif
 
/*#ifdef AI_USE_BINARY*/
/*#include "BIN.h" */
/*#endif /* AI_USE_BINARY   */
#include "HDL.h"
#include "SAI.h"
 
/*#include "cpa_std.h"*/
 
#undef EXTERN
#undef extern
 
#endif /* __AIUSECPA_H__*/
