// Implementation for the list of Masks
//
// (used by Masked Data and Controls)
//
// Writen by YB
///////////////////////////////////////////
#include "StdAfx.h"

#include "Others\CTL_Mask.hpp"

//######################################################################
//######################################################################
//######################################################################

//**********************************************************************
CTL_Editor_Mask::CTL_Editor_Mask(CString _csString,
																	 unsigned long _ulValue)
{
	m_pri_csString = _csString;
	m_pri_ulMaskValue = _ulValue;
}

//**********************************************************************
CTL_Editor_Mask::~CTL_Editor_Mask()
{

}

//**********************************************************************
CString CTL_Editor_Mask::m_pub_fn_csGetString()
{
	return m_pri_csString;
}

//**********************************************************************
unsigned long CTL_Editor_Mask::m_pub_fn_ulGetMaskValue()
{
	return m_pri_ulMaskValue;
}


//######################################################################
//######################################################################
//######################################################################

//**********************************************************************
CTL_Editor_MaskDescriptor::CTL_Editor_MaskDescriptor(CString _csName)
{
	m_pri_csName = _csName;
}

//**********************************************************************
CTL_Editor_MaskDescriptor::~CTL_Editor_MaskDescriptor()
{
	m_pri_fn_vEmptyList();
}

//**********************************************************************
CString CTL_Editor_MaskDescriptor::m_pub_fn_csGetName()
{
	return m_pri_csName;
}

//**********************************************************************
CTL_Editor_Mask *CTL_Editor_MaskDescriptor::m_pub_fn_pclAddMask(CString _csString,
																																	unsigned long _ulValue)
{
	CTL_Editor_Mask *pclNewMask = new CTL_Editor_Mask(_csString, _ulValue);

	AddTail(pclNewMask);

	return pclNewMask;
}

//**********************************************************************
void CTL_Editor_MaskDescriptor::m_pri_fn_vEmptyList()
{
	POSITION pos = GetHeadPosition();

	while ( pos != NULL )
		delete ( GetNext(pos) );

	RemoveAll();
}


//######################################################################
//######################################################################
//######################################################################

//**********************************************************************
CTL_Editor_MaskList::CTL_Editor_MaskList()
{

}

//**********************************************************************
CTL_Editor_MaskList::~CTL_Editor_MaskList()
{
	m_pub_fn_vEmptyList();
}

//**********************************************************************
CTL_Editor_MaskDescriptor *CTL_Editor_MaskList::m_pub_fn_pclAddMaskDescriptor(CString _csName)
{
	CTL_Editor_MaskDescriptor *pclNewMaskDesc = new CTL_Editor_MaskDescriptor(_csName);

	AddTail(pclNewMaskDesc);

	return pclNewMaskDesc;
}

//**********************************************************************
void CTL_Editor_MaskList::m_pub_fn_vEmptyList()
{
	POSITION pos = GetHeadPosition();

	while ( pos != NULL )
		delete ( GetNext(pos) );

	RemoveAll();
}

//************************************************************************
CTL_Editor_MaskDescriptor *CTL_Editor_MaskList::m_fn_pclGetMaskDescriptorByName(CString _csDescriptorName)
{
	CTL_Editor_MaskDescriptor *pclCurrent;
	BOOL bFound = FALSE;
	POSITION pos = GetHeadPosition();
	while ( (pos != NULL) && !bFound )
	{
		pclCurrent = GetNext(pos);
		bFound = ( pclCurrent->m_pub_fn_csGetName().CompareNoCase(_csDescriptorName) == 0 );
	}

	if ( bFound )
		return 	pclCurrent;
	else
		return NULL;
}

