/*=========================================================================
* 
* dllcom.cpp :  DLL definition
* 
*
* Version			1.0
* Creation date		
* Revision date		
*
* Shaitan
*=======================================================================*/


#include "stdafx.h"
#include "acp_base.h"
#include "itf.h"
#include "afxdllx.h"    
#include "edtbase.hpp"


//------------------------------------------------------------------------
// Global vars
static char		*gs_p_szCPAVersion = C_szCPAVersion;
static AFX_EXTENSION_MODULE NEAR    extensionDLL = { NULL, NULL };

#ifdef DLL_ONLY_ONE_INSTANCE
static EDT_HierarchyEditor *gs_p_oEDTInterface = NULL;
#endif 

// list of instances
static CList<CPA_DLLBase*,CPA_DLLBase*> g_oListOfInstances;	//private internal


//------------------------------------------------------------------------
// functions that are present in all DLL :
//------------------------------------------------------------------------

//========================================================================
// Get current CPA version
//========================================================================
extern "C" char __declspec(dllexport) *fn_p_szGetCPAVersion(void)
{
    return gs_p_szCPAVersion;
}

//========================================================================
// Get type of this DLL
//========================================================================
extern "C" tdstDLLIdentity __declspec(dllexport) *fn_p_stGetDLLIdentity(void)
{
	g_stHierarchyIdentity.eType = HIERARCHY_DLL;					
	g_stHierarchyIdentity.csName = C_szDLLHierarchyName;			
	g_stHierarchyIdentity.hModule = NULL;							
	g_stHierarchyIdentity.p_oListOfInstances = &g_oListOfInstances; 
	
	return &g_stHierarchyIdentity;
}

//========================================================================
// DLL int function
//========================================================================
extern "C" void __declspec(dllexport) fn_vInitDll(void)
{
	new CDynLinkLibrary(extensionDLL);
}

//========================================================================
// DLL entry point
//========================================================================
extern "C" int __stdcall DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		if (!AfxInitExtensionModule(extensionDLL, hInstance))
		   return 0;
	}
	return 1;
}

//========================================================================
// Get the DLL
//========================================================================
extern "C" CPA_DLLBase __declspec(dllexport) *fn_p_oGetDLL(long lKey)
{
#ifdef DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		if (gs_p_oEDTInterface == NULL)
		{
			gs_p_oEDTInterface = new EDT_HierarchyEditor();
			ASSERT(gs_p_oEDTInterface != NULL);
		}
		return gs_p_oEDTInterface;
		break;

	default:
		return NULL;
	}

#else //DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		return new EDT_HierarchyEditor();
		break;

	default:
		return NULL;
	}

#endif //DLL_ONLY_ONE_INSTANCE
}


//------------------------------------------------------------------------
// functions that are present in this type of DLL only :
//------------------------------------------------------------------------

#undef DLL_ONLY_ONE_INSTANCE
