/*=========================================================================
* 
* EDTdMove.cpp :  Move Dialog - Implementation file
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/

#include "stdafx.h"
#ifdef ACTIVE_EDITOR
#include "acp_base.h"

#include "EDTdMove.hpp"
#include "EDTBase.hpp"
#include "EDTSObj.hpp"

#include "ITF.h"

//#################################################################################
// EDT_DialogMove dialog
//#################################################################################

/*----------------------------------------
----------------------------------------*/
CPA_Interface * EDT_DialogMove::GetInterface (void)
{
	return m_pEditor->GetInterface();
}

/*----------------------------------------
----------------------------------------*/
EDT_DialogMove::EDT_DialogMove(CWnd* pParent /*=NULL*/)
	: CDialog(EDT_DialogMove::IDD, &g_oBaseFrame)
{
	//{{AFX_DATA_INIT(EDT_DialogMove)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


/*----------------------------------------
----------------------------------------*/
void EDT_DialogMove::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EDT_DialogMove)
	DDX_Control(pDX, EDT_IDC_LISTOBJECTS, m_cListObject);
	DDX_Control(pDX, EDT_IDC_LISTPARENTS, m_cListParent);
	DDX_Control(pDX, EDT_IDC_LISTSECTORS, m_cListSector);
	//}}AFX_DATA_MAP
}


/*----------------------------------------
----------------------------------------*/
BEGIN_MESSAGE_MAP(EDT_DialogMove, CDialog)
	//{{AFX_MSG_MAP(EDT_DialogMove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//#################################################################################
// EDT_DialogMove message handlers
//#################################################################################

/*----------------------------------------
----------------------------------------*/
BOOL EDT_DialogMove::fn_bDoDialog (EDT_HierarchyEditor *pEditor) 
{
	// init parameters
	m_pEditor = pEditor;
	m_bAcceptModif = TRUE;
	// this dialog is modal
	DoModal();
	// return user's answer
	return m_bAcceptModif;
}

/*----------------------------------------
----------------------------------------*/
BOOL EDT_DialogMove::OnInitDialog () 
{
	EDT_SaveParents *pElem;
	POSITION		pos;

	// Create the dialog
	CDialog::OnInitDialog();

	// init list moved
	for (pElem = M_GetListOfModifParent()->GetHeadElement(pos); pElem; 
		 pElem = M_GetListOfModifParent()->GetNextElement(pos))
	{
		// selected objects need no authorisation
		if (!M_GetListSelected()->Find(pElem->m_pChild))
		{
			m_cListObject.AddString(pElem->m_pChild->GetNameToDraw());
			m_cListParent.AddString(pElem->m_pInitialParent->GetNameToDraw());
			m_cListSector.AddString(pElem->m_pFinalParent->GetNameToDraw());
		}
	}
	return TRUE;
}

/*----------------------------------------
----------------------------------------*/
void EDT_DialogMove::OnOK() 
{
	m_bAcceptModif = TRUE;
	// close dialog
	CDialog::OnOK();
}

/*----------------------------------------
----------------------------------------*/
void EDT_DialogMove::OnCancel() 
{
	m_bAcceptModif = FALSE;
	// close dialog
	CDialog::OnCancel();
}



#endif // ACTIVE_EDITOR
