#if !defined(__ErmFIL_h__)
#define __ErmFIL_h__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "FIL_Ver.h"
 
/***************************************/
/**** Error macros (using ACPerror) ****/
/***************************************/
#define M_FILFatalError(ErrorNum) \
{ \
 if (ErrorNum>E_uwFILFatalErr&&ErrorNum<E_uwFILStartOfWarning) \
 { \
  Erm_M_ClearLastError(C_ucErmDefaultChannel);\
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,ErrorNum,C_lErmNoDebugData,C_ucErmOpenInfoWindow,C_ucAllowStopForDebug, NULL);\
 } \
 else \
 { \
  Erm_M_ClearLastError(C_ucErmDefaultChannel);\
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,E_uwFILFatalErrorNotAFatalError,C_lErmNoDebugData,C_ucErmOpenInfoWindow,C_ucAllowStopForDebug, NULL);\
 } \
}
 
#define M_FILFatalErrorWithMessage(ErrorNum,Message) \
{ \
 if (ErrorNum>E_uwFILFatalErr&&ErrorNum<E_uwFILStartOfWarning) \
 { \
  Erm_M_ClearLastError(C_ucErmDefaultChannel);\
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,ErrorNum,C_lErmNoDebugData,C_ucErmOpenInfoWindow,C_ucAllowStopForDebug, Message);\
 } \
 else \
 { \
  Erm_M_ClearLastError(C_ucErmDefaultChannel);\
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,E_uwFILFatalErrorNotAFatalError,C_lErmNoDebugData,C_ucErmOpenInfoWindow,C_ucAllowStopForDebug, NULL);\
 } \
}
 
#define M_FILInformationError(ErrorNum) \
{ \
 if (ErrorNum>E_uwFILStartOfInformationWarning&&ErrorNum<E_uwFILErrNumber) \
 { \
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,ErrorNum,C_lErmNoDebugData,g_stInternalGeneral.ucDisplayInformation,C_ucNeverStopForDebug, NULL);\
  Erm_M_ClearLastError(C_ucErmDefaultChannel);\
 } \
 else \
 { \
  M_FILFatalError(E_uwFILInformationErrorIsNotAInformationError); \
 } \
}
 
#define M_FILInformationErrorWithMessage(ErrorNum,Message) \
{ \
 if (ErrorNum>E_uwFILStartOfInformationWarning&&ErrorNum<E_uwFILErrNumber) \
 { \
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,ErrorNum,C_lErmNoDebugData,g_stInternalGeneral.ucDisplayInformation,C_ucNeverStopForDebug, Message);\
  Erm_M_ClearLastError(C_ucErmDefaultChannel);\
 } \
 else \
 { \
  M_FILFatalError(E_uwFILInformationErrorIsNotAInformationError); \
 } \
}
 
#define M_FILWarningError(ErrorNum) \
{ \
 if (ErrorNum>E_uwFILStartOfWarning&&ErrorNum<E_uwFILStartOfInformationWarning) \
 { \
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,ErrorNum,C_lErmNoDebugData,C_ucErmOpenInfoWindow,C_ucAllowStopForDebug, NULL);\
 } \
 else \
 { \
  M_FILFatalError(E_uwFILWarningErrorIsNotAWarningError); \
 } \
}
 
#define M_FILWarningErrorWithMessage(ErrorNum,Message) \
{ \
 if (ErrorNum>E_uwFILStartOfWarning&&ErrorNum<E_uwFILStartOfInformationWarning) \
 { \
  Erm_M_UpdateLastError(FIL,C_ucErmDefaultChannel,ErrorNum,C_lErmNoDebugData,C_ucErmOpenInfoWindow,C_ucAllowStopForDebug, Message);\
 } \
 else \
 { \
  M_FILFatalError(E_uwFILWarningErrorIsNotAWarningError); \
 } \
}
 
#define __FATAL_ERR_INPUT__
#define __INFORMATION_ERR_INPUT__ /**** Treat as a level 1 warning ****/
#define __WARNING_ERR_INPUT__     /**** Treat as a level 2 warning ****/
 
enum e_uwFILErrNumber
{
 E_uwFILFatalErr,
 #if defined(__FATAL_ERR_INPUT__)
 /**** Error's errors ****/
 E_uwFILFatalErrorNotAFatalError,
 E_uwFILInformationErrorIsNotAInformationError,
 E_uwFILWarningErrorIsNotAWarningError,
 E_uwFILConcatCheckSumOpen,
 E_uwFILConcatCheckSumRead,
 #endif /*__FATAL_ERR_INPUT__*/
 
 E_uwFILStartOfWarning,
 
 #if defined(__WARNING_ERR_INPUT__)
 #endif /*__WARNING_ERR_INPUT__*/
 
 E_uwFILStartOfInformationWarning,
 
 #if defined(__INFORMATION_ERR_INPUT__)
 E_uwFILBadBmpFormat,
 E_uwFILBadTgaFormat,
 E_uwFILInvalidGFVersion,
 #endif /*__INFORMATION_ERR_INPUT__*/
 
	E_uwFILErrNumber,
};
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef EXTERN
#undef extern
#undef LOCAL
#if !defined(D_FIL_VariableDefine)
#define EXTERN extern /*external declaration*/
#define LOCAL /*replace by nothing : we have to declare*/
#else /* D_FIL_VariableDefine */
#define EXTERN /*replace by nothing : we have to declare*/
#define LOCAL /*replace by nothing : we have to declare*/
#endif /* D_FIL_VariableDefine */
 
EXTERN unsigned char g_ucFILModuleId /* number of identification of the Game module*/
#if defined(D_FIL_VariableDefine)
= C_ucModuleNotInitialized
#endif /* D_FIL_VariableDefine */
;
 
#if defined(__ERROR_STRINGS__)
 
EXTERN CPA_EXPORT char * g_a_szFILInformationModule []
#if defined(D_FIL_VariableDefine) && !defined(CPA_WANTS_IMPORT)
= {C_szFILVersion, C_szFILFullName, C_szFILDate}
#endif /* D_FIL_VariableDefine &&  CPA_WANTS_IMPORT */
;
 
EXTERN char * g_szFILModuleName /* Obliged syntax 'sz'+[Abbreviation of ModuleName]+'ModuleName'*/
#if defined(D_FIL_VariableDefine)
= {"FIL"}
#endif /* D_FIL_VariableDefine */
;
 
EXTERN tdstErrorMsg g_a_stFILTabErr[] /* Obliged syntax 'a_sz'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(D_FIL_VariableDefine)
=
{
 #if defined(__FATAL_ERR_INPUT__)
 /**** Error's errors ****/
 E_uwFILFatalErrorNotAFatalError,"M_FILFatalError : try to raise a warning or an information",
 E_uwFILInformationErrorIsNotAInformationError,"M_FILInformationError : try to raise a fatal or a warning",
 E_uwFILWarningErrorIsNotAWarningError,"M_FILWarningError : try to raise a fatal or a information",
 E_uwFILConcatCheckSumOpen,"FIL_fn_vOpenConcatFile : File integrity fault when open :",
 E_uwFILConcatCheckSumRead,"FIL_fn_hOpenFileInConcatFile : File integrity fault when read :",
 #endif /*__FATAL_ERR_INPUT__*/
 
 #ifdef __WARNING_ERR_INPUT__
 #endif /*__WARNING_ERR_INPUT__*/
 
 #ifdef __INFORMATION_ERR_INPUT__
 E_uwFILBadBmpFormat,"Bad Bmp format",
 E_uwFILBadTgaFormat,"Bad Tga format",
 E_uwFILInvalidGFVersion,"Bad GF format",
 #endif /*__INFORMATION_ERR_INPUT__*/
 
	0xffff,"\0"/*fin*/
}
#endif /* D_FIL_VariableDefine */
;
#endif /* __ERROR_STRINGS__ */
 
#undef EXTERN
#undef extern
 
#endif /* !__ErmFIL_h__ */
