/* (c) Ubi R&D 1997*/
/* See Alain Robin for any comment or question*/
 
/* Here, we declare the private implementations for the virtual functions */
 
#ifndef __GMTVPROT_H__
#define __GMTVPROT_H__
 
/*----------------------------------------------------------------------------
//	Description : GMT_fn_hCreateFor3DOS
//	To create an empty game material handle
//----------------------------------------------------------------------------
//  Input :		
//  Output : Handle to the created game material
----------------------------------------------------------------------------*/
extern GMT_tdxHandleToGameMaterial GMT_fn_hCreateFor3DOS(void);
 
/*----------------------------------------------------------------------------
//	Description : GMT_fn_vDestroyFor3DOS
//	Delete a created game material handle
//----------------------------------------------------------------------------
//  Input :		_hOld : game material handle to delete
//  Output :	
----------------------------------------------------------------------------*/
extern void GMT_fn_vDestroyFor3DOS(GMT_tdxHandleToGameMaterial _hOld);
 
/*----------------------------------------------------------------------------
//	Description : GMT_fn_vCopyFor3DOS
//	Used to copy an existing game material
//----------------------------------------------------------------------------
//  Input :		_hSrc : source game material
//  Output :	_hDst : copied game material
----------------------------------------------------------------------------*/
extern void GMT_fn_vCopyFor3DOS(GMT_tdxHandleToGameMaterial _hDst, GMT_tdxHandleToGameMaterial _hSrc);
 
/*----------------------------------------------------------------------------
//	Description : GMT_fn_hCreateForA3D
//	To create an empty game material handle
//----------------------------------------------------------------------------
//  Input :		
//  Output : Handle to the created game material
----------------------------------------------------------------------------*/
/*extern GMT_tdxHandleToGameMaterial GMT_fn_hCreateForA3D(void);*/
 
/*----------------------------------------------------------------------------
//	Description : GMT_fn_vDestroyForA3D
//	Delete a created game material handle
//----------------------------------------------------------------------------
//  Input :		_hOld : game material handle to delete
//  Output :	
----------------------------------------------------------------------------*/
extern void GMT_fn_vDestroyForA3D(GMT_tdxHandleToGameMaterial _hOld);
 
/*----------------------------------------------------------------------------
//	Description : GMT_fn_vCopyForA3D
//	Used to copy an existing game material
//----------------------------------------------------------------------------
//  Input :		_hSrc : source game material
//  Output :	_hDst : copied game material
----------------------------------------------------------------------------*/
extern void GMT_fn_vCopyForA3D(GMT_tdxHandleToGameMaterial _hDst, GMT_tdxHandleToGameMaterial _hSrc);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vInitLoadGameMaterialFor3DOS
//  Loading process initialization for 3DOS
----------------------------------------------------------------------------//
//  Input :             
//  Output : 
----------------------------------------------------------------------------*/
extern void  GMT_fn_vInitLoadGameMaterialFor3DOS(void);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vInitLoadGameMaterialForA3D
//  Loading process initialization for A3D
----------------------------------------------------------------------------//
//  Input :             
//  Output : 
----------------------------------------------------------------------------*/
extern void  GMT_fn_vInitLoadGameMaterialForA3D(void);
 
/*----------------------------------------------------------------------------
//  Description : fn_eScriptCallBackGameMaterial
//  Reads the script file describing a game material 
----------------------------------------------------------------------------//
//  Input :  script input           
//  Output : script output
----------------------------------------------------------------------------*/
#if !defined(U64)
SCR_tde_Anl_ReturnValue fn_eScriptCallBackGameMaterial(
                                                     SCR_tdst_File_Description *p_stHandle,
                                                     char *szAction,
                                                     char *d_szPars[],
                                                     SCR_tde_Anl_Action eAction);
 
/*BEGIN OS 4/3/98*/
 
SCR_tde_Anl_ReturnValue fn_eScriptCallBackBinGameMaterial(
                                                     SCR_tdst_File_Description *p_stHandle,
                                                     char *szAction,
                                                     char *d_szPars[],
                                                     SCR_tde_Anl_Action eAction);
 
/*END OS 4/3/98*/
#endif /* U64 */
 
#endif /*__GMTVPROT_H__*/
