/* DevVpt.h*/
/* Prototypes and structures for Dev&Vpt.cpp*/
/* Author : Christophe MARTINAUD*/
/* Last update : 07/19/1996*/
/* Last update : 01/28/1997*/
 
#ifndef __DEVVPT_H
#define __DEVVPT_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/*#include <d3dtypes.h >*/
 
#define C_NB_MAX_DEVICES            16
#define C_NB_MAX_VPT_IN_DEV         16
#define C_NB_MAX_SETS_OF_RASTERS    16
 
/* Handle conversion macro*/
#define M_GLD_ParentDeviceHandle( hViewport ) (GLD_tdhDevice)((hViewport) / C_NB_MAX_VPT_IN_DEV); 
 
/* OldVP depends of the device, VP do not */
#define M_GLD_OldViewportHandle( hViewport ) (GLD_tdhViewport)( (hViewport) % C_NB_MAX_VPT_IN_DEV ); 
#define M_GLD_NewViewportHandleFromOld( hDevice, hViewport ) (GLD_tdhViewport)( ((hDevice) * C_NB_MAX_VPT_IN_DEV) + (hViewport) ); 
 
/* Viewport */
typedef struct GLD_stViewport
{
    GLD_tdstViewportAttributes      stViewAttrib;       /* Viewport Attributes*/
    BOOL                            bIsLocked;          /* Access to viewport will be denied when TRUE*/
} GLD_tdstViewport, *GLD_tdpstViewport;
 
 
/* Device */
typedef struct GLD_stDevice
{
    GLD_tdstDeviceAttributes    stDevAttrib;                            /* Device attributes*/
    GLD_tdpstViewport           pstViewports[ C_NB_MAX_VPT_IN_DEV ];    /* Viewports of device*/
    BOOL                        bIsLocked;                              /* Access to device will be denied when TRUE*/
    DWORD                       dwStyleBeforeSwap;
    DWORD                       dwExStyleBeforeSwap;
    RECT                        rcWindowBeforeSwap;
    DWORD                       dwBackgroundColor;                      /* Background Color*/
} GLD_tdstDevice, *GLD_tdpstDevice;
 
 
BOOL GLD_fn_bChangeDeviceDisplayMode( GLD_tdhDevice hDev );

#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* __DEVVPT_H*/
