/*
 =======================================================================================
  Name        : DLLCaps.h
  Author      : vincent lhullier            Date :23/09/98
  Description : Constant for DLL capabilities
 =======================================================================================
 */
 
#ifndef __DLLCAPS_H__
#define __DLLCAPS_H__
 
/*
 =======================================================================================
    Constant for Caps1 
 =======================================================================================
 */
#ifdef __cplusplus
extern "C" 
{
#endif
 
/*
 =======================================================================================
    Constants 
 =======================================================================================
 */
 
#define GLICAPS_DRV_C_ulIsHardware              0x00000001 
#define GLICAPS_DRV_C_ulCanUseAGP               0x00000002
#define GLICAPS_DRV_C_ulCanUseSystemMemory      0x00000004
#define GLICAPS_DRV_C_ulCanBeWindowed           0x00000008
#define GLICAPS_DRV_C_ulSupportAlphaTest        0x00000010
#define GLICAPS_DRV_C_ulReadjustViewport        0x00000020
 
#define GLICAPS_TEX_C_ulSupport8P               0x00000001
#define GLICAPS_TEX_C_ulSupportNonSquare        0x00000002
#define GLICAPS_TEX_C_ulSupportMipmap           0x00000004
#define GLICAPS_TEX_C_ulSupportMirror			0x00000008
 
/*
 * constant for request to DLL
 */
#define GLIDLL_Request_ReloadTexture            1
 
/*
 =======================================================================================
    Structures
 =======================================================================================
 */
typedef struct tdstGliCaps_
{
    unsigned long   ulSize;
    unsigned long   ulDriverCaps;
    unsigned long   ulTextureCaps;
    unsigned long   ulSurfaceCaps;
    unsigned long   ulMemoryCaps;
    unsigned long   ulTextureMaxSize;
    unsigned long   ulTotalTextureMemory;
    unsigned long   ulTotalVideoMemory;
    unsigned long   ulTotalAGPMemory;
    unsigned char   ucPrimarySurfacePixelFormat;
    float           fRefreshRate;
} tdstGliCaps;
 
/*
 =======================================================================================
    Globals
 =======================================================================================
 */
 
extern tdstGliCaps   GLI_g_stCaps;
 
 
 
#ifdef __cplusplus
} /*extern "C"*/
#endif
 
 
#endif /*__DLLCAPS_H__*/
