/* File: DrawFlags.h*/
/* Author: Steve McCalla*/
/* Date:	9 Sept 1998*/
/* these flags tell us which functions are called.*/
/* This allows us to find the common sets of functions and group them, saving thousands of*/
/* function calls and helping out our poor little 8k DCache on the Pentium.*/
/* When you want to find out which functions are called, just print the flag out */
/* to the error.log before calling the first func. Attention: ca va ramer quand tu le fais!*/
/**/
 
#ifndef DRAW_FLAGS_H
#define DRAW_FLAGS_H
 
 
#define		Flag_GLI_vSetSpecular						(1<<0)
#define		Flag_GLI_vComputeXYZ						(1<<1)
#define		Flag_GLI_FastZCull							(1<<3)
#define		Flag_GLI_FastMirrorCulling					(1<<4)
#define		Flag_GLI_bCullingXYALL						(1<<5)
#define		Flag_GLI_bCullingXMin						(1<<6)
#define		Flag_GLI_bCullingXMax						(1<<7)
#define		Flag_GLI_bCullingXMax_XMin					(1<<8)
#define		Flag_GLI_bCullingYMin						(1<<9)
#define		Flag_GLI_bCullingYMax						(1<<10)
#define		Flag_GLI_bCullingYMax_YMin					(1<<11)
#define		Flag_GLI_FastWaterCLipping					(1<<12)
#define		Flag_GLI_FastMirrorCLipping					(1<<13)
#define		Flag_GLI_vZClipping							(1<<14)
#define		Flag_GLI_TestBackfaceClockwise				(1<<15)
#define		Flag_GLI_TestBackfaceCounterClockwize		(1<<16)
#define		Flag_GLI_XMaxCLipping						(1<<17)
#define		Flag_GLI_XMinCLipping						(1<<18)
#define		Flag_GLI_YMinCLipping						(1<<20)
#define		Flag_GLI_YMaxCLipping						(1<<21)
#define		Flag_GLI_vComputeMirrorUVW					(1<<23)
#define		Flag_GLI_vComputeMovingUVW					(1<<24)
#define		Flag_GLI_vComputeNormalUVW					(1<<25)
#define		Flag_GLI_vZSortTriangle						(1<<26)
#define		Flag_GLI_vDrawWiredTriangle					(1<<27)
#define		Flag_GLI_vDrawTriangle						(1<<28)
#define		Flag_GLI_vCorrect3DFXBug1					(1<<29)
 
 
/* These values were determined experimentally - they may change as the maps change*/
#define		MaskBigFunc1	(Flag_GLI_vSetSpecular|Flag_GLI_vComputeXYZ|Flag_GLI_TestBackfaceClockwise|Flag_GLI_vComputeNormalUVW|Flag_GLI_vDrawTriangle|Flag_GLI_vCorrect3DFXBug1)
 
/* this variable is defined in ClipTriangles.c*/
extern unsigned long ulFuncMask;
 
 
 
 
#endif /*DRAW_FLAGS_H*/
