/*
 =======================================================================================
  Name        : TexArray.h
  Author      : Gliglou corporation
  Description : manage array of texture data
 =======================================================================================
 */
#ifndef __TEXARRAY_H__
#define __TEXARRAY_H__
 
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#include "texture.h"
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
 
/*
 =======================================================================================
    Globals
 =======================================================================================
 */
 
/*
 * array of texture / texture state
 */
extern GLI_tdstTexture *gs_aDEFTableOfTextureAlreadyRead [ GLI_C_lNBMaxOfTextures ];
extern long            gs_aDEFTableOfTextureMemoryChannels[ GLI_C_lNBMaxOfTextures ];
extern unsigned long   GLI_g_ulNumberOfLoadedTexture;
 
/*
 =======================================================================================
    Functions
 =======================================================================================
 */
 
void GLI_fn_vUnallocTextureInChannel( unsigned char _ucChannel );
void GLI_fn_vUnallocAllTextures( void );
long GLI_lComputeTexturesSize( void );
long GLI_lGetBigestSizeOfTexture( void );
void GLI_vUnCompressExistantTexture(void);

GLI_tdstTexture *TEX_fnpst_DoesTextureExist( char *_szFileName );
void             TEX_fnv_MakeItExisting( GLI_tdstTexture *_pst_TextureCreated );
 
#endif /*__TEXARRAY_H__*/
