/////////////////////////////////////////////////////////////
//														   //
//			Management of the Module : Interface  	       //
//									                       //
/////////////////////////////////////////////////////////////
//									                       //
// abbreviation of the module-name. Used in macro is 'Int' //
//									                       //
/////////////////////////////////////////////////////////////

#ifndef __ERRINT_H__
#define __ERRINT_H__

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************


#include "ERM.h"

#define C_szIntVersion "Int V5.0.0" /* The format is XXX Va.b.c with Xxx is the Tag of the module */
#define C_szIntFullName  "Interface"/* the complete and clear name of the module */
#define C_szIntDate __DATE__ /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/

#define __FATAL_ERR_INT__
#define __WARNING1_ERR_INT__
//----------
// Constant	 
//----------
// error of the Int Module
enum e_uwIntErrNumber{
	E_uwIntFatalErr,	
#ifdef __FATAL_ERR_INT__
//     -----------------
	E_uwIntFatalPbInit,	 
#endif //__FATAL_ERR_INT__
	E_uwIntStartOfWarning,// important constant, it allows to recognize if an error is fatal or not.
#ifdef __WARNING1_ERR_INT__
//     -------------------
	E_uwIntWarningPbFree,	
#endif //__WARNING1_ERR_INT__
	E_uwIntErrNumber
};

//------------------
// Global Variables
//------------------
#undef EXTERN
#ifndef __DeclareGlobalVariableErrInt_h__
#define EXTERN extern /*external declaration*/
#else //__DeclareGlobalVariableErrInt_h__
#define EXTERN /*replace by nothing : we have to declare*/
#endif //__DeclareGlobalVariableErrInt_h__


EXTERN CPA_EXPORT unsigned char g_ucIntModuleId /*number of identification of the Erm module*/
#ifdef __DeclareGlobalVariableErrInt_h__
= C_ucModuleNotInitialized
#endif //__DeclareGlobalVariableErrInt_h__
;

#ifdef __ERROR_STRINGS__

EXTERN CPA_EXPORT  char * g_a_szIntInformationModule []
#ifdef __DeclareGlobalVariableErrInt_h__
= {C_szIntVersion, C_szIntFullName, C_szIntDate}
#endif //__DeclareGlobalVariableErrInt_h__
;

EXTERN CPA_EXPORT char * g_szIntModuleName /* Obliged syntax 'g_sz'+[Abbreviation of ModuleName]+'ModuleName'*/
#ifdef __DeclareGlobalVariableErrInt_h__
= "Module Interface"
#endif //__DeclareGlobalVariableErrInt_h__
;

EXTERN CPA_EXPORT tdstErrorMsg g_a_stIntTabErr [] 	/* Obliged syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#ifdef __DeclareGlobalVariableErrInt_h__//Call from main program
={ 
#ifdef __FATAL_ERR_INT__   
//	 -------------
	E_uwIntFatalPbInit, "The memory allocation in the initialization of world fails",
#endif //__FATAL_ERR_INT__
#ifdef __WARNING1_ERR_INT__
//	 ----------------
	E_uwIntWarningPbFree, "Can not free interface memory",	
#endif //__WARNING1_ERR_INT__
	0xFFFF, "\0"//fin
};
#endif //__DeclareGlobalVariableErrInt_h__
;

#endif //__ERROR_STRINGS__
#endif //__ERRINT_H__
