/*=========================================================================
 * MemInt.h : Manage the memory allocation for CPA module.
 * This is a part of the CPA project.
 *
 * Version              1.0
 * Creation date        03/10/96
 * Revision date
 * Author : Olivier Didelot
 *
 * (c) Ubi Studios 1996
 *=======================================================================*/

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************

#ifndef __MemInt_H__
#define __MemInt_H__

#include "MMG.h"

enum e_ucIntStaticBlocks{
	E_ucIntBlock1, 
	E_ucIntBlock2,
	E_ucIntBlock3,	   
	E_ucIntBlock4,	   
	E_ucIntMaxBlocksNb  // maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'
};

#undef EXTERN
#ifdef __DeclareGlobalVariableMemInt_h__
#define EXTERN /*nothing*/
#else // no __DeclareGlobalVariableMemInt_h__
#define EXTERN extern
#endif //__DeclareGlobalVariableMemInt_h__

EXTERN CPA_EXPORT tdstBlockInfo g_a_stIntBlocksInfo[E_ucIntMaxBlocksNb];

#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN CPA_EXPORT tdstDynInfo g_stIntDynInfo;
#endif //__DEBUG_MALLOC_MODE__
#endif //__DYNAMIC_MALLOC_ALLOWED__

#endif //__MemInt_H__
