/*///////////////////////////////////////////////////////////*/
/**/
/*			Management of the Module : Net*/
/**/
/* File Name	: ErrNet.h*/
/* Date			: 03/10/96*/
/* Author		: First_Name Last_Name*/
/**/
/*///////////////////////////////////////////////////////////*/
/**/
/* abbreviation of the module-name. Used in macro is 'Net'*/
/**/
/*///////////////////////////////////////////////////////////*/
 
#ifndef __ERRNET_H__
#define __ERRNET_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
#define C_szNetVersion "NET V3.0.7"
#define C_szNetFullName  "NetLib 3"
#define C_szNetDate __DATE__
 
 /* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "ERM.h"
 
#define __FATAL_ERR_NET__
#define __WARNING_ERR_NET__
#define __OTHER_ERR_NET__
/*----------*/
/* Constant	 */
/*----------*/
/* error of the Net Module*/
typedef enum e_uwNetErrNumber_{
	E_uwNetFatalErr,	
#ifdef __FATAL_ERR_NET__
/*     -----------------*/
	E_uwNetFatalError1,	 
	/*...*/
#endif /*__FATAL_ERR_NET__*/
	E_uwNetStartOfWarning,/* important constant, it allows to recognize if an error is fatal or not.*/
#ifdef __WARNING_ERR_NET__
/*     -------------------*/
	E_uwNetWarningError1,	
#endif /*__WARNING_ERR_NET__*/
#ifdef __OTHER_ERR_NET__
/*     -------------------*/
	E_uwNetOtherError1,	
	/*...*/
#endif /*__OTHER_ERR_NET__*/
	E_uwNetErrNumber
} e_uwNetErrNumber;
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef EXTERN
#ifndef __DeclareGlobalVariableErrNet_h__
#define EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableErrNet_h__*/
#define EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableErrNet_h__*/
 
EXTERN CPA_EXPORT  unsigned char g_ucNetModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrNet_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif /*__DeclareGlobalVariableErrNet_h__&& CPA_WANTS_IMPORT*/
;
 
#ifdef __ERROR_STRINGS__
 
EXTERN CPA_EXPORT  char * g_a_szNetInformationModule []
#if defined(__DeclareGlobalVariableErrNet_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szNetVersion, C_szNetFullName, C_szNetDate}
#endif /*__DeclareGlobalVariableErrXxx_h__ &&  CPA_WANTS_IMPORT*/
	;
 
EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stNetTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrNet_h__) && !defined(CPA_WANTS_IMPORT)
={ 
#ifdef __FATAL_ERR_NET__   
/*	 -------------*/
	E_uwNetFatalError1, " text of the error # E_uwNetFatalError1 ",
	/*...*/
#endif /*__FATAL_ERR_NET__*/
#ifdef __WARNING_ERR_NET__
/*	 ----------------*/
	E_uwNetWarningError1, " text of the error # E_uwNetWarningError1 ",	
	/*...*/
#endif /*__WARNING_ERR_NET__*/
#ifdef __OTHER_ERR_NET__
/*	 ----------------*/
	E_uwNetOtherError1, " text of the error # E_uwNetOtherError1 ",
	/*...*/
#endif /*__OTHER_ERR_NET__*/
	0xFFFF, "\0"/*fin*/
};
#endif /*__DeclareGlobalVariableErrNet_h__ && CPA_WANTS_IMPORT*/
;
 
#endif /*__ERROR_STRINGS__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__ERRNET_H__*/
