/********************************************************************************/
/*																				*/
/* L0GlDef.c																	*/
/*																				*/
/*	This file defines the default (void) protocol interface						*/
/*																				*/
/********************************************************************************/
 
#include "warnings.h"
#include "l0gldef.h"
 
/*
////////////////////////////////////////////////////////////////////////////////
Description : vNetFillInvalidProtocolInterface
Fill tyhe tdstNetProtocolInterface with functions corresponding to an invalid
status
////////////////////////////////////////////////////////////////////////////////
Input :
a pointer to a p_stInvalidProtocol
////////////////////////////////////////////////////////////////////////////////
Output :
NetLib_E_es_NoError if no error occured
////////////////////////////////////////////////////////////////////////////////
Author : Albert Pais
////////////////////////////////////////////////////////////////////////////////
*/
void vNetFillInvalidProtocolInterface(tdstNetProtocolInterface *p_stInvalidProtocol)
{
  p_stInvalidProtocol->eProtocol = E_Net_pr_InvalidProtocol;
  p_stInvalidProtocol->fn_uwStartChannelScan = uwNetL0InvalidStartChannelScan;
  p_stInvalidProtocol->fn_uwStartBroadcastChannelScan = uwNetL0InvalidStartBroadcastChannelScan;
  p_stInvalidProtocol->fn_uwNextChannel = (tdfn_uwNextChannelScan)C_pNull;
  p_stInvalidProtocol->fn_uwNextBroadcastChannel = (tdfn_uwNextChannelScan)C_pNull;
  p_stInvalidProtocol->fn_eReadData = (tdfn_eReadData)C_pNull;
  p_stInvalidProtocol->fn_eSendData = (tdfn_eSendData)C_pNull;
  p_stInvalidProtocol->fn_eQueryChannelStatus = eNetL0InvalidQueryChannelStatus;
  p_stInvalidProtocol->fn_vCloseChannel = (tdfn_vCloseChannel)C_pNull;
  p_stInvalidProtocol->fn_vLevel0NetEngine = (tdfn_vLevel0NetEngine)C_pNull;
  p_stInvalidProtocol->fn_vLevel0CloseProtocol = (tdfn_vLevel0CloseProtocol)C_pNull;
  p_stInvalidProtocol->fn_eAddNewPlayer = (tdfn_eAddNewPlayer)C_pNull;
}
 
tduwNetChannel uwNetL0InvalidStartChannelScan(void)
{
 return C_uwNetInvalidChannel;
}
 
tduwNetChannel uwNetL0InvalidStartBroadcastChannelScan(void)
{
 return C_uwNetInvalidChannel;
}
 
NetLib_tdeErrorStatus eNetL0InvalidQueryChannelStatus(tduwNetChannel uwChannel)
{
 return NetLib_E_es_ProtocolNotInitialized;
}
