// CPACUnLt.hpp : header file
/////////////////////////////////////////////////////////////////////////////
#ifndef _ED_ACTOR_UNDO_LIST_DIALOG_
#define _ED_ACTOR_UNDO_LIST_DIALOG_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EdAcIRes.h"

class EdActors_EditorActor;

/////////////////////////////////////////////////////////////////////////////
// EdActors_UndoListBox window

class EdActors_UndoListBox : public CListBox
{
// Construction
public:
	EdActors_UndoListBox();

// Attributes
public:
	BOOL m_bMustUndo;

private:
	CRect m_crWindowRect;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EdActors_UndoListBox)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~EdActors_UndoListBox();

	// Generated message map functions
protected:
	//{{AFX_MSG(EdActors_UndoListBox)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

friend class EdActors_UndoRedoListDialog;
};

/////////////////////////////////////////////////////////////////////////////
// EdActors_UndoRedoListDialog dialog

class EdActors_UndoRedoListDialog : public CDialog
{
public:

	enum m_eUndoRedoListType
	{
		EDCAR_UNDOREDO_LIST_TYPE_UNDO = 0,
		EDCAR_UNDOREDO_LIST_TYPE_REDO,
	};

// Construction
public:		 
	// standard constructor
	EdActors_UndoRedoListDialog(CPoint clUpAndLeftPoint,
															m_eUndoRedoListType eType,
															CWnd* pParent = NULL);   
	
	~EdActors_UndoRedoListDialog();   

// Dialog Data
	//{{AFX_DATA(EdActors_UndoRedoListDialog)
	enum { IDD = IDD_CAR_D_UNDO_LIST };
	EdActors_UndoListBox	m_clListBox;
	//}}AFX_DATA

private:
	CPoint m_clUpAndLeftPoint;

	HINSTANCE m_hOldInstance;

	EdActors_EditorActor *m_pclEditorActor;

	m_eUndoRedoListType m_eType;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EdActors_UndoRedoListDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EdActors_UndoRedoListDialog)
	afx_msg void OnSelchangeListUndo();
	virtual BOOL OnInitDialog();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	//}}AFX_MSG

//	void OnOK();

	DECLARE_MESSAGE_MAP()

friend class EdActors_UndoListBox;
};

/////////////////////////////////////////////////////////////////////////////

#endif //_ED_ACTOR_UNDO_LIST_DIALOG_
