// Implementation file for the definition of a characteristic base type
////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

#include "EDACDatW.hpp"
#include "EDACActr.hpp"
#include "EDACCust.hpp"

//External Modules
#include "CTL.h"
//End of External Modules

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Constructor / Destructor
//************************************************************************
EdActors_WatchData::EdActors_WatchData(CTL_Editor_Data *pclData)
{
	m_csActorName = OAC_fn_pclGetParentActorOfData(pclData)->m_fn_csGetActorName();
	m_csCharacName = pclData->m_csScriptName;
	m_pclData = pclData;
}

//************************************************************************
EdActors_WatchData::~EdActors_WatchData()
{

}

//Member functions

//************************************************************************
CString EdActors_WatchData::m_fn_csGetActorName()
{
	return m_csActorName;
}

//************************************************************************
CString EdActors_WatchData::m_fn_csGetFieldName()
{
	return m_csCharacName;

}

//************************************************************************
CString EdActors_WatchData::m_fn_csGetDataValue()
{
	CString csReturnedString;
	CStringList *pclStringList = m_pclData->m_fn_pcslFormatDataValueString();

	POSITION pos = pclStringList->GetHeadPosition();
	while ( pos != NULL )
	{
		 csReturnedString += pclStringList->GetNext(pos);

		 if ( pos != NULL )
			csReturnedString += CString(" ; ");
	}
	
	return csReturnedString;
}
