// moduleinfodlg.cpp : implementation file
//

#include "stdafx.h"
#include "..\inc\edactors\EdAcIRes.h"
////
#include "_AInterf.hpp"
#include "IncGAM.h"
#include "TFa.h"
#include "DPT.h"

#include "EDACStrg.hpp"
#include "EDACInst.hpp"
#include "EDACModl.hpp"
#include "EDACVwAc.hpp"
#include "EDACDgIf.hpp"
#include "EDACDgQu.hpp"
#include "Defines.hpp"

//-----------------IR-------------------------
#include "EdIRStrg.hpp"
#include "EdIRFrm.hpp"
#include "EdIRDVVw.hpp"
#include "EdIRBeEn.hpp"
//--------------------------------------------

#include "EDACActr.hpp"


#include "OPD.h"
#include "OGd.h"

#include "ErO.h"

#undef CPA_WANTS_IMPORT
#undef CPA_EXPORT
#define CPA_WANTS_EXPORT
//-----------------IR-------------------------
		#include "EdIRIRD.hpp"
//--------------------------------------------
#include "_Actors.hpp"
#undef CPA_WANTS_EXPORT
#define CPA_WANTS_IMPORT

#include "moduleinfodlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CModuleInfoDlg dialog


CModuleInfoDlg::CModuleInfoDlg(CPA_SuperObject *pSuperObject, CWnd* pParent /*=NULL*/)
	: CDialog(CModuleInfoDlg::IDD, pParent)
{
	m_pSuperObject = pSuperObject;
	//{{AFX_DATA_INIT(CModuleInfoDlg)
	m_csFacesNumber = _T("");
	m_csSizeX = _T("");
	m_csSizeY = _T("");
	m_csSizeZ = _T("");
	m_csModuleName = _T("");
	//}}AFX_DATA_INIT
}


void CModuleInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModuleInfoDlg)
	DDX_Text(pDX, IDC_FACES_NUMBER, m_csFacesNumber);
	DDX_Text(pDX, IDC_SIZE_X, m_csSizeX);
	DDX_Text(pDX, IDC_SIZE_Y, m_csSizeY);
	DDX_Text(pDX, IDC_SIZE_Z, m_csSizeZ);
	DDX_Text(pDX, IDC_MODULE_NAME, m_csModuleName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CModuleInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CModuleInfoDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModuleInfoDlg message handlers

BOOL CModuleInfoDlg::OnInitDialog() 
{
	ComputeVariables ();
	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : ComputeVariables 
// Date   : 98-05
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian - CPA2
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CModuleInfoDlg::ComputeVariables ()
{
	ASSERT (m_pSuperObject);
	EditorPO *pPO = (EditorPO *)m_pSuperObject->GetObject ();
	ASSERT (pPO);
	m_csModuleName = pPO->GetName ();
	int iFacesNumber = mfn_iGetFacesNumber (pPO);
	m_csFacesNumber.Format ("%d", iFacesNumber);
	MTH3D_tdstVector tdstSize = mfn_GetSize (pPO);
	m_csSizeX.Format ("%f", tdstSize.xX);
	m_csSizeY.Format ("%f", tdstSize.xY);
	m_csSizeZ.Format ("%f", tdstSize.xZ);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : mfn_GetSize 
// Date   : 98-05
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian - CPA2
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
MTH3D_tdstVector CModuleInfoDlg::mfn_GetSize (EditorPO *pPO)
{
	ASSERT (pPO);
	MTH3D_tdstVector tdstSize;
	tdstSize.xX = tdstSize.xY = tdstSize.xZ = 0;
	Geometry3D *p3D = pPO->m_fnp_oGetGeometricWithDistance (0);
	if (p3D)
		tdstSize = p3D->mfn_3dvGetSizes ();

	return tdstSize;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : mfn_iGetFacesNumber 
// Date   : 98-05
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian - CPA2
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
int CModuleInfoDlg::mfn_iGetFacesNumber (EditorPO *pPO)
{	 
	ASSERT (pPO);
	ACP_tdxIndex iFacesNumber = 0;
	Geometry3D *p3D = pPO->m_fnp_oGetGeometricWithDistance (0);
	if (p3D)
		iFacesNumber = p3D->mfn_iGetFacesNumber ();

	return iFacesNumber;
}

