//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : ITView.h: interface for the CIndexedTriangleView class.
// Author      : 
// Date        : 
// Description :
////////////////////////////////////////////////////////////////////////////////////////
#ifndef __INDEXEDTRIANGLEVIEW_HPP__
#define __INDEXEDTRIANGLEVIEW_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// IndexedTriangleView.h : header file
//

class CTriEdit;
/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleView view

class CIndexedTriangleView : public CView
{
friend class CIndexedTriangleFrame;
protected:
	CIndexedTriangleView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CIndexedTriangleView)

// Attributes
public:
	CTriEdit *m_edit;

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIndexedTriangleView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CIndexedTriangleView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions

public:
//ROMTEAM WorldEditor (Cristian Stegaru 11/97)
	CTriEdit * mfn_pGetITEditor () { return m_edit;}
//ENDROMTEAM WorldEditor (Cristian Stegaru)
public:
	void SetLinearity(float l);
protected:
	void OnUndo();
	void OnRedo();
	void OnSave ();
	void OnHide (BOOL bHide);
	void OnExit ();
	void OnNewObject (int nX, int nY);
	int  CanUndo ();
	int  CanRedo ();

	//{{AFX_MSG(CIndexedTriangleView)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif //__INDEXEDTRIANGLEVIEW_HPP__
