//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : IndexedTriangleFrame.cpp : implementation file
// Author      : 
// Date        : 
// Description :
////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
//ROMTEAM WorldEditor (Cristian Stegaru 11/97)
#include "3DGe_res.h"       // main symbols
//ENDROMTEAM WorldEditor (Cristian Stegaru)
#include "EToolBar.h"
#include "ITFrame.h"
#include "ITView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleFrame

IMPLEMENT_DYNCREATE(CIndexedTriangleFrame, CFrameWnd)

CIndexedTriangleFrame::CIndexedTriangleFrame()
{
}

CIndexedTriangleFrame::~CIndexedTriangleFrame()
{
}


BEGIN_MESSAGE_MAP(CIndexedTriangleFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CIndexedTriangleFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_BT_NEW, OnNew)
	ON_COMMAND(ID_BT_SAVE, OnSave)
	ON_COMMAND(ID_BT_HIDE, OnHide)
	ON_COMMAND(ID_BT_UNDO, OnUndo)
	ON_COMMAND(ID_BT_REDO, OnRedo)
	ON_COMMAND(ID_BT_ONTOP, OnOnTop)
	ON_COMMAND(ID_BT_EXIT, OnExit)
	ON_UPDATE_COMMAND_UI(ID_BT_NEW, OnUpdateNewObject)
	ON_UPDATE_COMMAND_UI(ID_BT_SAVE, OnUpdateSave)
	ON_UPDATE_COMMAND_UI(ID_BT_HIDE, OnUpdateHide)
	ON_UPDATE_COMMAND_UI(ID_BT_UNDO, OnUpdateUndo)
	ON_UPDATE_COMMAND_UI(ID_BT_REDO, OnUpdateRedo)
	ON_UPDATE_COMMAND_UI(ID_BT_ONTOP, OnUpdateOnTop)
	ON_UPDATE_COMMAND_UI(ID_BT_EXIT, OnUpdateExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleFrame message handlers


//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnCreate
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
int CIndexedTriangleFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_wndToolBar.Init (this);
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY /*| CBRS_SIZE_DYNAMIC*/);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_TOP);
	EnableDocking(CBRS_ALIGN_TOP);
	DockControlBar(&m_wndToolBar, AFX_IDW_DOCKBAR_TOP);

	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnNew 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnNew ()
{
	int iXNb = 0, iYNb = 0;
	CString csName;
	((CEditorToolBar *)GetControlBar (IDW_TOOLBAR))->GetAttributes (iXNb, iYNb, csName);
	GetView ()->OnNewObject (iXNb, iYNb);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnSave 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnSave ()
{
	GetView ()->OnSave ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnHide 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnHide ()
{
	CToolBarCtrl &rToolBarCtrl = ((CEditorToolBar *)GetControlBar (IDW_TOOLBAR))->GetToolBarCtrl ();
	BOOL bHide = rToolBarCtrl.IsButtonChecked (ID_BT_HIDE);
	GetView ()->OnHide (bHide);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUndo 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUndo ()
{
	GetView ()->OnUndo ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnRedo 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnRedo ()
{
	GetView ()->OnRedo ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnOnTop 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnOnTop ()
{
	CToolBarCtrl &rToolBarCtrl = ((CEditorToolBar *)GetControlBar (IDW_TOOLBAR))->GetToolBarCtrl ();
	BOOL bTopMost = rToolBarCtrl.IsButtonChecked (ID_BT_ONTOP);
	const CWnd* pWndAfter = bTopMost? &wndTopMost : &wndNoTopMost;
	SetWindowPos (pWndAfter, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnExit 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnExit ()
{
	GetView ()->OnExit ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUpdateNewObject 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUpdateNewObject (CCmdUI* pCmdUI)
{
	pCmdUI->Enable ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUpdateSave 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUpdateSave (CCmdUI* pCmdUI)
{
	pCmdUI->Enable ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUpdateHide 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUpdateHide (CCmdUI* pCmdUI)
{
	pCmdUI->Enable ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUpdateUndo 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUpdateUndo (CCmdUI* pCmdUI)
{
	pCmdUI->Enable (0 < GetView ()->CanUndo ());
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUpdateRedo 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUpdateRedo (CCmdUI* pCmdUI)
{
	pCmdUI->Enable (0 < GetView ()->CanRedo ());
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUpdateOnTop 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUpdateOnTop (CCmdUI* pCmdUI)
{
	pCmdUI->Enable ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUpdateExit 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleFrame::OnUpdateExit (CCmdUI* pCmdUI)
{
	pCmdUI->Enable ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : GetView 
// Date   : November 1997
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Stegaru Cristian
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
CIndexedTriangleView* CIndexedTriangleFrame::GetView ()
{
	return (CIndexedTriangleView*)GetActiveView ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : mfn_pGetITEditor ()
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
CTriEdit * CIndexedTriangleFrame::mfn_pGetITEditor () 
{ 
	CIndexedTriangleView* pView = GetView ();
	if (pView)
		return pView->mfn_pGetITEditor ();

	return NULL;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : mfn_csGetITName ()
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
CString	CIndexedTriangleFrame::mfn_csGetITName ()
{
	m_wndToolBar.UpdateData ();
	return m_wndToolBar.GetName ();
}

