//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : IndexedTriangleView.cpp : implementation file
// Author      : 
// Date        : 
// Description :
////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ctriedit.h"
#include "ITView.h"
//ROMTEAM WorldEditor (Cristian Stegaru 11/97)
#include "ACP_Base.h"
#include "incITF.h"			// interface
#include "incGAM.h"
#include "3DInterf.hpp"
#include "EdThread.h"
#include "EToolBar.h"
#include "ITFrame.h"
//ENDROMTEAM WorldEditor (Cristian Stegaru)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleView

IMPLEMENT_DYNCREATE(CIndexedTriangleView, CView)

CIndexedTriangleView::CIndexedTriangleView()
{
	m_edit = new CTriEdit;
}

CIndexedTriangleView::~CIndexedTriangleView()
{
	delete m_edit;
}


BEGIN_MESSAGE_MAP(CIndexedTriangleView, CView)
	//{{AFX_MSG_MAP(CIndexedTriangleView)
	ON_WM_KEYDOWN()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleView drawing

void CIndexedTriangleView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
	if(m_edit) m_edit->OnPaint(pDC->m_hDC);
}

/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleView diagnostics

#ifdef _DEBUG
void CIndexedTriangleView::AssertValid() const
{
	CView::AssertValid();
}

void CIndexedTriangleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleView message handlers


BOOL CIndexedTriangleView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CView::PreCreateWindow(cs);
}

//Stegaru Cristian(SC)/November/97
void CIndexedTriangleView::SetLinearity(float l)
{
	ASSERT (m_edit);
	m_edit->SetLinearity (l);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnUndo()
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleView::OnUndo() 
{
	ASSERT (m_edit);
	m_edit->OnUndo();
}	

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnRedo()
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleView::OnRedo() 
{
	ASSERT (m_edit);
	m_edit->OnRedo();
}	

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnSave 
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleView::OnSave ()
{
	ASSERT (m_edit);
	CWinThread *pCurrentThread = AfxGetThread ();
	ASSERT (pCurrentThread);
	CIndexedTriangleFrame *pFrame = (CIndexedTriangleFrame*)GetParentFrame ();
	ASSERT (pFrame);
	((CEdThread*)pCurrentThread)->mfn_bCreateITObject (m_edit, pFrame->mfn_csGetITName ());
	PostQuitMessage (0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnHide 
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleView::OnHide (BOOL bHide)
{
	ASSERT (m_edit);
	m_edit->SetVisibility (bHide);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnExit 
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleView::OnExit ()
{
	AfxEndThread (0);	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : OnNewObject 
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void CIndexedTriangleView::OnNewObject (int nX, int nY)
{
	ASSERT (m_edit);
	m_edit->InitMesh(nX, nY);	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : CanUndo 
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
int  CIndexedTriangleView::CanUndo ()
{
	ASSERT (m_edit);
	return m_edit->CanUndo ();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : CanRedo 
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description :
// Author      : Cristian Stegaru
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
int  CIndexedTriangleView::CanRedo ()
{
	ASSERT (m_edit);
	return m_edit->CanRedo ();
}


BOOL CIndexedTriangleView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	BOOL retval = CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
	m_edit->SetHWnd(m_hWnd);
	return retval;
}


void CIndexedTriangleView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch(nChar)
	{	case VK_LEFT:	m_edit->Rotate(-3, 0); break;
		case VK_RIGHT: m_edit->Rotate(3, 0); break;
		case VK_UP:	m_edit->Rotate(0, -3); break;
		case VK_DOWN:	m_edit->Rotate(0, 3); break;
	}
	Invalidate();
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CIndexedTriangleView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	m_edit->Resize(cx, cy);	
}

BOOL CIndexedTriangleView::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;	
	return CView::OnEraseBkgnd(pDC);
}

BOOL CIndexedTriangleView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	POINT p;
	GetCursorPos(&p);
	ScreenToClient(&p);
	if(m_edit && m_edit->OnSetCursor(p.x, p.y))
	{ SetCursor(AfxGetApp()->LoadStandardCursor(IDC_UPARROW));	
		return 1;
	}
	else return CView::OnSetCursor(pWnd, nHitTest, message);
}

void CIndexedTriangleView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_edit->OnLButtonDown(nFlags, (POINT)point);	
	CView::OnLButtonDown(nFlags, point);
}

void CIndexedTriangleView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_edit && nFlags & MK_LBUTTON) m_edit->OnMouseMove(point);	
	CView::OnMouseMove(nFlags, point);
}

void CIndexedTriangleView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_edit->OnLButtonUp(nFlags, point);	
	CView::OnLButtonUp(nFlags, point);
}


