//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : Sphere3D.cpp: implementation of the Sphere3D class.
// Author      : Cristi Petrescu
// Date        : 97.11
// Description :
////////////////////////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "ACP_Base.h"

#include "ITF.h"
#include "incGAM.h"
#include "GLI.h"
#include "DPT.h"

#undef CPA_WANTS_IMPORT
#undef CPA_EXPORT
#define CPA_WANTS_EXPORT
    #include "OGD.h"
#undef CPA_WANTS_EXPORT
#ifndef CPA_WANTS_IMPORT
#define CPA_WANTS_IMPORT
#endif

#include "3dinterf.hpp"
#include "DlgSph3D.hpp"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method : Sphere3D::Sphere3D
// Date   : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : constructors to create a new object
//		make one for each Geometry3D one. No general constructor :-(
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
Sphere3D::Sphere3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, /*ACP_tdxIndex xNbPoints, ACP_tdxIndex xNbElements,*/ const CString _csName , tdeSaveStatus _eStatus )
	: Shape3D (bModifiable, _p_oEditor, 1, 1, _csName , _eStatus)
{
	CommonSphere3D ();
}

Sphere3D::Sphere3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, /*ACP_tdxIndex xNbPoints, ACP_tdxIndex xNbElements,*/ CPA_BaseObject *_p_oOwnerFile, const CString _csName /*= ""*/, char *_p_cRefPath /*= NULL*/, tdeSaveStatus _eStatus /*= E_ss_Responsible*/)
	: Shape3D (bModifiable, _p_oEditor, 1, 1, _p_oOwnerFile, _csName, _p_cRefPath, _eStatus)
{
	CommonSphere3D ();
}

/****????*****///rezolvat ?? ionut
Sphere3D::Sphere3D (BOOL bModifiable, CPA_EditorBase *_p_oEditor, CPA_BaseObject *_p_oOwnerFile, ACP_tdxHandleOfObject _hObject, const CString _csName /*= ""*/, char *_p_cRefPath /*= NULL*/, tdeSaveStatus _eStatus /*= E_ss_Modify*/)
	: Shape3D (bModifiable, _p_oEditor, _p_oOwnerFile, _hObject, _csName, _p_cRefPath, _eStatus)
{
	// this seems to be used at load time.
	// so do not alter the data!
	// CommonSphere3D ();
}

// ----------------------------------------------------------------------------
// Description : common implementation for the constructors
// ----------------------------------------------------------------------------
void Sphere3D::CommonSphere3D( )
{
	// initialise with dummy data
 
	MTH3D_tdstVector stCenterPoint = { 0 , 0 , 0 };
	fn_vSetListOfPoints  (1 , & stCenterPoint);
	m_hElement =  fn_hCreateElementSpheres (1); /****!!!!****/
	fn_eSetIndexedSphere (m_hElement , 0 , 0 , (float) 0.1);                
	fn_vEndCreation ();
}

Sphere3D::~Sphere3D()
{

}

/*
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D - _OnKeyDown
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : Default: we do not use the message
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL Sphere3D::_OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D - _OnKeyUp
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : Default: we do not use the message
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL Sphere3D::_OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	return FALSE;
}
*/

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D - _OnMouseMove
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : Change the size of the sphere if CTRL key is pressed
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL Sphere3D::_OnMouseMove(UINT nFlags, tdstMousePos * p_stPos, MTH3D_tdstVector * pDeplacement)
{
	if (Shape3D::_OnMouseMove (nFlags, p_stPos, pDeplacement))
	{
//CPA2 Corneliu Babiuc 11-04-98
		//reactualize global selected point to fit on sphere contour
		MTH3D_tdstVector stTempVertex;
		MTH3D_tdstVector stCopyGlobalSelectedPoint = m_stGlobalSelectedPoint;

		//compute the new norme
		MTH3D_M_vSubVector(&stTempVertex, &m_stGlobalSelectedPoint, &m_stCenterInMousePlane );
		GLI_tdxValue ScaleNorme = GetRadius()/MTH3D_M_xNormVector(&stTempVertex); 

		MTH3D_M_vMulScalarVector(&stTempVertex, ScaleNorme, &stTempVertex);
		MTH3D_M_vAddVector(&m_stGlobalSelectedPoint, &stTempVertex, &m_stCenterInMousePlane );
//END CPA2 Corneliu Babiuc 11-04-98
		// we make the movement
		MTH3D_M_vAddVector (& m_stGlobalSelectedPoint , 
							& m_stGlobalSelectedPoint , pDeplacement);
		MTH3D_tdstVector RadiusVertex;
		MTH3D_M_vSubVector (& RadiusVertex , & m_stGlobalSelectedPoint ,
							& m_stCenterInMousePlane);
		GLI_tdxValue NewRadius = MTH3D_M_xNormVector(& RadiusVertex); 
		SetRadius (& NewRadius);
//CPA2 Corneliu Babiuc 11-04-98
		//restore the original global position
		MTH3D_M_vAddVector (& m_stGlobalSelectedPoint , 
							& stCopyGlobalSelectedPoint , pDeplacement);
//END CPA2 Corneliu Babiuc 11-04-98
		return TRUE;
	}
	else
		return FALSE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D - _OnLButtonDown
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : initialize the size changing procedure if the CTRL key is pressed
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL Sphere3D::_OnLButtonDown(UINT nFlags, tdstMousePos * p_stPos, ACP_tdxIndex xIndex, HIE_tdstPickInfo * p_stObject)
{
	if (Shape3D::_OnLButtonDown(nFlags, p_stPos, xIndex, p_stObject))
	{
		// resizing is allowed
        MTH3D_tdstVector SphereCenter;
        // Compute coordinates in the global repere
        ConvertPointLocalToGlobal (& SphereCenter, HIE_fn_hGetSuperObjectGlobalMatrix (m_pSuperObject->GetStruct ()) , & GetCenter ());

        // Get the matrix of the camera
        GLI_tdxHandleToCamera hHandleToCamera = m_pGeometry3DDLL->GetInterface () -> GetMultiDevice () -> GetFocusDevice () -> GetCamera ();
        POS_tdstCompletePosition CameraMatrix , InvMatrix;
        GLI_xGetCameraMatrix (hHandleToCamera , & CameraMatrix);
        POS_fn_vInvertIsoMatrix(& InvMatrix , & CameraMatrix);
        // Get the coordinates of the Z axe
        MTH3D_tdstVector        ZAxe , DummyVector;
        POS_fn_vGetRotationMatrix(& InvMatrix , & DummyVector , & DummyVector , & ZAxe);
        // Compute the sphere center, projected into the plane where the mouse moves into
        MTH3D_M_vSubVector       (& SphereCenter , & SphereCenter , & m_stGlobalSelectedPoint);
        GLI_tdxValue DotProduct = MTH3D_M_xDotProductVector (& ZAxe , & SphereCenter);
        MTH3D_M_vMulScalarVector (& ZAxe , DotProduct , & ZAxe);
        MTH3D_M_vSubVector       (& SphereCenter , & SphereCenter , & ZAxe);
        MTH3D_M_vAddVector       (& m_stCenterInMousePlane ,
                                  & SphereCenter , & m_stGlobalSelectedPoint);
		return TRUE;
	}
	else
		return FALSE;
}

/*
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D - _OnLButtonUp
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : Default: we do not use the message
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL Sphere3D::_OnLButtonUp(UINT nFlags, tdstMousePos * p_stPos)
{
	return FALSE;
}
*/

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D - _OnLButtonDblClk
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : launch the modal dialog
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL Sphere3D::_OnLButtonDblClk (UINT nFlags, tdstMousePos *p_stPos, ACP_tdxIndex xIndex, HIE_tdstPickInfo *p_stPickInfo)
{
	int iDlgResult;

	HINSTANCE hOldInst = AfxGetResourceHandle();
	AfxSetResourceHandle ( ((CPA_DLLBase*)(GetEditor()))->GetDLLIdentity()->hModule );

	CDlgSphere3D dlgSphere3D(this);
	iDlgResult = dlgSphere3D.DoModal();
	
	AfxSetResourceHandle(hOldInst);

	if (iDlgResult == IDOK)
 		return TRUE;
	else
		return FALSE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D : GetCenter
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : return the 3D coordinates of the center of the sphere
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
MTH3D_tdstVector Sphere3D::GetCenter ()
{
    MTH3D_tdstVector stCenter;
    fn_eGetCenter (& stCenter , m_hElement);
    return stCenter;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D : SetCenter
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : set the 3D coordinates of the center of the sphere
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void Sphere3D::SetCenter (MTH3D_tdstVector * _pCenter)
{
    fn_eSetCenter (_pCenter , m_hElement);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D : SetCenterX
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : set the X coordinate of the center of the sphere
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void Sphere3D::SetCenterX (GLI_tdxValue _X)
{
    fn_eSetCenterX (& _X , m_hElement);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D : SetCenterY
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : set the Y coordinate of the center of the sphere
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void Sphere3D::SetCenterY (GLI_tdxValue _Y)
{
    fn_eSetCenterY (& _Y , m_hElement);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D : SetCenterZ
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : set the Z coordinate of the center of the sphere
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
void Sphere3D::SetCenterZ (GLI_tdxValue _Z)
{
    fn_eSetCenterZ (& _Z , m_hElement);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D : GetRadius
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : return the radius of the sphere
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
GLI_tdxValue Sphere3D::GetRadius ()
{
    GLI_tdxValue Radius;
    fn_eGetRadius (& Radius , m_hElement);
    return Radius;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Method :Sphere3D : SetRadius
// Date  : 97.11
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description : set the radius of the sphere
// return FALSE if the given radius is not correct (negative). In this case, radius is set to 0
// Author      : Cristi Petrescu
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification :
// Date         :
// By           :
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL Sphere3D::SetRadius (GLI_tdxValue * _Radius)
{
    return fn_eSetRadius (_Radius , m_hElement) == C_Ok;
}
