/*
 *=======================================================================================
 * Name        :edit_cla.hpp
 *
 * Author      : Vincent lhullier            Date :30/06/97
 *
 * Description : editor classe object
 *=======================================================================================
 * Modification -> Author :                  Date :
 * Description :
 *=======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef __EDIT_CLA_HPP__
#define __EDIT_CLA_HPP__

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "ITF.h"
#include "incGAM.h"

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/


/*
 =======================================================================================
	Class editor object 
 =======================================================================================
 */

class EditorPOClass : public CPA_BaseObject
{
  private:
	  CPA_BaseObjectList  m_oPhysicalObjects;

  public:
	
	/* ==> constructor and destructor */
    EditorPOClass(
			char			*_szName,
			CPA_EditorBase	*_pEditor, 
			CPA_BaseObject	*_pOwner = NULL, 
			BOOL			_bAvailable = FALSE
		);

    EditorPOClass(EditorPOClass &_r_oSource);

	~EditorPOClass(void);

	/* ==> return Data */
	long   GetDataType	(void) { return 0; }
    void * GetData		(void) { return NULL; }

	/* ==> loading PO object */
	BOOL fn_bLoadEditorPO( void );

	//CPA2 Stegaru Cristian 98-04
	void mfn_vLoadITEditorPO (CString csITName);
	//End CPA2 Stegaru Cristian 98-04

};


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#endif /* __EDIT_CLA_HPP__ */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/


