/*
 *=======================================================================================
 * Name        :ipo_dlgs.h
 *
 * Author      :VL                           Date :30/06/97
 *
 * Description :declaration of dialogs for IPO interface
 *=======================================================================================
 * Modification -> Author :                  Date :
 * Description :
 *=======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#if !defined(AFX_IPO_DLGS_H__F1425899_F11B_11D0_8EE2_00609736731A__INCLUDED_)
#define AFX_IPO_DLGS_H__F1425899_F11B_11D0_8EE2_00609736731A__INCLUDED_
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "../res/ipo_res.h"

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

class CPA_ObjectDLLBase;
class CPA_BaseObject;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*
 =======================================================================================
	CPhysicalObjectClassDialog form view
 =======================================================================================
 */
#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

//ANNECY Shaitan Correction (15/04/98) {
class IPOInterface;
//ENDANNECY Shaitan Correction }

class CPhysicalObjectClassDialog : public CFormView
{
  public:
	CPhysicalObjectClassDialog();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CPhysicalObjectClassDialog)

  // Form Data
  public:
	//{{AFX_DATA(CPhysicalObjectClassDialog)
	enum { IDD = IDD_DIALOG_POCLASS };
	//}}AFX_DATA

  // Attributes
  public:
//ANNECY Shaitan Correction (15/04/98) {
	IPOInterface			*m_p_oEditor;
//ENDANNECY Shaitan Correction }
	CFrameWnd				*m_p_oFrameForDevice3D;
	DEV_MultiDevice3D		*m_p_oDevice3D;
	CPA_Contact				*m_p_oContact;
	CPA_SuperObject			*m_p_oRootSO;
	CPA_World				*m_p_oWorld;
	GLI_tdxHandleToLight	m_hLightUp;
	GLI_tdxHandleToLight	m_hLightDown;
//ANNECY Shaitan Correction (15/04/98) {

	DEV_Device				*m_p_oMainDevice;
/*
	BOOL					m_bMainDeviceWasSwapped;
	BOOL					m_b3DView;

 */
//ENDANNECY Shaitan Correction }
	
	
  // Operations
  public:
//ANNECY Shaitan Correction (15/04/98) {
	void fn_vSetEditor( IPOInterface *_p_oEditor ) { m_p_oEditor = _p_oEditor; }
//ENDANNECY Shaitan Correction }
	void fn_vInitDevice( void );
	void fn_vInitClassList( void );
	void fn_vRefreshModelList( CPA_BaseObject *p_oClass );
	void fn_vRefreshModelList( void );
	void fn_vSaveBitmap( char *szFileName, int iWidth, int iHeight, COLORREF *a_stPixel);
	BOOL fn_bGetClassVignetteName( CPA_BaseObject *p_oClass, char *szVignetteName );
	BOOL fn_bGetPOModelVignetteName( CPA_BaseObject *p_oPO, char *szVignetteName );
	BOOL fn_bGetCurrentPOModelVignetteName( char *szVignetteName );

	void fn_vOnClose( void );
	void fn_vOnOpen( void );

//ANNECY Shaitan Correction (15/04/98) {
	CFrameWnd *			GetFrameForDevice3D (void) { return m_p_oFrameForDevice3D; }
	DEV_MultiDevice3D * GetDevice3D			(void) { return m_p_oDevice3D; }
//ENDANNECY Shaitan Correction }

//ROMTEAM WorldEditor (Cristian Stegaru 11/97)
	void fn_vUpdateClassList () 
	{ 
		OnSelchangeListPoclass();
		fn_vRefreshModelList ();
		InvalidateRect (NULL);
	}
//ENDROMTEAM WorldEditor (Cristian Stegaru)
// CPA2 ASilvescu 98-04-09
	void DisplayModelIcon();
// End CPA2 ASilvescu 98-04-09


  // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPhysicalObjectClassDialog)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	//}}AFX_VIRTUAL

  // Implementation
  protected:
	virtual ~CPhysicalObjectClassDialog();
	#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	#endif

	// Generated message map functions
	//{{AFX_MSG(CPhysicalObjectClassDialog)
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDIS);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnDblclkListPoclass();
	afx_msg void OnSelchangeListPoclass();
	afx_msg void OnDblclkListPomodel();
	afx_msg void OnSelchangeListPomodel();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnRadioAllclasses();
	afx_msg void OnRadioLoadedmodels();
	afx_msg void OnRadioAllmodels();
	afx_msg void OnRadioSelectedclass();
	afx_msg void OnButtonCreatevignette();
	afx_msg void OnCheck3dview();
	afx_msg void OnDestroy();
//ROMTEAM WorldEditor (Cristian Stegaru 11/97) 
	afx_msg void OnButtonIndexedTriangle ();
//ENDROMTEAM WorldEditor (Cristian Stegaru) 
// CPA2 ASilvescu 98-04-09
	afx_msg void OnCreateModelIcon();
// End CPA2 ASilvescu 98-04-09
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



/*
 =======================================================================================
	CIPOEditionDialog form view
 =======================================================================================
 */
class CIPOEditionDialog : public CFormView
{
  protected:
	CIPOEditionDialog();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CIPOEditionDialog)

  // Form Data
  public:
	//{{AFX_DATA(CIPOEditionDialog)
	enum { IDD = IDD_DIALOG_POANDDELTARLI };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

  // Attributes
  public:
	  CPA_ObjectDLLBase			*m_p_oEditor;
	  EditorIPO					*m_p_oIPO;
	  GEO_tdxHandleToVisualSet	m_hVisualSet;
	  ACP_tdxIndex				m_xNbLods;
	  ACP_tdxIndex				m_xCurrentLod;
	  ACP_tdxIndex				m_xSwapLod;

	  ACP_tdxHandleOfObject		m_xCurrentGeom;
	  ACP_tdxIndex				m_xNumberOfPoints;

  // Operations
  public:
	  void			fn_vSetEditor( CPA_ObjectDLLBase *_p_oEditor ) { m_p_oEditor = _p_oEditor; }
	  void			fn_vUpdateIPO( EditorIPO *_p_oIPO );
	  void			m_fn_vShowCurrentLod( void );
	  ACP_tdxIndex	m_fn_xGetClickedLodIndex( void );
	  void			m_fn_vSwapLOD( ACP_tdxIndex _xLod, BOOL _bRestore, BOOL _bRedraw );

  // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIPOEditionDialog)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	//}}AFX_VIRTUAL

  // Implementation
  protected:
	virtual ~CIPOEditionDialog();
	#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	#endif

	// Generated message map functions
	//{{AFX_MSG(CIPOEditionDialog)
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDIS);
	afx_msg void OnButtonEditpo();
	afx_msg void OnButtonLod();
	afx_msg void OnDoubleclickedButtonLod();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif // !defined(AFX_IPO_DLGS_H__F1425899_F11B_11D0_8EE2_00609736731A__INCLUDED_)
