/*=========================================================================
* 
* SECdEdit.hpp :  class SECT_DialogEdit
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/

#ifndef __SECT_D_EDIT_HPP__
#define __SECT_D_EDIT_HPP__

#include "SECTres.h"

class Sector_Interface;
class SECT_DialogEnv;

/*===========================================================================
*		Description:	Class for the Dialog
*		Creation date:	
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                                                                                          Author:         
*=========================================================================*/
class SECT_DialogEdit : public CFormView
{
// Construction
protected:
	Sector_Interface  *m_pSectorInterface;
	CPA_SuperObject	  *m_pEditedSector;
	char			  m_szName[256];
	BOOL			  m_bInitialised;

public:
// standard constructor
	SECT_DialogEdit (CWnd* pParent = NULL);   

// get functions
	CPA_SuperObject		* GetSelectedSector		(void) { return m_pEditedSector; }
	Sector_Interface	* GetSectorInterface (void) { return m_pSectorInterface; }

// Dialog
	void fn_vInitDialog		  (Sector_Interface *p_oDLL, CWnd *pParent, const CString csTag);
	void fn_vReinitDialog	  (CPA_SuperObject *pSector);

protected:
	
// Dialog Data
	//{{AFX_DATA(SECT_DialogEdit)
	enum { IDD = SEC_IDD_DIALOGEDIT };
	CComboBox		m_cComboSector;
	CButton			m_cVirtual;
	CButton			m_cZmaxCheck;
	CEdit			m_cZmaxEdit;
	CButton			m_cZfarCheck;
	CEdit			m_cZfarEdit;
	CButton			m_cDefault;
	CEdit			m_cCamTypeEdit;
	CEdit			m_cPriorityEdit;
	CSpinButtonCtrl	m_cPrioritySpin;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SECT_DialogEdit)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(SECT_DialogEdit)
	afx_msg void OnSize(UINT, int, int);
	afx_msg void OnSelChangeComboSector();
	afx_msg void OnVirtual();
	afx_msg void OnZmaxCheck();
	afx_msg void OnEditZmax();
	afx_msg void OnZfarCheck();
	afx_msg void OnEditZfar();
	afx_msg void OnDefault();
	afx_msg void OnEditCamType();
//	afx_msg void OnEditPriority();
	afx_msg void OnPrioritySpin(NMHDR * pNMHDR, LRESULT * pResult);
	afx_msg void OnDestroy();	
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif //__SECT_D_EDIT_HPP__
