/*=========================================================================
* 
* SECTdVis.hpp :  class SECT_DialogVis
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
/*
#ifndef __SECT_D_VIS_HPP__
#define __SECT_D_VIS_HPP__

#include "SECTres.h"

#include "SECTenv.hpp"

class Sector_Interface;

/===========================================================================
*		Description:	Class for the Dialog Visual Environment
*		Creation date:	
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                                                                                          Author:         
*=========================================================================/

class SECT_DialogVis : public CFormView
{
protected:
// dialog parameters
	Sector_Interface	*m_pSectorInterface;
	SECT_VisEnvironment	*m_pVisEnv;
	SECT_VisEnvironment	*m_pDefaultVisEnv;
	BOOL				m_bInitialised;

// visual environment parameters
	CString				m_csName;
	MTH_tdxReal			m_xNear;
	MTH_tdxReal			m_xFar;
	MTH_tdxReal			m_xBlendNear;
	MTH_tdxReal			m_xBlendFar;
	MTH_tdxReal			m_xInfinite;
	COLORREF			m_stColor;

public:
// standard constructor
	SECT_DialogVis (CWnd* pParent = NULL);   

// Dialog
	void fn_vInitDialog			(Sector_Interface *p_oDLL, CWnd *pParent);
	void fn_vReinitDialog		(void);
	void fn_vInitControls		(BOOL bEnable);
	void fn_vInitVisEnvironment	(SECT_VisEnvironment *pVisEnv, BOOL bEnable);

	void fn_vUpdateSliders	(void);
	void fn_vUpdateColor	(void);

protected:
	
// Dialog Data
	//{{AFX_DATA(SECT_DialogVis)
	enum { IDD = SEC_IDD_DIALOGVIS };

	// name
	CEdit		m_cName;
	CButton		m_cDefault;
	// save
	CButton		m_cCancel;
	CButton		m_cSave;
	// parameters
	CEdit		m_cNear;
	CEdit		m_cFar;
	CSliderCtrl	m_cBlendNear;
	CSliderCtrl	m_cBlendFar;
	CEdit		m_cInfinite;
	// color
	CSliderCtrl	m_cRSlider;
	CSliderCtrl	m_cGSlider;
	CSliderCtrl	m_cBSlider;
	CButton		m_cColor;

	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SECT_DialogVis)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(SECT_DialogVis)
	afx_msg void OnSize(UINT, int, int);
	afx_msg void OnDestroy();	
	afx_msg void OnDrawItem (int nIDCtl, LPDRAWITEMSTRUCT lpDIS);
	// save
	afx_msg void OnSave();
	afx_msg	void OnCancel();
	// name
	afx_msg	void OnChangeName();
	afx_msg	void OnDefault();
	// parameters
	afx_msg void OnChangeNear();
	afx_msg void OnChangeFar();
	afx_msg void OnChangeInfinite();
	// color
	afx_msg void OnVScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnEditColor ();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

#endif //__SECT_D_VIS_HPP__

*/