//
// Common functions for Object DLL capabilities
//

#include "stdafx.h"
#include "afxdllx.h"    
#include "ACP_Base.h"
#include "..\Main\Inc\_EditID.h"

#include "_zInterf.hpp"

// List of all the instances of the dll
static CList<CPA_DLLBase * , CPA_DLLBase *> g_oListOfInstances;    //private internal


//------------------------------------------------------------------------
// Global vars
static char                         *gs_p_szCPAVersion = C_szCPAVersion;
static AFX_EXTENSION_MODULE NEAR    extensionDLL = { NULL, NULL };

#ifdef DLL_ONLY_ONE_INSTANCE
static ZDx_Interface * gs_p_oZDxInterface = NULL;
#endif


//------------------------------------------------------------------------
// functions that are present in all DLL :
//------------------------------------------------------------------------

//========================================================================
// Get current CPA version
//========================================================================
extern "C" char __declspec(dllexport) *fn_p_szGetCPAVersion(void)
{
    return gs_p_szCPAVersion;
}

//========================================================================
// Get type of this DLL
//========================================================================
extern "C" tdstDLLIdentity __declspec(dllexport) *fn_p_stGetDLLIdentity(void)
{
    g_stZDxDllIdentity . eType              = OBJECT_DLL;
    g_stZDxDllIdentity . csName             = C_szDLLZDxName;
    g_stZDxDllIdentity . hModule            = NULL;
    g_stZDxDllIdentity . p_oListOfInstances = & g_oListOfInstances;
    return & g_stZDxDllIdentity;
}

//========================================================================
// DLL int function
//========================================================================
extern "C" void __declspec(dllexport) fn_vInitDll(void)
{
	new CDynLinkLibrary(extensionDLL);
}

//========================================================================
// DLL entry point
//========================================================================
extern "C" int __stdcall DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		if (!AfxInitExtensionModule(extensionDLL, hInstance))
		   return 0;
	}
	return 1;
}

//========================================================================
// Get the DLL
//========================================================================
extern "C" CPA_DLLBase __declspec(dllexport) *fn_p_oGetDLL(long lKey)
{
#ifdef DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		if (gs_p_oZDxInterface == NULL)
		{
			gs_p_oZDxInterface = new ZDx_Interface();
			ASSERT(gs_p_oZDxInterface != NULL);
		}
		return gs_p_oZDxInterface;
		break;

	default:
		return NULL;
	}

#else //DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		return new ZDx_Interface();
		break;

	default:
		return NULL;
	}

#endif //DLL_ONLY_ONE_INSTANCE
}


//------------------------------------------------------------------------
// functions that are present in this type of DLL only :
//------------------------------------------------------------------------

#undef DLL_ONLY_ONE_INSTANCE
