/*
0         1         2         3         4         5         6         7
01234567890123456789012345678901234567890123456789012345678901234567890123456789
--------------------------------------------------------------------------------
-- Description : Particles system
--------------------------------------------------------------------------------
-- Creation date : 12 jun 1997               Author : FPI
--------------------------------------------------------------------------------
*/
#ifndef D_THROW_PRT
 
#include "acp_base.h"
#include "MTH.h"
#include "RND.h"
#include "MEC.h"
#include "GMT.h"
#include "GEO.h"
#include "GLI.h"
#include "COL.h"
 
#include "PRT/PrtSyst.h"
 
/*
--------------------------------------------------------------------------------
-- Description : Global variables
--------------------------------------------------------------------------------
*/
 
/*
--------------------------------------------------------------------------------
-- Description : Particles system creation
--------------------------------------------------------------------------------
-- Creation date : 12 jun 1997               Author : FPI
--------------------------------------------------------------------------------
*/
 
void PRT_fn_vCreateParticlesSystem ( PRT_tdstParticlesSystem **_p_pstParticlesSystem,
                                     ACP_tdxIndex _xNbParticles )
{
  GEO_M_CPAMalloc ( *_p_pstParticlesSystem,
                    PRT_tdstParticlesSystem *,
                    sizeof ( PRT_tdstParticlesSystem ),
                    E_uwGEONotEnoughtMemory );
 
  (*_p_pstParticlesSystem)->xNbParticles = _xNbParticles;
  (*_p_pstParticlesSystem)->xNbActiveParticles = 0;
 
  /* Objet graphique */
  (*_p_pstParticlesSystem)->hParticlesSystemObject = NULL;
}
 
/*
--------------------------------------------------------------------------------
-- Description : 
--------------------------------------------------------------------------------
-- Creation date : 13 jun 1997               Author : FPI
--------------------------------------------------------------------------------
*/
 
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
void PRT_fn_vInitParticlesSystem ( PRT_tdstParticlesSystem *_p_stParticlesSystem )
{
  _p_stParticlesSystem->xNbActiveParticles = 0;
}
 
/*
--------------------------------------------------------------------------------
-- Description : 
--------------------------------------------------------------------------------
-- Creation date : 12 jun 1997               Author : FPI
--------------------------------------------------------------------------------
*/
 
void PRT_fn_vSetObjectParticlesSystem ( PRT_tdstParticlesSystem *_p_stParticlesSystem,
                                        ACP_tdxHandleOfObject _hParticlesSystemObject )
{
  _p_stParticlesSystem->hParticlesSystemObject = _hParticlesSystemObject;
}
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
 
#endif /* D_THROW_PRT */
