//==============================================================================================
//							FICHIER D'EN-TETE DU MODULE DE TRAITEMENT DE L'"ADPCM"
//
//		Crer	  :	23 / 01 / 98
//		Auteur	  :	Nicolas Meyer
//		Fichier	  :	ApmVoice.h
//
//		Descriptif:	Dfinitions de la structure d'une voie ADPCM
//
//==============================================================================================

#ifndef _APMVOICE_H_
#define _APMVOICE_H_

/*********************************************************************************************************
// DEFINITION DE STRUCTURES

*/
// Structure dcrivant les callbacks ADPCM
typedef struct _SND_tdstADPCMCallback {
	SND_td_pfn_vSoundCallback	pfnCallBack;		// Pointeur callback
	long						lCallbackParam;
} SND_tdstADPCMCallback;
typedef SND_tdstADPCMCallback* lpSND_tdstADPCMCallback;

// Pointeur de fonction
typedef void (  * SND_td_pfn_vADPCMCallback )( lpSND_tdstADPCMCallback pstCall );


// Structure dcrivant une voie ADPCM (188 octets)
typedef struct _SND_tdstADPCMVoice	SND_tdstADPCMVoice;
typedef SND_tdstADPCMVoice*			lpSND_tdstADPCMVoice;
typedef lpSND_tdstADPCMVoice*		hSND_tdstADPCMVoice;	//Handle
typedef struct  _SND_tdstADPCMVoice {
	unsigned short				unChannels;
	unsigned short				unSamplesPerSec;	// Frquence d'enregistrement des samples
	// Gestion des CallBack
	SND_tdstADPCMCallback		stCall;
	// Flags statiques
	ApmBool						bVolable;			// Flag volume
	ApmBool						bPanable;			// Flag panoramique
	ApmBool						bPitchable;			// Flag pitch
	unsigned long				ulStaticVolume;		// Volume statique de la ressource
	// Flags dynamique
	ApmBool						bPause;				// Flag en pause
	ApmBool						bStream;			// Flag stream
	ApmBool						bLoop;				// Flag bouclage
	// Gestion de la voie et du Fade
	ApmBool						bIsPlaying;			// Flag voie en cours
	ApmBool						bFade;				// Flag transition avec Fade
	ApmBool						bFadeIn;			// Flag de fade ascendant ou descendant
	ApmBool						bCallbackDone;		// Appel  la callback effectu
	// Paramtres gnraux
	long						lVolume;			// Volume		0 < valeur < 127
	long						lPan;				// Panoramique	0 < valeur < 127
	unsigned long				ulPitch;			// Pitch		rl 23_9
	long						lCoeffLeft;			// Coefficient gauche
	long						lCoeffRight;		// Coefficient droit
	//( Mettre imprativement Right aprs Left pour les optimisations MMX )
	unsigned long				ulNbSample;			// Nombre d'chantillons total
	unsigned long				ulBufferStart;		// Contient le nombre de samples buffer  la cration de la voie
	unsigned long				ulSampleStart;		// Indice du sample vers lequel on doit reboucler
	unsigned long				ulSampleLength;		// Taille de la boucle en sample
	unsigned long				ulSamplePos;		// Position courante(dcompression) du sample en tenant compte du pitch
	// Gestion des donnes compresses en mmoire
	char*						pchBeginDatas;		// Pointeur sur le dbut des donnes ADPCM
	char*						pchCurrentDatas;	// Pointeur sur la donne courante ADPCM
	char*						pchEndDatas;		// Pointeur sur la dernire donne ADPCM
	tdhSndFile*					phFile;				// Pointeur sur une structure dcrivant un stream
	tduState					uInitEnv;			// Conditions initiales de dcompression
	tduState					uEnv;				// Etat de dcompression de la voie
	tduState					uLoop;				// Etat de dcompression au point de bouclage
	// Gestion des thmes
	lpSND_tdstADPCMVoice		pstTheme;			// Pointeur sur le prochain bloc thme
	unsigned long				ulNbSampleFade;		// Indice de progression au cours du fade
	unsigned long               ulFadeStep;         // Scale fade factor
	tduRefRes					uRefRes;			// ressource associe
	hSND_tdstADPCMVoice			hstVoice;			// Handle de la voie
	ApmBool						bTheme;				// La voie courante est un thme
	// Assynchronous buffer manage
	ApmBool						bIsFinishing;       // Permit to the assynchronous buffer to end
	unsigned long               ulBufferEnd;
} SND_tdstADPCMVoice;

#endif	//	_APMVOICE_H_