// DlgVwCt.h : header file
//

#ifndef __DLGVWCT_HPP__
#define __DLGVWCT_HPP__

#include "T3d_Res.h"
#include "T3Dinterf.hpp"

#define C_OPENVIEWER      20

/////////////////////////////////////////////////////////////////////////////
// CDlgViewerContent dialog
class CPA_ReachableObjectList;

class CDlgViewerContent : public CDialog
{
protected:
    CPA_List<tdst_VW_ObjInfo>   *m_p_oListOfInitialObjects;
    CPA_MainWorld               *m_p_oMainWorld;
    CString                     m_ocstTreeName;
    BOOL                        m_bTreeUsed;
    CImageList                  m_stImageList;
    CBitmap                     m_oBmpEdNoObject;
    CBitmap                     m_oBmpEdSupObj;
    CBitmap                     m_oBmpNoEdNoObject;
    CBitmap                     m_oBmpNoEdSupObj;
    CBitmap                     m_oBmpPEdNoObject;
    CBitmap                     m_oBmpPEdSupObj;
    CBitmap                     m_oBmpPNoEdNoObject;
    CBitmap                     m_oBmpPNoEdSupObj;
// Construction
public:
    CDlgViewerContent(CPA_MainWorld *_p_oMainWorld, CPA_List<tdst_VW_ObjInfo> *_p_oListOfInitialObjects,CWnd* pParent = NULL);   // standard constructor
    ~CDlgViewerContent();
// Dialog Data
	//{{AFX_DATA(CDlgViewerContent)
	enum { IDD = IDD_DLG_VIEWERCONTENT };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgViewerContent)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgViewerContent)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnGetMinMaxInfo( MINMAXINFO FAR* lpMMI );
	virtual void OnOK();
	afx_msg void OnBtdelete();
    afx_msg void OnBtadd();
    afx_msg void OnSelchangeComboType();
    afx_msg void OnDblClkListObjects();
	afx_msg void OnDblclkListContent();
	afx_msg void OnBtOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
    void mfn_vFillChoiceList(CPA_List<CPA_SuperObject> *_p_oList);
    void mfn_vShowHierarchyTree();
    void mfn_vAddListOfType(CString _csTypeName, CString _csListName);
    void mfn_vAddHierarchyTree(CString _csListName);
    void mfn_vFillHierarchyTree (CPA_SuperObject *pEdParent, HTREEITEM hTreeParent);
    void mfn_vAddSelectionFromList();
    void mfn_vAddSelectionFromTree();
    void mfn_vUpdateList();
};

#endif // __DLGVWCT_HPP__
