/*=============================================================================
 *
 *  Filename:           DlgActLs.hpp : header file
 *  Version:            1.0
 *  Date:				02/01/97
 *  Author:             V.L.
 *
 *  Description:		description of Form view class for action list
 *
 *===========================================================================*/
#ifndef __DLGACTLS_HPP__
#define __DLGACTLS_HPP__

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "TAct_res.h"

class TAction_Interface;
class CPA_Action;

/*=============================================================================
* CDlgActionList class
=============================================================================*/
class CDlgActionList : public CFormView
{
  protected:
    TAction_Interface*  m_p_oParentDLL;
    CFont               m_oBoldFont;

  protected:
    CDlgActionList();           // protected constructor used by dynamic creation
    DECLARE_DYNCREATE(CDlgActionList)

  // Form Data
  public:
	//{{AFX_DATA(CDlgActionList)
	enum { IDD = IDD_DLG_ACTION_LIST };
	//CListBox	m_CTRL_ListAction;
	//}}AFX_DATA

  // Attributes
  public:
	BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName,
				DWORD dwRequestedStyle, const RECT& rect, CWnd* pParentWnd, UINT nID,
				CCreateContext* pContext);
  // Operations
  public:
    void fn_vSetActionList  ( CPA_List<CPA_Action> *_p_oListOfActions );
    void fn_vSetParentDLL   ( TAction_Interface *_p_oDLL )  { m_p_oParentDLL = _p_oDLL; }
    void fn_vSetAction      ( CPA_Action *_p_oAction );
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgActionList)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

  // Implementation
  protected:
	virtual ~CDlgActionList();

    void fn_vUpdateButtons      (BOOL _bEnabled);
    void OnRButtonDownActionList(MSG *pMsg);
    void OnKeyDownActionList    (MSG *pMsg);

	#ifdef _DEBUG
		virtual void AssertValid() const;
		virtual void Dump(CDumpContext& dc) const;
	#endif

	// Generated message map functions
	//{{AFX_MSG(CDlgActionList)
	afx_msg void OnDestroy();
	afx_msg void OnSelchangeListAction();
	afx_msg void OnBtCopyaction();
	afx_msg void OnBtDelaction();
	afx_msg void OnBtDelallaction();
	afx_msg void OnBtNewaction();
	afx_msg void OnBtRenameaction();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBtEditza();
	afx_msg void OnBtInitaction();
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__DLGACTLS_HPP__

/////////////////////////////////////////////////////////////////////////////
