//#################################################################################
//
// BASE DEFINITION CLASS OF DLL interface Modification
//
//#################################################################################
//
//

#ifndef __ZAMODIF_HPP__
#define __ZAMODIF_HPP__

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

class CPA_Family;
class CPA_Action;
class CPA_State;
class TAction_Interface;
class CPA_tdoNameList;
class CPA_ZonesActivating;
class CPA_ZonesActivatingList;

typedef struct tdstZAStates_
{
    CPA_State *m_p_oState;
    CPA_ZonesActivating *m_p_oNewZA;
} tdstZAStates;

///////////////////////////////////////////////////////////////////////////////
// class ZAList_New

class ZAList_New : public CPA_Modif
{
protected:
    TAction_Interface       *m_p_oParentDLL;
    CPA_tdoNameList         *m_p_oNameList;
    CPA_ZonesActivatingList *m_p_oZAList;
    CString                  m_csName;
// methods
public:
    ZAList_New(TAction_Interface *_p_oParentDLL, CPA_tdoNameList *_p_oNameList, CString _csName);
    ~ZAList_New();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZAList_Copy

class ZAList_Copy : public CPA_Modif
{
protected:
    TAction_Interface       *m_p_oParentDLL;
    CPA_ZonesActivatingList *m_p_oSourceZAList;
    CPA_ZonesActivatingList *m_p_oTargetZAList;
// methods
public:
    ZAList_Copy(TAction_Interface *_p_oParentDLL, CPA_ZonesActivatingList *_p_oSourceZAList);
    ~ZAList_Copy();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZAList_Rename

class ZAList_Rename : public CPA_Modif
{
protected:
    TAction_Interface       *m_p_oParentDLL;
    CPA_ZonesActivatingList *m_p_oZAList;
	CString					 m_csName;
// methods
public:
    ZAList_Rename(TAction_Interface *_p_oParentDLL, CPA_ZonesActivatingList *_p_oZAList, CString _csName);
    ~ZAList_Rename();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZAList_Delete

class ZAList_Delete : public CPA_Modif
{
protected:
    TAction_Interface       *m_p_oParentDLL;
    CPA_ZonesActivatingList *m_p_oZAList;
// methods
public:
    ZAList_Delete(TAction_Interface *_p_oParentDLL, CPA_ZonesActivatingList *_p_oZAList);
    ~ZAList_Delete();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZAList_ExtendToFamily

class ZAList_ExtendToFamily : public CPA_Modif
{
protected:
    TAction_Interface        *m_p_oParentDLL;
    CPA_ZonesActivatingList  *m_p_oZAList;
    CPA_ZonesActivating      *m_p_oZA;
    CPA_List<CPA_State>      *m_p_oListOfDisplayStates;
    CMap<CPA_State*,CPA_State*,CPA_ZonesActivating*,CPA_ZonesActivating*> m_oListOfZAState;

// methods
public:
    ZAList_ExtendToFamily(TAction_Interface *_p_oParentDLL, CPA_ZonesActivatingList *_p_oZAList,
                          CPA_ZonesActivating *_p_oZA, CPA_List<CPA_State> *_p_oListOfDisplayStates);
    ~ZAList_ExtendToFamily();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZAList_ExtendToAction

class ZAList_ExtendToAction : public CPA_Modif
{
protected:
    TAction_Interface        *m_p_oParentDLL;
    CPA_ZonesActivatingList  *m_p_oZAList;
    CPA_Action               *m_p_oAction;
    CPA_ZonesActivating      *m_p_oZA;
    CPA_List<CPA_State>      *m_p_oListOfDisplayStates;
    CMap<CPA_State*,CPA_State*,CPA_ZonesActivating*,CPA_ZonesActivating*> m_oListOfZAState;

// methods
public:
    ZAList_ExtendToAction(TAction_Interface *_p_oParentDLL, CPA_Action *_p_oACtion,
                          CPA_ZonesActivatingList *_p_oZAList, CPA_ZonesActivating *_p_oZA, CPA_List<CPA_State> *_p_oListOfDisplayStates);
    ~ZAList_ExtendToAction();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZAList_SetZAToState

class ZAList_SetZAToState : public CPA_Modif
{
protected:
    TAction_Interface       *m_p_oParentDLL;
    CPA_ZonesActivatingList  *m_p_oZAList;
    CPA_List<CPA_State>      *m_p_oListOfDisplayStates;
    CPA_List<tdstZAStates>   m_oListOfChanged;
// methods
public:
    ZAList_SetZAToState(TAction_Interface *_p_oParentDLL, CPA_ZonesActivatingList *_p_oZAList,
                        CPA_List<CPA_State> *_p_oListOfDisplayStates);
    ~ZAList_SetZAToState();
// actions
    BOOL Do();
    BOOL Undo();
    void mfn_vAddZAToState( CPA_ZonesActivating *_p_oZA, CPA_State *_p_oState );
};

///////////////////////////////////////////////////////////////////////////////
// class ZA_New

class ZA_New : public CPA_Modif
{
protected:
    TAction_Interface   *m_p_oParentDLL;
    CPA_tdoNameList     *m_p_oNameList;
    CPA_ZonesActivating  *m_p_oZA;
    CString              m_csName;
// methods
public:
    ZA_New(TAction_Interface *_p_oParentDLL, CPA_tdoNameList *_p_oNameList, CString _csName);
    ~ZA_New();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZA_Copy

class ZA_Copy : public CPA_Modif
{
protected:
    TAction_Interface   *m_p_oParentDLL;
    CPA_ZonesActivating *m_p_oSourceZA;
    CPA_ZonesActivating *m_p_oTargetZA;
// methods
public:
    ZA_Copy(TAction_Interface *_p_oParentDLL, CPA_ZonesActivating *_p_oSourceZA);
    ~ZA_Copy();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZA_Rename

class ZA_Rename : public CPA_Modif
{
protected:
    TAction_Interface   *m_p_oParentDLL;
    CPA_ZonesActivating *m_p_oZA;
	CString				 m_csName;
// methods
public:
    ZA_Rename(TAction_Interface *_p_oParentDLL, CPA_ZonesActivating *_p_oZA, CString _csName);
    ~ZA_Rename();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZA_Delete

class ZA_Delete : public CPA_Modif
{
protected:
    TAction_Interface   *m_p_oParentDLL;
    CPA_ZonesActivating *m_p_oZA;
    BOOL                 m_bDefault;
// methods
public:
    ZA_Delete(TAction_Interface *_p_oParentDLL, CPA_ZonesActivating *_p_oZA);
    ~ZA_Delete();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZA_Modify

class ZA_Modify : public CPA_Modif
{
protected:
    TAction_Interface   *m_p_oParentDLL;
    CPA_ZonesActivating  *m_p_oZA;
    unsigned short      m_usIndex;
    BOOL                m_bNewState;
// methods
public:
    ZA_Modify(TAction_Interface *_p_oParentDLL, CPA_ZonesActivating  *_p_oZA,
              unsigned short _usIndex, BOOL _bNewState);
    ~ZA_Modify();
// actions
    BOOL Do();
    BOOL Undo();
};

///////////////////////////////////////////////////////////////////////////////
// class ZA_Default

class ZA_Default : public CPA_Modif
{
protected:
    TAction_Interface    *m_p_oParentDLL;
    CPA_ZonesActivating  *m_p_oNewDefaultZA;
// methods
public:
    ZA_Default(TAction_Interface *_p_oParentDLL, CPA_ZonesActivating  *_p_oNewDefaultZA);
    ~ZA_Default();
// actions
    BOOL Do();
    BOOL Undo();
    BOOL mfn_vMakeModif();
};

#endif //__ZAMODIF_HPP__