//
// Common functions for Object DLL capabilities
// C. Beaudet
//

//MFC
#include "stdafx.h"
#include "afxdllx.h"
//Interface
#include "ACP_Base.h"
// ALX
#include "TAC.h"
// End ALX
#include "ITF.h"
//local
#include "FAinterf.hpp"
#include "X:\Cpa\Main\Inc\_EditID.h"

//------------------------------------------------------------------------
// Global vars
static char		*gs_p_szCPAVersion = C_szCPAVersion;
static AFX_EXTENSION_MODULE NEAR    extensionDLL = { NULL, NULL };

#ifdef DLL_ONLY_ONE_INSTANCE
static TFamily_Interface *gs_p_oTFamilyInterface = NULL;
#endif

static CList<CPA_DLLBase*,CPA_DLLBase*> g_oListOfInstances;	//private internal


//------------------------------------------------------------------------
// functions that are present in all DLL :
//------------------------------------------------------------------------

//========================================================================
// Get current CPA version
//========================================================================
extern "C" char __declspec(dllexport) *fn_p_szGetCPAVersion(void)
{
    return gs_p_szCPAVersion;
}

//========================================================================
// Get type of this DLL
//========================================================================
extern "C" tdstDLLIdentity __declspec(dllexport) *fn_p_stGetDLLIdentity(void)
{
    g_stTFamilyIdentity . eType                 = TOOL_DLL;
    g_stTFamilyIdentity . csName                = C_szDLLFamilyName;
    g_stTFamilyIdentity . hModule               = NULL;
    g_stTFamilyIdentity . p_oListOfInstances    = &g_oListOfInstances;
	return &g_stTFamilyIdentity;
}

//========================================================================
// DLL int function
//========================================================================
extern "C" void __declspec(dllexport) fn_vInitDll(void)
{
	new CDynLinkLibrary(extensionDLL);
}

//========================================================================
// DLL entry point
//========================================================================
extern "C" int __stdcall DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		if (!AfxInitExtensionModule(extensionDLL, hInstance))
		   return 0;
	}
	return 1;
}

//========================================================================
// Get the DLL
//========================================================================
extern "C" CPA_DLLBase __declspec(dllexport) *fn_p_oGetDLL(long lKey)
{
#ifdef DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		if (gs_p_oTFamilyInterface == NULL)
		{
			gs_p_oTFamilyInterface = new TFamily_Interface();
			ASSERT(gs_p_oTFamilyInterface != NULL);
		}
		return gs_p_oTFamilyInterface;
		break;

	default:
		return NULL;
	}

#else //DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		return new TFamily_Interface();
		break;

	default:
		return NULL;
	}

#endif //DLL_ONLY_ONE_INSTANCE
}


//------------------------------------------------------------------------
// functions that are present in this type of DLL only :
//------------------------------------------------------------------------

#undef DLL_ONLY_ONE_INSTANCE