/*=============================================================================
 *
 *  Filename:						MatList.hpp
 *  Version:            1.0
 *  Date:								06/11/96
 *  Author:             V.L.
 *
 *  Description:				interface of MaterialList view
 *
 *===========================================================================*/

#ifndef __PATTERNLIST_HPP__
#define __PATTERNLIST_HPP__

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

#include <afxtempl.h>
#include <afxcview.h>

#include "Acp_base.h"
#include "itf.h"
#include "gmt.h"
//#include "Sort3Lst.hpp"
//#include "cpamdf.hpp"

class Material_Interface;
class tdoEditorGameMaterial;
class tdoEditorVisualMaterial;
class tdoDeleteEngineMechanicsModif;
class tdoDeleteEngineCollideModif;
class Geometry3D;

/*=============================================================================
* C3ListView : view that display a ThreeSortedList
=============================================================================*/

#define C_szNoBitmapName         "edt_data\\tools\\Material\\NoBitmap.bmp"
#define C_szUnviewableBitmapName "edt_data\\tools\\Material\\UnviewableBitmap.bmp"

class CPatternedListView : public C3ListView
{
protected:
	CBitmap m_oHatchBitmap;
	CBrush m_oHatchBrush;

public:
	CPatternedListView();
	~CPatternedListView();

	void m_fn_vRedrawSelectedItem(int iItem = -1);

protected:
	virtual void m_fn_vOverriddenDrawItem(short wItem, CDC *pDC, RECT *rect);
	short m_wSpecialImage;

	// Generated message map functions
	//{{AFX_MSG(CPatternedListView)
	afx_msg int OnCreate( LPCREATESTRUCT );
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif /* __PATTERNLIST_HPP__ */
