/*=============================================================================
 *
 *  Filename:      MMatObj.hpp
 *  Version:            1.0
 *  Date:								06/11/96
 *  Author:             B.G.
 *
 *  Description:    editor material class
 *
 *===========================================================================*/

#ifndef __TEXOBJ_HPP__
#define __TEXOBJ_HPP__

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

#include <afxtempl.h>
#include <afxcview.h>

#include "Acp_base.h"
#include "itf.h"
#include "gmt.h"
#include "scr.h"
#include "dpt.h"
#include "x:\cpa\main\inc\_editid.h"

class tdoEditorTexture : public CPA_SaveObject
{
public:
	tdoEditorTexture(
		CPA_FileObject *_p_oOwnerFile,
		CString _csId,
		BOOL _bSectionAlreadyExists,
		GLI_tdstTexture *_hTemplateTexture
	);
	~tdoEditorTexture();

	GLI_tdstTexture *m_hGetEngineTexture() { return m_hTexture; }
	static void m_vCallBackSaveTexture( // save the mechanics material section
		SCR_tdst_File_Description *_p_stFile,
		char *_p_szSectionName,
		void *_p_vData,
		SCR_tde_Ntfy_Action _eAction
	);
	void m_vAssociateEngineMaterial(GLI_tdstTexture *_htexture, BOOL _bSectionAlreadyExists);
	void m_vLoadAssociatedEngineTexture();
	BOOL m_bIsReferenced();

	void m_vRememberTextureName(CString _csTextureName);
	CString m_csGetTextureName() { return m_csTextureName; }
	void m_vReplaceHandle(GLI_tdstTexture *_hReplacingTexture);

	//overloads from base class
	virtual void *GetData(void) { return m_hTexture; }
  virtual long GetDataType(void) { return 0; };
  virtual tdeMissingCriteria fn_eCheckUnicity(const CString csNewName) { return fn_eCheckUnicityWithOwner(csNewName); }
	virtual void fn_vNotifySave(void);

	static CString m_csGetMaterialType();
	static CString m_csGetScriptExtension();
	static SCR_tdst_Link_Table *m_p_stGetAssociatedLinkTable();
	static BOOL m_bIsEngineMaterialValid(GLI_tdstTexture *_hTexture);
	static void m_vInvalidateEngineMaterial(GLI_tdstTexture *&r_hTexture);

	//virtual void fn_vNotify(SCR_tde_Ntfy_Action _eAction);
	//CString GetReferencedSectionName(void);

private:
	CString m_csTextureName;
	GLI_tdstTexture *m_hTexture;
};

#endif /* __TEXOBJ_HPP__ */
