/*=========================================================================
File Name:		DIASOUND.HPP
Purpose:		Implements functions handling the sound characteristics
				Implements Following Classes:

				- DiaSound


Author:			Yann Le Tensorer
Date:			May,1997
==========================================================================*/

// DiaSound dialog
#ifndef __DiaSound_hpp
#define __DiaSound_hpp

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

#include "matres.h"
#include "itf.h"
#include "gmatobj.hpp"


#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class tdoCopyBuffer;

class DiaSound : public CFormView
{
protected:
	DiaSound();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(DiaSound)

// Form Data
public:
	//{{AFX_DATA(DiaSound)
	enum { IDD = IDD_SOUND_DIALOG };
	CButton	m_CheckDisableSound;
	CString	m_ComboString;
	//}}AFX_DATA

// Attributes
public:
	tdoCopyBuffer *m_p_oCopyBuffer;
	CString			m_csReachableName[255];
	unsigned long	m_ulReachableHandle[255];
	int m_wNumberOfReachableNames;
	SND_tdxHandleToSoundMaterial m_hHandleToSoundMaterial;
	unsigned long m_ulSound;
	BOOL m_bHasBeenInitialized;
	//GMT_tdxHandleToGameMaterial m_hHandleToGameMaterial;
	unsigned long m_ulDefaultSoundHandle;

// Operations
public:
	void fn_vInitDialog ( void );
	void m_fn_vShowMaterial(GMT_tdxHandleToGameMaterial _hMat);
	BOOL m_fn_bGetReachablesNames();
	void m_fn_vEnableWindowFields(BOOL bEnable);
	// Copy/Paste functions
	void m_fn_vCopy();									// Copy the parameters into the copy buffer
	void m_fn_vPaste();									// Paste the parameters from the copy buffer
	unsigned long m_fn_ulFindHandleFromName(CString _csName);
	CString m_fn_csFindNameFromHandle(unsigned long _ulHandle);

private:
	virtual int OnToolHitTest( CPoint point, TOOLINFO* pTI ) const;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DiaSound)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~DiaSound();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(DiaSound)
	afx_msg void OnButtonCopySoundMaterial();
	afx_msg void OnButtonInstanciatesound();
	afx_msg void OnButtonPasteSoundMaterial();
	afx_msg void OnCheckDisableSound();
	afx_msg void OnSelChangeComboType();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////



#endif




