// Constant string definitions
////////////////////////////////
#ifndef _EDIRSTRG_HPP_
#define _EDIRSTRG_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "SCR.h"
#include "AI\AIBase\ReadRule.h"

#ifndef M_MAKECHAR
#define M_MAKECHAR(a) ((char *)(LPCTSTR(a)))
#endif //M_MAKECHAR

#define C_VERSION_NUMBER	"v4.18.0"
#define C_MODULE_NAME			"IA Editor"
#define C_VERSION					C_MODULE_NAME" "C_VERSION_NUMBER" "__DATE__

//////////////////////
// Used for Scripts	//
//////////////////////

const CString	g_c_csBrainName											="EditorBrain";

const CString	g_c_csIntelligenceSectionName				="CreateEditorIntelligence";
const CString	g_c_csIntelligenceFileExtension			=".eru";
/* CHRISTOPHE QUICK SAVE MODIFICATIONS */ 
const CString	g_c_csIntelligenceFileExtensionQS		=".tru";
/* END CHRISTOPHE QUICK SAVE MODIFICATIONS */
const CString	g_c_csIntelligenceTextFileExtension	=".eit";

const CString	g_c_csReflexSectionName							="CreateEditorReflex";
const CString	g_c_csReflexFileExtension						=".erf";
/* CHRISTOPHE QUICK SAVE MODIFICATIONS */
const CString	g_c_csReflexFileExtensionQS					=".trf";
/* END CHRISTOPHE QUICK SAVE MODIFICATIONS */
const CString	g_c_csReflexTextFileExtension				=".ert";

const CString	g_c_csDeclarationSectionName				="CreateEditorDeclaration";
const CString	g_c_csDeclarationFileExtension			=".ede";
/* CHRISTOPHE QUICK SAVE MODIFICATIONS */
const CString	g_c_csDeclarationFileExtensionQS		=".tde";
/* END CHRISTOPHE MODIFICATIONS */
const CString	g_c_csDeclarationTextFileExtension	=".edt";

// BEGIN CPA2 Cristi Petrescu 98-03-
const CString	g_c_csMacroSectionName							="CreateEditorMacro";
const CString	g_c_csMacroFileExtension						=".emc";
const CString	g_c_csMacroTextFileExtension					=".emt";
const CString	g_c_csMacroFileExtensionQS					    =".tmc";
// END CPA2 Cristi Petrescu 98-03-

// BEGIN ROMTEAM CPA2 Cristi Petrescu 98-04-
const CString	g_c_csSubrSectionName							="CreateEditorSubr";
const CString	g_c_csSubrFileExtension						=".esb";
const CString	g_c_csSubrTextFileExtension					=".est";
const CString	g_c_csSubrFileExtensionQS					    =".tsb";
// END ROMTEAM CPA2 Cristi Petrescu 98-04-

const CString	g_c_csBehaviourSectionName					="CreateEditorBehaviour";
const CString	g_c_csBehaviourLanguage							="Language";
const CString	g_c_csBehaviourName									="Name";
const CString	g_c_csBehaviourBoundingBox					="BoundingBox";
const CString	g_c_csBehaviourText									="Text";
//BEGIN ROMTEAM Cristi Petrescu 98-06-
const CString	g_c_csShowPrivateVariable					= "ShowPrivate";
//END ROMTEAM Cristi Petrescu 98-06-

//////////////////////////////
// Used for DsgVar Controls	//
//////////////////////////////

const CString	g_c_csDsgVarInitText				=" (Init)";
const CString	g_c_csDsgVarSaveTypeText		=" (Save Type)";
const CString	g_c_csDsgVarInitTypeText		=" (Init Type)";
const CString	g_c_csDsgVarIndexText				="Index of ";

//////////////////////////////
// Used for Engine Scripts	//
//////////////////////////////

const CString	g_c_csAISectionName					=C_CreateAIModel_String;
const	CString	g_c_csAIFileExtension				=".ai";
const	CString	g_c_csAIDecSectionName			=C_CreateVariableDeclarationAIModel_String;
const	CString	g_c_csAIDecFileExtension		=".dec";
const	CString	g_c_csAIRulSectionName			=C_CreateIntellAIModel_String;
const	CString	g_c_csAIRulFileExtension		=".rul";
const	CString	g_c_csAIRfxSectionName			=C_CreateReflexAIModel_String;
const	CString	g_c_csAIRfxFileExtension		=".rfx";
//BEGIN ROMTEAM Cristi Petrescu 98-04-
const	CString	g_c_csAISubrSectionName			=C_CreateMacroAIModel_String;
const	CString	g_c_csAISubrFileExtension		=".mac";
//END ROMTEAM Cristi Petrescu 98-04-
// Shaitan FastC {
const	CString	g_c_csAICrrSectionName			="CreateRefAIModel";
const	CString	g_c_csAINodeSectionName			="CreateRefTree";
const	CString	g_c_csAICrrFileExtension		=".crr";
const	CString	g_c_csAINodeFileExtension		=".nod";
const	CString	g_c_csAIFastIsC_SectionName		="CFast_IsC";
const	CString	g_c_csAIFastFId_SectionName		="CFast_FunctionIndex";
//End Shaitan FastC }

const	CString	g_c_csAIDefineFileName			=C_DefineAIFiles;
const	CString	g_c_csAIDefineSectionName		=C_CreateAIDefines_String;
const	CString	g_c_csAIDefineConstantRef		=C_ConstantRefString;
const	CString	g_c_csAIDefineRealRef				=C_RealRefString;

const CString	g_c_csRulSectionName				=C_CreateIntelligence_String;
const CString	g_c_csRfxSectionName				=C_CreateIntelligence_String;
const CString	g_c_csDecSectionName				=C_CreateVariables_String;
const CString	g_c_csCarDecSectionName			=C_InitVariables_String;
const CString	g_c_csCarRulSectionName			=C_InitComportIntelligence_String;
const CString	g_c_csCarRfxVarSectionName	=C_InitComportReflex_String;
//BEGIN ROMTEAM Cristi Petrescu 98-04-
const CString	g_c_csEngSubrSectionName				=C_CreateListOfMacro_String;
//END ROMTEAM Cristi Petrescu 98-04-

const CString	g_c_csBehavSectionName			=C_CreateComport_String;

const	CString g_c_csDecSaveTypeEntryName	=C_TypeSaveVariables_String;
const	CString g_c_csDecInitTypeEntryName	=C_TypeInitVariables_String;

////////////////////
// Used for Bison //
////////////////////

const CString	g_c_csCreateSchedule		=C_CreateSchedule_String;
const CString	g_c_csCreateRule				=C_CreateRule_String;
const CString	g_c_csCreateDsgVar			=C_CreateVariables_String;
//BEGIN ROMTEAM Cristi Petrescu 98-04-
const CString   g_c_csCreateSubr			=C_CreateMacro_String;
//END ROMTEAM Cristi Petrescu 98-04-

const CString	g_c_csBeginMacro				="BeginMacro";
const CString	g_c_csEndMacro					="EndMacro";

const CString	g_c_csKeyWord						=C_KeyWordString;
const CString	g_c_csCondition					=C_ConditionString;
const CString	g_c_csMetaAction				=C_MetaActionString;
const CString	g_c_csProcedure					=C_ProcedureString;
//BEGIN ROMTEAM Cristi Petrescu 98-04-
const CString	g_c_csSubrRef					=C_MacroRefString;
//END ROMTEAM Cristi Petrescu 98-04-
const CString	g_c_csField							=C_FieldString;
const CString	g_c_csConstant					=C_ConstantString;
const CString	g_c_csConstantRef				=C_ConstantRefString;
const CString	g_c_csOperator					=C_OperatorString;
const CString	g_c_csFunction					=C_FunctionString;
const CString	g_c_csDsgVarRef					=C_DsgVarRefString;
const CString	g_c_csPerso							=C_PersoRefString;
const CString	g_c_csReal							=C_RealString;
const CString	g_c_csRealRef						=C_RealRefString;
const CString	g_c_csZdd								="Zdd";
const CString	g_c_csZde								="Zde";
const CString	g_c_csZdm								="Zdm";
const CString	g_c_csZdr								="Zdr";
const CString	g_c_csVector						=C_VectorString;
const CString	g_c_csVectorConstant		=C_ConstantVectorString;
const CString	g_c_csAction						=C_ActionRefString;
const CString	g_c_csState							="State";
const CString	g_c_csWayPoint					=C_WayPointString;
const CString	g_c_csModule						=C_ModuleString;
const CString	g_c_csDsgVarId					=C_DsgVarIdString;
const CString	g_c_csKeyButton					=C_ButtonString;
const CString	g_c_csComport						=C_ComportRefString;
const CString	g_c_csMaskType					=C_MaskString;
const CString	g_c_csPower							=C_ConstantString;
// Shaitan Clean Env {
//const CString	g_c_csSurface						=C_SurfaceRefString;
//const CString	g_c_csEnvironment				=C_EnvironmentRefString;
//End Shaitan Clean Env }
const CString	g_c_csSector						=C_SectorRefString;
const CString	g_c_csSuperObject				=C_SuperObjectRefString;
const CString	g_c_csLipSynchro				=C_LipSynchroRefString;
const CString	g_c_csObjectTable				=C_ObjectTableRefString;
const CString	g_c_csFamily						=C_FamilyRefString;
const CString	g_c_csModel							=C_ModelRefString;
const CString	g_c_csSoundEvent				=C_SoundEventRefString;
const CString	g_c_csString						=C_StringString;
const CString	g_c_csTextRef						=C_TextRefString;
//const CString	g_c_csFontRef						=C_FontRefString;
const CString	g_c_csGameMaterial			=C_GameMaterialRefString;
const CString	g_c_csLight							=C_LightString;
const CString	g_c_csCaps              =C_CapsString;
const CString	g_c_csGraph             =C_GraphString;
const CString	g_c_csParticleGenerator	=C_ParticleGeneratorString;
const CString	g_c_csMyRfxBehaviour		="MyReflexBehaviour";
const CString	g_c_csMyIABehaviour			="MyIntelligenceBehaviour";
const CString	g_c_csRfxBehaviour			="ReflexBehaviour";
const CString	g_c_csIABehaviour				="IntelligenceBehaviour";

////////////////////
// Used for Other //
////////////////////

const CString g_c_csDsgVarName					="Variables designer";
const CString g_c_csMacroName						="Macros";

const CString	g_c_csReturn							="\xd\xa";

const	CString	g_c_csInteger							="Integer";
const	CString	g_c_csDecimal							="Decimal";
const	CString	g_c_csBoolean							="Boolean";
const	CString	g_c_csEnum								="Enum";
const	CString	g_c_csText								="Text";
const	CString	g_c_csObjectList					="ObjectList";

const	CString	g_c_csTrue								="True";
const	CString	g_c_csFalse								="False";

const	CString	g_c_csInitialIABehaviour	="Initial IA Behaviour";
const	CString	g_c_csInitialRfxBehaviour	="Initial Reflex Behaviour";
const	CString	g_c_csCurrentIABehaviour	="Current IA Behaviour";
const	CString	g_c_csCurrentRfxBehaviour	="Current Reflex Behaviour";

#endif //_EDIRSTRG_HPP_
