// Definition of Strings used to describe the fields in the Mechanics Editor
////////////////////////////////////////////////////////////////////////////
#ifndef _EMEC_FIELDS_DESCRIPTOR_STRINGS_
#define _EMEC_FIELDS_DESCRIPTOR_STRINGS_

////////////////////
// Walk type cards //
/////////////////////
// also used by Jump type cards
const CString g_c_cs_FieldName_Walk_Mass								= "Mass (kg)";
const CString g_c_cs_FieldName_Walk_FatherSonLink				= "Father-Son link";
const CString g_c_cs_FieldName_Walk_StairsStepHeight		= "Stairs Step Height (m)";
const CString g_c_cs_FieldName_Walk_MinLinearSpeed			= "Min Linear Speed (m/s)";
const CString g_c_cs_FieldName_Walk_MaxLinearSpeed			= "Max Linear Speed (m/s)";
const CString g_c_cs_FieldName_Walk_MinAngularSpeed			= "Min Angular Speed (deg/s)";
const CString g_c_cs_FieldName_Walk_MaxAngularSpeed			= "Max Angular Speed (deg/s)";
const CString g_c_cs_FieldName_Walk_GroundLimit					= "Ground Limit (deg)";
const CString g_c_cs_FieldName_Walk_SlopeLimit					= "Slope Limit (deg)";
const CString g_c_cs_FieldName_Walk_WallLimit						= "Wall Limit (deg)";
const CString g_c_cs_FieldName_Walk_AtticLimit					= "Attic Limit (deg)";
const CString g_c_cs_FieldName_Walk_StepFrontLimit			= "Step Front Limit (deg)";
const CString g_c_cs_FieldName_Walk_StepHighLimit				= "Step High Limit (deg)";
const CString g_c_cs_FieldName_Walk_IsOrientationFree		= "Is Orientation Free";
const CString g_c_cs_FieldName_Walk_OrientationVelocity = "Orientation Velocity (deg/s)";
const CString g_c_cs_FieldName_Walk_IsDTForced					= "Is Dt Forced";
const CString g_c_cs_FieldName_Walk_MechanicsEngineFrequency = "Mechanics Eng. Freq.(Hz)";
const CString g_c_cs_FieldName_Walk_IsAgainstWall				= "Is Against Wall";
const CString g_c_cs_FieldName_Walk_WallOrientationVelocity = "Wall Orient. Velocity (deg/s)";
const CString g_c_cs_FieldName_Walk_BringDownHeight			= "Bring Down Height";
const CString g_c_cs_FieldName_Walk_AirResistingSurface	= "Air Resisting Surface";
const CString g_c_cs_FieldName_Walk_GravityRatio				= "Gravity Ratio";


////////////////////
// Ski type cards //
////////////////////
const CString g_c_cs_FieldName_Ski_Mass									= "Mass (kg)";
const CString g_c_cs_FieldName_Ski_Factor								= "Factor";
const CString g_c_cs_FieldName_Ski_MinLinearSpeed				= "Min Linear Speed (m/s)";
const CString g_c_cs_FieldName_Ski_MaxLinearSpeed				= "Max Linear Speed (m/s)";
const CString g_c_cs_FieldName_Ski_MinAngularSpeed			= "Min Angular Speed (deg/s)";
const CString g_c_cs_FieldName_Ski_MaxAngularSpeed			= "Max Angular Speed (deg/s)";
const CString g_c_cs_FieldName_Ski_SlideCoef						= "Slide Coef";
const CString g_c_cs_FieldName_Ski_TChaseTimeConstant		= "TChase Time Constant";
const CString g_c_cs_FieldName_Ski_HandCoef							= "HandCoef";
const CString g_c_cs_FieldName_Ski_ReturnCoeff					= "ReturnCoeff";
const CString g_c_cs_FieldName_Ski_EdgeCoeff						= "EdgeCoeff";
const CString g_c_cs_FieldName_Ski_PlaquageCoeff				= "PlaquageCoeff";
const CString g_c_cs_FieldName_Ski_GravityCoeff					= "GravityCoeff";
const CString g_c_cs_FieldName_Ski_AlphaFilter					= "AlphaFilter";
const CString g_c_cs_FieldName_Ski_InTheAirControl			= "InTheAirControl";
const CString g_c_cs_FieldName_Ski_InTheAirGravity			= "InTheAirGravity";
const CString g_c_cs_FieldName_Ski_PlaquageGap					= "PlaquageGap";
const CString g_c_cs_FieldName_Ski_PlaquageAngle				= "PlaquageAngle (deg)";
const CString g_c_cs_FieldName_Ski_MinSpeedToCompute		= "MinSpeedToCompute";


/////////////////////
// Swim type cards //
/////////////////////
const CString g_c_cs_FieldName_Swim_Mass											= "Mass";
const CString g_c_cs_FieldName_Swim_TractionScale							= "Traction Scale";
const CString g_c_cs_FieldName_Swim_AlphaTimeConstant					= "Alpha Time Constant";
const CString g_c_cs_FieldName_Swim_ThetaTimeConstant					= "Theta Time Constant";
const CString g_c_cs_FieldName_Swim_TractionScaleTimeConstant = "Traction Scale Time Constant";
const CString g_c_cs_FieldName_Swim_AlphaPas									= "Alpha Pas";
const CString g_c_cs_FieldName_Swim_ThetaPas									= "Theta Pas";
const CString g_c_cs_FieldName_Swim_TractionScalePas					= "Traction Scale Pas";
const CString g_c_cs_FieldName_Swim_ArchimedaRadius						= "Archimeda Radius";
const CString g_c_cs_FieldName_Swim_LimitVolumeCoef						= "Limit Volume Coef";
const CString g_c_cs_FieldName_Swim_CrossingAirWaterCoef			= "Crossing Air Water Coef";
const CString g_c_cs_FieldName_Swim_DepthOfLimitVolume				= "Depth Of Limit Volume";
const CString g_c_cs_FieldName_Swim_AlphaDecay								= "Alpha Decay";
const CString g_c_cs_FieldName_Swim_AlphaMin									= "Alpha Min";
const CString g_c_cs_FieldName_Swim_AlphaMax									= "Alpha Max";
const CString g_c_cs_FieldName_Swim_AlphaOffset								= "Alpha Offset";


//////////////////////
// Stone type cards //
//////////////////////
const CString g_c_cs_FieldName_Stone_Mass							= "Mass (kg)";
const CString g_c_cs_FieldName_Stone_Diameter					= "Diameter (m)";
const CString g_c_cs_FieldName_Stone_MechanicsEngineFrequency	= "Mechanics Eng. Freq.(Hz)";
const CString g_c_cs_FieldName_Stone_Center_X					= "Center X";
const CString g_c_cs_FieldName_Stone_Center_Y					= "Center Y";
const CString g_c_cs_FieldName_Stone_Center_Z					= "Center Z";
	
/////////////////////
// Raft type cards //
/////////////////////
const CString g_c_cs_FieldName_Raft_TorqueResistance		= "Torque Resistance";
const CString g_c_cs_FieldName_Raft_IAxisModificator		= "I Axis Modificator";
const CString g_c_cs_FieldName_Raft_JAxisModificator		= "J Axis Modificator";
const CString g_c_cs_FieldName_Raft_SinkCoeff						= "Sink Coeff";
const CString g_c_cs_FieldName_Raft_SinkMaxDistance			= "Sink Max Distance";
const CString g_c_cs_FieldName_Raft_VerticalSpeedTreshold		= "Vertical Speed Treshold (m/s)";
const CString g_c_cs_FieldName_Raft_MaxAngularSpeed			= "Max Angular Speed (rad/s)";
const CString g_c_cs_FieldName_Raft_AngularSpeedTreshold		= "Angular Speed Treshold (rad/s)";

/////////////////////////
// Platform type cards //
/////////////////////////
const CString g_c_cs_FieldName_Platform_Mass								= "Mass (kg)";
const CString g_c_cs_FieldName_Platform_MinLinearSpeed			= "Min Linear Speed (m/s)";
const CString g_c_cs_FieldName_Platform_MaxLinearSpeed			= "Max Linear Speed (m/s)";
const CString g_c_cs_FieldName_Platform_MinAngularSpeed			= "Min Angular Speed (deg/s)";
const CString g_c_cs_FieldName_Platform_MaxAngularSpeed			= "Max Angular Speed (deg/s)";
const CString g_c_cs_FieldName_Platform_GravityRatio				= "Gravity Ratio";
const CString g_c_cs_FieldName_Platform_ViscosityFactor			= "Viscosity Factor";
const CString g_c_cs_FieldName_Platform_StiffnessFactor			= "Stiffness Factor";

//ANNECY jt {
/////////////////////
// Base type cards //
/////////////////////
const CString g_c_cs_FieldName_Base_Animation			= "Animation";
const CString g_c_cs_FieldName_Base_Collide				= "Collide";
const CString g_c_cs_FieldName_Base_Gravity				= "Gravity";
const CString g_c_cs_FieldName_Base_Tilt				= "Tilt";
const CString g_c_cs_FieldName_Base_Gi				    = "Gi";
const CString g_c_cs_FieldName_Base_Climb				= "Climb";
const CString g_c_cs_FieldName_Base_OnGround			= "OnGround";
const CString g_c_cs_FieldName_Base_Spider				= "Spider";
const CString g_c_cs_FieldName_Base_Shoot				= "Shoot";
const CString g_c_cs_FieldName_Base_Swim				= "Swim";
const CString g_c_cs_FieldName_Base_CollisionControl	= "Collision control";
const CString g_c_cs_FieldName_Base_KeepSpeedZ		    = "KeepSpeedZ";
const CString g_c_cs_FieldName_Base_SpeedLimit		    = "SpeedLimit";
const CString g_c_cs_FieldName_Base_Inertia				= "Inertia";
const CString g_c_cs_FieldName_Base_Stream				= "Stream";
const CString g_c_cs_FieldName_Base_StickOnPlatform		= "StickOnPlatform";
const CString g_c_cs_FieldName_Base_Scale				= "Scale";

const CString g_c_cs_FieldName_Base_GravityFactor		= "g";
const CString g_c_cs_FieldName_Base_Slide				= "Slide";
const CString g_c_cs_FieldName_Base_Rebound				= "Rebound";
const CString g_c_cs_FieldName_Base_SlopeLimit			= "SlopeLimit";
const CString g_c_cs_FieldName_Base_InertiaFactorX		= "Ix";
const CString g_c_cs_FieldName_Base_InertiaFactorY		= "Iy";
const CString g_c_cs_FieldName_Base_InertiaFactorZ		= "Iz";
const CString g_c_cs_FieldName_Base_TiltIntensity		= "TiltIntensity";
const CString g_c_cs_FieldName_Base_TiltInertia			= "TiltInertia";
const CString g_c_cs_FieldName_Base_TiltOrigin			= "TiltOrigin";
const CString g_c_cs_FieldName_Base_MaxSpeed			= "MaxSpeed";
//ENDANNECY jt }

#endif //_EMEC_FIELDS_DESCRIPTOR_STRINGS_


