// Modification functions for Data
//////////////////////////////////////
#include "StdAfx.h"

#include "EMECDtMd.hpp"

//External Modules
#include "ErO.h"
#include "CTL.h"
//End of External Modules

//*******************************************************************************
void EMEC_fn_vModifFloatFromCosToDegre(CTL_Editor_Data *_pclBaseData)
{
	ERROR_ASSERT( _pclBaseData != NULL );
	ERROR_ASSERT( _pclBaseData->m_pub_fn_tdeGetDataType() == CTL_DATA_TYPE__DECIMAL );

	CTL_Editor_DecimalData *pclTrueData = (CTL_Editor_DecimalData *)_pclBaseData;
	long double ldValue = pclTrueData->m_ldCurrentValue;
	ldValue = MTH_M_xACos(ldValue);
	ldValue = MTH_M_xRadToDeg(ldValue);

	pclTrueData->m_ldCurrentValue = ldValue;
}

//*******************************************************************************
void EMEC_fn_vModifFloatFromDegreToCos(CTL_Editor_Data *_pclBaseData)
{
	ERROR_ASSERT( _pclBaseData != NULL );
	ERROR_ASSERT( _pclBaseData->m_pub_fn_tdeGetDataType() == CTL_DATA_TYPE__DECIMAL );

	CTL_Editor_DecimalData *pclTrueData = (CTL_Editor_DecimalData *)_pclBaseData;
	long double ldValue = pclTrueData->m_ldCurrentValue;
	ldValue = MTH_M_xDegToRad(ldValue);
	ldValue = MTH_M_xCos(ldValue);

	pclTrueData->m_ldCurrentValue = ldValue;
}
	
//*******************************************************************************
void EMEC_fn_vModifFloatFromRadianPerSecondToDegrePerSecond(CTL_Editor_Data *_pclBaseData)
{
	ERROR_ASSERT( _pclBaseData != NULL );
	ERROR_ASSERT( _pclBaseData->m_pub_fn_tdeGetDataType() == CTL_DATA_TYPE__DECIMAL );

	CTL_Editor_DecimalData *pclTrueData = (CTL_Editor_DecimalData *)_pclBaseData;
	long double ldValue = pclTrueData->m_ldCurrentValue;
	ldValue = MTH_M_xRadToDeg(ldValue);

	pclTrueData->m_ldCurrentValue = ldValue;
}
	
//*******************************************************************************
void EMEC_fn_vModifFloatFromDegrePerSecondToRadianPerSecond(CTL_Editor_Data *_pclBaseData)
{
	ERROR_ASSERT( _pclBaseData != NULL );
	ERROR_ASSERT( _pclBaseData->m_pub_fn_tdeGetDataType() == CTL_DATA_TYPE__DECIMAL );

	CTL_Editor_DecimalData *pclTrueData = (CTL_Editor_DecimalData *)_pclBaseData;
	long double ldValue = pclTrueData->m_ldCurrentValue;
	ldValue = MTH_M_xDegToRad(ldValue);

	pclTrueData->m_ldCurrentValue = ldValue;
}
	
//*******************************************************************************
void EMEC_fn_vModifFloatFromHertzToSecond(CTL_Editor_Data *_pclBaseData)
{
	ERROR_ASSERT( _pclBaseData != NULL );
	ERROR_ASSERT( _pclBaseData->m_pub_fn_tdeGetDataType() == CTL_DATA_TYPE__DECIMAL );

	CTL_Editor_DecimalData *pclTrueData = (CTL_Editor_DecimalData *)_pclBaseData;
	long double ldValue = pclTrueData->m_ldCurrentValue;
	ldValue = 1 / ldValue;

	pclTrueData->m_ldCurrentValue = ldValue;
}
	
//*******************************************************************************
void EMEC_fn_vModifFloatFromSecondToHertz(CTL_Editor_Data *_pclBaseData)
{
	ERROR_ASSERT( _pclBaseData != NULL );
	ERROR_ASSERT( _pclBaseData->m_pub_fn_tdeGetDataType() == CTL_DATA_TYPE__DECIMAL );

	CTL_Editor_DecimalData *pclTrueData = (CTL_Editor_DecimalData *)_pclBaseData;
	long double ldValue = pclTrueData->m_ldCurrentValue;
	ldValue = 1 / ldValue;

	pclTrueData->m_ldCurrentValue = ldValue;
}

