/*=========================================================================
* 
* LPSinter.hpp :  LipSync DLL Interface - definition
* 
*
* Version			1.0
* Creation date		16/08/97	
* Revision date		18/08/97
*
* Shaitan
*=======================================================================*/

#ifndef __LPS_INTER_HPP__
#define __LPS_INTER_HPP__

#include "incITF.h"

// if you want only one instance of your DLL
// activate the next line
#define DLL_ONLY_ONE_INSTANCE

class LPS_DialogLoad;

/*===========================================================================
*		Description:	class LipSync_Interface
*		Creation date:	16/08/97
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:	18/08/97		Author: Shaitan       
*=========================================================================*/
class LipSync_Interface : public CPA_ToolDLLBase
{
protected:
	LPS_DialogLoad *m_pDialogLoad;
	long			m_lNbUnloaded;

public:
	LipSync_Interface  (void);
	~LipSync_Interface (void);


//====================================================================================
//========================= COMMON DLL FUNCTIONS OVERLOAD ============================
//====================================================================================

	// ACP Messages Functions overload
	void   fn_vConstruct				(void);
    void   fn_vJustAfterRegistered      (void);
    void   fn_vLevelChanges             (void);

	// Menus
    BOOL fn_bDefineSubMenu				(EDT_SubMenu *p_oEDTSubMenu);
    void _OnSubMenuCommand				(EDT_SubMenu *p_oEDTSubMenu, UINT uiMsgID);

    // Reachable Objects
    BOOL fn_bLoadBaseObject				(CPA_BaseObject *p_oObject);


//====================================================================================
//=========================== TOOL DLL FUNCTIONS OVERLOAD ============================
//====================================================================================

	// To communicate with that editor
	long OnQueryAction					(CPA_EditorBase *p_oSender, WPARAM, LPARAM);

//====================================================================================
//=========================== LIPSYNC TOOL DLL SPECIFIC FUNCTIONS =====================
//====================================================================================

	void fn_vLoadFamilyLipSynchros		(CString csFamilyName);

};

extern tdstDLLIdentity g_stLipSyncIdentity;

#endif // __LPS_INTER_HPP__