/*=========================================================================
* 
* dllcom.cpp :  DLL definition
* 
*
* Version			1.0
* Creation date		18/08/97	Author : C. Beaudet	
* Revision date		18/08/97	Author : Shaitan
*
* Shaitan
*=======================================================================*/

//MFC
#include "stdafx.h"
#include "afxdllx.h"
//Interface
#include "ACP_Base.h"
#include "ITF.h"
//local
#include "LPSinter.hpp"
#include "TLS/LPSconst.hpp"
#include "X:\Cpa\Main\Inc\_EditID.h"

//------------------------------------------------------------------------
// Global vars
static char		*gs_p_szCPAVersion = C_szCPAVersion;
static AFX_EXTENSION_MODULE NEAR    extensionDLL = { NULL, NULL };

#ifdef DLL_ONLY_ONE_INSTANCE
static LipSync_Interface *gs_p_oLipSyncInterface = NULL;
#endif

static CList<CPA_DLLBase*,CPA_DLLBase*> g_oListOfInstances;	//private internal


//------------------------------------------------------------------------
// functions that are present in all DLL :
//------------------------------------------------------------------------

//========================================================================
// Get current CPA version
//========================================================================
extern "C" char __declspec(dllexport) *fn_p_szGetCPAVersion(void)
{
    return gs_p_szCPAVersion;
}

//========================================================================
// Get type of this DLL
//========================================================================
extern "C" tdstDLLIdentity __declspec(dllexport) *fn_p_stGetDLLIdentity(void)
{
    g_stLipSyncIdentity . eType                 = TOOL_DLL;
    g_stLipSyncIdentity . csName                = C_szLipSyncDLLName;
    g_stLipSyncIdentity . hModule               = NULL;
    g_stLipSyncIdentity . p_oListOfInstances    = &g_oListOfInstances;
	return &g_stLipSyncIdentity;
}

//========================================================================
// DLL int function
//========================================================================
extern "C" void __declspec(dllexport) fn_vInitDll(void)
{
	new CDynLinkLibrary(extensionDLL);
}

//========================================================================
// DLL entry point
//========================================================================
extern "C" int __stdcall DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		if (!AfxInitExtensionModule(extensionDLL, hInstance))
		   return 0;
	}
	return 1;
}

//========================================================================
// Get the DLL
//========================================================================
extern "C" CPA_DLLBase __declspec(dllexport) *fn_p_oGetDLL(long lKey)
{
#ifdef DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		if (gs_p_oLipSyncInterface == NULL)
		{
			gs_p_oLipSyncInterface = new LipSync_Interface();
			ASSERT(gs_p_oLipSyncInterface != NULL);
		}
		return gs_p_oLipSyncInterface;
		break;

	default:
		return NULL;
	}

#else //DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		return new LipSync_Interface();
		break;

	default:
		return NULL;
	}

#endif //DLL_ONLY_ONE_INSTANCE
}


//------------------------------------------------------------------------
// functions that are present in this type of DLL only :
//------------------------------------------------------------------------

#undef DLL_ONLY_ONE_INSTANCE