/*=========================================================================
* 
* ot_intf.hpp :  ObjectTable DLL Interface - definition
* 
* Version			2.0
* Creation date		06/06/97	Author : Vincent Lhullier	
* Revision date		18/08/97	Author : Shaitan	
*
* Shaitan
*=======================================================================*/

#ifndef __OT_INTF_HPP__
#define __OT_INTF_HPP__

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#include "incGAM.h"
#include "x:\cpa\main\inc\_editid.h"
#include "TOT.h"
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#define DLL_ONLY_ONE_INSTANCE

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

class CPA_Family;
class OT_DialogLoad;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*===========================================================================
*		Description:	class ObjectTableInterface
*		Creation date:	06/06/97
*		Author:			Vincent Lhullier
*---------------------------------------------------------------------------
*		Revision date:	18/08/97		Author: Shaitan       
*=========================================================================*/
class ObjectTableInterface : public CPA_ToolDLLBase
{
protected:
	OT_DialogLoad	*m_pDialogLoad;
	long			 m_lNbUnloaded;

public:
    ObjectTableInterface  (void);
    ~ObjectTableInterface (void);

//====================================================================================
//========================= COMMON DLL FUNCTIONS OVERLOAD ============================
//====================================================================================


	// ACP Messages Functions overload	
	void	fn_vConstruct				(void);
	void	fn_vJustAfterRegistered		(void);

	// Menus
    BOOL	fn_bDefineSubMenu			(EDT_SubMenu *p_oEDTSubMenu);
    void	_OnSubMenuCommand			(EDT_SubMenu *p_oEDTSubMenu, UINT uiMsgID);

    // Reachable Objects
	BOOL	fn_bLoadBaseObject			(CPA_BaseObject *p_oObject);

//====================================================================================
//=========================== TOOL DLL FUNCTIONS OVERLOAD ============================
//====================================================================================

	// To communicate with that editor
	long OnQueryAction					(CPA_EditorBase *p_oSender, WPARAM, LPARAM);


//====================================================================================
//=========================== OBJECT TABLES TOOL DLL SPECIFIC FUNCTIONS =====================
//====================================================================================

	void	m_fn_vLoadFamilyObjectTables (CPA_Family *p_oFamily);
};


#undef extern
extern tdstDLLIdentity g_stOTIdentity;

#endif //__OT_INTF_HPP__