/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          mng_win.h

DESCRIPTION :  Include file of VDO module

VERSION :       1.00/Nicolas Meyer/Creation

		Nota Bene : This file is only portable on PC platform
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#if !defined(_mng_win_h_)
#define _mng_win_h_

#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif

/* ##CONSTANTE#--------------------------------------------------------------------------
                          Constantes declaration
---------------------------------------------------------------------------------------*/
#define C_VDO_NONE		0
#define C_VDO_STOP		1
#define C_VDO_PLAY		2
#define C_VDO_PAUSE		3
#define C_VDO_LOADED	4
#define C_VDO_ERROR		5
 
#define C_VDO_FULLSCREEN	0
#define C_VDO_WINDOWED		1

#define C_VDO_MAXOPENVIDEO	4

/* ##TYPEDEF#----------------------------------------------------------------------------
                          Types definition
---------------------------------------------------------------------------------------*/

/* ##-########################### 
   ##     *VDO_tdxHandleToVideo
   ############################## */
typedef struct tdstVideo_ *VDO_tdxHandleToVideo;

/* ##-########################### 
   ##         tdstVideo
   ############################## */
typedef struct tdstVideo_
{
	HWND			hVideoWindow;
	MCIDEVICEID		hDeviceId;
	unsigned char	ucMode;
} tdstVideo;



/*#define VDO_tdxHandleToVideo HWND; */


extern "C"
{

/* ##F===================================================================================
NAME :          VDO_fn_szGetCommandLine
DESCRIPTION :   Get the command line in VDO
INPUT :         
OUTPUT :        string
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT char * VDO_fn_szGetCommandLine();

/* ##F===================================================================================
NAME :          VDO_fn_vInitVideo
DESCRIPTION :   Init the video window
INPUT :         
OUTPUT :        
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/	
extern CPA_EXPORT void VDO_fn_vInitVideo();

/* ##F===================================================================================
NAME :          VDO_fn_vDesInitVideo
DESCRIPTION :   Desinit the video window in VDO
INPUT :         
OUTPUT :        
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT void VDO_fn_vDesInitVideo();

/* ##F===================================================================================
NAME :          VDO_fn_xOpenVideo
DESCRIPTION :   Open the video file in VDO
INPUT :         *szFilename (name of the video)
OUTPUT :        handle of object video
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT VDO_tdxHandleToVideo VDO_fn_xOpenVideo(char *szFilename);

/* ##F===================================================================================
NAME :          VDO_fn_xPlayVideo
DESCRIPTION :   Play the video in VDO
INPUT :         p_stVideoHandle (handle of the video object)
		ucMode (playing mode)
OUTPUT :        
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT void VDO_fn_xPlayVideo(VDO_tdxHandleToVideo p_stVideoHandle, unsigned char ucMode);

/* ##F===================================================================================
NAME :          VDO_fn_xStopVideo
DESCRIPTION :   Stop the video in VDO
INPUT :         p_stVideoHandle (handle of the video object)
OUTPUT :        
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT void VDO_fn_xStopVideo(VDO_tdxHandleToVideo p_stVideoHandle);

/* ##F===================================================================================
NAME :          VDO_fn_xCloseVideo
DESCRIPTION :   Close the video file in VDO
INPUT :         p_stVideoHandle (handle of the video object)
OUTPUT :        
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT void VDO_fn_xCloseVideo(VDO_tdxHandleToVideo p_stVideoHandle);

/* ##F===================================================================================
NAME :          VDO_fn_xOpenVideoMPEG
DESCRIPTION :   Open a MPEG video file
INPUT :         *szFilename (name of the file)
OUTPUT :        handle of the video object
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/	
extern CPA_EXPORT VDO_tdxHandleToVideo VDO_fn_xOpenVideoMPEG(char *szFilename);

/* ##F===================================================================================
NAME :          VDO_fn_xPlayVideoMPEG
DESCRIPTION :   Play a MPEG video
INPUT :         p_stVideoHandle (handle of the video object)
		ucMode (playing mode)
OUTPUT :
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT void VDO_fn_xPlayVideoMPEG(VDO_tdxHandleToVideo p_stVideoHandle, unsigned char ucMode);

/* ##F===================================================================================
NAME :          VDO_fn_xStopVideoMPEG
DESCRIPTION :   Stop a MPEG video
INPUT :         p_stVideoHandle (handle of the video object)
OUTPUT :
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT void VDO_fn_xStopVideoMPEG(VDO_tdxHandleToVideo p_stVideoHandle);

/* ##F===================================================================================
NAME :          VDO_fn_xCloseVideoMPEG
DESCRIPTION :   Close a MPEG video file
INPUT :         p_stVideoHandle (handle of the video object)
OUTPUT :
=========================================================================================
CREATION :      Nicolas Meyer
=======================================================================================*/
extern CPA_EXPORT void VDO_fn_xCloseVideoMPEG(VDO_tdxHandleToVideo p_stVideoHandle);

}
#endif /* _mng_win_h_ */

