/*------------------------------------------------------------------------------
	FILE	:	Error.h
	CREATED	:	98/09/02
	AUTHOR	:	Catalin Cocos
	CONTENTS:	LDT Error management
------------------------------------------------------------------------------*/

#ifndef __LDT_ERROR__
#define __LDT_ERROR__

#include "Link.h"

#define LDT_MAX_ERROR_DESCRIPTION 4000 /* maximum number of characters for error description */

extern char LDT_ErrDesc[LDT_MAX_ERROR_DESCRIPTION +1];

void SignalError(int level, LDT_tdst_Link * pLink, int errorcode, char* szErrDesc, char* szSourceFile, int line);
void InitErrFile();
void CLoseErrFile();

#ifdef LDT_ERROR_TREATMENT
	#define ERRoR(level, link, code, Desc) SignalError(level, link, code, Desc, __FILE__, __LINE__)
#else
	#define ERRoR(level, link, code, Desc) 
#endif

#endif
