/*------------------------------------------------------------------------------
	FILE	:	DynArray.h
	CREATED	:	98/06/11
	AUTHOR	:	Mircea Petrescu
	CONTENTS:	management of unsolved references
				( for get x from reference operations )
------------------------------------------------------------------------------*/

#ifndef __LDT_Refs__
#define __LDT_Refs__

/* Types */

typedef struct tdst_Ref_ tdst_Ref;

/* the packing of a reference */
struct tdst_Ref_
{
	LDT_tdst_Link *pObject;
	LDT_tdst_Link *pGetFrom;
	int iType;
	short xCount;
	long *pVal;
};

/* handle to a reference list */
typedef void * HREF;

typedef struct tdst_Solver_ tdst_Solver;

struct tdst_Solver_
{
	void (*Solve)( HREF );
	HREF hRef;
	int iPriority;
};

int SortSolvers( const void **A, const void **B );

#endif

